/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/process","vs/base/common/uuid","os","vs/platform/configuration/common/configuration","vs/base/common/map","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","vs/editor/common/core/range","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/iterator","vs/base/common/processes","vs/platform/environment/node/argv","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/platform/shell/node/shellEnv","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/functional","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/console","vs/base/common/htmlContent","vs/base/common/labels","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],ye=function(te){for(var e=[],k=0,t=te.length;k<t;k++)e[k]=we[te[k]];return e};define(we[125],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class k{static get(){const w=new Map,S=new Map,T=new Map,E=new Map;function v(y,d){y.has(d.detail)||y.set(d.detail,-d.timestamp)}function P(y,d){let b=y.get(d.detail);!b||b>=0||y.set(d.detail,b+d.timestamp)}const R=te.getStats().slice(0).sort((y,d)=>y.timestamp-d.timestamp);for(const y of R)switch(y.type){case 10:v(w,y);break;case 11:case 12:P(w,y);break;case 21:v(S,y);break;case 22:P(S,y);break;case 33:v(T,y);break;case 34:P(T,y);break;case 31:v(E,y);break;case 32:P(E,y);break}let A=0;T.forEach(y=>A+=y);function C(y){let d=[];return y.forEach((b,f)=>d.push([f,b])),d}return{amdLoad:C(w),amdInvoke:C(S),nodeRequire:C(T),nodeEval:C(E),nodeRequireTotal:A}}static toMarkdownTable(w,S){let T="",E=[];return w.forEach((v,P)=>{E[P]=v.length}),S.forEach(v=>{v.forEach((P,R)=>{typeof P=="undefined"&&(P=v[R]="-");const A=P.toString().length;E[R]=Math.max(A,E[R])})}),w.forEach((v,P)=>{T+=`| ${v+" ".repeat(E[P]-v.toString().length)} `}),T+=`|
`,w.forEach((v,P)=>{T+=`| ${"-".repeat(E[P])} `}),T+=`|
`,S.forEach(v=>{v.forEach((P,R)=>{typeof P!="undefined"&&(T+=`| ${P+" ".repeat(E[R]-P.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=k}),define(we[126],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,w){if(!t)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=k}),define(we[37],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(T){return T?T.replace(/\$\((.*?)\)/g,(E,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(E,v,P){this.id=E,this.definition=v,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function w(T,E){const v=["codicon","codicon-"+T];return E&&v.push("codicon-modifier-"+E),v}e.getClassNamesArray=w;var S;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function v(A){if(A instanceof t)return["codicon","codicon-"+A.id];const C=E.exec(A.id);if(!C)return v(t.error);let[,y,d]=C;const b=["codicon","codicon-"+y];return d&&b.push("codicon-modifier-"+d.substr(1)),b}T.asClassNameArray=v;function P(A){return v(A).join(" ")}T.asClassName=P;function R(A){return"."+v(A).join(".")}T.asCSSSelector=R})(S=e.CSSIcon||(e.CSSIcon={}))}),define(we[76],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(T){return(E,v,P)=>{let R=null,A=null;if(typeof P.value=="function"?(R="value",A=P.value):typeof P.get=="function"&&(R="get",A=P.get),!A)throw new Error("not supported");P[R]=T(A,v)}}e.createDecorator=k;function t(T,E,v){let P=null,R=null;if(typeof v.value=="function"?(P="value",R=v.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(P="get",R=v.get),!R)throw new Error("not supported");const A=`$memoize$${E}`;v[P]=function(...C){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,C)}),this[A]}}e.memoize=t;function w(T,E,v){return k((P,R)=>{const A=`$debounce$${R}`,C=`$debounce$result$${R}`;return function(...y){this[C]||(this[C]=v?v():void 0),clearTimeout(this[A]),E&&(this[C]=E(this[C],...y),y=[this[C]]),this[A]=setTimeout(()=>{P.apply(this,y),this[C]=v?v():void 0},T)}})}e.debounce=w;function S(T,E,v){return k((P,R)=>{const A=`$throttle$timer$${R}`,C=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...b){if(this[C]||(this[C]=v?v():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),E&&(this[C]=E(this[C],...b)),this[d])return;const f=this[y]+T;f<=Date.now()?(this[y]=Date.now(),P.apply(this,[this[C]]),this[C]=v?v():void 0):(this[d]=!0,this[A]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),P.apply(this,[this[C]]),this[C]=v?v():void 0},f-Date.now()))}})}e.throttle=S}),define(we[9],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(l=>{l(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=k,e.errorHandler=new k;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function w(u){v(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=w;function S(u){v(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=S;function T(u){if(u instanceof Error){let{name:n,message:l}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:n,message:l,stack:i}}return u}e.transformErrorForSerialization=T;const E="Canceled";function v(u){return u instanceof P?!0:u instanceof Error&&u.name===E&&u.message===E}e.isCancellationError=v;class P extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=P;function R(){const u=new Error(E);return u.name=u.message,u}e.canceled=R;function A(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=A;function C(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=C;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function b(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=b;class f extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=f;class m extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=m;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;class h extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(n){if(n&&n instanceof h)return n;if(n&&n instanceof Error){const l=new h;return l.name=n.name,l.message=n.message,l.stack=n.stack,l}return new h(n)}}e.ErrorNoTelemetry=h;class a extends Error{constructor(n){super(n);Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(we[18],ye([0,1,9]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(N,q=0){return N[N.length-(1+q)]}e.tail=t;function w(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=w;function S(N,q,Y=(ie,de)=>ie===de){if(N===q)return!0;if(!N||!q||N.length!==q.length)return!1;for(let ie=0,de=N.length;ie<de;ie++)if(!Y(N[ie],q[ie]))return!1;return!0}e.equals=S;function T(N,q,Y){let ie=0,de=N.length-1;for(;ie<=de;){const le=(ie+de)/2|0,ue=Y(N[le],q);if(ue<0)ie=le+1;else if(ue>0)de=le-1;else return le}return-(ie+1)}e.binarySearch=T;function E(N,q){let Y=0,ie=N.length;if(ie===0)return 0;for(;Y<ie;){const de=Math.floor((Y+ie)/2);q(N[de])?ie=de:Y=de+1}return Y}e.findFirstInSorted=E;function v(N,q,Y){if(N=N|0,N>=q.length)throw new TypeError("invalid index");let ie=q[Math.floor(q.length*Math.random())],de=[],le=[],ue=[];for(let pe of q){const X=Y(pe,ie);X<0?de.push(pe):X>0?le.push(pe):ue.push(pe)}return N<de.length?v(N,de,Y):N<de.length+ue.length?ue[0]:v(N-(de.length+ue.length),le,Y)}e.quickSelect=v;function P(N,q){const Y=[];let ie;for(const de of N.slice(0).sort(q))!ie||q(ie[0],de)!==0?(ie=[de],Y.push(ie)):ie.push(de);return Y}e.groupBy=P;function R(N,q,Y){const ie=[];function de(pe,X,Z){if(X===0&&Z.length===0)return;const G=ie[ie.length-1];G&&G.start+G.deleteCount===pe?(G.deleteCount+=X,G.toInsert.push(...Z)):ie.push({start:pe,deleteCount:X,toInsert:Z})}let le=0,ue=0;for(;;){if(le===N.length){de(le,0,q.slice(ue));break}if(ue===q.length){de(le,N.length-le,[]);break}const pe=N[le],X=q[ue],Z=Y(pe,X);Z===0?(le+=1,ue+=1):Z<0?(de(le,1,[]),le+=1):Z>0&&(de(le,0,[X]),ue+=1)}return ie}e.sortedDiff=R;function A(N,q,Y){const ie=R(N,q,Y),de=[],le=[];for(const ue of ie)de.push(...N.slice(ue.start,ue.start+ue.deleteCount)),le.push(...ue.toInsert);return{removed:de,added:le}}e.delta=A;function C(N,q,Y){if(Y===0)return[];const ie=N.slice(0,Y).sort(q);return d(N,q,ie,Y,N.length),ie}e.top=C;function y(N,q,Y,ie,de){return Y===0?Promise.resolve([]):new Promise((le,ue)=>{(async()=>{const pe=N.length,X=N.slice(0,Y).sort(q);for(let Z=Y,G=Math.min(Y+ie,pe);Z<pe;Z=G,G=Math.min(G+ie,pe)){if(Z>Y&&await new Promise(Q=>setTimeout(Q)),de&&de.isCancellationRequested)throw new k.CancellationError;d(N,q,X,Z,G)}return X})().then(le,ue)})}e.topAsync=y;function d(N,q,Y,ie,de){for(const le=Y.length;ie<de;ie++){const ue=N[ie];if(q(ue,Y[le-1])<0){Y.pop();const pe=E(Y,X=>q(ue,X)<0);Y.splice(pe,0,ue)}}}function b(N){return N.filter(q=>!!q)}e.coalesce=b;function f(N){let q=0;for(let Y=0;Y<N.length;Y++)N[Y]&&(N[q]=N[Y],q+=1);N.length=q}e.coalesceInPlace=f;function m(N,q,Y){N.splice(Y,0,N.splice(q,1)[0])}e.move=m;function p(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=p;function h(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=h;function a(N,q=Y=>Y){const Y=new Set;return N.filter(ie=>{const de=q(ie);return Y.has(de)?!1:(Y.add(de),!0)})}e.distinct=a;function u(N){const q=new Set;return Y=>{const ie=N(Y);return q.has(ie)?!1:(q.add(ie),!0)}}e.uniqueFilter=u;function n(N,q){const Y=l(N,q);if(Y!==-1)return N[Y]}e.findLast=n;function l(N,q){for(let Y=N.length-1;Y>=0;Y--){const ie=N[Y];if(q(ie))return Y}return-1}e.lastIndex=l;function i(N,q){return N.length>0?N[0]:q}e.firstOrDefault=i;function s(N,q){return N.length>0?N[N.length-1]:q}e.lastOrDefault=s;function r(N,q,Y=(ie,de)=>ie===de){let ie=0;for(let de=0,le=Math.min(N.length,q.length);de<le&&Y(N[de],q[de]);de++)ie++;return ie}e.commonPrefixLength=r;function o(N){return[].concat(...N)}e.flatten=o;function c(N,q){let Y=typeof q=="number"?N:0;typeof q=="number"?Y=N:(Y=0,q=N);const ie=[];if(Y<=q)for(let de=Y;de<q;de++)ie.push(de);else for(let de=Y;de>q;de--)ie.push(de);return ie}e.range=c;function g(N,q,Y){return N.reduce((ie,de)=>(ie[q(de)]=Y?Y(de):de,ie),Object.create(null))}e.index=g;function I(N,q){return N.push(q),()=>_(N,q)}e.insert=I;function _(N,q){const Y=N.indexOf(q);if(Y>-1)return N.splice(Y,1),q}e.remove=_;function z(N,q,Y){const ie=N.slice(0,q),de=N.slice(q);return ie.concat(Y,de)}e.arrayInsert=z;function W(N,q){let Y;if(typeof q=="number"){let ie=q;Y=()=>{const de=Math.sin(ie++)*179426549;return de-Math.floor(de)}}else Y=Math.random;for(let ie=N.length-1;ie>0;ie-=1){const de=Math.floor(Y()*(ie+1)),le=N[ie];N[ie]=N[de],N[de]=le}}e.shuffle=W;function ee(N,q){const Y=N.indexOf(q);Y>-1&&(N.splice(Y,1),N.unshift(q))}e.pushToStart=ee;function D(N,q){const Y=N.indexOf(q);Y>-1&&(N.splice(Y,1),N.push(q))}e.pushToEnd=D;function H(N,q){for(const Y of q)N.push(Y)}e.pushMany=H;function F(N,q){return Array.isArray(N)?N.map(q):q(N)}e.mapArrayOrNot=F;function $(N){return Array.isArray(N)?N:[N]}e.asArray=$;function oe(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=oe;function K(N,q){for(const Y of N){const ie=q(Y);if(ie!==void 0)return ie}}e.mapFind=K;function j(N,q,Y){const ie=B(N,q),de=N.length,le=Y.length;N.length=de+le;for(let ue=de-1;ue>=ie;ue--)N[ue+le]=N[ue];for(let ue=0;ue<le;ue++)N[ue+ie]=Y[ue]}e.insertInto=j;function O(N,q,Y,ie){const de=B(N,q),le=N.splice(de,Y);return j(N,de,ie),le}e.splice=O;function B(N,q){return q<0?Math.max(q+N.length,0):Math.min(q,N.length)}function V(N,q){return(Y,ie)=>q(N(Y),N(ie))}e.compareBy=V;const J=(N,q)=>N-q;e.numberComparator=J;function se(N,q){if(N.length===0)return;let Y=N[0];for(let ie=1;ie<N.length;ie++){const de=N[ie];q(de,Y)>0&&(Y=de)}return Y}e.findMaxBy=se;function me(N,q){if(N.length===0)return;let Y=N[0];for(let ie=1;ie<N.length;ie++){const de=N[ie];q(de,Y)>=0&&(Y=de)}return Y}e.findLastMaxBy=me;function he(N,q){return se(N,(Y,ie)=>-q(Y,ie))}e.findMinBy=he;class U{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let Y=this.firstIdx;for(;Y<this.items.length&&q(this.items[Y]);)Y++;const ie=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,ie}takeFromEndWhile(q){let Y=this.lastIdx;for(;Y>=0&&q(this.items[Y]);)Y--;const ie=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,ie}peek(){return this.items[this.firstIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}takeCount(q){const Y=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,Y}}e.ArrayQueue=U}),define(we[77],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const w=this;let S=!1,T;return function(){return S||(S=!0,T=t.apply(w,arguments)),T}}e.once=k}),define(we[52],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function w(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=w;const S=Object.freeze([]);function T(){return S}t.empty=T;function*E(u){yield u}t.single=E;function v(u){return u||S}t.from=v;function P(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=P;function R(u){return u[Symbol.iterator]().next().value}t.first=R;function A(u,n){for(const l of u)if(n(l))return!0;return!1}t.some=A;function C(u,n){for(const l of u)if(n(l))return l}t.find=C;function*y(u,n){for(const l of u)n(l)&&(yield l)}t.filter=y;function*d(u,n){let l=0;for(const i of u)yield n(i,l++)}t.map=d;function*b(...u){for(const n of u)for(const l of n)yield l}t.concat=b;function*f(u){for(const n of u)for(const l of n)yield l}t.concatNested=f;function m(u,n,l){let i=l;for(const s of u)i=n(i,s);return i}t.reduce=m;function*p(u,n,l=u.length){for(n<0&&(n+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);n<l;n++)yield u[n]}t.slice=p;function h(u,n=Number.POSITIVE_INFINITY){const l=[];if(n===0)return[l,u];const i=u[Symbol.iterator]();for(let s=0;s<n;s++){const r=i.next();if(r.done)return[l,t.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return i}}]}t.consume=h;function a(u,n,l=(i,s)=>i===s){const i=u[Symbol.iterator](),s=n[Symbol.iterator]();for(;;){const r=i.next(),o=s.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!l(r.value,o.value))return!1}}t.equals=a})(k=e.Iterable||(e.Iterable={}))}),define(we[61],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(n){n.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function T(n,l=!1){let i=0,s=n.length,r="",o=0,c=16,g=0;function I(F){let $=0,oe=0;for(;$<F;){const K=n.charCodeAt(i);if(K>=48&&K<=57)oe=oe*16+K-48;else if(K>=65&&K<=70)oe=oe*16+K-65+10;else if(K>=97&&K<=102)oe=oe*16+K-97+10;else break;i++,$++}return $<F&&(oe=-1),oe}function _(F){i=F,r="",o=0,c=16,g=0}function z(){const F=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&P(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&P(n.charCodeAt(i)))for(i++;i<n.length&&P(n.charCodeAt(i));)i++;else return g=3,n.substring(F,i);let $=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&P(n.charCodeAt(i))){for(i++;i<n.length&&P(n.charCodeAt(i));)i++;$=i}else g=3;return n.substring(F,$)}function W(){let F="",$=i;for(;;){if(i>=s){F+=n.substring($,i),g=2;break}const oe=n.charCodeAt(i);if(oe===34){F+=n.substring($,i),i++;break}if(oe===92){if(F+=n.substring($,i),i++,i>=s){g=2;break}switch(n.charCodeAt(i++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const j=I(4);j>=0?F+=String.fromCharCode(j):g=4;break}default:g=5}$=i;continue}if(oe>=0&&oe<=31)if(v(oe)){F+=n.substring($,i),g=2;break}else g=6;i++}return F}function ee(){if(r="",g=0,o=i,i>=s)return o=s,c=17;let F=n.charCodeAt(i);if(E(F)){do i++,r+=String.fromCharCode(F),F=n.charCodeAt(i);while(E(F));return c=15}if(v(F))return i++,r+=String.fromCharCode(F),F===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),c=14;switch(F){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,r=W(),c=10;case 47:{const $=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<s&&!v(n.charCodeAt(i));)i++;return r=n.substring($,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const oe=s-1;let K=!1;for(;i<oe;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,g=1),r=n.substring($,i),c=13}return r+=String.fromCharCode(F),i++,c=16}case 45:if(r+=String.fromCharCode(F),i++,i===s||!P(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=z(),c=11;default:for(;i<s&&D(F);)i++,F=n.charCodeAt(i);if(o!==i){switch(r=n.substring(o,i),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(F),i++,c=16}}function D(F){if(E(F)||v(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let F;do F=ee();while(F>=12&&F<=15);return F}return{setPosition:_,getPosition:()=>i,scan:l?H:ee,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>g}}e.createScanner=T;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function v(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function A(n,l){const i=[],s=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function g(I,_,z,W){o.value=I,o.offset=_,o.length=z,o.type=W,o.colonOffset=void 0,r=o}try{h(n,{onObjectBegin:(I,_)=>{if(l<=I)throw s;r=void 0,c=l>I,i.push("")},onObjectProperty:(I,_,z)=>{if(l<_||(g(I,_,z,"property"),i[i.length-1]=I,l<=_+z))throw s},onObjectEnd:(I,_)=>{if(l<=I)throw s;r=void 0,i.pop()},onArrayBegin:(I,_)=>{if(l<=I)throw s;r=void 0,i.push(0)},onArrayEnd:(I,_)=>{if(l<=I)throw s;r=void 0,i.pop()},onLiteralValue:(I,_,z)=>{if(l<_||(g(I,_,z,u(I)),l<=_+z))throw s},onSeparator:(I,_,z)=>{if(l<=_)throw s;if(I===":"&&r&&r.type==="property")r.colonOffset=_,c=!1,r=void 0;else if(I===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(c=!0,i[i.length-1]=""),r=void 0}}})}catch(I){if(I!==s)throw I}return{path:i,previousNode:r,isAtPropertyKey:c,matches:I=>{let _=0;for(let z=0;_<I.length&&z<i.length;z++)if(I[_]===i[z]||I[_]==="*")_++;else if(I[_]!=="**")return!1;return _===I.length}}}e.getLocation=A;function C(n,l=[],i=S.DEFAULT){let s=null,r=[];const o=[];function c(I){Array.isArray(r)?r.push(I):s!==null&&(r[s]=I)}return h(n,{onObjectBegin:()=>{const I={};c(I),o.push(r),r=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const I=[];c(I),o.push(r),r=I,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:c,onError:(I,_,z)=>{l.push({error:I,offset:_,length:z})}},i),r[0]}e.parse=C;function y(n,l=[],i=S.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(I){s.type==="property"&&(s.length=I-s.offset,s=s.parent)}function o(I){return s.children.push(I),I}h(n,{onObjectBegin:I=>{s=o({type:"object",offset:I,length:-1,parent:s,children:[]})},onObjectProperty:(I,_,z)=>{s=o({type:"property",offset:_,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:I,offset:_,length:z,parent:s})},onObjectEnd:(I,_)=>{s.length=I+_-s.offset,s=s.parent,r(I+_)},onArrayBegin:(I,_)=>{s=o({type:"array",offset:I,length:-1,parent:s,children:[]})},onArrayEnd:(I,_)=>{s.length=I+_-s.offset,s=s.parent,r(I+_)},onLiteralValue:(I,_,z)=>{o({type:u(I),offset:_,length:z,parent:s,value:I}),r(_+z)},onSeparator:(I,_,z)=>{s.type==="property"&&(I===":"?s.colonOffset=_:I===","&&r(_))},onError:(I,_,z)=>{l.push({error:I,offset:_,length:z})}},i);const g=s.children[0];return g&&delete g.parent,g}e.parseTree=y;function d(n,l){if(!n)return;let i=n;for(let s of l)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===s){i=o.children[1],r=!0;break}if(!r)return}else{const r=s;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=d;function b(n){if(!n.parent||!n.parent.children)return[];const l=b(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;l.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&l.push(i)}return l}e.getNodePath=b;function f(n){switch(n.type){case"array":return n.children.map(f);case"object":{const l=Object.create(null);for(let i of n.children){const s=i.children[1];s&&(l[i.children[0].value]=f(s))}return l}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=f;function m(n,l,i=!1){return l>=n.offset&&l<n.offset+n.length||i&&l===n.offset+n.length}e.contains=m;function p(n,l,i=!1){if(m(n,l,i)){const s=n.children;if(Array.isArray(s))for(let r=0;r<s.length&&s[r].offset<=l;r++){const o=p(s[r],l,i);if(o)return o}return n}}e.findNodeAtOffset=p;function h(n,l,i=S.DEFAULT){const s=T(n,!1);function r(me){return me?()=>me(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(me){return me?he=>me(he,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=r(l.onObjectBegin),g=o(l.onObjectProperty),I=r(l.onObjectEnd),_=r(l.onArrayBegin),z=r(l.onArrayEnd),W=o(l.onLiteralValue),ee=o(l.onSeparator),D=r(l.onComment),H=o(l.onError),F=i&&i.disallowComments,$=i&&i.allowTrailingComma;function oe(){for(;;){const me=s.scan();switch(s.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:F||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(me){case 12:case 13:F?K(10):D();break;case 16:K(1);break;case 15:case 14:break;default:return me}}}function K(me,he=[],U=[]){if(H(me),he.length+U.length>0){let N=s.getToken();for(;N!==17;){if(he.indexOf(N)!==-1){oe();break}else if(U.indexOf(N)!==-1)break;N=oe()}}}function j(me){const he=s.getTokenValue();return me?W(he):g(he),oe(),!0}function O(){switch(s.getToken()){case 11:{let me=0;try{me=JSON.parse(s.getTokenValue()),typeof me!="number"&&(K(2),me=0)}catch{K(2)}W(me);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return oe(),!0}function B(){return s.getToken()!==10?(K(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(ee(":"),oe(),se()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function V(){c(),oe();let me=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(me||K(4,[],[]),ee(","),oe(),s.getToken()===2&&$)break}else me&&K(6,[],[]);B()||K(4,[],[2,5]),me=!0}return I(),s.getToken()!==2?K(7,[2],[]):oe(),!0}function J(){_(),oe();let me=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(me||K(4,[],[]),ee(","),oe(),s.getToken()===4&&$)break}else me&&K(6,[],[]);se()||K(4,[],[4,5]),me=!0}return z(),s.getToken()!==4?K(8,[4],[]):oe(),!0}function se(){switch(s.getToken()){case 3:return J();case 1:return V();case 10:return j(!0);default:return O()}}return oe(),s.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):se()?(s.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=h;function a(n,l){let i=T(n),s=[],r,o=0,c;do switch(c=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==c&&s.push(n.substring(o,c)),l!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,l)),o=i.getPosition();break}while(r!==17);return s.join("")}e.stripComments=a;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(we[127],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new k(()=>w(this.getValue()))}}e.Lazy=k}),define(we[2],ye([0,1,77,52]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const w=!1;let S=null;function T(r){S=r}if(e.setDisposableTracker=T,w){const r="__is_disposable_tracked__";T(new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(c)},3e3)}setParent(o,c){if(o&&o!==p.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==p.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function E(r){return S?.trackDisposable(r),r}function v(r){S?.markAsDisposed(r)}function P(r,o){S?.setParent(r,o)}function R(r,o){if(!!S)for(const c of r)S.setParent(c,o)}function A(r){return S?.markAsSingleton(r),r}e.markAsSingleton=A;class C extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=C;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function d(r){if(t.Iterable.is(r)){let o=[];for(const c of r)if(c)try{c.dispose()}catch(g){o.push(g)}if(o.length===1)throw o[0];if(o.length>1)throw new C(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function b(...r){const o=f(()=>d(r));return R(r,o),o}e.combinedDisposable=b;function f(r){const o=E({dispose:(0,k.once)(()=>{v(o),r()})});return o}e.toDisposable=f;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new m,E(this),P(this._store,this)}dispose(){v(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&P(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&P(o,null),o}}e.MutableDisposable=h;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(o){let c=o;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,v(this))},this}}e.SafeDisposable=u;class n{constructor(){this.references=new Map}acquire(o,...c){let g=this.references.get(o);g||(g={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,g));const{object:I}=g,_=(0,k.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(o,g.object),this.references.delete(o))});return g.counter++,{object:I,dispose:_}}}e.ReferenceCollection=n;class l{constructor(o){this.referenceCollection=o}async acquire(o,...c){const g=this.referenceCollection.acquire(o,...c);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(I){throw g.dispose(),I}}}e.AsyncReferenceCollection=l;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function s(r){const o=new m;try{r(o)}finally{o.dispose()}}e.disposeOnReturn=s}),define(we[128],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(S){this.element=S,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let S=this._first;for(;S!==k.Undefined;){const T=S.next;S.prev=k.Undefined,S.next=k.Undefined,S=T}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,T){const E=new k(S);if(this._first===k.Undefined)this._first=E,this._last=E;else if(T){const P=this._last;this._last=E,E.prev=P,P.next=E}else{const P=this._first;this._first=E,E.next=P,P.prev=E}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(E))}}shift(){if(this._first!==k.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==k.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==k.Undefined&&S.next!==k.Undefined){const T=S.prev;T.next=S.next,S.next.prev=T}else S.prev===k.Undefined&&S.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):S.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):S.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==k.Undefined;)yield S.element,S=S.next}}e.LinkedList=t}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[129],ye([1]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(le,ue){for(var pe=0;pe<ue.length;pe++){var X=ue[pe];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(le,X.key,X)}}function k(le,ue,pe){return ue&&e(le.prototype,ue),pe&&e(le,pe),Object.defineProperty(le,"prototype",{writable:!1}),le}function t(le,ue){if(!!le){if(typeof le=="string")return w(le,ue);var pe=Object.prototype.toString.call(le).slice(8,-1);if(pe==="Object"&&le.constructor&&(pe=le.constructor.name),pe==="Map"||pe==="Set")return Array.from(le);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return w(le,ue)}}function w(le,ue){(ue==null||ue>le.length)&&(ue=le.length);for(var pe=0,X=new Array(ue);pe<ue;pe++)X[pe]=le[pe];return X}function S(le,ue){var pe=typeof Symbol!="undefined"&&le[Symbol.iterator]||le["@@iterator"];if(pe)return(pe=pe.call(le)).next.bind(pe);if(Array.isArray(le)||(pe=t(le))||ue&&le&&typeof le.length=="number"){pe&&(le=pe);var X=0;return function(){return X>=le.length?{done:!0}:{done:!1,value:le[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=T();function E(le){te.defaults=le}var v=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ue){return C[ue]};function d(le,ue){if(ue){if(v.test(le))return le.replace(P,y)}else if(R.test(le))return le.replace(A,y);return le}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(le){return le.replace(b,function(ue,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(le,ue){le=le.source||le,ue=ue||"";var pe={replace:function(Z,G){return G=G.source||G,G=G.replace(m,"$1"),le=le.replace(Z,G),pe},getRegex:function(){return new RegExp(le,ue)}};return pe}var h=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(le,ue,pe){if(le){var X;try{X=decodeURIComponent(f(pe)).replace(h,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ue&&!a.test(pe)&&(pe=r(ue,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var n={},l=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(le,ue){n[" "+le]||(l.test(le)?n[" "+le]=le+"/":n[" "+le]=I(le,"/",!0)),le=n[" "+le];var pe=le.indexOf(":")===-1;return ue.substring(0,2)==="//"?pe?ue:le.replace(i,"$1")+ue:ue.charAt(0)==="/"?pe?ue:le.replace(s,"$1")+ue:le+ue}var o={exec:function(){}};function c(le){for(var ue=1,pe,X;ue<arguments.length;ue++){pe=arguments[ue];for(X in pe)Object.prototype.hasOwnProperty.call(pe,X)&&(le[X]=pe[X])}return le}function g(le,ue){var pe=le.replace(/\|/g,function(G,Q,ae){for(var ve=!1,ke=Q;--ke>=0&&ae[ke]==="\\";)ve=!ve;return ve?"|":" |"}),X=pe.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>ue)X.splice(ue);else for(;X.length<ue;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function I(le,ue,pe){var X=le.length;if(X===0)return"";for(var Z=0;Z<X;){var G=le.charAt(X-Z-1);if(G===ue&&!pe)Z++;else if(G!==ue&&pe)Z++;else break}return le.substr(0,X-Z)}function _(le,ue){if(le.indexOf(ue[1])===-1)return-1;for(var pe=le.length,X=0,Z=0;Z<pe;Z++)if(le[Z]==="\\")Z++;else if(le[Z]===ue[0])X++;else if(le[Z]===ue[1]&&(X--,X<0))return Z;return-1}function z(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(le,ue){if(ue<1)return"";for(var pe="";ue>1;)ue&1&&(pe+=le),ue>>=1,le+=le;return pe+le}function ee(le,ue,pe,X){var Z=ue.href,G=ue.title?d(ue.title):null,Q=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){X.state.inLink=!0;var ae={type:"link",raw:pe,href:Z,title:G,text:Q,tokens:X.inlineTokens(Q,[])};return X.state.inLink=!1,ae}else return{type:"image",raw:pe,href:Z,title:G,text:d(Q)}}function D(le,ue){var pe=le.match(/^(\s+)(?:```)/);if(pe===null)return ue;var X=pe[1];return ue.split(`
`).map(function(Z){var G=Z.match(/^\s+/);if(G===null)return Z;var Q=G[0];return Q.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var H=function(){function le(pe){this.options=pe||te.defaults}var ue=le.prototype;return ue.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ue.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var G=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?G:I(G,`
`)}}},ue.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var G=Z[0],Q=D(G,Z[3]||"");return{type:"code",raw:G,lang:Z[2]?Z[2].trim():Z[2],text:Q}}},ue.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var G=Z[2].trim();if(/#$/.test(G)){var Q=I(G,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(G=Q.trim())}var ae={type:"heading",raw:Z[0],depth:Z[1].length,text:G,tokens:[]};return this.lexer.inline(ae.text,ae.tokens),ae}},ue.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},ue.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var G=Z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},ue.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var G,Q,ae,ve,ke,Te,Ne,Ue,fe,Ee,ge,Fe,_e=Z[1].trim(),qe=_e.length>1,Be={type:"list",raw:"",ordered:qe,start:qe?+_e.slice(0,-1):"",loose:!1,items:[]};_e=qe?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=qe?_e:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*)?(?:\\n|$))");X&&(Fe=!1,!(!(Z=Ge.exec(X))||this.rules.block.hr.test(X)));){if(G=Z[0],X=X.substring(G.length),Ue=Z[2].split(`
`,1)[0],fe=X.split(`
`,1)[0],this.options.pedantic?(ve=2,ge=Ue.trimLeft()):(ve=Z[2].search(/[^ ]/),ve=ve>4?1:ve,ge=Ue.slice(ve),ve+=Z[1].length),Te=!1,!Ue&&/^ *$/.test(fe)&&(G+=fe+`
`,X=X.substring(fe.length+1),Fe=!0),!Fe)for(var je=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])");X&&(Ee=X.split(`
`,1)[0],Ue=Ee,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!je.test(Ue));){if(Ue.search(/[^ ]/)>=ve||!Ue.trim())ge+=`
`+Ue.slice(ve);else if(!Te)ge+=`
`+Ue;else break;!Te&&!Ue.trim()&&(Te=!0),G+=Ee+`
`,X=X.substring(Ee.length+1)}Be.loose||(Ne?Be.loose=!0:/\n *\n *$/.test(G)&&(Ne=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ge),Q&&(ae=Q[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:G,task:!!Q,checked:ae,loose:!1,text:ge}),Be.raw+=G}Be.items[Be.items.length-1].raw=G.trimRight(),Be.items[Be.items.length-1].text=ge.trimRight(),Be.raw=Be.raw.trimRight();var Ke=Be.items.length;for(ke=0;ke<Ke;ke++){this.lexer.state.top=!1,Be.items[ke].tokens=this.lexer.blockTokens(Be.items[ke].text,[]);var re=Be.items[ke].tokens.filter(function(Pe){return Pe.type==="space"}),be=re.every(function(Pe){for(var Le=Pe.raw.split(""),ze=0,Me=S(Le),He;!(He=Me()).done;){var Ye=He.value;if(Ye===`
`&&(ze+=1),ze>1)return!0}return!1});!Be.loose&&re.length&&be&&(Be.loose=!0,Be.items[ke].loose=!0)}return Be}},ue.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var G={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};return this.options.sanitize&&(G.type="paragraph",G.text=this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]),G.tokens=[],this.lexer.inline(G.text,G.tokens)),G}},ue.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var G=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:Z[0],href:Z[2],title:Z[3]}}},ue.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var G={type:"table",header:g(Z[1]).map(function(Ne){return{text:Ne}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=Z[0];var Q=G.align.length,ae,ve,ke,Te;for(ae=0;ae<Q;ae++)/^ *-+: *$/.test(G.align[ae])?G.align[ae]="right":/^ *:-+: *$/.test(G.align[ae])?G.align[ae]="center":/^ *:-+ *$/.test(G.align[ae])?G.align[ae]="left":G.align[ae]=null;for(Q=G.rows.length,ae=0;ae<Q;ae++)G.rows[ae]=g(G.rows[ae],G.header.length).map(function(Ne){return{text:Ne}});for(Q=G.header.length,ve=0;ve<Q;ve++)G.header[ve].tokens=[],this.lexer.inlineTokens(G.header[ve].text,G.header[ve].tokens);for(Q=G.rows.length,ve=0;ve<Q;ve++)for(Te=G.rows[ve],ke=0;ke<Te.length;ke++)Te[ke].tokens=[],this.lexer.inlineTokens(Te[ke].text,Te[ke].tokens);return G}}},ue.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z){var G={type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},ue.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var G={type:"paragraph",raw:Z[0],text:Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},ue.text=function(X){var Z=this.rules.block.text.exec(X);if(Z){var G={type:"text",raw:Z[0],text:Z[0],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},ue.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:d(Z[1])}},ue.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]):Z[0]}},ue.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var G=Z[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Q=I(G.slice(0,-1),"\\");if((G.length-Q.length)%2==0)return}else{var ae=_(Z[2],"()");if(ae>-1){var ve=Z[0].indexOf("!")===0?5:4,ke=ve+Z[1].length+ae;Z[2]=Z[2].substring(0,ae),Z[0]=Z[0].substring(0,ke).trim(),Z[3]=""}}var Te=Z[2],Ne="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ue&&(Te=Ue[1],Ne=Ue[3])}else Ne=Z[3]?Z[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(G)?Te=Te.slice(1):Te=Te.slice(1,-1)),ee(Z,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ue.reflink=function(X,Z){var G;if((G=this.rules.inline.reflink.exec(X))||(G=this.rules.inline.nolink.exec(X))){var Q=(G[2]||G[1]).replace(/\s+/g," ");if(Q=Z[Q.toLowerCase()],!Q||!Q.href){var ae=G[0].charAt(0);return{type:"text",raw:ae,text:ae}}return ee(G,Q,G[0],this.lexer)}},ue.emStrong=function(X,Z,G){G===void 0&&(G="");var Q=this.rules.inline.emStrong.lDelim.exec(X);if(!!Q&&!(Q[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Q[1]||Q[2]||"";if(!ae||ae&&(G===""||this.rules.inline.punctuation.exec(G))){var ve=Q[0].length-1,ke,Te,Ne=ve,Ue=0,fe=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,Z=Z.slice(-1*X.length+ve);(Q=fe.exec(Z))!=null;)if(ke=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!ke){if(Te=ke.length,Q[3]||Q[4]){Ne+=Te;continue}else if((Q[5]||Q[6])&&ve%3&&!((ve+Te)%3)){Ue+=Te;continue}if(Ne-=Te,!(Ne>0)){if(Te=Math.min(Te,Te+Ne+Ue),Math.min(ve,Te)%2){var Ee=X.slice(1,ve+Q.index+Te);return{type:"em",raw:X.slice(0,ve+Q.index+Te+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var ge=X.slice(2,ve+Q.index+Te-1);return{type:"strong",raw:X.slice(0,ve+Q.index+Te+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},ue.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var G=Z[2].replace(/\n/g," "),Q=/[^ ]/.test(G),ae=/^ /.test(G)&&/ $/.test(G);return Q&&ae&&(G=G.substring(1,G.length-1)),G=d(G,!0),{type:"codespan",raw:Z[0],text:G}}},ue.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},ue.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2],[])}},ue.autolink=function(X,Z){var G=this.rules.inline.autolink.exec(X);if(G){var Q,ae;return G[2]==="@"?(Q=d(this.options.mangle?Z(G[1]):G[1]),ae="mailto:"+Q):(Q=d(G[1]),ae=Q),{type:"link",raw:G[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},ue.url=function(X,Z){var G;if(G=this.rules.inline.url.exec(X)){var Q,ae;if(G[2]==="@")Q=d(this.options.mangle?Z(G[0]):G[0]),ae="mailto:"+Q;else{var ve;do ve=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(ve!==G[0]);Q=d(G[0]),G[1]==="www."?ae="http://"+Q:ae=Q}return{type:"link",raw:G[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},ue.inlineText=function(X,Z){var G=this.rules.inline.text.exec(X);if(G){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):d(G[0]):G[0]:Q=d(this.options.smartypants?Z(G[0]):G[0]),{type:"text",raw:G[0],text:Q}}},le}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=p(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=p(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=p(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=p(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=p(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=p(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=c({},F),F.gfm=c({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=p(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=p(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=c({},F.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:p(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=p($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=p(F._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=p($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=p($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=p($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=p($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=p($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=p($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=p($.reflink).replace("label",$._label).replace("ref",F._label).getRegex(),$.nolink=p($.nolink).replace("ref",F._label).getRegex(),$.reflinkSearch=p($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=c({},$),$.pedantic=c({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=c({},$.normal,{escape:p($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=p($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=c({},$.gfm,{br:p($.br).replace("{2,}","*").getRegex(),text:p($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function oe(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(le){var ue="",pe,X,Z=le.length;for(pe=0;pe<Z;pe++)X=le.charCodeAt(pe),Math.random()>.5&&(X="x"+X.toString(16)),ue+="&#"+X+";";return ue}var j=function(){function le(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||te.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:F.normal,inline:$.normal};this.options.pedantic?(X.block=F.pedantic,X.inline=$.pedantic):this.options.gfm&&(X.block=F.gfm,this.options.breaks?X.inline=$.breaks:X.inline=$.gfm),this.tokenizer.rules=X}le.lex=function(X,Z){var G=new le(Z);return G.lex(X)},le.lexInline=function(X,Z){var G=new le(Z);return G.inlineTokens(X)};var ue=le.prototype;return ue.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ue.blockTokens=function(X,Z){var G=this;Z===void 0&&(Z=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var Q,ae,ve,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(Q=Ne.call({lexer:G},X,Z))?(X=X.substring(Q.raw.length),Z.push(Q),!0):!1}))){if(Q=this.tokenizer.space(X)){X=X.substring(Q.raw.length),Q.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(Q);continue}if(Q=this.tokenizer.code(X)){X=X.substring(Q.raw.length),ae=Z[Z.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Q.raw,ae.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(Q);continue}if(Q=this.tokenizer.fences(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.heading(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.hr(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.blockquote(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.list(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.html(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.def(X)){X=X.substring(Q.raw.length),ae=Z[Z.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Q.raw,ae.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.lheading(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(ve=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Ue=X.slice(1),fe=void 0;G.options.extensions.startBlock.forEach(function(Ee){fe=Ee.call({lexer:this},Ue),typeof fe=="number"&&fe>=0&&(Ne=Math.min(Ne,fe))}),Ne<1/0&&Ne>=0&&(ve=X.substring(0,Ne+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(ve))){ae=Z[Z.length-1],ke&&ae.type==="paragraph"?(ae.raw+=`
`+Q.raw,ae.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(Q),ke=ve.length!==X.length,X=X.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(X)){X=X.substring(Q.raw.length),ae=Z[Z.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+Q.raw,ae.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):Z.push(Q);continue}if(X){var Te="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,Z},ue.inline=function(X,Z){this.inlineQueue.push({src:X,tokens:Z})},ue.inlineTokens=function(X,Z){var G=this;Z===void 0&&(Z=[]);var Q,ae,ve,ke=X,Te,Ne,Ue;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)fe.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+W("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+W("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ne||(Ue=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(Q=ge.call({lexer:G},X,Z))?(X=X.substring(Q.raw.length),Z.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.tag(X)){X=X.substring(Q.raw.length),ae=Z[Z.length-1],ae&&Q.type==="text"&&ae.type==="text"?(ae.raw+=Q.raw,ae.text+=Q.text):Z.push(Q);continue}if(Q=this.tokenizer.link(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(Q.raw.length),ae=Z[Z.length-1],ae&&Q.type==="text"&&ae.type==="text"?(ae.raw+=Q.raw,ae.text+=Q.text):Z.push(Q);continue}if(Q=this.tokenizer.emStrong(X,ke,Ue)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.codespan(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.br(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.del(X)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(Q=this.tokenizer.autolink(X,K)){X=X.substring(Q.raw.length),Z.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(X,K))){X=X.substring(Q.raw.length),Z.push(Q);continue}if(ve=X,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Fe=X.slice(1),_e=void 0;G.options.extensions.startInline.forEach(function(qe){_e=qe.call({lexer:this},Fe),typeof _e=="number"&&_e>=0&&(ge=Math.min(ge,_e))}),ge<1/0&&ge>=0&&(ve=X.substring(0,ge+1))}(),Q=this.tokenizer.inlineText(ve,oe)){X=X.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(Ue=Q.raw.slice(-1)),Ne=!0,ae=Z[Z.length-1],ae&&ae.type==="text"?(ae.raw+=Q.raw,ae.text+=Q.text):Z.push(Q);continue}if(X){var Ee="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return Z},k(le,null,[{key:"rules",get:function(){return{block:F,inline:$}}}]),le}(),O=function(){function le(pe){this.options=pe||te.defaults}var ue=le.prototype;return ue.code=function(X,Z,G){var Q=(Z||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(X,Q);ae!=null&&ae!==X&&(G=!0,X=ae)}return X=X.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+d(Q,!0)+'">'+(G?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(G?X:d(X,!0))+`</code></pre>
`},ue.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ue.html=function(X){return X},ue.heading=function(X,Z,G,Q){return this.options.headerIds?"<h"+Z+' id="'+this.options.headerPrefix+Q.slug(G)+'">'+X+"</h"+Z+`>
`:"<h"+Z+">"+X+"</h"+Z+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(X,Z,G){var Q=Z?"ol":"ul",ae=Z&&G!==1?' start="'+G+'"':"";return"<"+Q+ae+`>
`+X+"</"+Q+`>
`},ue.listitem=function(X){return"<li>"+X+`</li>
`},ue.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(X){return"<p>"+X+`</p>
`},ue.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},ue.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ue.tablecell=function(X,Z){var G=Z.header?"th":"td",Q=Z.align?"<"+G+' align="'+Z.align+'">':"<"+G+">";return Q+X+"</"+G+`>
`},ue.strong=function(X){return"<strong>"+X+"</strong>"},ue.em=function(X){return"<em>"+X+"</em>"},ue.codespan=function(X){return"<code>"+X+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(X){return"<del>"+X+"</del>"},ue.link=function(X,Z,G){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return G;var Q='<a href="'+d(X)+'"';return Z&&(Q+=' title="'+Z+'"'),Q+=">"+G+"</a>",Q},ue.image=function(X,Z,G){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return G;var Q='<img src="'+X+'" alt="'+G+'"';return Z&&(Q+=' title="'+Z+'"'),Q+=this.options.xhtml?"/>":">",Q},ue.text=function(X){return X},le}(),B=function(){function le(){}var ue=le.prototype;return ue.strong=function(X){return X},ue.em=function(X){return X},ue.codespan=function(X){return X},ue.del=function(X){return X},ue.html=function(X){return X},ue.text=function(X){return X},ue.link=function(X,Z,G){return""+G},ue.image=function(X,Z,G){return""+G},ue.br=function(){return""},le}(),V=function(){function le(){this.seen={}}var ue=le.prototype;return ue.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(X,Z){var G=X,Q=0;if(this.seen.hasOwnProperty(G)){Q=this.seen[X];do Q++,G=X+"-"+Q;while(this.seen.hasOwnProperty(G))}return Z||(this.seen[X]=Q,this.seen[G]=0),G},ue.slug=function(X,Z){Z===void 0&&(Z={});var G=this.serialize(X);return this.getNextSafeSlug(G,Z.dryrun)},le}(),J=function(){function le(pe){this.options=pe||te.defaults,this.options.renderer=this.options.renderer||new O,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new V}le.parse=function(X,Z){var G=new le(Z);return G.parse(X)},le.parseInline=function(X,Z){var G=new le(Z);return G.parseInline(X)};var ue=le.prototype;return ue.parse=function(X,Z){Z===void 0&&(Z=!0);var G="",Q,ae,ve,ke,Te,Ne,Ue,fe,Ee,ge,Fe,_e,qe,Be,Ge,je,Ke,re,be,Pe=X.length;for(Q=0;Q<Pe;Q++){if(ge=X[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(be=this.options.extensions.renderers[ge.type].call({parser:this},ge),be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){G+=be||"";continue}switch(ge.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,f(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(fe="",Ue="",ke=ge.header.length,ae=0;ae<ke;ae++)Ue+=this.renderer.tablecell(this.parseInline(ge.header[ae].tokens),{header:!0,align:ge.align[ae]});for(fe+=this.renderer.tablerow(Ue),Ee="",ke=ge.rows.length,ae=0;ae<ke;ae++){for(Ne=ge.rows[ae],Ue="",Te=Ne.length,ve=0;ve<Te;ve++)Ue+=this.renderer.tablecell(this.parseInline(Ne[ve].tokens),{header:!1,align:ge.align[ve]});Ee+=this.renderer.tablerow(Ue)}G+=this.renderer.table(fe,Ee);continue}case"blockquote":{Ee=this.parse(ge.tokens),G+=this.renderer.blockquote(Ee);continue}case"list":{for(Fe=ge.ordered,_e=ge.start,qe=ge.loose,ke=ge.items.length,Ee="",ae=0;ae<ke;ae++)Ge=ge.items[ae],je=Ge.checked,Ke=Ge.task,Be="",Ge.task&&(re=this.renderer.checkbox(je),qe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=re+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=re+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:re}):Be+=re),Be+=this.parse(Ge.tokens,qe),Ee+=this.renderer.listitem(Be,Ke,je);G+=this.renderer.list(Ee,Fe,_e);continue}case"html":{G+=this.renderer.html(ge.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(Ee=ge.tokens?this.parseInline(ge.tokens):ge.text;Q+1<Pe&&X[Q+1].type==="text";)ge=X[++Q],Ee+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);G+=Z?this.renderer.paragraph(Ee):Ee;continue}default:{var Le='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return G},ue.parseInline=function(X,Z){Z=Z||this.renderer;var G="",Q,ae,ve,ke=X.length;for(Q=0;Q<ke;Q++){if(ae=X[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(ve=this.options.extensions.renderers[ae.type].call({parser:this},ae),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ae.type))){G+=ve||"";continue}switch(ae.type){case"escape":{G+=Z.text(ae.text);break}case"html":{G+=Z.html(ae.text);break}case"link":{G+=Z.link(ae.href,ae.title,this.parseInline(ae.tokens,Z));break}case"image":{G+=Z.image(ae.href,ae.title,ae.text);break}case"strong":{G+=Z.strong(this.parseInline(ae.tokens,Z));break}case"em":{G+=Z.em(this.parseInline(ae.tokens,Z));break}case"codespan":{G+=Z.codespan(ae.text);break}case"br":{G+=Z.br();break}case"del":{G+=Z.del(this.parseInline(ae.tokens,Z));break}case"text":{G+=Z.text(ae.text);break}default:{var Te='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return G},le}();function se(le,ue,pe){if(typeof le=="undefined"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ue=="function"&&(pe=ue,ue=null),ue=c({},se.defaults,ue||{}),z(ue),pe){var X=ue.highlight,Z;try{Z=j.lex(le,ue)}catch(ve){return pe(ve)}var G=function(ke){var Te;if(!ke)try{ue.walkTokens&&se.walkTokens(Z,ue.walkTokens),Te=J.parse(Z,ue)}catch(Ne){ke=Ne}return ue.highlight=X,ke?pe(ke):pe(null,Te)};if(!X||X.length<3||(delete ue.highlight,!Z.length))return G();var Q=0;se.walkTokens(Z,function(ve){ve.type==="code"&&(Q++,setTimeout(function(){X(ve.text,ve.lang,function(ke,Te){if(ke)return G(ke);Te!=null&&Te!==ve.text&&(ve.text=Te,ve.escaped=!0),Q--,Q===0&&G()})},0))}),Q===0&&G();return}try{var ae=j.lex(le,ue);return ue.walkTokens&&se.walkTokens(ae,ue.walkTokens),J.parse(ae,ue)}catch(ve){if(ve.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+d(ve.message+"",!0)+"</pre>";throw ve}}se.options=se.setOptions=function(le){return c(se.defaults,le),E(se.defaults),se},se.getDefaults=T,se.defaults=te.defaults,se.use=function(){for(var le=arguments.length,ue=new Array(le),pe=0;pe<le;pe++)ue[pe]=arguments[pe];var X=c.apply(void 0,[{}].concat(ue)),Z=se.defaults.extensions||{renderers:{},childTokens:{}},G;ue.forEach(function(Q){if(Q.extensions&&(G=!0,Q.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var ke=Z.renderers?Z.renderers[ve.name]:null;ke?Z.renderers[ve.name]=function(){for(var Te=arguments.length,Ne=new Array(Te),Ue=0;Ue<Te;Ue++)Ne[Ue]=arguments[Ue];var fe=ve.renderer.apply(this,Ne);return fe===!1&&(fe=ke.apply(this,Ne)),fe}:Z.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ve.level]?Z[ve.level].unshift(ve.tokenizer):Z[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?Z.startBlock?Z.startBlock.push(ve.start):Z.startBlock=[ve.start]:ve.level==="inline"&&(Z.startInline?Z.startInline.push(ve.start):Z.startInline=[ve.start]))}ve.childTokens&&(Z.childTokens[ve.name]=ve.childTokens)})),Q.renderer&&function(){var ve=se.defaults.renderer||new O,ke=function(Ue){var fe=ve[Ue];ve[Ue]=function(){for(var Ee=arguments.length,ge=new Array(Ee),Fe=0;Fe<Ee;Fe++)ge[Fe]=arguments[Fe];var _e=Q.renderer[Ue].apply(ve,ge);return _e===!1&&(_e=fe.apply(ve,ge)),_e}};for(var Te in Q.renderer)ke(Te);X.renderer=ve}(),Q.tokenizer&&function(){var ve=se.defaults.tokenizer||new H,ke=function(Ue){var fe=ve[Ue];ve[Ue]=function(){for(var Ee=arguments.length,ge=new Array(Ee),Fe=0;Fe<Ee;Fe++)ge[Fe]=arguments[Fe];var _e=Q.tokenizer[Ue].apply(ve,ge);return _e===!1&&(_e=fe.apply(ve,ge)),_e}};for(var Te in Q.tokenizer)ke(Te);X.tokenizer=ve}(),Q.walkTokens){var ae=se.defaults.walkTokens;X.walkTokens=function(ve){Q.walkTokens.call(this,ve),ae&&ae.call(this,ve)}}G&&(X.extensions=Z),se.setOptions(X)})},se.walkTokens=function(le,ue){for(var pe=function(){var Q=Z.value;switch(ue.call(se,Q),Q.type){case"table":{for(var ae=S(Q.header),ve;!(ve=ae()).done;){var ke=ve.value;se.walkTokens(ke.tokens,ue)}for(var Te=S(Q.rows),Ne;!(Ne=Te()).done;)for(var Ue=Ne.value,fe=S(Ue),Ee;!(Ee=fe()).done;){var ge=Ee.value;se.walkTokens(ge.tokens,ue)}break}case"list":{se.walkTokens(Q.items,ue);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Q.type]?se.defaults.extensions.childTokens[Q.type].forEach(function(Fe){se.walkTokens(Q[Fe],ue)}):Q.tokens&&se.walkTokens(Q.tokens,ue)}},X=S(le),Z;!(Z=X()).done;)pe()},se.parseInline=function(le,ue){if(typeof le=="undefined"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ue=c({},se.defaults,ue||{}),z(ue);try{var pe=j.lexInline(le,ue);return ue.walkTokens&&se.walkTokens(pe,ue.walkTokens),J.parseInline(pe,ue)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},se.Parser=J,se.parser=J.parse,se.Renderer=O,se.TextRenderer=B,se.Lexer=j,se.lexer=j.lex,se.Tokenizer=H,se.Slugger=V,se.parse=se;var me=se.options,he=se.setOptions,U=se.use,N=se.walkTokens,q=se.parseInline,Y=se,ie=J.parse,de=j.lex;te.Lexer=j,te.Parser=J,te.Renderer=O,te.Slugger=V,te.TextRenderer=B,te.Tokenizer=H,te.getDefaults=T,te.lexer=de,te.marked=se,te.options=me,te.parse=Y,te.parseInline=q,te.parser=ie,te.setOptions=he,te.use=U,te.walkTokens=N,Object.defineProperty(te,"__esModule",{value:!0})}),function(){function te(w){const S=[];typeof w=="number"&&S.push("code/timeOrigin",w);function T(v){S.push(v,Date.now())}function E(){const v=[];for(let P=0;P<S.length;P+=2)v.push({name:S[P],startTime:S[P+1]});return v}return{mark:T,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(w+T.startTime)});return S}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function k(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),define(we[3],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const k="en";let t=!1,w=!1,S=!1,T=!1,E=!1,v=!1,P=!1,R=!1,A=!1,C,y=k,d,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const m=typeof f?.versions?.electron=="string",p=m&&f?.type==="renderer";if(typeof navigator=="object"&&!p)b=navigator.userAgent,t=b.indexOf("Windows")>=0,w=b.indexOf("Macintosh")>=0,R=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=b.indexOf("Linux")>=0,v=!0,C=navigator.language,y=C;else if(typeof f=="object"){t=f.platform==="win32",w=f.platform==="darwin",S=f.platform==="linux",T=S&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,P=m,A=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=k,y=k;const o=f.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),g=c.availableLanguages["*"];C=c.locale,y=g||k,d=c._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function a(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let u=0;w?u=1:t?u=3:S&&(u=2),e.isWindows=t,e.isMacintosh=w,e.isLinux=S,e.isLinuxSnap=T,e.isNative=E,e.isElectron=P,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=A,e.platform=u,e.userAgent=b,e.language=y;var n;(function(o){function c(){return e.language}o.value=c;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=g;function I(){return e.language==="en"}o.isDefault=I})(n=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let I=0,_=o.length;I<_;I++){const z=o[I];if(z.id===g.data.vscodeScheduleAsyncWork){o.splice(I,1),z.callback();return}}});let c=0;return g=>{const I=++c;o.push({id:I,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return o=>setTimeout(o)})();var l;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=w||R?2:t?1:3;let i=!0,s=!1;function r(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,i=new Uint16Array(o.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[25],ye([0,1,3]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const w=k.globals.vscode.process;t={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[5],ye([0,1,25]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,w=97,S=90,T=122,E=46,v=47,P=92,R=58,A=63;class C extends Error{constructor(a,u,n){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const i=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${i} ${l} of type ${u}`;s+=`. Received type ${typeof n}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function y(h,a){if(typeof h!="string")throw new C(a,"string",h)}function d(h){return h===v||h===P}function b(h){return h===v}function f(h){return h>=t&&h<=S||h>=w&&h<=T}function m(h,a,u,n){let l="",i=0,s=-1,r=0,o=0;for(let c=0;c<=h.length;++c){if(c<h.length)o=h.charCodeAt(c);else{if(n(o))break;o=v}if(n(o)){if(!(s===c-1||r===1))if(r===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const g=l.lastIndexOf(u);g===-1?(l="",i=0):(l=l.slice(0,g),i=l.length-1-l.lastIndexOf(u)),s=c,r=0;continue}else if(l.length!==0){l="",i=0,s=c,r=0;continue}}a&&(l+=l.length>0?`${u}..`:"..",i=2)}else l.length>0?l+=`${u}${h.slice(s+1,c)}`:l=h.slice(s+1,c),i=c-s-1;s=c,r=0}else o===E&&r!==-1?++r:r=-1}return l}function p(h,a){if(a===null||typeof a!="object")throw new C("pathObject","Object",a);const u=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${n}`:`${u}${h}${n}`:n}e.win32={resolve(...h){let a="",u="",n=!1;for(let l=h.length-1;l>=-1;l--){let i;if(l>=0){if(i=h[l],y(i,"path"),i.length===0)continue}else a.length===0?i=k.cwd():(i=k.env[`=${a}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${a}\\`));const s=i.length;let r=0,o="",c=!1;const g=i.charCodeAt(0);if(s===1)d(g)&&(r=1,c=!0);else if(d(g))if(c=!0,d(i.charCodeAt(1))){let I=2,_=I;for(;I<s&&!d(i.charCodeAt(I));)I++;if(I<s&&I!==_){const z=i.slice(_,I);for(_=I;I<s&&d(i.charCodeAt(I));)I++;if(I<s&&I!==_){for(_=I;I<s&&!d(i.charCodeAt(I));)I++;(I===s||I!==_)&&(o=`\\\\${z}\\${i.slice(_,I)}`,r=I)}}}else r=1;else f(g)&&i.charCodeAt(1)===R&&(o=i.slice(0,2),r=2,s>2&&d(i.charCodeAt(2))&&(c=!0,r=3));if(o.length>0)if(a.length>0){if(o.toLowerCase()!==a.toLowerCase())continue}else a=o;if(n){if(a.length>0)break}else if(u=`${i.slice(r)}\\${u}`,n=c,c&&a.length>0)break}return u=m(u,!n,"\\",d),n?`${a}\\${u}`:`${a}${u}`||"."},normalize(h){y(h,"path");const a=h.length;if(a===0)return".";let u=0,n,l=!1;const i=h.charCodeAt(0);if(a===1)return b(i)?"\\":h;if(d(i))if(l=!0,d(h.charCodeAt(1))){let r=2,o=r;for(;r<a&&!d(h.charCodeAt(r));)r++;if(r<a&&r!==o){const c=h.slice(o,r);for(o=r;r<a&&d(h.charCodeAt(r));)r++;if(r<a&&r!==o){for(o=r;r<a&&!d(h.charCodeAt(r));)r++;if(r===a)return`\\\\${c}\\${h.slice(o)}\\`;r!==o&&(n=`\\\\${c}\\${h.slice(o,r)}`,u=r)}}}else u=1;else f(i)&&h.charCodeAt(1)===R&&(n=h.slice(0,2),u=2,a>2&&d(h.charCodeAt(2))&&(l=!0,u=3));let s=u<a?m(h.slice(u),!l,"\\",d):"";return s.length===0&&!l&&(s="."),s.length>0&&d(h.charCodeAt(a-1))&&(s+="\\"),n===void 0?l?`\\${s}`:s:l?`${n}\\${s}`:`${n}${s}`},isAbsolute(h){y(h,"path");const a=h.length;if(a===0)return!1;const u=h.charCodeAt(0);return d(u)||a>2&&f(u)&&h.charCodeAt(1)===R&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let a,u;for(let i=0;i<h.length;++i){const s=h[i];y(s,"path"),s.length>0&&(a===void 0?a=u=s:a+=`\\${s}`)}if(a===void 0)return".";let n=!0,l=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++l;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++l,i>2&&(d(u.charCodeAt(2))?++l:n=!1))}if(n){for(;l<a.length&&d(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a)return"";const u=e.win32.resolve(h),n=e.win32.resolve(a);if(u===n||(h=u.toLowerCase(),a=n.toLowerCase(),h===a))return"";let l=0;for(;l<h.length&&h.charCodeAt(l)===P;)l++;let i=h.length;for(;i-1>l&&h.charCodeAt(i-1)===P;)i--;const s=i-l;let r=0;for(;r<a.length&&a.charCodeAt(r)===P;)r++;let o=a.length;for(;o-1>r&&a.charCodeAt(o-1)===P;)o--;const c=o-r,g=s<c?s:c;let I=-1,_=0;for(;_<g;_++){const W=h.charCodeAt(l+_);if(W!==a.charCodeAt(r+_))break;W===P&&(I=_)}if(_!==g){if(I===-1)return n}else{if(c>g){if(a.charCodeAt(r+_)===P)return n.slice(r+_+1);if(_===2)return n.slice(r+_)}s>g&&(h.charCodeAt(l+_)===P?I=_:_===2&&(I=3)),I===-1&&(I=0)}let z="";for(_=l+I+1;_<=i;++_)(_===i||h.charCodeAt(_)===P)&&(z+=z.length===0?"..":"\\..");return r+=I,z.length>0?`${z}${n.slice(r,o)}`:(n.charCodeAt(r)===P&&++r,n.slice(r,o))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const a=e.win32.resolve(h);if(a.length<=2)return h;if(a.charCodeAt(0)===P){if(a.charCodeAt(1)===P){const u=a.charCodeAt(2);if(u!==A&&u!==E)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(f(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===P)return`\\\\?\\${a}`;return h},dirname(h){y(h,"path");const a=h.length;if(a===0)return".";let u=-1,n=0;const l=h.charCodeAt(0);if(a===1)return d(l)?h:".";if(d(l)){if(u=n=1,d(h.charCodeAt(1))){let r=2,o=r;for(;r<a&&!d(h.charCodeAt(r));)r++;if(r<a&&r!==o){for(o=r;r<a&&d(h.charCodeAt(r));)r++;if(r<a&&r!==o){for(o=r;r<a&&!d(h.charCodeAt(r));)r++;if(r===a)return h;r!==o&&(u=n=r+1)}}}}else f(l)&&h.charCodeAt(1)===R&&(u=a>2&&d(h.charCodeAt(2))?3:2,n=u);let i=-1,s=!0;for(let r=a-1;r>=n;--r)if(d(h.charCodeAt(r))){if(!s){i=r;break}}else s=!1;if(i===-1){if(u===-1)return".";i=u}return h.slice(0,i)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,n=-1,l=!0,i;if(h.length>=2&&f(h.charCodeAt(0))&&h.charCodeAt(1)===R&&(u=2),a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,r=-1;for(i=h.length-1;i>=u;--i){const o=h.charCodeAt(i);if(d(o)){if(!l){u=i+1;break}}else r===-1&&(l=!1,r=i+1),s>=0&&(o===a.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=r))}return u===n?n=r:n===-1&&(n=h.length),h.slice(u,n)}for(i=h.length-1;i>=u;--i)if(d(h.charCodeAt(i))){if(!l){u=i+1;break}}else n===-1&&(l=!1,n=i+1);return n===-1?"":h.slice(u,n)},extname(h){y(h,"path");let a=0,u=-1,n=0,l=-1,i=!0,s=0;h.length>=2&&h.charCodeAt(1)===R&&f(h.charCodeAt(0))&&(a=n=2);for(let r=h.length-1;r>=a;--r){const o=h.charCodeAt(r);if(d(o)){if(!i){n=r+1;break}continue}l===-1&&(i=!1,l=r+1),o===E?u===-1?u=r:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||l===-1||s===0||s===1&&u===l-1&&u===n+1?"":h.slice(u,l)},format:p.bind(null,"\\"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.length;let n=0,l=h.charCodeAt(0);if(u===1)return d(l)?(a.root=a.dir=h,a):(a.base=a.name=h,a);if(d(l)){if(n=1,d(h.charCodeAt(1))){let I=2,_=I;for(;I<u&&!d(h.charCodeAt(I));)I++;if(I<u&&I!==_){for(_=I;I<u&&d(h.charCodeAt(I));)I++;if(I<u&&I!==_){for(_=I;I<u&&!d(h.charCodeAt(I));)I++;I===u?n=I:I!==_&&(n=I+1)}}}}else if(f(l)&&h.charCodeAt(1)===R){if(u<=2)return a.root=a.dir=h,a;if(n=2,d(h.charCodeAt(2))){if(u===3)return a.root=a.dir=h,a;n=3}}n>0&&(a.root=h.slice(0,n));let i=-1,s=n,r=-1,o=!0,c=h.length-1,g=0;for(;c>=n;--c){if(l=h.charCodeAt(c),d(l)){if(!o){s=c+1;break}continue}r===-1&&(o=!1,r=c+1),l===E?i===-1?i=c:g!==1&&(g=1):i!==-1&&(g=-1)}return r!==-1&&(i===-1||g===0||g===1&&i===r-1&&i===s+1?a.base=a.name=h.slice(s,r):(a.name=h.slice(s,i),a.base=h.slice(s,r),a.ext=h.slice(i,r))),s>0&&s!==n?a.dir=h.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let a="",u=!1;for(let n=h.length-1;n>=-1&&!u;n--){const l=n>=0?h[n]:k.cwd();y(l,"path"),l.length!==0&&(a=`${l}/${a}`,u=l.charCodeAt(0)===v)}return a=m(a,!u,"/",b),u?`/${a}`:a.length>0?a:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===v,u=h.charCodeAt(h.length-1)===v;return h=m(h,!a,"/",b),h.length===0?a?"/":u?"./":".":(u&&(h+="/"),a?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===v},join(...h){if(h.length===0)return".";let a;for(let u=0;u<h.length;++u){const n=h[u];y(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a||(h=e.posix.resolve(h),a=e.posix.resolve(a),h===a))return"";const u=1,n=h.length,l=n-u,i=1,s=a.length-i,r=l<s?l:s;let o=-1,c=0;for(;c<r;c++){const I=h.charCodeAt(u+c);if(I!==a.charCodeAt(i+c))break;I===v&&(o=c)}if(c===r)if(s>r){if(a.charCodeAt(i+c)===v)return a.slice(i+c+1);if(c===0)return a.slice(i+c)}else l>r&&(h.charCodeAt(u+c)===v?o=c:c===0&&(o=0));let g="";for(c=u+o+1;c<=n;++c)(c===n||h.charCodeAt(c)===v)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(i+o)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===v;let u=-1,n=!0;for(let l=h.length-1;l>=1;--l)if(h.charCodeAt(l)===v){if(!n){u=l;break}}else n=!1;return u===-1?a?"/":".":a&&u===1?"//":h.slice(0,u)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,n=-1,l=!0,i;if(a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,r=-1;for(i=h.length-1;i>=0;--i){const o=h.charCodeAt(i);if(o===v){if(!l){u=i+1;break}}else r===-1&&(l=!1,r=i+1),s>=0&&(o===a.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=r))}return u===n?n=r:n===-1&&(n=h.length),h.slice(u,n)}for(i=h.length-1;i>=0;--i)if(h.charCodeAt(i)===v){if(!l){u=i+1;break}}else n===-1&&(l=!1,n=i+1);return n===-1?"":h.slice(u,n)},extname(h){y(h,"path");let a=-1,u=0,n=-1,l=!0,i=0;for(let s=h.length-1;s>=0;--s){const r=h.charCodeAt(s);if(r===v){if(!l){u=s+1;break}continue}n===-1&&(l=!1,n=s+1),r===E?a===-1?a=s:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||n===-1||i===0||i===1&&a===n-1&&a===u+1?"":h.slice(a,n)},format:p.bind(null,"/"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.charCodeAt(0)===v;let n;u?(a.root="/",n=1):n=0;let l=-1,i=0,s=-1,r=!0,o=h.length-1,c=0;for(;o>=n;--o){const g=h.charCodeAt(o);if(g===v){if(!r){i=o+1;break}continue}s===-1&&(r=!1,s=o+1),g===E?l===-1?l=o:c!==1&&(c=1):l!==-1&&(c=-1)}if(s!==-1){const g=i===0&&u?1:i;l===-1||c===0||c===1&&l===s-1&&l===i+1?a.base=a.name=h.slice(g,s):(a.name=h.slice(g,l),a.base=h.slice(g,s),a.ext=h.slice(l,s))}return i>0?a.dir=h.slice(0,i-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[62],ye([0,1,5]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(A){A.text="text/plain",A.binary="application/octet-stream",A.unknown="application/unknown",A.markdown="text/markdown",A.latex="text/latex",A.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(A){const C=(0,k.extname)(A),y=w[C.toLowerCase()];return y!==void 0?y:E(A)}e.getMediaOrTextMime=T;function E(A){const C=(0,k.extname)(A);return S[C.toLowerCase()]}e.getMediaMime=E;function v(A){for(const C in S)if(S[C]===A)return C}e.getExtensionForMimeType=v;const P=/^(.+)\/(.+?)(;.+)?$/;function R(A,C){const y=P.exec(A);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:C?void 0:A}e.normalizeMimeType=R}),define(we[53],ye([0,1,3]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var w;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(w=e.TerminateResponseCode||(e.TerminateResponseCode={}));function S(E,...v){const P=v.reduce((C,y)=>(C[y]=!0,C),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(C=>!P[C]).forEach(C=>{for(let y=0;y<R.length;y++)if(C.search(R[y])!==-1){delete E[C];break}})}e.sanitizeProcessEnvironment=S;function T(E){!E||(delete E.DEBUG,k.isMacintosh&&delete E.DYLD_LIBRARY_PATH,k.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:te)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(te){var e={};function k(t){if(e[t])return e[t].exports;var w=e[t]={i:t,l:!1,exports:{}};return te[t].call(w.exports,w,w.exports,k),w.l=!0,w.exports}return k.m=te,k.c=e,k.d=function(t,w,S){k.o(t,w)||Object.defineProperty(t,w,{enumerable:!0,get:S})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,w){if(1&w&&(t=k(t)),8&w||4&w&&typeof t=="object"&&t&&t.__esModule)return t;var S=Object.create(null);if(k.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:t}),2&w&&typeof t!="string")for(var T in t)k.d(S,T,function(E){return t[E]}.bind(null,T));return S},k.n=function(t){var w=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(w,"a",w),w},k.o=function(t,w){return Object.prototype.hasOwnProperty.call(t,w)},k.p="",k(k.s=0)}([function(te,e,k){(function(t){var w;e=te.exports=U,w=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],v=e.src=[],P=0,R=P++;v[R]="0|[1-9]\\d*";var A=P++;v[A]="[0-9]+";var C=P++;v[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=P++;v[y]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var d=P++;v[d]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var b=P++;v[b]="(?:"+v[R]+"|"+v[C]+")";var f=P++;v[f]="(?:"+v[A]+"|"+v[C]+")";var m=P++;v[m]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var p=P++;v[p]="(?:-?("+v[f]+"(?:\\."+v[f]+")*))";var h=P++;v[h]="[0-9A-Za-z-]+";var a=P++;v[a]="(?:\\+("+v[h]+"(?:\\."+v[h]+")*))";var u=P++,n="v?"+v[y]+v[m]+"?"+v[a]+"?";v[u]="^"+n+"$";var l="[v=\\s]*"+v[d]+v[p]+"?"+v[a]+"?",i=P++;v[i]="^"+l+"$";var s=P++;v[s]="((?:<|>)?=?)";var r=P++;v[r]=v[A]+"|x|X|\\*";var o=P++;v[o]=v[R]+"|x|X|\\*";var c=P++;v[c]="[v=\\s]*("+v[o]+")(?:\\.("+v[o]+")(?:\\.("+v[o]+")(?:"+v[m]+")?"+v[a]+"?)?)?";var g=P++;v[g]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[p]+")?"+v[a]+"?)?)?";var I=P++;v[I]="^"+v[s]+"\\s*"+v[c]+"$";var _=P++;v[_]="^"+v[s]+"\\s*"+v[g]+"$";var z=P++;v[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=P++;v[W]="(?:~>?)";var ee=P++;v[ee]="(\\s*)"+v[W]+"\\s+",E[ee]=new RegExp(v[ee],"g");var D=P++;v[D]="^"+v[W]+v[c]+"$";var H=P++;v[H]="^"+v[W]+v[g]+"$";var F=P++;v[F]="(?:\\^)";var $=P++;v[$]="(\\s*)"+v[F]+"\\s+",E[$]=new RegExp(v[$],"g");var oe=P++;v[oe]="^"+v[F]+v[c]+"$";var K=P++;v[K]="^"+v[F]+v[g]+"$";var j=P++;v[j]="^"+v[s]+"\\s*("+l+")$|^$";var O=P++;v[O]="^"+v[s]+"\\s*("+n+")$|^$";var B=P++;v[B]="(\\s*)"+v[s]+"\\s*("+l+"|"+v[c]+")",E[B]=new RegExp(v[B],"g");var V=P++;v[V]="^\\s*("+v[c]+")\\s+-\\s+("+v[c]+")\\s*$";var J=P++;v[J]="^\\s*("+v[g]+")\\s+-\\s+("+v[g]+")\\s*$";var se=P++;v[se]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)w(me,v[me]),E[me]||(E[me]=new RegExp(v[me]));function he(fe,Ee){if(fe instanceof U)return fe;if(typeof fe!="string"||fe.length>S||!(Ee?E[i]:E[u]).test(fe))return null;try{return new U(fe,Ee)}catch{return null}}function U(fe,Ee){if(fe instanceof U){if(fe.loose===Ee)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof U))return new U(fe,Ee);w("SemVer",fe,Ee),this.loose=Ee;var ge=fe.trim().match(Ee?E[i]:E[u]);if(!ge)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var _e=+Fe;if(_e>=0&&_e<T)return _e}return Fe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=he,e.valid=function(fe,Ee){var ge=he(fe,Ee);return ge?ge.version:null},e.clean=function(fe,Ee){var ge=he(fe.trim().replace(/^[=v]+/,""),Ee);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(fe){return w("SemVer.compare",this.version,this.loose,fe),fe instanceof U||(fe=new U(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},U.prototype.compareMain=function(fe){return fe instanceof U||(fe=new U(fe,this.loose)),q(this.major,fe.major)||q(this.minor,fe.minor)||q(this.patch,fe.patch)},U.prototype.comparePre=function(fe){if(fe instanceof U||(fe=new U(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var Ee=0;do{var ge=this.prerelease[Ee],Fe=fe.prerelease[Ee];if(w("prerelease compare",Ee,ge,Fe),ge===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Fe)return q(ge,Fe)}while(++Ee)},U.prototype.inc=function(fe,Ee){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,Ee,ge,Fe){typeof ge=="string"&&(Fe=ge,ge=void 0);try{return new U(fe,ge).inc(Ee,Fe).version}catch{return null}},e.diff=function(fe,Ee){if(le(fe,Ee))return null;var ge=he(fe),Fe=he(Ee);if(ge.prerelease.length||Fe.prerelease.length){for(var _e in ge)if((_e==="major"||_e==="minor"||_e==="patch")&&ge[_e]!==Fe[_e])return"pre"+_e;return"prerelease"}for(var _e in ge)if((_e==="major"||_e==="minor"||_e==="patch")&&ge[_e]!==Fe[_e])return _e},e.compareIdentifiers=q;var N=/^[0-9]+$/;function q(fe,Ee){var ge=N.test(fe),Fe=N.test(Ee);return ge&&Fe&&(fe=+fe,Ee=+Ee),ge&&!Fe?-1:Fe&&!ge?1:fe<Ee?-1:fe>Ee?1:0}function Y(fe,Ee,ge){return new U(fe,ge).compare(new U(Ee,ge))}function ie(fe,Ee,ge){return Y(fe,Ee,ge)>0}function de(fe,Ee,ge){return Y(fe,Ee,ge)<0}function le(fe,Ee,ge){return Y(fe,Ee,ge)===0}function ue(fe,Ee,ge){return Y(fe,Ee,ge)!==0}function pe(fe,Ee,ge){return Y(fe,Ee,ge)>=0}function X(fe,Ee,ge){return Y(fe,Ee,ge)<=0}function Z(fe,Ee,ge,Fe){var _e;switch(Ee){case"===":typeof fe=="object"&&(fe=fe.version),typeof ge=="object"&&(ge=ge.version),_e=fe===ge;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof ge=="object"&&(ge=ge.version),_e=fe!==ge;break;case"":case"=":case"==":_e=le(fe,ge,Fe);break;case"!=":_e=ue(fe,ge,Fe);break;case">":_e=ie(fe,ge,Fe);break;case">=":_e=pe(fe,ge,Fe);break;case"<":_e=de(fe,ge,Fe);break;case"<=":_e=X(fe,ge,Fe);break;default:throw new TypeError("Invalid operator: "+Ee)}return _e}function G(fe,Ee){if(fe instanceof G){if(fe.loose===Ee)return fe;fe=fe.value}if(!(this instanceof G))return new G(fe,Ee);w("comparator",fe,Ee),this.loose=Ee,this.parse(fe),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(fe,Ee){return q(Ee,fe)},e.major=function(fe,Ee){return new U(fe,Ee).major},e.minor=function(fe,Ee){return new U(fe,Ee).minor},e.patch=function(fe,Ee){return new U(fe,Ee).patch},e.compare=Y,e.compareLoose=function(fe,Ee){return Y(fe,Ee,!0)},e.rcompare=function(fe,Ee,ge){return Y(Ee,fe,ge)},e.sort=function(fe,Ee){return fe.sort(function(ge,Fe){return e.compare(ge,Fe,Ee)})},e.rsort=function(fe,Ee){return fe.sort(function(ge,Fe){return e.rcompare(ge,Fe,Ee)})},e.gt=ie,e.lt=de,e.eq=le,e.neq=ue,e.gte=pe,e.lte=X,e.cmp=Z,e.Comparator=G;var Q={};function ae(fe,Ee){if(fe instanceof ae)return fe.loose===Ee?fe:new ae(fe.raw,Ee);if(fe instanceof G)return new ae(fe.value,Ee);if(!(this instanceof ae))return new ae(fe,Ee);if(this.loose=Ee,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function ve(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function ke(fe,Ee,ge,Fe,_e,qe,Be,Ge,je,Ke,re,be,Pe){return((Ee=ve(ge)?"":ve(Fe)?">="+ge+".0.0":ve(_e)?">="+ge+"."+Fe+".0":">="+Ee)+" "+(Ge=ve(je)?"":ve(Ke)?"<"+(+je+1)+".0.0":ve(re)?"<"+je+"."+(+Ke+1)+".0":be?"<="+je+"."+Ke+"."+re+"-"+be:"<="+Ge)).trim()}function Te(fe,Ee){for(var ge=0;ge<fe.length;ge++)if(!fe[ge].test(Ee))return!1;if(Ee.prerelease.length){for(ge=0;ge<fe.length;ge++)if(w(fe[ge].semver),fe[ge].semver!==Q&&fe[ge].semver.prerelease.length>0){var Fe=fe[ge].semver;if(Fe.major===Ee.major&&Fe.minor===Ee.minor&&Fe.patch===Ee.patch)return!0}return!1}return!0}function Ne(fe,Ee,ge){try{Ee=new ae(Ee,ge)}catch{return!1}return Ee.test(fe)}function Ue(fe,Ee,ge,Fe){var _e,qe,Be,Ge,je;switch(fe=new U(fe,Fe),Ee=new ae(Ee,Fe),ge){case">":_e=ie,qe=X,Be=de,Ge=">",je=">=";break;case"<":_e=de,qe=pe,Be=ie,Ge="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(fe,Ee,Fe))return!1;for(var Ke=0;Ke<Ee.set.length;++Ke){var re=Ee.set[Ke],be=null,Pe=null;if(re.forEach(function(Le){Le.semver===Q&&(Le=new G(">=0.0.0")),be=be||Le,Pe=Pe||Le,_e(Le.semver,be.semver,Fe)?be=Le:Be(Le.semver,Pe.semver,Fe)&&(Pe=Le)}),be.operator===Ge||be.operator===je||(!Pe.operator||Pe.operator===Ge)&&qe(fe,Pe.semver)||Pe.operator===je&&Be(fe,Pe.semver))return!1}return!0}G.prototype.parse=function(fe){var Ee=this.loose?E[j]:E[O],ge=fe.match(Ee);if(!ge)throw new TypeError("Invalid comparator: "+fe);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=Q},G.prototype.toString=function(){return this.value},G.prototype.test=function(fe){return w("Comparator.test",fe,this.loose),this.semver===Q||(typeof fe=="string"&&(fe=new U(fe,this.loose)),Z(fe,this.operator,this.semver,this.loose))},G.prototype.intersects=function(fe,Ee){if(!(fe instanceof G))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new ae(fe.value,Ee),Ne(this.value,ge,Ee);if(fe.operator==="")return ge=new ae(this.value,Ee),Ne(fe.semver,ge,Ee);var Fe=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),_e=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),qe=this.semver.version===fe.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),Ge=Z(this.semver,"<",fe.semver,Ee)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),je=Z(this.semver,">",fe.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return Fe||_e||qe&&Be||Ge||je},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(fe){var Ee=this.loose;fe=fe.trim(),w("range",fe,Ee);var ge=Ee?E[J]:E[V];fe=fe.replace(ge,ke),w("hyphen replace",fe),fe=fe.replace(E[B],"$1$2$3"),w("comparator trim",fe,E[B]),fe=(fe=(fe=fe.replace(E[ee],"$1~")).replace(E[$],"$1^")).split(/\s+/).join(" ");var Fe=Ee?E[j]:E[O],_e=fe.split(" ").map(function(qe){return function(Be,Ge){return w("comp",Be),Be=function(je,Ke){return je.trim().split(/\s+/).map(function(re){return function(be,Pe){w("caret",be,Pe);var Le=Pe?E[K]:E[oe];return be.replace(Le,function(ze,Me,He,Ye,Qe){var xe;return w("caret",be,ze,Me,He,Ye,Qe),ve(Me)?xe="":ve(He)?xe=">="+Me+".0.0 <"+(+Me+1)+".0.0":ve(Ye)?xe=Me==="0"?">="+Me+"."+He+".0 <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+".0 <"+(+Me+1)+".0.0":Qe?(w("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),xe=Me==="0"?He==="0"?">="+Me+"."+He+"."+Ye+Qe+" <"+Me+"."+He+"."+(+Ye+1):">="+Me+"."+He+"."+Ye+Qe+" <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+"."+Ye+Qe+" <"+(+Me+1)+".0.0"):(w("no pr"),xe=Me==="0"?He==="0"?">="+Me+"."+He+"."+Ye+" <"+Me+"."+He+"."+(+Ye+1):">="+Me+"."+He+"."+Ye+" <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+"."+Ye+" <"+(+Me+1)+".0.0"),w("caret return",xe),xe})}(re,Ke)}).join(" ")}(Be,Ge),w("caret",Be),Be=function(je,Ke){return je.trim().split(/\s+/).map(function(re){return function(be,Pe){var Le=Pe?E[H]:E[D];return be.replace(Le,function(ze,Me,He,Ye,Qe){var xe;return w("tilde",be,ze,Me,He,Ye,Qe),ve(Me)?xe="":ve(He)?xe=">="+Me+".0.0 <"+(+Me+1)+".0.0":ve(Ye)?xe=">="+Me+"."+He+".0 <"+Me+"."+(+He+1)+".0":Qe?(w("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),xe=">="+Me+"."+He+"."+Ye+Qe+" <"+Me+"."+(+He+1)+".0"):xe=">="+Me+"."+He+"."+Ye+" <"+Me+"."+(+He+1)+".0",w("tilde return",xe),xe})}(re,Ke)}).join(" ")}(Be,Ge),w("tildes",Be),Be=function(je,Ke){return w("replaceXRanges",je,Ke),je.split(/\s+/).map(function(re){return function(be,Pe){be=be.trim();var Le=Pe?E[_]:E[I];return be.replace(Le,function(ze,Me,He,Ye,Qe,xe){w("xRange",be,ze,Me,He,Ye,Qe,xe);var nt=ve(He),tt=nt||ve(Ye),ot=tt||ve(Qe);return Me==="="&&ot&&(Me=""),nt?ze=Me===">"||Me==="<"?"<0.0.0":"*":Me&&ot?(tt&&(Ye=0),ot&&(Qe=0),Me===">"?(Me=">=",tt?(He=+He+1,Ye=0,Qe=0):ot&&(Ye=+Ye+1,Qe=0)):Me==="<="&&(Me="<",tt?He=+He+1:Ye=+Ye+1),ze=Me+He+"."+Ye+"."+Qe):tt?ze=">="+He+".0.0 <"+(+He+1)+".0.0":ot&&(ze=">="+He+"."+Ye+".0 <"+He+"."+(+Ye+1)+".0"),w("xRange return",ze),ze})}(re,Ke)}).join(" ")}(Be,Ge),w("xrange",Be),Be=function(je,Ke){return w("replaceStars",je,Ke),je.trim().replace(E[se],"")}(Be,Ge),w("stars",Be),Be}(qe,Ee)}).join(" ").split(/\s+/);return this.loose&&(_e=_e.filter(function(qe){return!!qe.match(Fe)})),_e=_e.map(function(qe){return new G(qe,Ee)})},ae.prototype.intersects=function(fe,Ee){if(!(fe instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Fe){return fe.set.some(function(_e){return _e.every(function(qe){return Fe.intersects(qe,Ee)})})})})},e.toComparators=function(fe,Ee){return new ae(fe,Ee).set.map(function(ge){return ge.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new U(fe,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(Te(this.set[Ee],fe))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(fe,Ee,ge){var Fe=null,_e=null;try{var qe=new ae(Ee,ge)}catch{return null}return fe.forEach(function(Be){qe.test(Be)&&(Fe&&_e.compare(Be)!==-1||(_e=new U(Fe=Be,ge)))}),Fe},e.minSatisfying=function(fe,Ee,ge){var Fe=null,_e=null;try{var qe=new ae(Ee,ge)}catch{return null}return fe.forEach(function(Be){qe.test(Be)&&(Fe&&_e.compare(Be)!==1||(_e=new U(Fe=Be,ge)))}),Fe},e.validRange=function(fe,Ee){try{return new ae(fe,Ee).range||"*"}catch{return null}},e.ltr=function(fe,Ee,ge){return Ue(fe,Ee,"<",ge)},e.gtr=function(fe,Ee,ge){return Ue(fe,Ee,">",ge)},e.outside=Ue,e.prerelease=function(fe,Ee){var ge=he(fe,Ee);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(fe,Ee,ge){return fe=new ae(fe,ge),Ee=new ae(Ee,ge),fe.intersects(Ee)},e.coerce=function(fe){if(fe instanceof U)return fe;if(typeof fe!="string")return null;var Ee=fe.match(E[z]);return Ee==null?null:he((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,k(1))},function(te,e){var k,t,w=te.exports={};function S(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function E(f){if(k===setTimeout)return setTimeout(f,0);if((k===S||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:S}catch{k=S}try{t=typeof clearTimeout=="function"?clearTimeout:T}catch{t=T}})();var v,P=[],R=!1,A=-1;function C(){R&&v&&(R=!1,v.length?P=v.concat(P):A=-1,P.length&&y())}function y(){if(!R){var f=E(C);R=!0;for(var m=P.length;m;){for(v=P,P=[];++A<m;)v&&v[A].run();A=-1,m=P.length}v=null,R=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===T||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(f)}}function d(f,m){this.fun=f,this.array=m}function b(){}w.nextTick=function(f){var m=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)m[p-1]=arguments[p];P.push(new d(f,m)),P.length!==1||R||E(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=b,w.addListener=b,w.once=b,w.off=b,w.removeListener=b,w.removeAllListeners=b,w.emit=b,w.prependListener=b,w.prependOnceListener=b,w.listeners=function(f){return[]},w.binding=function(f){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(f){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(we[130],ye([0,1]),function(te,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,v,P){this.level=E,this.key=v,this.value=P,this.forward=[]}}const w=void 0;class S{constructor(E,v=2**16){this.comparator=E,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new t(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,w,w)}has(E){return Boolean(S._search(this,E,this.comparator))}get(E){return S._search(this,E,this.comparator)?.value}set(E,v){return S._insert(this,E,v,this.comparator)&&(this._size+=1),this}delete(E){const v=S._delete(this,E,this.comparator);return v&&(this._size-=1),v}forEach(E,v){let P=this._header.forward[0];for(;P;)E.call(v,P.value,P.key,this),P=P.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",v=this._header.forward[0];for(;v;)E+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return E}static _search(E,v,P){let R=E._header;for(let A=E._level-1;A>=0;A--)for(;R.forward[A]&&P(R.forward[A].key,v)<0;)R=R.forward[A];if(R=R.forward[0],R&&P(R.key,v)===0)return R}static _insert(E,v,P,R){let A=[],C=E._header;for(let y=E._level-1;y>=0;y--){for(;C.forward[y]&&R(C.forward[y].key,v)<0;)C=C.forward[y];A[y]=C}if(C=C.forward[0],C&&R(C.key,v)===0)return C.value=P,!1;{let y=S._randomLevel(E);if(y>E._level){for(let d=E._level;d<y;d++)A[d]=E._header;E._level=y}C=new t(y,v,P);for(let d=0;d<y;d++)C.forward[d]=A[d].forward[d],A[d].forward[d]=C;return!0}}static _randomLevel(E,v=.5){let P=1;for(;Math.random()<v&&P<E._maxLevel;)P+=1;return P}static _delete(E,v,P){let R=[],A=E._header;for(let C=E._level-1;C>=0;C--){for(;A.forward[C]&&P(A.forward[C].key,v)<0;)A=A.forward[C];R[C]=A}if(A=A.forward[0],!A||P(A.key,v)!==0)return!1;for(let C=0;C<E._level&&R[C].forward[C]===A;C++)R[C].forward[C]=A.forward[C];for(;E._level>0&&E._header.forward[E._level-1]===w;)E._level-=1;return!0}}e.SkipList=S}),define(we[131],ye([0,1,3]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class w{constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new w(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=w}),define(we[7],ye([0,1,9,77,2,128,131]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let E=!1,v=!1;var P;(function(o){o.None=()=>w.Disposable.None;function c(he){if(v){const{onListenerDidAdd:U}=he,N=d.create();let q=0;he.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),U?.()}}}function g(he){return(U,N=null,q)=>{let Y=!1,ie;return ie=he(de=>{if(!Y)return ie?ie.dispose():Y=!0,U.call(N,de)},null,q),Y&&ie.dispose(),ie}}o.once=g;function I(he,U,N){return H((q,Y=null,ie)=>he(de=>q.call(Y,U(de)),null,ie),N)}o.map=I;function _(he,U,N){return H((q,Y=null,ie)=>he(de=>{U(de),q.call(Y,de)},null,ie),N)}o.forEach=_;function z(he,U,N){return H((q,Y=null,ie)=>he(de=>U(de)&&q.call(Y,de),null,ie),N)}o.filter=z;function W(he){return he}o.signal=W;function ee(...he){return(U,N=null,q)=>(0,w.combinedDisposable)(...he.map(Y=>Y(ie=>U.call(N,ie),null,q)))}o.any=ee;function D(he,U,N,q){let Y=N;return I(he,ie=>(Y=U(Y,ie),Y),q)}o.reduce=D;function H(he,U){let N;const q={onFirstListenerAdd(){N=he(Y.fire,Y)},onLastListenerRemove(){N.dispose()}};U||c(q);const Y=new f(q);return U&&U.add(Y),Y.event}function F(he,U,N=100,q=!1,Y,ie){let de,le,ue,pe=0;const X={leakWarningThreshold:Y,onFirstListenerAdd(){de=he(G=>{pe++,le=U(le,G),q&&!ue&&(Z.fire(le),le=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Q=le;le=void 0,ue=void 0,(!q||pe>1)&&Z.fire(Q),pe=0},N)})},onLastListenerRemove(){de.dispose()}};ie||c(X);const Z=new f(X);return ie&&ie.add(Z),Z.event}o.debounce=F;function $(he,U=(q,Y)=>q===Y,N){let q=!0,Y;return z(he,ie=>{const de=q||!U(ie,Y);return q=!1,Y=ie,de},N)}o.latch=$;function oe(he,U,N){return[o.filter(he,U,N),o.filter(he,q=>!U(q),N)]}o.split=oe;function K(he,U=!1,N=[]){let q=N.slice(),Y=he(le=>{q?q.push(le):de.fire(le)});const ie=()=>{q&&q.forEach(le=>de.fire(le)),q=null},de=new f({onFirstListenerAdd(){Y||(Y=he(le=>de.fire(le)))},onFirstListenerDidAdd(){q&&(U?setTimeout(ie):ie())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return de.event}o.buffer=K;class j{constructor(U){this.event=U}map(U){return new j(I(this.event,U))}forEach(U){return new j(_(this.event,U))}filter(U){return new j(z(this.event,U))}reduce(U,N){return new j(D(this.event,U,N))}latch(){return new j($(this.event))}debounce(U,N=100,q=!1,Y){return new j(F(this.event,U,N,q,Y))}on(U,N,q){return this.event(U,N,q)}once(U,N,q){return g(this.event)(U,N,q)}}function O(he){return new j(he)}o.chain=O;function B(he,U,N=q=>q){const q=(...le)=>de.fire(N(...le)),Y=()=>he.on(U,q),ie=()=>he.removeListener(U,q),de=new f({onFirstListenerAdd:Y,onLastListenerRemove:ie});return de.event}o.fromNodeEventEmitter=B;function V(he,U,N=q=>q){const q=(...le)=>de.fire(N(...le)),Y=()=>he.addEventListener(U,q),ie=()=>he.removeEventListener(U,q),de=new f({onFirstListenerAdd:Y,onLastListenerRemove:ie});return de.event}o.fromDOMEventEmitter=V;function J(he){return new Promise(U=>g(he)(U))}o.toPromise=J;function se(he,U){return U(void 0),he(N=>U(N))}o.runAndSubscribe=se;function me(he,U){let N=null;function q(ie){N?.dispose(),N=new w.DisposableStore,U(ie,N)}q(void 0);const Y=he(ie=>q(ie));return(0,w.toDisposable)(()=>{Y.dispose(),N?.dispose()})}o.runAndSubscribeWithStore=me})(P=e.Event||(e.Event={}));class R{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${R._idPool++}`}start(c){this._stopWatch=new T.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let A=-1;function C(o){const c=A;return A=o,{dispose(){A=c}}}e.setGlobalLeakWarningThreshold=C;class y{constructor(c,g=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,g){let I=A;if(typeof this.customThreshold=="number"&&(I=this.customThreshold),I<=0||g<I)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=I*.5;let z,W=0;for(const[ee,D]of this._stacks)(!z||W<D)&&(z=ee,W=D);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${W}):`),console.warn(z)}return()=>{const z=this._stacks.get(c.value)||0;this._stacks.set(c.value,z-1)}}}class d{constructor(c){this.value=c}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,g,I){this.callback=c,this.callbackThis=g,this.stack=I,this.subscription=new w.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class f{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=A>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const g of c)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,g,I)=>{this._listeners||(this._listeners=new S.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let z,W;this._leakageMon&&this._listeners.size>=30&&(W=d.create(),z=this._leakageMon.check(W,this._listeners.size+1)),E&&(W=W??d.create());const ee=new b(c,g,W),D=this._listeners.push(ee);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,g);const H=ee.subscription.set(()=>{z&&z(),this._disposed||(D(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return I instanceof w.DisposableStore?I.add(H):Array.isArray(I)&&I.push(H),H}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(let g of this._listeners)this._deliveryQueue.push(this,g,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class m{constructor(){this._queue=new S.LinkedList}get size(){return this._queue.size}push(c,g,I){this._queue.push(new h(c,g,I))}clear(c){const g=new S.LinkedList;for(const I of this._queue)I.emitter!==c&&g.push(I);this._queue=g}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(g){(0,k.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=m;class p extends m{clear(c){this._queue.clear()}}class h{constructor(c,g,I){this.emitter=c,this.listener=g,this.event=I}}class a extends f{async fireAsync(c,g,I){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,c]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[_,z]=this._asyncDeliveryQueue.shift(),W=[],ee={...z,token:g,waitUntil:D=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");I&&(D=I(D,_.callback)),W.push(D)}};try{_.invoke(ee)}catch(D){(0,k.onUnexpectedError)(D);continue}Object.freeze(W),await Promise.allSettled(W).then(D=>{for(const H of D)H.status==="rejected"&&(0,k.onUnexpectedError)(H.reason)})}}}}e.AsyncEmitter=a;class u extends f{constructor(c){super(c);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=u;class n extends u{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=n;class l extends f{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const g={event:c,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const I=()=>{this.hasListeners&&this.unhook(g);const _=this.events.indexOf(g);this.events.splice(_,1)};return(0,w.toDisposable)((0,t.once)(I))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(g=>this.emitter.fire(g))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(c){return(g,I,_)=>c(z=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>g.call(I,z)):g.call(I,z)},void 0,_)}bufferEvents(c){const g=[];this.buffers.push(g);const I=c();return this.buffers.pop(),g.forEach(_=>_()),I}}e.EventBufferer=s;class r{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=w.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(we[21],ye([0,1,7]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,v){const P=setTimeout(E.bind(v),0);return{dispose(){clearTimeout(P)}}});var w;(function(E){function v(P){return P===E.None||P===E.Cancelled||P instanceof S?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}E.isCancellationToken=v,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(w=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=w.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=T}),define(we[132],ye([0,1,21]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new k.CancellationTokenSource,v=this.task(E.token);return this.result={promise:v,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class w{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const v=JSON.stringify(E);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=w;class S{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const v=this.fn(E);return this._map.set(E,v),v}}e.CachedFunction=S}),define(we[78],ye([0,1,7,2]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const w=T=>({onDidChange:k.Event.None,value:T});e.staticObservableValue=w;class S extends t.Disposable{constructor(E){super();this._value=E,this.changeEmitter=this._register(new k.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=S}),define(we[43],ye([0,1,9,2]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(a){const u=a;return u?typeof u.read=="function":!1}e.isReadable=w;function S(a){const u=a;return u?[u.on,u.pause,u.resume,u.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=S;function T(a){const u=a;return u?S(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function E(a,u){return new v(a,u)}e.newWriteableStream=E;class v{constructor(u,n){this.reducer=u,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(n=>n(u))}emitError(u){this.listeners.error.length===0?(0,k.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(n=>n(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,n){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(u,n){if(this.state.destroyed)return;let l;switch(u){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(n);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(a,u){const n=[];let l;for(;(l=a.read())!==null;)n.push(l);return u(n)}e.consumeReadable=P;function R(a,u,n){const l=[];let i;for(;(i=a.read())!==null&&l.length<n;)l.push(i);return i===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return a.read()}}}e.peekReadable=R;function A(a,u){return new Promise((n,l)=>{const i=[];C(a,{onData:s=>{u&&i.push(s)},onError:s=>{u?l(s):n(void 0)},onEnd:()=>{n(u?u(i):void 0)}})})}e.consumeStream=A;function C(a,u){let n=!1;return a.on("error",l=>{n||u.onError(l)}),a.on("end",()=>{n||u.onEnd()}),a.on("data",l=>{n||u.onData(l)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=C;function y(a,u){return new Promise((n,l)=>{const i=new t.DisposableStore,s=[],r=g=>{if(s.push(g),s.length>u)return i.dispose(),a.pause(),n({stream:a,buffer:s,ended:!1})},o=g=>l(g),c=()=>n({stream:a,buffer:s,ended:!0});i.add((0,t.toDisposable)(()=>a.removeListener("error",o))),a.on("error",o),i.add((0,t.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),i.add((0,t.toDisposable)(()=>a.removeListener("data",r))),a.on("data",r)})}e.peekStream=y;function d(a,u){const n=E(u);return n.end(a),n}e.toStream=d;function b(){const a=E(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=b;function f(a){let u=!1;return{read:()=>u?null:(u=!0,a)}}e.toReadable=f;function m(a,u,n){const l=E(n);return C(a,{onData:i=>l.write(u.data(i)),onError:i=>l.error(u.error?u.error(i):i),onEnd:()=>l.end()}),l}e.transform=m;function p(a,u,n){let l=!1;return{read:()=>{const i=u.read();return l?i:(l=!0,i!==null?n([a,i]):a)}}}e.prefixedReadable=p;function h(a,u,n){let l=!1;const i=E(n);return C(u,{onData:s=>l?i.write(s):(l=!0,i.write(n([a,s]))),onError:s=>i.error(s),onEnd:()=>{l||(l=!0,i.write(a)),i.end()}}),i}e.prefixedStream=h}),define(we[16],ye([0,1,43]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let w,S;class T{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return t?new T(Buffer.allocUnsafe(g)):new T(new Uint8Array(g))}static wrap(g){return t&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new T(g)}static fromString(g,I){return!(I?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(g)):(w||(w=new TextEncoder),new T(w.encode(g)))}static fromByteArray(g){const I=T.alloc(g.length);for(let _=0,z=g.length;_<z;_++)I.buffer[_]=g[_];return I}static concat(g,I){if(typeof I=="undefined"){I=0;for(let W=0,ee=g.length;W<ee;W++)I+=g[W].byteLength}const _=T.alloc(I);let z=0;for(let W=0,ee=g.length;W<ee;W++){const D=g[W];_.set(D,z),z+=D.byteLength}return _}clone(){const g=T.alloc(this.byteLength);return g.set(this),g}toString(){return t?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(g,I){return new T(this.buffer.subarray(g,I))}set(g,I){if(g instanceof T)this.buffer.set(g.buffer,I);else if(g instanceof Uint8Array)this.buffer.set(g,I);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),I);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return P(this.buffer,g)}writeUInt32BE(g,I){R(this.buffer,g,I)}readUInt32LE(g){return A(this.buffer,g)}writeUInt32LE(g,I){C(this.buffer,g,I)}readUInt8(g){return y(this.buffer,g)}writeUInt8(g,I){d(this.buffer,g,I)}}e.VSBuffer=T;function E(c,g){return c[g+0]<<0>>>0|c[g+1]<<8>>>0}e.readUInt16LE=E;function v(c,g,I){c[I+0]=g&255,g=g>>>8,c[I+1]=g&255}e.writeUInt16LE=v;function P(c,g){return c[g]*2**24+c[g+1]*2**16+c[g+2]*2**8+c[g+3]}e.readUInt32BE=P;function R(c,g,I){c[I+3]=g,g=g>>>8,c[I+2]=g,g=g>>>8,c[I+1]=g,g=g>>>8,c[I]=g}e.writeUInt32BE=R;function A(c,g){return c[g+0]<<0>>>0|c[g+1]<<8>>>0|c[g+2]<<16>>>0|c[g+3]<<24>>>0}e.readUInt32LE=A;function C(c,g,I){c[I+0]=g&255,g=g>>>8,c[I+1]=g&255,g=g>>>8,c[I+2]=g&255,g=g>>>8,c[I+3]=g&255}e.writeUInt32LE=C;function y(c,g){return c[g]}e.readUInt8=y;function d(c,g,I){c[I]=g}e.writeUInt8=d;function b(c){return k.consumeReadable(c,g=>T.concat(g))}e.readableToBuffer=b;function f(c){return k.toReadable(c)}e.bufferToReadable=f;function m(c){return k.consumeStream(c,g=>T.concat(g))}e.streamToBuffer=m;async function p(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await m(c.stream)])}e.bufferedStreamToBuffer=p;function h(c){return k.toStream(c,g=>T.concat(g))}e.bufferToStream=h;function a(c){return k.transform(c,{data:g=>typeof g=="string"?T.fromString(g):T.wrap(g)},g=>T.concat(g))}e.streamToBufferReadableStream=a;function u(c){return k.newWriteableStream(g=>T.concat(g),c)}e.newWriteableBufferStream=u;function n(c,g){return k.prefixedReadable(c,g,I=>T.concat(I))}e.prefixedBufferReadable=n;function l(c,g){return k.prefixedStream(c,g,I=>T.concat(I))}e.prefixedBufferStream=l;function i(c){let g=0,I=0,_=0;const z=new Uint8Array(Math.floor(c.length/4*3)),W=D=>{switch(I){case 3:z[_++]=g|D,I=0;break;case 2:z[_++]=g|D>>>2,g=D<<6,I=3;break;case 1:z[_++]=g|D>>>4,g=D<<4,I=2;break;default:g=D<<2,I=1}};for(let D=0;D<c.length;D++){const H=c.charCodeAt(D);if(H>=65&&H<=90)W(H-65);else if(H>=97&&H<=122)W(H-97+26);else if(H>=48&&H<=57)W(H-48+52);else if(H===43||H===45)W(62);else if(H===47||H===95)W(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${c[D]}`)}}const ee=_;for(;I>0;)W(0);return T.wrap(z).slice(0,ee)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},g=!0,I=!1){const _=I?r:s;let z="";const W=c.byteLength%3;let ee=0;for(;ee<c.byteLength-W;ee+=3){const D=c[ee+0],H=c[ee+1],F=c[ee+2];z+=_[D>>>2],z+=_[(D<<4|H>>>4)&63],z+=_[(H<<2|F>>>6)&63],z+=_[F&63]}if(W===1){const D=c[ee+0];z+=_[D>>>2],z+=_[D<<4&63],g&&(z+="==")}else if(W===2){const D=c[ee+0],H=c[ee+1];z+=_[D>>>2],z+=_[(D<<4|H>>>4)&63],z+=_[H<<2&63],g&&(z+="=")}return z}e.encodeBase64=o}),define(we[15],ye([0,1,132,127]),function(te,e,k,t){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=S;const T=/{(\d+)}/g;function E(re,...be){return be.length===0?re:re.replace(T,function(Pe,Le){const ze=parseInt(Le,10);return isNaN(ze)||ze<0||ze>=be.length?Pe:be[ze]})}e.format=E;const v=/{([^}]+)}/g;function P(re,be){return re.replace(v,(Pe,Le)=>be[Le]??Pe)}e.format2=P;function R(re){return re.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=R;function A(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function C(re,be){let Pe=0;const Le=be.charCodeAt(0);for(let ze=re.length-1;ze>=0;ze--)re.charCodeAt(ze)===Le&&Pe++;return Pe}e.count=C;function y(re,be,Pe="\u2026"){return re.length<=be?re:`${re.substr(0,be)}${Pe}`}e.truncate=y;function d(re,be=" "){const Pe=b(re,be);return f(Pe,be)}e.trim=d;function b(re,be){if(!re||!be)return re;const Pe=be.length;if(Pe===0||re.length===0)return re;let Le=0;for(;re.indexOf(be,Le)===Le;)Le=Le+Pe;return re.substring(Le)}e.ltrim=b;function f(re,be){if(!re||!be)return re;const Pe=be.length,Le=re.length;if(Pe===0||Le===0)return re;let ze=Le,Me=-1;for(;Me=re.lastIndexOf(be,ze-1),!(Me===-1||Me+Pe!==ze);){if(Me===0)return"";ze=Me}return re.substring(0,ze)}e.rtrim=f;function m(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function p(re){return re.replace(/\*/g,"")}e.stripWildcards=p;function h(re,be,Pe={}){if(!re)throw new Error("Cannot create regex from empty string");be||(re=A(re)),Pe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Le="";return Pe.global&&(Le+="g"),Pe.matchCase||(Le+="i"),Pe.multiline&&(Le+="m"),Pe.unicode&&(Le+="u"),new RegExp(re,Le)}e.createRegExp=h;function a(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function u(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function n(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=n;function l(re){return re.split(/\r\n|\r|\n/)}e.splitLines=l;function i(re){for(let be=0,Pe=re.length;be<Pe;be++){const Le=re.charCodeAt(be);if(Le!==32&&Le!==9)return be}return-1}e.firstNonWhitespaceIndex=i;function s(re,be=0,Pe=re.length){for(let Le=be;Le<Pe;Le++){const ze=re.charCodeAt(Le);if(ze!==32&&ze!==9)return re.substring(be,Le)}return re.substring(be,Pe)}e.getLeadingWhitespace=s;function r(re,be=re.length-1){for(let Pe=be;Pe>=0;Pe--){const Le=re.charCodeAt(Pe);if(Le!==32&&Le!==9)return Pe}return-1}e.lastNonWhitespaceIndex=r;function o(re,be,Pe){let Le=[],ze=0;for(const Me of re.matchAll(be)){if(Le.push(re.slice(ze,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");ze=Me.index+Me[0].length,Le.push(Pe(Me[0],...Me.slice(1),Me.index,re,Me.groups))}return Le.push(re.slice(ze)),Promise.all(Le).then(Me=>Me.join(""))}e.replaceAsync=o;function c(re,be){return re<be?-1:re>be?1:0}e.compare=c;function g(re,be,Pe=0,Le=re.length,ze=0,Me=be.length){for(;Pe<Le&&ze<Me;Pe++,ze++){let Qe=re.charCodeAt(Pe),xe=be.charCodeAt(ze);if(Qe<xe)return-1;if(Qe>xe)return 1}const He=Le-Pe,Ye=Me-ze;return He<Ye?-1:He>Ye?1:0}e.compareSubstring=g;function I(re,be){return _(re,be,0,re.length,0,be.length)}e.compareIgnoreCase=I;function _(re,be,Pe=0,Le=re.length,ze=0,Me=be.length){for(;Pe<Le&&ze<Me;Pe++,ze++){let Qe=re.charCodeAt(Pe),xe=be.charCodeAt(ze);if(Qe===xe)continue;if(Qe>=128||xe>=128)return g(re.toLowerCase(),be.toLowerCase(),Pe,Le,ze,Me);z(Qe)&&(Qe-=32),z(xe)&&(xe-=32);const nt=Qe-xe;if(nt!==0)return nt}const He=Le-Pe,Ye=Me-ze;return He<Ye?-1:He>Ye?1:0}e.compareSubstringIgnoreCase=_;function z(re){return re>=97&&re<=122}e.isLowerAsciiLetter=z;function W(re){return re>=65&&re<=90}e.isUpperAsciiLetter=W;function ee(re,be){return re.length===be.length&&_(re,be)===0}e.equalsIgnoreCase=ee;function D(re,be){const Pe=be.length;return be.length>re.length?!1:_(re,be,0,Pe)===0}e.startsWithIgnoreCase=D;function H(re,be){let Pe,Le=Math.min(re.length,be.length);for(Pe=0;Pe<Le;Pe++)if(re.charCodeAt(Pe)!==be.charCodeAt(Pe))return Pe;return Le}e.commonPrefixLength=H;function F(re,be){let Pe,Le=Math.min(re.length,be.length);const ze=re.length-1,Me=be.length-1;for(Pe=0;Pe<Le;Pe++)if(re.charCodeAt(ze-Pe)!==be.charCodeAt(Me-Pe))return Pe;return Le}e.commonSuffixLength=F;function $(re){return 55296<=re&&re<=56319}e.isHighSurrogate=$;function oe(re){return 56320<=re&&re<=57343}e.isLowSurrogate=oe;function K(re,be){return(re-55296<<10)+(be-56320)+65536}e.computeCodePoint=K;function j(re,be,Pe){const Le=re.charCodeAt(Pe);if($(Le)&&Pe+1<be){const ze=re.charCodeAt(Pe+1);if(oe(ze))return K(Le,ze)}return Le}e.getNextCodePoint=j;function O(re,be){const Pe=re.charCodeAt(be-1);if(oe(Pe)&&be>1){const Le=re.charCodeAt(be-2);if($(Le))return K(Le,Pe)}return Pe}class B{constructor(be,Pe=0){this._str=be,this._len=be.length,this._offset=Pe}get offset(){return this._offset}setOffset(be){this._offset=be}prevCodePoint(){const be=O(this._str,this._offset);return this._offset-=be>=65536?2:1,be}nextCodePoint(){const be=j(this._str,this._len,this._offset);return this._offset+=be>=65536?2:1,be}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class V{constructor(be,Pe=0){this._iterator=new B(be,Pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const be=ge.getInstance(),Pe=this._iterator,Le=Pe.offset;let ze=be.getGraphemeBreakType(Pe.nextCodePoint());for(;!Pe.eol();){const Me=Pe.offset,He=be.getGraphemeBreakType(Pe.nextCodePoint());if(fe(ze,He)){Pe.setOffset(Me);break}ze=He}return Pe.offset-Le}prevGraphemeLength(){const be=ge.getInstance(),Pe=this._iterator,Le=Pe.offset;let ze=be.getGraphemeBreakType(Pe.prevCodePoint());for(;Pe.offset>0;){const Me=Pe.offset,He=be.getGraphemeBreakType(Pe.prevCodePoint());if(fe(He,ze)){Pe.setOffset(Me);break}ze=He}return Le-Pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function J(re,be){return new V(re,be).nextGraphemeLength()}e.nextCharLength=J;function se(re,be){return new V(re,be).prevGraphemeLength()}e.prevCharLength=se;function me(re,be){be>0&&oe(re.charCodeAt(be))&&be--;const Pe=be+J(re,be);return[Pe-se(re,Pe),Pe]}e.getCharContainingOffset=me;const he=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(re){return he.test(re)}e.containsRTL=U;const N=/^[\t\n\r\x20-\x7E]*$/;function q(re){return N.test(re)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=Y;function ie(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=ie;function de(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=de;function le(re,be){if(re.length<be)return re;const Pe=/\b/g;let Le=0;for(;Pe.test(re)&&!(re.length-Pe.lastIndex<be);)Le=Pe.lastIndex,Pe.lastIndex+=1;return re.substring(Le).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function Z(re){return re&&(re=re.replace(ue,""),re=re.replace(pe,""),re=re.replace(X,"")),re}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(re){return G(re)?re.substr(1):re}e.stripUTF8BOM=Q;function ae(re,be){if(!re||!be||re.length<be.length)return!1;const Pe=be.length,Le=re.toLowerCase();let ze=0,Me=-1;for(;ze<Pe;){const He=Le.indexOf(be[ze],Me+1);if(He<0)return!1;Me=He,ze++}return!0}e.fuzzyContains=ae;function ve(re,be=!1){return re?(be&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=ve;function ke(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=ke;function Te(re,be=1){if(be===0)return"";let Pe=-1;do Pe=re.indexOf(`
`,Pe+1),be--;while(be>0&&Pe>=0);return Pe===-1?re:(re[Pe-1]==="\r"&&Pe--,re.substr(0,Pe))}e.getNLines=Te;function Ne(re){const be=90-65+1;return re=re%(2*be),re<be?String.fromCharCode(97+re):String.fromCharCode(65+re-be)}e.singleLetterHash=Ne;function Ue(re){return ge.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=Ue;function fe(re,be){return re===0?be!==5&&be!==7:re===2&&be===3?!1:re===4||re===2||re===3||be===4||be===2||be===3?!0:!(re===8&&(be===8||be===9||be===11||be===12)||(re===11||re===9)&&(be===9||be===10)||(re===12||re===10)&&be===10||be===5||be===13||be===7||re===1||re===13&&be===14||re===6&&be===6)}var Ee;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ee=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=Fe()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const Pe=this._data,Le=Pe.length/3;let ze=1;for(;ze<=Le;)if(be<Pe[3*ze])ze=2*ze;else if(be>Pe[3*ze+1])ze=2*ze+1;else return Pe[3*ze+2];return 0}}ge._INSTANCE=null;function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function _e(re,be){if(re===0)return 0;const Pe=qe(re,be);if(Pe!==void 0)return Pe;const Le=new B(be,re);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=_e;function qe(re,be){const Pe=new B(be,re);let Le=Pe.prevCodePoint();for(;Be(Le)||Le===65039||Le===8419;){if(Pe.offset===0)return;Le=Pe.prevCodePoint()}if(!de(Le))return;let ze=Pe.offset;return ze>0&&Pe.prevCodePoint()===8205&&(ze=Pe.offset),ze}function Be(re){return 127995<=re&&re<=127999}var Ge;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class je{constructor(be){this.confusableDictionary=be}static getInstance(be){return je.cache.get(Array.from(be))}static getLocales(){return je._locales.getValue()}isAmbiguous(be){return this.confusableDictionary.has(be)}getPrimaryConfusable(be){return this.confusableDictionary.get(be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,w=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new k.LRUCachedFunction(re=>{function be(xe){const nt=new Map;for(let tt=0;tt<xe.length;tt+=2)nt.set(xe[tt],xe[tt+1]);return nt}function Pe(xe,nt){const tt=new Map(xe);for(const[ot,pt]of nt)tt.set(ot,pt);return tt}function Le(xe,nt){if(!xe)return nt;const tt=new Map;for(const[ot,pt]of xe)nt.has(ot)&&tt.set(ot,pt);return tt}const ze=w.ambiguousCharacterData.getValue();let Me=re.filter(xe=>!xe.startsWith("_")&&xe in ze);Me.length===0&&(Me=["_default"]);let He;for(const xe of Me){const nt=be(ze[xe]);He=Le(He,nt)}const Ye=be(ze._common),Qe=Pe(Ye,He);return new je(Qe)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class Ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ke.getRawData())),this._data}static isInvisibleCharacter(be){return Ke.getData().has(be)}static get codePoints(){return Ke.getData()}}e.InvisibleCharacters=Ke,Ke._data=void 0}),define(we[133],ye([0,1,15]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return w(m,0)}e.hash=t;function w(m,p){switch(typeof m){case"object":return m===null?S(349,p):Array.isArray(m)?v(m,p):P(m,p);case"string":return E(m,p);case"boolean":return T(m,p);case"number":return S(m,p);case"undefined":return S(937,p);default:return S(617,p)}}e.doHash=w;function S(m,p){return(p<<5)-p+m|0}e.numberHash=S;function T(m,p){return S(m?433:863,p)}function E(m,p){p=S(149417,p);for(let h=0,a=m.length;h<a;h++)p=S(m.charCodeAt(h),p);return p}e.stringHash=E;function v(m,p){return p=S(104579,p),m.reduce((h,a)=>w(a,h),p)}function P(m,p){return p=S(181387,p),Object.keys(m).sort().reduce((h,a)=>(h=E(a,h),w(m[a],h)),p)}class R{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=w(p,this._value),this._value}}e.Hasher=R;var A;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function C(m,p,h=32){const a=h-p,u=~((1<<a)-1);return(m<<p|(u&m)>>>a)>>>0}function y(m,p=0,h=m.byteLength,a=0){for(let u=0;u<h;u++)m[p+u]=a}function d(m,p,h="0"){for(;m.length<p;)m=h+m;return m}function b(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),p/4)}e.toHexString=b;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const h=p.length;if(h===0)return;const a=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,l,i;for(n!==0?(l=n,i=-1,n=0):(l=p.charCodeAt(0),i=0);;){let s=l;if(k.isHighSurrogate(l))if(i+1<h){const r=p.charCodeAt(i+1);k.isLowSurrogate(r)?(i++,s=k.computeCodePoint(l,r)):s=65533}else{n=l;break}else k.isLowSurrogate(l)&&(s=65533);if(u=this._push(a,u,s),i++,i<h)l=p.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(p,h,a){return a<128?p[h++]=a:a<2048?(p[h++]=192|(a&1984)>>>6,p[h++]=128|(a&63)>>>0):a<65536?(p[h++]=224|(a&61440)>>>12,p[h++]=128|(a&4032)>>>6,p[h++]=128|(a&63)>>>0):(p[h++]=240|(a&1835008)>>>18,p[h++]=128|(a&258048)>>>12,p[h++]=128|(a&4032)>>>6,p[h++]=128|(a&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=f._bigBlock32,h=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,h.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,C(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let a=this._h0,u=this._h1,n=this._h2,l=this._h3,i=this._h4,s,r,o;for(let c=0;c<80;c++)c<20?(s=u&n|~u&l,r=1518500249):c<40?(s=u^n^l,r=1859775393):c<60?(s=u&n|u&l|n&l,r=2400959708):(s=u^n^l,r=3395469782),o=C(a,5)+s+i+r+p.getUint32(c*4,!1)&4294967295,i=l,l=n,n=C(u,30),u=a,a=o;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(te,e,k,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(te,k):w?w.value=k:e.set(te,k),k},et=this&&this.__classPrivateFieldGet||function(te,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(te):t?t.value:e.get(te)};define(we[29],ye([0,1,18,15]),function(te,e,k,t){"use strict";var w,S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function v(r,o,c){let g=r.get(o);return g===void 0&&(g=c,r.set(o,g)),g}e.getOrSet=v;function P(r){const o=[];return r.forEach((c,g)=>{o.push(`${g} => ${c}`)}),`Map(${r.size}) {${o.join(", ")}}`}e.mapToString=P;function R(r){const o=[];return r.forEach(c=>{o.push(c)}),`Set(${r.size}) {${o.join(", ")}}`}e.setToString=R;class A{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const c=o.charCodeAt(0),g=this._value.charCodeAt(this._pos);return c-g}value(){return this._value[this._pos]}}e.StringIterator=A;class C{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,t.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class y{constructor(o=!0,c=!0){this._splitOnBackslash=o,this._caseSensitive=c}reset(o){this._from=0,this._to=0,this._value=o,this._valueLen=o.length;for(let c=o.length-1;c>=0;c--,this._valueLen--){const g=this._value.charCodeAt(c);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let o=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,t.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(d||(d={}));class b{constructor(o,c){this._ignorePathCasing=o,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(o)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,t.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(m||(m={}));class p{constructor(o){this._iter=o}static forUris(o=()=>!1,c=()=>!1){return new p(new b(o,c))}static forPaths(o=!1){return new p(new y(void 0,!o))}static forStrings(){return new p(new A)}static forConfigKeys(){return new p(new C)}clear(){this._root=void 0}fill(o,c){if(c){const g=c.slice(0);(0,k.shuffle)(g);for(let I of g)this.set(I,o)}else{const g=o.slice(0);(0,k.shuffle)(g);for(let I of g)this.set(I[0],I[1])}}set(o,c){const g=this._iter.reset(o);let I;this._root||(this._root=new f,this._root.segment=g.value());const _=[];for(I=this._root;;){const W=g.cmp(I.segment);if(W>0)I.left||(I.left=new f,I.left.segment=g.value()),_.push([-1,I]),I=I.left;else if(W<0)I.right||(I.right=new f,I.right.segment=g.value()),_.push([1,I]),I=I.right;else if(g.hasNext())g.next(),I.mid||(I.mid=new f,I.mid.segment=g.value()),_.push([0,I]),I=I.mid;else break}const z=I.value;I.value=c,I.key=o;for(let W=_.length-1;W>=0;W--){const ee=_[W][1];ee.updateHeight();const D=ee.balanceFactor();if(D<-1||D>1){const H=_[W][0],F=_[W+1][0];if(H===1&&F===1)_[W][1]=ee.rotateLeft();else if(H===-1&&F===-1)_[W][1]=ee.rotateRight();else if(H===1&&F===-1)ee.right=_[W+1][1]=_[W+1][1].rotateRight(),_[W][1]=ee.rotateLeft();else if(H===-1&&F===1)ee.left=_[W+1][1]=_[W+1][1].rotateLeft(),_[W][1]=ee.rotateRight();else throw new Error;if(W>0)switch(_[W-1][0]){case-1:_[W-1][1].left=_[W][1];break;case 1:_[W-1][1].right=_[W][1];break;case 0:_[W-1][1].mid=_[W][1];break}else this._root=_[0][1]}}return z}get(o){return this._getNode(o)?.value}_getNode(o){const c=this._iter.reset(o);let g=this._root;for(;g;){const I=c.cmp(g.segment);if(I>0)g=g.left;else if(I<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(o){const c=this._getNode(o);return!(c?.value===void 0&&c?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,c){const g=this._iter.reset(o),I=[];let _=this._root;for(;_;){const z=g.cmp(_.segment);if(z>0)I.push([-1,_]),_=_.left;else if(z<0)I.push([1,_]),_=_.right;else if(g.hasNext())g.next(),I.push([0,_]),_=_.mid;else break}if(!!_){if(c?(_.left=void 0,_.mid=void 0,_.right=void 0,_.height=1):(_.key=void 0,_.value=void 0),!_.mid&&!_.value)if(_.left&&_.right){const z=this._min(_.right),{key:W,value:ee,segment:D}=z;this._delete(z.key,!1),_.key=W,_.value=ee,_.segment=D}else{const z=_.left??_.right;if(I.length>0){const[W,ee]=I[I.length-1];switch(W){case-1:ee.left=z;break;case 0:ee.mid=z;break;case 1:ee.right=z;break}}else this._root=z}for(let z=I.length-1;z>=0;z--){const W=I[z][1];W.updateHeight();const ee=W.balanceFactor();if(ee>1?(W.right.balanceFactor()>=0||(W.right=W.right.rotateRight()),I[z][1]=W.rotateLeft()):ee<-1&&(W.left.balanceFactor()<=0||(W.left=W.left.rotateLeft()),I[z][1]=W.rotateRight()),z>0)switch(I[z-1][0]){case-1:I[z-1][1].left=I[z][1];break;case 1:I[z-1][1].right=I[z][1];break;case 0:I[z-1][1].mid=I[z][1];break}else this._root=I[0][1]}}}_min(o){for(;o.left;)o=o.left;return o}findSubstr(o){const c=this._iter.reset(o);let g=this._root,I;for(;g;){const _=c.cmp(g.segment);if(_>0)g=g.left;else if(_<0)g=g.right;else if(c.hasNext())c.next(),I=g.value||I,g=g.mid;else break}return g&&g.value||I}findSuperstr(o){const c=this._iter.reset(o);let g=this._root;for(;g;){const I=c.cmp(g.segment);if(I>0)g=g.left;else if(I<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(o){for(const[c,g]of this)o(g,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){!o||(o.left&&(yield*this._entries(o.left)),o.value&&(yield[o.key,o.value]),o.mid&&(yield*this._entries(o.mid)),o.right&&(yield*this._entries(o.right)))}_isBalanced(){const o=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:o(c.left)&&o(c.right)};return o(this._root)}}e.TernarySearchTree=p;class h{constructor(o,c){this.uri=o,this.value=c}}class a{constructor(o,c){this[w]="ResourceMap",o instanceof a?(this.map=new Map(o.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=o??a.defaultToKey)}set(o,c){return this.map.set(this.toKey(o),new h(o,c)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,c){typeof c!="undefined"&&(o=o.bind(c));for(let[g,I]of this.map)o(I.value,I.uri,this)}*values(){for(let o of this.map.values())yield o.value}*keys(){for(let o of this.map.values())yield o.uri}*entries(){for(let o of this.map.values())yield[o.uri,o.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=a,a.defaultToKey=r=>r.toString();class u{constructor(o,c){this[S]="ResourceSet",!o||typeof o=="function"?this._map=new a(o):(this._map=new a(c),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,c){this._map.forEach((g,I)=>o.call(c,I,I,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var n;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,c=0){const g=this._map.get(o);if(!!g)return c!==0&&this.touch(g,c),g.value}set(o,c,g=0){let I=this._map.get(o);if(I)I.value=c,g!==0&&this.touch(I,g);else{switch(I={key:o,value:c,next:void 0,previous:void 0},g){case 0:this.addItemLast(I);break;case 1:this.addItemFirst(I);break;case 2:this.addItemLast(I);break;default:this.addItemLast(I);break}this._map.set(o,I),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const c=this._map.get(o);if(!!c)return this._map.delete(o),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,c){const g=this._state;let I=this._head;for(;I;){if(c?o.bind(c)(I.value,I.key,this):o(I.value,I.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");I=I.next}}keys(){const o=this,c=this._state;let g=this._head;const I={[Symbol.iterator](){return I},next(){if(o._state!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const _={value:g.key,done:!1};return g=g.next,_}else return{value:void 0,done:!0}}};return I}values(){const o=this,c=this._state;let g=this._head;const I={[Symbol.iterator](){return I},next(){if(o._state!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const _={value:g.value,done:!1};return g=g.next,_}else return{value:void 0,done:!0}}};return I}entries(){const o=this,c=this._state;let g=this._head;const I={[Symbol.iterator](){return I},next(){if(o._state!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const _={value:[g.key,g.value],done:!1};return g=g.next,_}else return{value:void 0,done:!0}}};return I}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let c=this._head,g=this.size;for(;c&&g>o;)this._map.delete(c.key),c=c.next,g--;this._head=c,this._size=g,c&&(c.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const c=o.next,g=o.previous;if(!c||!g)throw new Error("Invalid list");c.previous=g,g.next=c}o.next=void 0,o.previous=void 0,this._state++}touch(o,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(o===this._head)return;const g=o.next,I=o.previous;o===this._tail?(I.next=void 0,this._tail=I):(g.previous=I,I.next=g),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(c===2){if(o===this._tail)return;const g=o.next,I=o.previous;o===this._head?(g.previous=void 0,this._head=g):(g.previous=I,I.next=g),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((c,g)=>{o.push([g,c])}),o}fromJSON(o){this.clear();for(const[c,g]of o)this.set(c,g)}}e.LinkedMap=l;class i extends l{constructor(o,c=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,c=2){return super.get(o,c)}peek(o){return super.get(o,0)}set(o,c){return super.set(o,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(o){E.set(this,void 0),Et(this,E,o,"f")}get size(){return et(this,E,"f").size}forEach(o,c){et(this,E,"f").forEach(o,c)}get(o){return et(this,E,"f").get(o)}has(o){return et(this,E,"f").has(o)}entries(){return et(this,E,"f").entries()}keys(){return et(this,E,"f").keys()}values(){return et(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return et(this,E,"f").entries()}}e.ReadonlyMapView=s}),define(we[134],ye([0,1,29,15]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...G){return function(Q,ae){for(let ve=0,ke=G.length;ve<ke;ve++){const Te=G[ve](Q,ae);if(Te)return Te}return null}}e.or=w,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(G,Q,ae){if(!ae||ae.length<Q.length)return null;let ve;return G?ve=t.startsWithIgnoreCase(ae,Q):ve=ae.indexOf(Q)===0,ve?Q.length>0?[{start:0,end:Q.length}]:[]:null}function T(G,Q){const ae=Q.toLowerCase().indexOf(G.toLowerCase());return ae===-1?null:[{start:ae,end:ae+G.length}]}e.matchesContiguousSubString=T;function E(G,Q){return v(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=E;function v(G,Q,ae,ve){if(ae===G.length)return[];if(ve===Q.length)return null;if(G[ae]===Q[ve]){let ke=null;return(ke=v(G,Q,ae+1,ve+1))?m({start:ve,end:ve+1},ke):null}return v(G,Q,ae,ve+1)}function P(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function A(G){return 48<=G&&G<=57}function C(G){return G===32||G===9||G===10||G===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>y.add(G.charCodeAt(0)));function d(G){return C(G)||y.has(G)}function b(G,Q){return G===Q||d(G)&&d(Q)}function f(G){return P(G)||R(G)||A(G)}function m(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function p(G,Q){for(let ae=Q;ae<G.length;ae++){const ve=G.charCodeAt(ae);if(R(ve)||A(ve)||ae>0&&!f(G.charCodeAt(ae-1)))return ae}return G.length}function h(G,Q,ae,ve){if(ae===G.length)return[];if(ve===Q.length)return null;if(G[ae]!==Q[ve].toLowerCase())return null;{let ke=null,Te=ve+1;for(ke=h(G,Q,ae+1,ve+1);!ke&&(Te=p(Q,Te))<Q.length;)ke=h(G,Q,ae+1,Te),Te++;return ke===null?null:m({start:ve,end:ve+1},ke)}}function a(G){let Q=0,ae=0,ve=0,ke=0,Te=0;for(let ge=0;ge<G.length;ge++)Te=G.charCodeAt(ge),R(Te)&&Q++,P(Te)&&ae++,f(Te)&&ve++,A(Te)&&ke++;const Ne=Q/G.length,Ue=ae/G.length,fe=ve/G.length,Ee=ke/G.length;return{upperPercent:Ne,lowerPercent:Ue,alphaPercent:fe,numericPercent:Ee}}function u(G){const{upperPercent:Q,lowerPercent:ae}=G;return ae===0&&Q>.6}function n(G){const{upperPercent:Q,lowerPercent:ae,alphaPercent:ve,numericPercent:ke}=G;return ae>.2&&Q<.8&&ve>.6&&ke<.2}function l(G){let Q=0,ae=0,ve=0,ke=0;for(let Te=0;Te<G.length;Te++)ve=G.charCodeAt(Te),R(ve)&&Q++,P(ve)&&ae++,C(ve)&&ke++;return(Q===0||ae===0)&&ke===0?G.length<=30:Q<=5}function i(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!l(G)||Q.length>60)return null;const ae=a(Q);if(!n(ae)){if(!u(ae))return null;Q=Q.toLowerCase()}let ve=null,ke=0;for(G=G.toLowerCase();ke<Q.length&&(ve=h(G,Q,0,ke))===null;)ke=p(Q,ke+1);return ve}e.matchesCamelCase=i;function s(G,Q,ae=!1){if(!Q||Q.length===0)return null;let ve=null,ke=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();ke<Q.length&&(ve=r(G,Q,0,ke,ae))===null;)ke=o(Q,ke+1);return ve}e.matchesWords=s;function r(G,Q,ae,ve,ke){if(ae===G.length)return[];if(ve===Q.length)return null;if(b(G.charCodeAt(ae),Q.charCodeAt(ve))){let Te=null,Ne=ve+1;if(Te=r(G,Q,ae+1,ve+1,ke),!ke)for(;!Te&&(Ne=o(Q,Ne))<Q.length;)Te=r(G,Q,ae+1,Ne,ke),Ne++;return Te===null?null:m({start:ve,end:ve+1},Te)}else return null}function o(G,Q){for(let ae=Q;ae<G.length;ae++)if(d(G.charCodeAt(ae))||ae>0&&d(G.charCodeAt(ae-1)))return ae;return G.length}const c=w(e.matchesPrefix,i,T),g=w(e.matchesPrefix,i,E),I=new k.LRUCache(1e4);function _(G,Q,ae=!1){if(typeof G!="string"||typeof Q!="string")return null;let ve=I.get(G);ve||(ve=new RegExp(t.convertSimple2RegExpPattern(G),"i"),I.set(G,ve));const ke=ve.exec(Q);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:ae?g(G,Q):c(G,Q)}e.matchesFuzzy=_;function z(G,Q){const ae=ie(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ae?ee(ae):null}e.matchesFuzzy2=z;function W(G,Q,ae,ve,ke,Te){const Ne=Math.min(13,G.length);for(;ae<Ne;ae++){const Ue=ie(G,Q,ae,ve,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ue)return Ue}return[0,Te]}e.anyScore=W;function ee(G){if(typeof G=="undefined")return[];const Q=[],ae=G[1];for(let ve=G.length-1;ve>1;ve--){const ke=G[ve]+ae,Te=Q[Q.length-1];Te&&Te.end===ke?Te.end=ke+1:Q.push({start:ke,end:ke+1})}return Q}e.createMatches=ee;const D=128;function H(){const G=[],Q=[];for(let ae=0;ae<=D;ae++)Q[ae]=0;for(let ae=0;ae<=D;ae++)G.push(Q.slice(0));return G}function F(G){const Q=[];for(let ae=0;ae<=G;ae++)Q[ae]=0;return Q}const $=F(2*D),oe=F(2*D),K=H(),j=H(),O=H(),B=!1;function V(G,Q,ae,ve,ke){function Te(Ue,fe,Ee=" "){for(;Ue.length<fe;)Ue=Ee+Ue;return Ue}let Ne=` |   |${ve.split("").map(Ue=>Te(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=ae;Ue++)Ue===0?Ne+=" |":Ne+=`${Q[Ue-1]}|`,Ne+=G[Ue].slice(0,ke+1).map(fe=>Te(fe.toString(),3)).join("|")+`
`;return Ne}function J(G,Q,ae,ve){G=G.substr(Q),ae=ae.substr(ve),console.log(V(j,G,G.length,ae,ae.length)),console.log(V(O,G,G.length,ae,ae.length)),console.log(V(K,G,G.length,ae,ae.length))}function se(G,Q){if(Q<0||Q>=G.length)return!1;const ae=G.codePointAt(Q);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ae)}}function me(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function he(G,Q,ae){return Q[G]!==ae[G]}function U(G,Q,ae,ve,ke,Te,Ne=!1){for(;Q<ae&&ke<Te;)G[Q]===ve[ke]&&(Ne&&($[Q]=ke),Q+=1),ke+=1;return Q===ae}e.isPatternInWord=U;var N;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(N||(N={}));var q;(function(G){G.Default=[-100,0];function Q(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}G.isDefault=Q})(q=e.FuzzyScore||(e.FuzzyScore={}));class Y{constructor(Q,ae){this.firstMatchCanBeWeak=Q,this.boostFullMatch=ae}}e.FuzzyScoreOptions=Y,Y.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ie(G,Q,ae,ve,ke,Te,Ne=Y.default){const Ue=G.length>D?D:G.length,fe=ve.length>D?D:ve.length;if(ae>=Ue||Te>=fe||Ue-ae>fe-Te||!U(Q,ae,Ue,ke,Te,fe,!0))return;de(Ue,fe,ae,Te,Q,ke);let Ee=1,ge=1,Fe=ae,_e=Te;const qe=[!1];for(Ee=1,Fe=ae;Fe<Ue;Ee++,Fe++){const re=$[Fe],be=oe[Fe],Pe=Fe+1<Ue?oe[Fe+1]:fe;for(ge=re-Te+1,_e=re;_e<Pe;ge++,_e++){let Le=Number.MIN_SAFE_INTEGER,ze=!1;_e<=be&&(Le=le(G,Q,Fe,ae,ve,ke,_e,fe,Te,K[Ee-1][ge-1]===0,qe));let Me=0;Le!==Number.MAX_SAFE_INTEGER&&(ze=!0,Me=Le+j[Ee-1][ge-1]);const He=_e>re,Ye=He?j[Ee][ge-1]+(K[Ee][ge-1]>0?-5:0):0,Qe=_e>re+1&&K[Ee][ge-1]>0,xe=Qe?j[Ee][ge-2]+(K[Ee][ge-2]>0?-5:0):0;if(Qe&&(!He||xe>=Ye)&&(!ze||xe>=Me))j[Ee][ge]=xe,O[Ee][ge]=3,K[Ee][ge]=0;else if(He&&(!ze||Ye>=Me))j[Ee][ge]=Ye,O[Ee][ge]=2,K[Ee][ge]=0;else if(ze)j[Ee][ge]=Me,O[Ee][ge]=1,K[Ee][ge]=K[Ee-1][ge-1]+1;else throw new Error("not possible")}}if(B&&J(G,ae,ve,Te),!qe[0]&&!Ne.firstMatchCanBeWeak)return;Ee--,ge--;const Be=[j[Ee][ge],Te];let Ge=0,je=0;for(;Ee>=1;){let re=ge;do{const be=O[Ee][re];if(be===3)re=re-2;else if(be===2)re=re-1;else break}while(re>=1);Ge>1&&Q[ae+Ee-1]===ke[Te+ge-1]&&!he(re+Te-1,ve,ke)&&Ge+1>K[Ee][re]&&(re=ge),re===ge?Ge++:Ge=1,je||(je=re),Ee--,ge=re-1,Be.push(ge)}fe===Ue&&Ne.boostFullMatch&&(Be[0]+=2);const Ke=je-Ue;return Be[0]-=Ke,Be}e.fuzzyScore=ie;function de(G,Q,ae,ve,ke,Te){let Ne=G-1,Ue=Q-1;for(;Ne>=ae&&Ue>=ve;)ke[Ne]===Te[Ue]&&(oe[Ne]=Ue,Ne--),Ue--}function le(G,Q,ae,ve,ke,Te,Ne,Ue,fe,Ee,ge){if(Q[ae]!==Te[Ne])return Number.MIN_SAFE_INTEGER;let Fe=1,_e=!1;return Ne===ae-ve?Fe=G[ae]===ke[Ne]?7:5:he(Ne,ke,Te)&&(Ne===0||!he(Ne-1,ke,Te))?(Fe=G[ae]===ke[Ne]?7:5,_e=!0):se(Te,Ne)&&(Ne===0||!se(Te,Ne-1))?Fe=5:(se(Te,Ne-1)||me(Te,Ne-1))&&(Fe=5,_e=!0),Fe>1&&ae===ve&&(ge[0]=!0),_e||(_e=he(Ne,ke,Te)||se(Te,Ne-1)||me(Te,Ne-1)),ae===ve?Ne>fe&&(Fe-=_e?3:5):Ee?Fe+=_e?2:0:Fe+=_e?0:1,Ne+1===Ue&&(Fe-=_e?3:5),Fe}function ue(G,Q,ae,ve,ke,Te,Ne){return X(G,Q,ae,ve,ke,Te,!0,Ne)}e.fuzzyScoreGracefulAggressive=ue;function pe(G,Q,ae,ve,ke,Te,Ne){return X(G,Q,ae,ve,ke,Te,!1,Ne)}e.fuzzyScoreGraceful=pe;function X(G,Q,ae,ve,ke,Te,Ne,Ue){let fe=ie(G,Q,ae,ve,ke,Te,Ue);if(fe&&!Ne)return fe;if(G.length>=3){const Ee=Math.min(7,G.length-1);for(let ge=ae+1;ge<Ee;ge++){const Fe=Z(G,ge);if(Fe){const _e=ie(Fe,Fe.toLowerCase(),ae,ve,ke,Te,Ue);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function Z(G,Q){if(Q+1>=G.length)return;const ae=G[Q],ve=G[Q+1];if(ae!==ve)return G.slice(0,Q)+ve+ae+G.slice(Q+2)}}),define(we[135],ye([0,1,37,134,15]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(k.CSSIcon.iconNameCharacter),E=new RegExp(`(\\\\)?${S.source}`,"g");function v(f){return f.replace(E,(m,p)=>p?m:`\\${m}`)}e.escapeIcons=v;const P=new RegExp(`\\\\${S.source}`,"g");function R(f){return f.replace(P,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=R;const A=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function C(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(A,(m,p,h,a)=>h?m:p||a||"")}e.stripIcons=C;function y(f){const m=f.indexOf(e.iconStartMarker);return m===-1?{text:f}:d(f,m)}e.parseLabelWithIcons=y;function d(f,m){const p=[];let h="";function a(c){if(c){h+=c;for(const g of c)p.push(l)}}let u=-1,n="",l=0,i,s,r=m;const o=f.length;for(a(f.substr(0,m));r<o;)i=f[r],s=f[r+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=r,a(n),n=e.iconStartMarker,r++):i===")"&&u!==-1?(l+=r-u+1,u=-1,n=""):u!==-1?T.test(i)?n+=i:(a(n),u=-1,n=""):a(i),r++;return a(n),{text:h,iconOffsets:p}}function b(f,m,p=!1){const{text:h,iconOffsets:a}=m;if(!a||a.length===0)return(0,t.matchesFuzzy)(f,h,p);const u=(0,w.ltrim)(h," "),n=h.length-u.length,l=(0,t.matchesFuzzy)(f,u,p);if(l)for(const i of l){const s=a[i.start+n]+n;i.start+=s,i.end+=s}return l}e.matchesFuzzyIconAware=b}),define(we[79],ye([0,1,29]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function w(P){return v(P,"NFC",t)}e.normalizeNFC=w;const S=new k.LRUCache(1e4);function T(P){return v(P,"NFD",S)}e.normalizeNFD=T;const E=/[^\u0000-\u0080]/;function v(P,R,A){if(!P)return P;const C=A.get(P);if(C)return C;let y;return E.test(P)?y=P.normalize(R):y=P,A.set(P,y),y}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(R){return T(R).replace(P,"")}}()}),define(we[63],ye([0,1,15]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(t||(t={})),function(w){const S="error",T="warning",E="warn",v="info",P="ignore";function R(C){return C?k.equalsIgnoreCase(S,C)?w.Error:k.equalsIgnoreCase(T,C)||k.equalsIgnoreCase(E,C)?w.Warning:k.equalsIgnoreCase(v,C)?w.Info:w.Ignore:w.Ignore}w.fromValue=R;function A(C){switch(C){case w.Error:return S;case w.Warning:return T;case w.Info:return v;default:return P}}w.toString=A}(t||(t={})),e.default=t}),define(we[12],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(c){return Array.isArray(c)}e.isArray=k;function t(c){return typeof c=="string"}e.isString=t;function w(c){return Array.isArray(c)&&c.every(g=>t(g))}e.isStringArray=w;function S(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=S;function T(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=T;function E(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=E;function v(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=v;function P(c){return c===!0||c===!1}e.isBoolean=P;function R(c){return typeof c=="undefined"}e.isUndefined=R;function A(c){return!C(c)}e.isDefined=A;function C(c){return R(c)||c===null}e.isUndefinedOrNull=C;function y(c,g){if(!c)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=y;function d(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=d;function b(...c){const g=[];for(let I=0;I<c.length;I++){const _=c[I];if(C(_))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);g.push(_)}return g}e.assertAllDefined=b;const f=Object.prototype.hasOwnProperty;function m(c){if(!S(c))return!1;for(let g in c)if(f.call(c,g))return!1;return!0}e.isEmptyObject=m;function p(c){return typeof c=="function"}e.isFunction=p;function h(...c){return c.length>0&&c.every(p)}e.areFunctions=h;function a(c,g){const I=Math.min(c.length,g.length);for(let _=0;_<I;_++)u(c[_],g[_])}e.validateConstraints=a;function u(c,g){if(t(g)){if(typeof c!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(p(g)){try{if(c instanceof g)return}catch{}if(!C(c)&&c.constructor===g||g.length===1&&g.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function n(c){let g=[],I=Object.getPrototypeOf(c);for(;Object.prototype!==I;)g=g.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return g}e.getAllPropertyNames=n;function l(c){const g=[];for(const I of n(c))typeof c[I]=="function"&&g.push(I);return g}e.getAllMethodNames=l;function i(c,g){const I=z=>function(){const W=Array.prototype.slice.call(arguments,0);return g(z,W)};let _={};for(const z of c)_[z]=I(z);return _}e.createProxyObject=i;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function r(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=r;function o(c,g="Unreachable"){throw new Error(g)}e.assertNever=o}),define(we[33],ye([0,1,5,3,15,12]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function E(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=E;function v(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function P(r,o=k.posix.sep){if(!r)return"";const c=r.length,g=r.charCodeAt(0);if(T(g)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let _=3;const z=_;for(;_<c&&!T(r.charCodeAt(_));_++);if(z!==_&&!T(r.charCodeAt(_+1))){for(_+=1;_<c;_++)if(T(r.charCodeAt(_)))return r.slice(0,_+1).replace(/[\\/]/g,o)}}return o}else if(m(g)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let I=r.indexOf("://");if(I!==-1){for(I+=3;I<c;I++)if(T(r.charCodeAt(I)))return r.slice(0,I+1)}return""}e.getRoot=P;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let c=2;const g=c;for(;c<r.length&&(o=r.charCodeAt(c),o!==92);c++);return!(g===c||(o=r.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=R;const A=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=t.isWindows){const c=o?A:C;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||o&&y.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function b(r,o,c){const g=r===o;return!c||g?g:!r||!o?!1:(0,w.equalsIgnoreCase)(r,o)}e.isEqual=b;function f(r,o,c,g=k.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(c){if(!(0,w.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let _=o.length;return o.charAt(o.length-1)===g&&_--,r.charAt(_)===g}return o.charAt(o.length-1)!==g&&(o+=g),r.indexOf(o)===0}e.isEqualOrParent=f;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=m;function p(r,o){return t.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(o,r)),r=(0,k.normalize)(r),t.isWindows?(r=(0,w.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,w.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=p;function h(r){const o=(0,k.normalize)(r);return t.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=h;function a(r,o=t.isWindows){return o?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(r){return a(r)?r[0]:void 0}e.getDriveLetter=u;function n(r,o,c){return o.length>r.length?-1:r===o?0:(c&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=n;function l(r){const o=r.split(":");let c,g,I;for(const _ of o){const z=Number(_);(0,S.isNumber)(z)?g===void 0?g=z:I===void 0&&(I=z):c=c?[c,_].join(":"):_}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:g!==void 0?g:void 0,column:I!==void 0?I:g!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(r,o,c=8){let g="";for(let _=0;_<c;_++)g+=i.charAt(Math.floor(Math.random()*i.length));let I;return o?I=`${o}-${g}`:I=g,r?(0,k.join)(r,I):I}e.randomPath=s}),define(we[22],ye([0,1,12]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const f=Array.isArray(b)?[]:{};return Object.keys(b).forEach(m=>{b[m]&&typeof b[m]=="object"?f[m]=t(b[m]):f[m]=b[m]}),f}e.deepClone=t;function w(b){if(!b||typeof b!="object")return b;const f=[b];for(;f.length>0;){const m=f.shift();Object.freeze(m);for(const p in m)if(S.call(m,p)){const h=m[p];typeof h=="object"&&!Object.isFrozen(h)&&!(0,k.isTypedArray)(h)&&f.push(h)}}return b}e.deepFreeze=w;const S=Object.prototype.hasOwnProperty;function T(b,f){return E(b,f,new Set)}e.cloneAndChange=T;function E(b,f,m){if((0,k.isUndefinedOrNull)(b))return b;const p=f(b);if(typeof p!="undefined")return p;if((0,k.isArray)(b)){const h=[];for(const a of b)h.push(E(a,f,m));return h}if((0,k.isObject)(b)){if(m.has(b))throw new Error("Cannot clone recursive data-structure");m.add(b);const h={};for(let a in b)S.call(b,a)&&(h[a]=E(b[a],f,m));return m.delete(b),h}return b}function v(b,f,m=!0){return(0,k.isObject)(b)?((0,k.isObject)(f)&&Object.keys(f).forEach(p=>{p in b?m&&((0,k.isObject)(b[p])&&(0,k.isObject)(f[p])?v(b[p],f[p],m):b[p]=f[p]):b[p]=f[p]}),b):f}e.mixin=v;function P(b,f){if(b===f)return!0;if(b==null||f===null||f===void 0||typeof b!=typeof f||typeof b!="object"||Array.isArray(b)!==Array.isArray(f))return!1;let m,p;if(Array.isArray(b)){if(b.length!==f.length)return!1;for(m=0;m<b.length;m++)if(!P(b[m],f[m]))return!1}else{const h=[];for(p in b)h.push(p);h.sort();const a=[];for(p in f)a.push(p);if(a.sort(),!P(h,a))return!1;for(m=0;m<h.length;m++)if(!P(b[h[m]],f[h[m]]))return!1}return!0}e.equals=P;function R(b){const f=new Set;return JSON.stringify(b,(m,p)=>{if((0,k.isObject)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.safeStringify=R;function A(b,f,m){const p=f(b);return typeof p=="undefined"?m:p}e.getOrDefault=A;function C(b,f){const m=Object.create(null);return!b||!f||Object.keys(f).forEach(h=>{const a=b[h],u=f[h];P(a,u)||(m[h]=u)}),m}e.distinct=C;function y(b,f){const m=f.toLowerCase(),p=Object.keys(b).find(h=>h.toLowerCase()===m);return p?b[p]:b[f]}e.getCaseInsensitive=y;function d(b,f){const m=Object.create(null);for(const[p,h]of Object.entries(b))f(p,h)&&(m[p]=h);return m}e.filter=d}),define(we[4],ye([0,1,5,3]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const w=/^\w[\w\d+.-]*$/,S=/^\//,T=/^\/\//;function E(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!w.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!S.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,s){return!i&&!s?"file":i}function P(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==A&&(s=A+s):s=A;break}return s}const R="",A="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(s,r,o,c,g,I=!1){typeof s=="object"?(this.scheme=s.scheme||R,this.authority=s.authority||R,this.path=s.path||R,this.query=s.query||R,this.fragment=s.fragment||R):(this.scheme=v(s,I),this.authority=r||R,this.path=P(this.scheme,o||R),this.query=c||R,this.fragment=g||R,E(this,I))}static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:r,authority:o,path:c,query:g,fragment:I}=s;return r===void 0?r=this.scheme:r===null&&(r=R),o===void 0?o=this.authority:o===null&&(o=R),c===void 0?c=this.path:c===null&&(c=R),g===void 0?g=this.query:g===null&&(g=R),I===void 0?I=this.fragment:I===null&&(I=R),r===this.scheme&&o===this.authority&&c===this.path&&g===this.query&&I===this.fragment?this:new b(r,o,c,g,I)}static parse(s,r=!1){const o=C.exec(s);return o?new b(o[2]||R,l(o[4]||R),l(o[5]||R),l(o[7]||R),l(o[9]||R),r):new b(R,R,R,R,R)}static file(s){let r=R;if(t.isWindows&&(s=s.replace(/\\/g,A)),s[0]===A&&s[1]===A){const o=s.indexOf(A,2);o===-1?(r=s.substring(2),s=A):(r=s.substring(2,o),s=s.substring(o)||A)}return new b("file",r,s,R,R)}static from(s){const r=new b(s.scheme,s.authority,s.path,s.query,s.fragment);return E(r,!0),r}static joinPath(s,...r){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&s.scheme==="file"?o=y.file(k.win32.join(h(s,!0),...r)).path:o=k.posix.join(s.path,...r),s.with({path:o})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const r=new b(s);return r._formatted=s.external,r._fsPath=s._sep===d?s.fsPath:null,r}}else return s}}e.URI=y;const d=t.isWindows?1:void 0;class b extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,s){let r,o=-1;for(let c=0;c<i.length;c++){const g=i.charCodeAt(c);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||s&&g===47)o!==-1&&(r+=encodeURIComponent(i.substring(o,c)),o=-1),r!==void 0&&(r+=i.charAt(c));else{r===void 0&&(r=i.substr(0,c));const I=f[g];I!==void 0?(o!==-1&&(r+=encodeURIComponent(i.substring(o,c)),o=-1),r+=I):o===-1&&(o=c)}}return o!==-1&&(r+=encodeURIComponent(i.substring(o))),r!==void 0?r:i}function p(i){let s;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(s===void 0&&(s=i.substr(0,r)),s+=f[o]):s!==void 0&&(s+=i[r])}return s!==void 0?s:i}function h(i,s){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=h;function a(i,s){const r=s?p:m;let o="",{scheme:c,authority:g,path:I,query:_,fragment:z}=i;if(c&&(o+=c,o+=":"),(g||c==="file")&&(o+=A,o+=A),g){let W=g.indexOf("@");if(W!==-1){const ee=g.substr(0,W);g=g.substr(W+1),W=ee.indexOf(":"),W===-1?o+=r(ee,!1):(o+=r(ee.substr(0,W),!1),o+=":",o+=r(ee.substr(W+1),!1)),o+="@"}g=g.toLowerCase(),W=g.indexOf(":"),W===-1?o+=r(g,!1):(o+=r(g.substr(0,W),!1),o+=g.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}o+=r(I,!0)}return _&&(o+="?",o+=r(_,!1)),z&&(o+="#",o+=s?z:m(z,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(n)?i.replace(n,s=>u(s)):i}}),define(we[80],ye([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(P){const R=P;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=t;function w(P){const R=[];let A;try{const C=JSON.parse(P.arguments),y=C[C.length-1];y&&y.__$stack&&(C.pop(),A=y.__$stack),R.push(...C)}catch{R.push("Unable to log remote console arguments",P.arguments)}return{args:R,stack:A}}e.parse=w;function S(P){if(typeof P!="string")return S(w(P).stack);const R=P;if(R){const A=T(R),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(A||"");if(C&&C.length===4)return{uri:k.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=S;function T(P){if(!P)return P;const R=P.indexOf(`
`);return R===-1?P:P.substring(0,R)}function E(P,R){const{args:A,stack:C}=w(P),y=typeof A[0]=="string"&&A.length===1;let d=T(C);d&&(d=`(${d.trim()})`);let b=[];if(typeof A[0]=="string"?d&&y?b=[`%c[${R}] %c${A[0]} %c${d}`,v("blue"),v(""),v("grey")]:b=[`%c[${R}] %c${A[0]}`,v("blue"),v(""),...A.slice(1)]:b=[`%c[${R}]%`,v("blue"),...A],d&&!y&&b.push(d),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,b)}e.log=E;function v(P){return`color: ${P}`}}),define(we[44],ye([0,1,16,15,4]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(P){return JSON.stringify(P,E)}e.stringify=S;function T(P){let R=JSON.parse(P);return R=v(R),R}e.parse=T;function E(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function v(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return w.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let A=0;A<P.length;++A)P[A]=v(P[A],R+1);else for(const A in P)Object.hasOwnProperty.call(P,A)&&(P[A]=v(P[A],R+1))}return P}e.revive=v}),define(we[8],ye([0,1,3,4]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,P,R){this._hosts[v]=P,this._ports[v]=R}setConnectionToken(v,P){this._connectionTokens[v]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const P=v.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const A=this._ports[P],C=this._connectionTokens[P];let y=`path=${encodeURIComponent(v.path)}`;return typeof C=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${R}:${A}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class T{asBrowserUri(v,P){const R=this.toUri(v,P);return R.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===w.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${w.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:w.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(v,P){const R=this.toUri(v,P);return R.scheme===w.vscodeFileResource?R.with({scheme:w.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(v,P){return t.URI.isUri(v)?v:t.URI.parse(P.toUrl(v))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(we[19],ye([0,1,33,8,5,3,15,4]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(y){return(0,E.uriToFsPath)(y,!0)}e.originalFSPath=v;class P{constructor(d){this._ignorePathCasing=d}compare(d,b,f=!1){return d===b?0:(0,T.compare)(this.getComparisonKey(d,f),this.getComparisonKey(b,f))}isEqual(d,b,f=!1){return d===b?!0:!d||!b?!1:this.getComparisonKey(d,f)===this.getComparisonKey(b,f)}getComparisonKey(d,b=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,b,f=!1){if(d.scheme===b.scheme){if(d.scheme===t.Schemas.file)return k.isEqualOrParent(v(d),v(b),this._ignorePathCasing(d))&&d.query===b.query&&(f||d.fragment===b.fragment);if((0,e.isEqualAuthority)(d.authority,b.authority))return k.isEqualOrParent(d.path,b.path,this._ignorePathCasing(d),"/")&&d.query===b.query&&(f||d.fragment===b.fragment)}return!1}joinPath(d,...b){return E.URI.joinPath(d,...b)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return w.posix.basename(d.path)}extname(d){return w.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let b;return d.scheme===t.Schemas.file?b=E.URI.file(w.dirname(v(d))).path:(b=w.posix.dirname(d.path),d.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),b="/")),d.with({path:b})}normalizePath(d){if(!d.path.length)return d;let b;return d.scheme===t.Schemas.file?b=E.URI.file(w.normalize(v(d))).path:b=w.posix.normalize(d.path),d.with({path:b})}relativePath(d,b){if(d.scheme!==b.scheme||!(0,e.isEqualAuthority)(d.authority,b.authority))return;if(d.scheme===t.Schemas.file){const p=w.relative(v(d),v(b));return S.isWindows?k.toSlashes(p):p}let f=d.path||"/",m=b.path||"/";if(this._ignorePathCasing(d)){let p=0;for(const h=Math.min(f.length,m.length);p<h&&!(f.charCodeAt(p)!==m.charCodeAt(p)&&f.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);f=m.substr(0,p)+f.substr(p)}return w.posix.relative(f,m)}resolvePath(d,b){if(d.scheme===t.Schemas.file){const f=E.URI.file(w.resolve(v(d),b));return d.with({authority:f.authority,path:f.path})}return b=k.toPosixPath(b),d.with({path:w.posix.resolve(d.path,b)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,b){return d===b||d!==void 0&&b!==void 0&&(0,T.equalsIgnoreCase)(d,b)}hasTrailingPathSeparator(d,b=w.sep){if(d.scheme===t.Schemas.file){const f=v(d);return f.length>k.getRoot(f).length&&f[f.length-1]===b}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,b=w.sep){return(0,e.hasTrailingPathSeparator)(d,b)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,b=w.sep){let f=!1;if(d.scheme===t.Schemas.file){const m=v(d);f=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===b}else{b="/";const m=d.path;f=m.length===1&&m.charCodeAt(m.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(d,b)?d.with({path:d.path+"/"}):d}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(y=>y.scheme===t.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new P(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,d){const b=[];for(let f=0;f<y.length;f++){const m=d(y[f]);y.some((p,h)=>h===f?!1:(0,e.isEqualOrParent)(m,d(p)))||b.push(y[f])}return b}e.distinctParents=R;var A;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(b){const f=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(h=>{const[a,u]=h.split(":");a&&u&&f.set(a,u)});const p=b.path.substring(0,b.path.indexOf(";"));return p&&f.set(y.META_DATA_MIME,p),f}y.parseMetaData=d})(A=e.DataUri||(e.DataUri={}));function C(y,d,b){if(d){let f=y.path;return f&&f[0]!==w.posix.sep&&(f=w.posix.sep+f),y.with({scheme:b,authority:d,path:f})}return y.with({scheme:b})}e.toLocalResource=C}),define(we[14],ye([0,1,21,9,7,2,19,3]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(he){return!!he&&typeof he.then=="function"}e.isThenable=v;function P(he){const U=new k.CancellationTokenSource,N=he(U.token),q=new Promise((Y,ie)=>{const de=U.token.onCancellationRequested(()=>{de.dispose(),U.dispose(),ie(new t.CancellationError)});Promise.resolve(N).then(le=>{de.dispose(),U.dispose(),Y(le)},le=>{de.dispose(),U.dispose(),ie(le)})});return new class{cancel(){U.cancel()}then(Y,ie){return q.then(Y,ie)}catch(Y){return this.then(void 0,Y)}finally(Y){return q.finally(Y)}}}e.createCancelablePromise=P;function R(he,U,N){return new Promise((q,Y)=>{const ie=U.onCancellationRequested(()=>{ie.dispose(),q(N)});he.then(q,Y).finally(()=>ie.dispose())})}e.raceCancellation=R;function A(he,U){return new Promise((N,q)=>{const Y=U.onCancellationRequested(()=>{Y.dispose(),q(new t.CancellationError)});he.then(N,q).finally(()=>Y.dispose())})}e.raceCancellationError=A;async function C(he){let U=-1;const N=he.map((Y,ie)=>Y.then(de=>(U=ie,de))),q=await Promise.race(N);return he.forEach((Y,ie)=>{ie!==U&&Y.cancel()}),q}e.raceCancellablePromises=C;function y(he,U,N){let q;const Y=setTimeout(()=>{q?.(void 0),N?.()},U);return Promise.race([he.finally(()=>clearTimeout(Y)),new Promise(ie=>q=ie)])}e.raceTimeout=y;function d(he){return new Promise((U,N)=>{const q=he();v(q)?q.then(U,N):U(q)})}e.asPromise=d;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=U(),new Promise((N,q)=>{this.activePromise.then(Y=>{this.activePromise=null,N(Y)},Y=>{this.activePromise=null,q(Y)})})}}e.Throttler=b;class f{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=f;class m{constructor(){this.promiseMap=new Map}queue(U,N){const Y=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===Y&&this.promiseMap.delete(U)});return this.promiseMap.set(U,Y),Y}}e.SequencerByKey=m;const p=(he,U)=>{let N=!0;const q=setTimeout(()=>{N=!1,U()},he);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},h=he=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,he())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,ie)=>{this.doResolve=Y,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?h(q):p(N,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class u{constructor(U){this.delayer=new a(U),this.throttler=new b}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class n{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class l extends n{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(he,U){return U?new Promise((N,q)=>{const Y=setTimeout(()=>{ie.dispose(),N()},he),ie=U.onCancellationRequested(()=>{clearTimeout(Y),ie.dispose(),q(new t.CancellationError)})}):P(N=>i(he,N))}e.timeout=i;function s(he,U=0){const N=setTimeout(he,U);return(0,S.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=s;function r(he){const U=[];let N=0;const q=he.length;function Y(){return N<q?he[N++]():null}function ie(de){de!=null&&U.push(de);const le=Y();return le?le.then(ie):Promise.resolve(U)}return Promise.resolve(null).then(ie)}e.sequence=r;function o(he,U=q=>!!q,N=null){let q=0;const Y=he.length,ie=()=>{if(q>=Y)return Promise.resolve(N);const de=he[q++];return Promise.resolve(de()).then(ue=>U(ue)?Promise.resolve(ue):ie())};return ie()}e.first=o;function c(he,U=q=>!!q,N=null){if(he.length===0)return Promise.resolve(N);let q=he.length;const Y=()=>{q=-1;for(const ie of he)ie.cancel?.()};return new Promise((ie,de)=>{for(const le of he)le.then(ue=>{--q>=0&&U(ue)?(Y(),ie(ue)):q===0&&ie(N)}).catch(ue=>{--q>=0&&(Y(),de(ue))})})}e.firstParallel=c;class g{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:U,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class I extends g{constructor(){super(1)}}e.Queue=I;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new O;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,N=T.extUri){const q=N.getComparisonKey(U);let Y=this.queues.get(q);return Y||(Y=new I,w.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,Y)),Y}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class z{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=z;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=W;class ee{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=ee;class D{constructor(U,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class H extends ee{constructor(U,N){super(U,N);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class F extends S.Disposable{constructor(U,N){super();this.options=U,this.handler=N,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ee(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,E.setTimeout0)(()=>{if(U)return;const N=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(he,U)=>{const N=requestIdleCallback(he,typeof U=="number"?{timeout:U}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class ${constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function oe(he,U,N){let q;for(let Y=0;Y<N;Y++)try{return await he()}catch(ie){q=ie,await i(U)}throw q}e.retry=oe;class K{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,N,q){return this._pending={taskId:U,cancel:()=>q?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,q;const Y=new Promise((ie,de)=>{N=ie,q=de});this._next={run:U,promise:Y,promiseResolve:N,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=K;class j{constructor(U,N=()=>Date.now()){this.interval=U,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback(new t.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=O;var B;(function(he){async function U(q){let Y;const ie=await Promise.all(q.map(de=>de.then(le=>le,le=>{Y||(Y=le)})));if(typeof Y!="undefined")throw Y;return ie}he.settled=U;function N(q){return new Promise(async(Y,ie)=>{try{await q(Y,ie)}catch(de){ie(de)}})}he.withAsyncBody=N})(B=e.Promises||(e.Promises={}));var V;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(V||(V={}));class J{constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const N={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(U(N)),this.resolve()}catch(q){this.reject(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(U){return new J(N=>{N.emitMany(U)})}static fromPromise(U){return new J(async N=>{N.emitMany(await U)})}static fromPromises(U){return new J(async N=>{await Promise.all(U.map(async q=>N.emitOne(await q)))})}static merge(U){return new J(async N=>{await Promise.all(U.map(async q=>{for await(const Y of q)N.emitOne(Y)}))})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,N){return new J(async q=>{for await(const Y of U)q.emitOne(N(Y))})}map(U){return J.map(this,U)}static filter(U,N){return new J(async q=>{for await(const Y of U)N(Y)&&q.emitOne(Y)})}filter(U){return J.filter(this,U)}static coalesce(U){return J.filter(U,N=>!!N)}coalesce(){return J.coalesce(this)}static async toPromise(U){const N=[];for await(const q of U)N.push(q);return N}toPromise(){return J.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class se extends J{constructor(U,N){super(N);this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function me(he){const U=new k.CancellationTokenSource,N=he(U.token);return new se(U,async q=>{const Y=U.token.onCancellationRequested(()=>{Y.dispose(),U.dispose(),q.reject(new t.CancellationError)});try{for await(const ie of N){if(U.token.isCancellationRequested)return;q.emitOne(ie)}Y.dispose(),U.dispose()}catch(ie){Y.dispose(),U.dispose(),q.reject(ie)}})}e.createCancelableAsyncIterable=me}),define(we[64],ye([0,1,18,14,33,29,5,3,15]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",A="[^/\\\\]",C=/\//g;function y(O,B){switch(O){case 0:return"";case 1:return`${A}*?`;default:return`(?:${R}|${A}+${R}${B?`|${R}${A}+`:""})*?`}}function d(O,B){if(!O)return[];const V=[];let J=!1,se=!1,me="";for(const he of O){switch(he){case B:if(!J&&!se){V.push(me),me="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":se=!0;break;case"]":se=!1;break}me+=he}return me&&V.push(me),V}e.splitGlobAware=d;function b(O){if(!O)return"";let B="";const V=d(O,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))B=".*";else{let J=!1;V.forEach((se,me)=>{if(se===e.GLOBSTAR){if(J)return;B+=y(2,me===V.length-1)}else{let he=!1,U="",N=!1,q="";for(const Y of se){if(Y!=="}"&&he){U+=Y;continue}if(N&&(Y!=="]"||!q)){let ie;Y==="-"?ie=Y:(Y==="^"||Y==="!")&&!q?ie="^":Y===e.GLOB_SPLIT?ie="":ie=(0,v.escapeRegExpCharacters)(Y),q+=ie;continue}switch(Y){case"{":he=!0;continue;case"[":N=!0;continue;case"}":{B+=`(?:${d(U,",").map(le=>b(le)).join("|")})`,he=!1,U="";break}case"]":{B+="["+q+"]",N=!1,q="";break}case"?":B+=A;continue;case"*":B+=y(1);continue;default:B+=(0,v.escapeRegExpCharacters)(Y)}}me<V.length-1&&(V[me+1]!==e.GLOBSTAR||me+2<V.length)&&(B+=R)}J=se===e.GLOBSTAR})}return B}const f=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new S.LRUCache(1e4),l=function(){return!1},i=function(){return null};function s(O,B){if(!O)return i;let V;typeof O!="string"?V=O.pattern:V=O,V=V.trim();const J=`${V}_${!!B.trimForExclusions}`;let se=n.get(J);if(se)return r(se,O);let me;return f.test(V)?se=c(V.substr(4),V):(me=m.exec(o(V,B)))?se=g(me[1],V):(B.trimForExclusions?h:p).test(V)?se=I(V,B):(me=a.exec(o(V,B)))?se=_(me[1].substr(1),V,!0):(me=u.exec(o(V,B)))?se=_(me[1],V,!1):se=z(V),n.set(J,se),r(se,O)}function r(O,B){if(typeof B=="string")return O;const V=function(J,se){return(0,w.isEqualOrParent)(J,B.base,!E.isLinux)?O(J.substr(B.base.length+1),se):null};return V.allBasenames=O.allBasenames,V.allPaths=O.allPaths,V.basenames=O.basenames,V.patterns=O.patterns,V}function o(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,B){return function(V,J){return typeof V=="string"&&V.endsWith(O)?B:null}}function g(O,B){const V=`/${O}`,J=`\\${O}`,se=function(he,U){return typeof he!="string"?null:U?U===O?B:null:he===O||he.endsWith(V)||he.endsWith(J)?B:null},me=[O];return se.basenames=me,se.patterns=[B],se.allBasenames=me,se}function I(O,B){const V=K(O.slice(1,-1).split(",").map(U=>s(U,B)).filter(U=>U!==i),O),J=V.length;if(!J)return i;if(J===1)return V[0];const se=function(U,N){for(let q=0,Y=V.length;q<Y;q++)if(V[q](U,N))return O;return null},me=V.find(U=>!!U.allBasenames);me&&(se.allBasenames=me.allBasenames);const he=V.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return he.length&&(se.allPaths=he),se}function _(O,B,V){const J=T.sep===T.posix.sep,se=J?O:O.replace(C,T.sep),me=T.sep+se,he=T.posix.sep+O;let U;return V?U=function(N,q){return typeof N=="string"&&(N===se||N.endsWith(me)||!J&&(N===O||N.endsWith(he)))?B:null}:U=function(N,q){return typeof N=="string"&&(N===se||!J&&N===O)?B:null},U.allPaths=[(V?"*/":"./")+O],U}function z(O){try{const B=new RegExp(`^${b(O)}$`);return function(V){return B.lastIndex=0,typeof V=="string"&&B.test(V)?O:null}}catch{return i}}function W(O,B,V){return!O||typeof B!="string"?!1:ee(O)(B,void 0,V)}e.match=W;function ee(O,B={}){if(!O)return l;if(typeof O=="string"||D(O)){const V=s(O,B);if(V===i)return l;const J=function(se,me){return!!V(se,me)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return $(O,B)}e.parse=ee;function D(O){const B=O;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=D;function H(O){return O.allBasenames||[]}e.getBasenameTerms=H;function F(O){return O.allPaths||[]}e.getPathTerms=F;function $(O,B){const V=K(Object.getOwnPropertyNames(O).map(U=>oe(U,O[U],B)).filter(U=>U!==i)),J=V.length;if(!J)return i;if(!V.some(U=>!!U.requiresSiblings)){if(J===1)return V[0];const U=function(Y,ie){let de;for(let le=0,ue=V.length;le<ue;le++){const pe=V[le](Y,ie);if(typeof pe=="string")return pe;(0,t.isThenable)(pe)&&(de||(de=[]),de.push(pe))}return de?(async()=>{for(const le of de){const ue=await le;if(typeof ue=="string")return ue}return null})():null},N=V.find(Y=>!!Y.allBasenames);N&&(U.allBasenames=N.allBasenames);const q=V.reduce((Y,ie)=>ie.allPaths?Y.concat(ie.allPaths):Y,[]);return q.length&&(U.allPaths=q),U}const se=function(U,N,q){let Y,ie;for(let de=0,le=V.length;de<le;de++){const ue=V[de];ue.requiresSiblings&&q&&(N||(N=(0,T.basename)(U)),Y||(Y=N.substr(0,N.length-(0,T.extname)(U).length)));const pe=ue(U,N,Y,q);if(typeof pe=="string")return pe;(0,t.isThenable)(pe)&&(ie||(ie=[]),ie.push(pe))}return ie?(async()=>{for(const de of ie){const le=await de;if(typeof le=="string")return le}return null})():null},me=V.find(U=>!!U.allBasenames);me&&(se.allBasenames=me.allBasenames);const he=V.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return he.length&&(se.allPaths=he),se}function oe(O,B,V){if(B===!1)return i;const J=s(O,V);if(J===i)return i;if(typeof B=="boolean")return J;if(B){const se=B.when;if(typeof se=="string"){const me=(he,U,N,q)=>{if(!q||!J(he,U))return null;const Y=se.replace("$(basename)",N),ie=q(Y);return(0,t.isThenable)(ie)?ie.then(de=>de?O:null):ie?O:null};return me.requiresSiblings=!0,me}}return J}function K(O,B){const V=O.filter(U=>!!U.basenames);if(V.length<2)return O;const J=V.reduce((U,N)=>{const q=N.basenames;return q?U.concat(q):U},[]);let se;if(B){se=[];for(let U=0,N=J.length;U<N;U++)se.push(B)}else se=V.reduce((U,N)=>{const q=N.patterns;return q?U.concat(q):U},[]);const me=function(U,N){if(typeof U!="string")return null;if(!N){let Y;for(Y=U.length;Y>0;Y--){const ie=U.charCodeAt(Y-1);if(ie===47||ie===92)break}N=U.substr(Y)}const q=J.indexOf(N);return q!==-1?se[q]:null};me.basenames=J,me.patterns=se,me.allBasenames=J;const he=O.filter(U=>!U.basenames);return he.push(me),he}function j(O,B){return(0,k.equals)(O,B,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=j}),define(we[81],ye([0,1,9,135,19,15,4]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(f="",m=!1){if(this.value=f,typeof this.value!="string")throw(0,k.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(f,m=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(p,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,m){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(f,m,p){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(f),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(f,m){const p=new RegExp((0,S.escapeRegExpCharacters)(m),"g");return f.replace(p,(h,a)=>f.charAt(a-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=v;function P(b){return R(b)?!b.value:Array.isArray(b)?b.every(P):!0}e.isEmptyMarkdownString=P;function R(b){return b instanceof v?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function A(b,f){return b===f?!0:!b||!f?!1:b.value===f.value&&b.isTrusted===f.isTrusted&&b.supportThemeIcons===f.supportThemeIcons&&b.supportHtml===f.supportHtml&&(b.baseUri===f.baseUri||!!b.baseUri&&!!f.baseUri&&(0,w.isEqual)(T.URI.from(b.baseUri),T.URI.from(f.baseUri)))}e.markdownStringEqual=A;function C(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function y(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=y;function d(b){const f=[],m=b.split("|").map(h=>h.trim());b=m[0];const p=m[1];if(p){const h=/height=(\d+)/.exec(p),a=/width=(\d+)/.exec(p),u=h?h[1]:"",n=a?a[1]:"",l=isFinite(parseInt(n)),i=isFinite(parseInt(u));l&&f.push(`width="${n}"`),i&&f.push(`height="${u}"`)}return{href:b,dimensions:f}}e.parseHrefAndDimensions=d}),define(we[82],ye([0,1,18,33,8,5,3,19,15,4]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(o,c){const{os:g,tildify:I,relative:_}=c;if(_){const ee=A(o,_,g);if(typeof ee=="string")return ee}let z=o.fsPath;if(g===1&&!T.isWindows?z=z.replace(/\//g,"\\"):g!==1&&T.isWindows&&(z=z.replace(/\\/g,"/")),g!==1&&I?.userHome){let ee=I.userHome.fsPath,D;o.scheme!==I.userHome.scheme&&o.path.startsWith(S.posix.sep)?D=I.userHome.with({path:o.path}).fsPath:D=o.fsPath,T.isWindows&&(D=(0,t.toSlashes)(D),ee=(0,t.toSlashes)(ee)),z=b(D,ee,g)}return(g===1?S.win32:S.posix).normalize(y(z,g===1))}e.getPathLabel=R;function A(o,c,g){const I=g===1?S.win32:S.posix,_=g===3?E.extUri:E.extUriIgnorePathCase,z=c.getWorkspace(),W=(0,k.firstOrDefault)(z.folders);if(!W)return;o.scheme!==W.uri.scheme&&o.path.startsWith(S.posix.sep)&&(o=W.uri.with({path:o.path}));const ee=c.getWorkspaceFolder(o);if(!ee)return;let D;if(_.isEqual(ee.uri,o)?D="":D=_.relativePath(ee.uri,o)??"",D&&(D=I.normalize(D)),z.folders.length>1&&!c.noPrefix){const H=ee.name?ee.name:_.basenameOrAuthority(ee.uri);D=D?`${H} \u2022 ${D}`:H}return D}function C(o){if(!o)return;typeof o=="string"&&(o=P.URI.file(o));const c=(0,E.basename)(o)||(o.scheme===w.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,t.isRootOrDriveLetter)(c)?y(c):c}e.getBaseLabel=C;function y(o,c=T.isWindows){return(0,t.hasDriveLetter)(o,c)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=y;let d=Object.create(null);function b(o,c,g=T.OS){if(g===1||!o||!c)return o;let I=d.original===c?d.normalized:void 0;return I||(I=`${(0,v.rtrim)(c,S.posix.sep)}${S.posix.sep}`,d={original:c,normalized:I}),(g===3?o.startsWith(I):(0,v.startsWithIgnoreCase)(o,I))&&(o=`~/${o.substr(I.length)}`),o}e.tildify=b;function f(o,c){return o.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=f;const m="\u2026",p="\\\\",h="~";function a(o,c=S.sep){const g=new Array(o.length);let I=!1;for(let _=0;_<o.length;_++){let z=o[_];if(z===""){g[_]=`.${c}`;continue}if(!z){g[_]=z;continue}I=!0;let W="";z.indexOf(p)===0?(W=z.substr(0,z.indexOf(p)+p.length),z=z.substr(z.indexOf(p)+p.length)):z.indexOf(c)===0?(W=z.substr(0,z.indexOf(c)+c.length),z=z.substr(z.indexOf(c)+c.length)):z.indexOf(h)===0&&(W=z.substr(0,z.indexOf(h)+h.length),z=z.substr(z.indexOf(h)+h.length));const ee=z.split(c);for(let D=1;I&&D<=ee.length;D++)for(let H=ee.length-D;I&&H>=0;H--){I=!1;let F=ee.slice(H,H+D).join(c);for(let $=0;!I&&$<o.length;$++)if($!==_&&o[$]&&o[$].indexOf(F)>-1){const oe=H+D===ee.length,K=H>0&&o[$].indexOf(c)>-1?c+F:F,j=o[$].endsWith(K);I=!oe||j}if(!I){let $="";(ee[0].endsWith(":")||W!=="")&&(H===1&&(H=0,D++,F=ee[0]+c+F),H>0&&($=ee[0]+c),$=W+$),H>0&&($=$+m+c),$=$+F,H+D<ee.length&&($=$+c+m),g[_]=$}}I&&(g[_]=z)}return g}e.shorten=a;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function n(o,c=Object.create(null)){const g=[];let I=!1,_="";for(const z of o)if(z==="$"||I&&z==="{")_&&g.push({value:_,type:u.TEXT}),_="",I=!0;else if(z==="}"&&I){const W=c[_];if(typeof W=="string")W.length&&g.push({value:W,type:u.VARIABLE});else if(W){const ee=g[g.length-1];(!ee||ee.type!==u.SEPARATOR)&&g.push({value:W.label,type:u.SEPARATOR})}_="",I=!1}else _+=z;return _&&!I&&g.push({value:_,type:u.TEXT}),g.filter((z,W)=>{if(z.type===u.SEPARATOR){const ee=g[W-1],D=g[W+1];return[ee,D].every(H=>H&&(H.type===u.VARIABLE||H.type===u.TEXT)&&H.value.length>0)}return!0}).map(z=>z.value).join("")}e.template=n;function l(o,c){return T.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function i(o,c){return T.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(o){const c=o.indexOf("/")!==-1?S.posix:S.win32,g=c.basename(o),I=c.dirname(o);return g.length?{name:g,parentPath:I}:{name:I,parentPath:""}}e.splitName=r}),define(we[65],ye([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class w{constructor(A){this._uriTransformer=A}transformIncoming(A){const C=this._uriTransformer.transformIncoming(A);return C===A?A:t(k.URI.from(C))}transformOutgoing(A){const C=this._uriTransformer.transformOutgoing(A);return C===A?A:t(k.URI.from(C))}transformOutgoingURI(A){const C=this._uriTransformer.transformOutgoing(A);return C===A?A:k.URI.from(C)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function S(R,A,C){if(!R||C>200)return null;if(typeof R=="object"){if(R instanceof k.URI)return A.transformOutgoing(R);for(let y in R)if(Object.hasOwnProperty.call(R,y)){const d=S(R[y],A,C+1);d!==null&&(R[y]=d)}}return null}function T(R,A){const C=S(R,A,0);return C===null?R:C}e.transformOutgoingURIs=T;function E(R,A,C,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return C?k.URI.revive(A.transformIncoming(R)):A.transformIncoming(R);for(let d in R)if(Object.hasOwnProperty.call(R,d)){const b=E(R[d],A,C,y+1);b!==null&&(R[d]=b)}}return null}function v(R,A){const C=E(R,A,!1,0);return C===null?R:C}e.transformIncomingURIs=v;function P(R,A){const C=E(R,A,!0,0);return C===null?R:C}e.transformAndReviveIncomingURIs=P}),define(we[26],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(v){return k.test(v)}e.isUUID=t;const w=new Uint8Array(16),S=[];for(let v=0;v<256;v++)S.push(v.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(v){for(let P=0;P<v.length;P++)v[P]=Math.floor(Math.random()*256);return v};function E(){T(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let v=0,P="";return P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P+="-",P+=S[w[v++]],P+=S[w[v++]],P+="-",P+=S[w[v++]],P+=S[w[v++]],P+="-",P+=S[w[v++]],P+=S[w[v++]],P+="-",P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P+=S[w[v++]],P}e.generateUuid=E}),define(we[136],ye([0,1,258]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(S="utf8"){this.stringDecoder=new k.StringDecoder(S),this.remaining=null}write(S){const T=[],E=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(E.length<1)return T;let v=0,P,R=v;for(;R<E.length;)if(P=E.charCodeAt(R),P===13||P===10){if(T.push(E.substring(v,R)),R++,R<E.length){const A=P;P=E.charCodeAt(R),(A===13&&P===10||A===10&&P===13)&&R++}v=R}else R++;return this.remaining=v<E.length?E.substr(v):null,T}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function te(e,k,t,w){function S(d){return new Promise(b=>t.exists(d,b))}function T(d){return new Promise((b,f)=>{const m=new Date;t.utimes(d,m,m,p=>p?f(p):b())})}function E(d){return new Promise((b,f)=>t.mkdir(d,{recursive:!0},m=>m&&m.code!=="EEXIST"?f(m):b(d)))}function v(d){return new Promise((b,f)=>t.rm(d,{recursive:!0,force:!0,maxRetries:3},m=>m?f(m):b()))}function P(d){return new Promise((b,f)=>t.readFile(d,"utf8",(m,p)=>m?f(m):b(p)))}function R(d,b){return new Promise((f,m)=>t.writeFile(d,b,"utf8",p=>p?m(p):f()))}function A(d){const b=k.join(d,"languagepacks.json");try{return e(b)}catch{}}function C(d,b){try{for(;b;){if(d[b])return b;{const f=b.lastIndexOf("-");if(f>0)b=b.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function y(d,b,f,m){if(m==="pseudo")return Promise.resolve({locale:m,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,availableLanguages:{}});const p=m;w.mark("code/willGenerateNls");const h=function(a){return w.mark("code/didGenerateNls"),Promise.resolve({locale:a,availableLanguages:{}})};try{if(!d)return h(p);const a=A(b);if(!a||(m=C(a,m),!m))return h(p);const u=a[m];let n;return!u||typeof u.hash!="string"||!u.translations||typeof(n=u.translations.vscode)!="string"?h(p):S(n).then(l=>{if(!l)return h(p);const i=u.hash+"."+m,s=k.join(b,"clp",i),r=k.join(s,d),o=k.join(s,"tcf.json"),c=k.join(s,"corrupted.info"),g={locale:p,availableLanguages:{"*":m},_languagePackId:i,_translationsConfigFile:o,_cacheRoot:s,_resolvedLanguagePackCoreLocation:r,_corruptedFile:c};return S(c).then(I=>{let _;return I?_=v(s):_=Promise.resolve(void 0),_.then(()=>S(r).then(z=>z?(T(r).catch(()=>{}),w.mark("code/didGenerateNls"),g):E(r).then(()=>Promise.all([P(f),P(n)])).then(W=>{const ee=JSON.parse(W[0]),D=JSON.parse(W[1]).contents,H=Object.keys(ee.bundles),F=[];for(const $ of H){const oe=ee.bundles[$],K=Object.create(null);for(const j of oe){const O=ee.keys[j],B=ee.messages[j],V=D[j];let J;if(V){J=[];for(let se=0;se<O.length;se++){const me=O[se],he=typeof me=="string"?me:me.key;let U=V[he];U===void 0&&(U=B[se]),J.push(U)}}else J=B;K[j]=J}F.push(R(k.join(r,$.replace(/\//g,"!")+".nls.json"),JSON.stringify(K)))}return F.push(R(o,JSON.stringify(u.translations))),Promise.all(F)}).then(()=>(w.mark("code/didGenerateNls"),g)).catch(W=>(console.error("Generating translation files failed.",W),h(m)))))})})}catch(a){return console.error("Generating translation files failed.",a),h(m)}}return{getNLSConfiguration:y}}if(typeof define=="function")define(we[137],ye([0,83,30,45]),function(e,k,t,w){return te(e.__$__nodeRequire,k,t,w)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("fs"),t=require("../common/performance");module.exports=te(require,e,k,t)}else throw new Error("Unknown context")}(),define(we[138],ye([0,1,27]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(T){const E=T.replace(/\-/g,":").toLowerCase();return!t.has(E)}function S(){const T=(0,k.networkInterfaces)();for(let E in T){const v=T[E];if(v){for(const{mac:P}of v)if(w(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=S}),define(we[84],ye([0,1,27,9,29,26,138]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=w.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,A=0;const C=(0,k.networkInterfaces)();for(let y in C){const d=C[y];if(d)for(const{mac:b,internal:f}of d)f||(A+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(R+=1))}this._value=A>0?R/A:0}return this._value}};let E;async function v(){return E||(E=(async()=>await P()||S.generateUuid())()),E}e.getMachineId=v;async function P(){try{const R=await new Promise((C,y)=>{te(["crypto"],C,y)}),A=(0,T.getMac)();return R.createHash("sha256").update(A,"utf8").digest("hex")}catch(R){t.onUnexpectedError(R);return}}}),define(we[20],ye([0,1,30,27,139,14,33,79,5,3,19,4]),function(te,e,k,t,w,S,T,E,v,P,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function y(F,$=C.UNLINK){if((0,T.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return $===C.UNLINK?b(F):d(F)}async function d(F){try{const $=(0,T.randomPath)((0,t.tmpdir)());try{await k.promises.rename(F,$)}catch{return b(F)}b($).catch(oe=>{})}catch($){if($.code!=="ENOENT")throw $}}async function b(F){return(0,w.promisify)(k.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,T.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function m(F,$){return a(await($?p(F):(0,w.promisify)(k.readdir)(F)))}async function p(F){try{return await(0,w.promisify)(k.readdir)(F,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const $=[],oe=await m(F);for(const K of oe){let j=!1,O=!1,B=!1;try{const V=await e.Promises.lstat((0,v.join)(F,K));j=V.isFile(),O=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}$.push({name:K,isFile:()=>j,isDirectory:()=>O,isSymbolicLink:()=>B})}return $}function h(F){return a(k.readdirSync(F))}e.readdirSync=h;function a(F){return F.map($=>typeof $=="string"?P.isMacintosh?(0,E.normalizeNFC)($):$:($.name=P.isMacintosh?(0,E.normalizeNFC)($.name):$.name,$))}async function u(F){const $=await m(F),oe=[];for(const K of $)await l.existsDirectory((0,v.join)(F,K))&&oe.push(K);return oe}function n(F,$=1e3){return new Promise(oe=>{let K=!1;const j=setInterval(()=>{K||(K=!0,k.access(F,O=>{K=!1,O&&(clearInterval(j),oe(void 0))}))},$)})}e.whenDeleted=n;var l;(function(F){async function $(j){let O;try{if(O=await e.Promises.lstat(j),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(P.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw V}throw B}}F.stat=$;async function oe(j){try{const{stat:O,symbolicLink:B}=await F.stat(j);return O.isFile()&&B?.dangling!==!0}catch{}return!1}F.existsFile=oe;async function K(j){try{const{stat:O,symbolicLink:B}=await F.stat(j);return O.isDirectory()&&B?.dangling!==!0}catch{}return!1}F.existsDirectory=K})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new S.ResourceQueue;function s(F,$,oe){return i.queueFor(A.URI.file(F),R.extUriBiasedIgnorePathCase).queue(()=>{const K=g(oe);return new Promise((j,O)=>o(F,$,K,B=>B?O(B):j()))})}let r=!0;function o(F,$,oe,K){if(!r)return k.writeFile(F,$,{mode:oe.mode,flag:oe.flag},K);k.open(F,oe.flag,oe.mode,(j,O)=>{if(j)return K(j);k.writeFile(O,$,B=>{if(B)return k.close(O,()=>K(B));k.fdatasync(O,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),r=!1),k.close(O,J=>K(J))))})})}function c(F,$,oe){const K=g(oe);if(!r)return k.writeFileSync(F,$,{mode:K.mode,flag:K.flag});const j=k.openSync(F,K.flag,K.mode);try{k.writeFileSync(j,$);try{k.fdatasyncSync(j)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),r=!1}}finally{k.closeSync(j)}}e.writeFileSync=c;function g(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function I(F,$){if(F!==$)try{await e.Promises.rename(F,$)}catch(oe){if(F.toLowerCase()!==$.toLowerCase()&&oe.code==="EXDEV"||F.endsWith("."))await _(F,$,{preserveSymlinks:!1}),await y(F,C.MOVE);else throw oe}}async function _(F,$,oe){return W(F,$,{root:{source:F,target:$},options:oe,handledSourcePaths:new Set})}const z=511;async function W(F,$,oe){if(oe.handledSourcePaths.has(F))return;oe.handledSourcePaths.add(F);const{stat:K,symbolicLink:j}=await l.stat(F);if(j){if(oe.options.preserveSymlinks)try{return await H(F,$,oe)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(j.dangling)return}return K.isDirectory()?ee(F,$,K.mode&z,oe):D(F,$,K.mode&z)}async function ee(F,$,oe,K){await e.Promises.mkdir($,{recursive:!0,mode:oe});const j=await m(F);for(const O of j)await W((0,v.join)(F,O),(0,v.join)($,O),K)}async function D(F,$,oe){await e.Promises.copyFile(F,$),await e.Promises.chmod($,oe)}async function H(F,$,oe){let K=await e.Promises.readlink(F);(0,T.isEqualOrParent)(K,oe.root.source,!P.isLinux)&&(K=(0,v.join)(oe.root.target,K.substr(oe.root.source.length+1))),await e.Promises.symlink(K,$)}e.Promises=new class{get access(){return(0,w.promisify)(k.access)}get stat(){return(0,w.promisify)(k.stat)}get lstat(){return(0,w.promisify)(k.lstat)}get utimes(){return(0,w.promisify)(k.utimes)}get read(){return(F,$,oe,K,j)=>new Promise((O,B)=>{k.read(F,$,oe,K,j,(V,J,se)=>V?B(V):O({bytesRead:J,buffer:se}))})}get readFile(){return(0,w.promisify)(k.readFile)}get write(){return(F,$,oe,K,j)=>new Promise((O,B)=>{k.write(F,$,oe,K,j,(V,J,se)=>V?B(V):O({bytesWritten:J,buffer:se}))})}get appendFile(){return(0,w.promisify)(k.appendFile)}get fdatasync(){return(0,w.promisify)(k.fdatasync)}get truncate(){return(0,w.promisify)(k.truncate)}get rename(){return(0,w.promisify)(k.rename)}get copyFile(){return(0,w.promisify)(k.copyFile)}get open(){return(0,w.promisify)(k.open)}get close(){return(0,w.promisify)(k.close)}get symlink(){return(0,w.promisify)(k.symlink)}get readlink(){return(0,w.promisify)(k.readlink)}get chmod(){return(0,w.promisify)(k.chmod)}get mkdir(){return(0,w.promisify)(k.mkdir)}get unlink(){return(0,w.promisify)(k.unlink)}get rmdir(){return(0,w.promisify)(k.rmdir)}get realpath(){return(0,w.promisify)(k.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return s}get rm(){return y}get move(){return I}get copy(){return _}}}),define(we[140],ye([0,1,30,5,3,15,20]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(C){if(w.isLinux)return C;const y=(0,t.dirname)(C);if(C===y)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const f=(0,T.readdirSync)(y).filter(m=>m.toLowerCase()===d);if(f.length===1){const m=E(y);if(m)return(0,t.join)(m,f[0])}else if(f.length>1){const m=f.indexOf(d);if(m>=0){const p=E(y);if(p)return(0,t.join)(p,f[m])}}}catch{}return null}e.realcaseSync=E;async function v(C){if(w.isLinux)return C;const y=(0,t.dirname)(C);if(C===y)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const f=(await T.Promises.readdir(y)).filter(m=>m.toLowerCase()===d);if(f.length===1){const m=await v(y);if(m)return(0,t.join)(m,f[0])}else if(f.length>1){const m=f.indexOf(d);if(m>=0){const p=await v(y);if(p)return(0,t.join)(p,f[m])}}}catch{}return null}e.realcase=v;async function P(C){try{return await T.Promises.realpath(C)}catch{const d=A(C);return await T.Promises.access(d,k.constants.R_OK),d}}e.realpath=P;function R(C){try{return k.realpathSync(C)}catch{const d=A(C);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=R;function A(C){return(0,S.rtrim)((0,t.normalize)(C),t.sep)}}),define(we[141],ye([0,1,85]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,v,P,R=1){let A=!1;return new Promise(C=>{const y=setTimeout(()=>{if(!A)return A=!0,C(0)},P);w(E,v,R,d=>{if(!A)return A=!0,clearTimeout(y),C(d)})})}e.findFreePort=t;function w(E,v,P,R){if(v===0)return R(0);const A=new k.Socket;A.once("connect",()=>(T(A),w(E+P,v-1,P,R))),A.once("data",()=>{}),A.once("error",C=>(T(A),C.code!=="ECONNREFUSED"?w(E+P,v-1,P,R):R(E))),A.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(E,v,P){let R=!1,A,C=1;const y=k.createServer({pauseOnConnect:!0});function d(b,f){R||(R=!0,y.removeAllListeners(),y.close(),A&&clearTimeout(A),f(b))}return new Promise(b=>{A=setTimeout(()=>{d(0,b)},P),y.on("listening",()=>{d(E,b)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&C<v?(E++,C++,y.listen(E,"127.0.0.1")):d(0,b)}),y.on("close",()=>{d(0,b)}),y.listen(E,"127.0.0.1")})}e.findFreePortFaster=S;function T(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(v){console.error(v)}}}),define(we[86],ye([0,1,27,5,20]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,T=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var v;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(v||(v={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class A{constructor(u,n,l){this.exePath=u,this.displayName=n,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:a=!1}={}){return a?P===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:u=!1}={}){const n=C({useAlternateBitness:a});if(!n)return null;const l=t.join(n,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(l))return null;let i=-1,s=null;for(const c of await w.Promises.readdir(l)){let g=-1;if(u){const _=c.indexOf("-");if(_<0)continue;const z=c.substring(0,_);if(!S.test(z)||c.substring(_+1)!=="preview")continue;g=parseInt(z,10)}else{if(!S.test(c))continue;g=parseInt(c,10)}if(g<=i)continue;const I=t.join(l,c,"pwsh.exe");!await w.SymlinkSupport.existsFile(I)||(s=I,i=g)}if(!s)return null;const r=n.includes("x86")?" (x86)":"",o=u?" Preview":"";return new A(s,`PowerShell${o}${r}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:l}=a?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(u))if(n.test(i)){const s=t.join(u,i,"pwsh.exe");return new A(s,l)}return null}function b(){const a=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new A(a,".NET Core PowerShell Global Tool")}function f(){const a=t.join(process.env.windir,P===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new A(a,"Windows PowerShell",!0)}async function*m(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await d(),a&&(yield a),a=b(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await d({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=f(),a&&(yield a)}async function*p(){for await(const a of m())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=p;async function h(){for await(const a of p())return a;return null}e.getFirstAvailablePowerShellInstallation=h}),define(we[87],ye([0,1,38,8]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function w(T){return new Promise((E,v)=>{let P;const R=new Map;function A(y,d,b,f,m){const p=R.get(d);if(y===T||p){const h={name:C(b),cmd:b,pid:y,ppid:d,load:f,mem:m};R.set(y,h),y===T&&(P=h),p&&(p.children||(p.children=[]),p.children.push(h),p.children.length>1&&(p.children=p.children.sort((a,u)=>a.pid-u.pid)))}}function C(y){const d=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,p=/--crashes-directory/,h=/\\pipe\\winpty-control/,a=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(p.exec(y))return"electron-crash-reporter";if(h.exec(y))return"winpty-process";if(a.exec(y))return"console-window-host (Windows internal process)";let n=u.exec(y);if(n&&n.length===2)return n[1]==="renderer"?d.exec(y)?"shared-process":b.exec(y)?"issue-reporter":f.exec(y)?"process-explorer":"window":n[1]==="utility"&&m.exec(y)?"utility-network-service":n[1];const l=/[a-zA-Z-]+\.js/g;let i="";do n=l.exec(y),n&&(i+=n+" ");while(n);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,b)=>{te(["windows-process-tree"],d,b)}).then(d=>{d.getProcessList(T,b=>{if(!b){v(new Error(`Root process ${T} not found`));return}d.getProcessCpuUsage(b,f=>{const m=new Map;f.forEach(p=>{const h=y(p.commandLine||"");m.set(p.pid,{name:C(h),cmd:h,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),P=m.get(T),P?(m.forEach(p=>{const h=m.get(p.ppid);h&&(h.children||(h.children=[]),h.children.push(p))}),m.forEach(p=>{p.children&&(p.children=p.children.sort((h,a)=>h.pid-a.pid))}),E(P)):v(new Error(`Root process ${T} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[P];const b=[];for(;d.length;){const m=d.shift();m&&(b.push(m.pid),m.children&&(d=d.concat(m.children)))}let f=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",te).fsPath);f+=" "+b.join(" "),(0,k.exec)(f,{},(m,p,h)=>{if(m||h)v(m||new Error(h.toString()));else{const a=p.toString().split(`
`);for(let u=0;u<b.length;u++){const n=R.get(b[u]);n.load=parseFloat(a[u])}if(!P){v(new Error(`Root process ${T} not found`));return}E(P)}})};(0,k.exec)("which ps",{},(d,b,f)=>{if(d||f)if(process.platform!=="linux")v(d||new Error(f.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",te).fsPath);(0,k.exec)(m,{},(p,h,a)=>{p||a?v(p||new Error(a.toString())):(S(h,A),y())})}else{const m=b.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,a,u)=>{h||u&&!u.includes("screen size is bogus")?v(h||new Error(u.toString())):(S(a,A),process.platform==="linux"?y():P?E(P):v(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=w;function S(T,E){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=T.toString().split(`
`);for(const R of P){const A=v.exec(R.trim());A&&A.length===6&&E(parseInt(A[1]),parseInt(A[2]),A[5],parseFloat(A[3]),parseFloat(A[4]))}}});var Re=this&&this.__decorate||function(te,e,k,t){var w=arguments.length,S=w<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(te,e,k,t);else for(var E=te.length-1;E>=0;E--)(T=te[E])&&(S=(w<3?T(S):w>3?T(e,k,S):T(e,k))||S);return w>3&&S&&Object.defineProperty(e,k,S),S};define(we[39],ye([0,1,18,14,16,21,76,9,7,2,44,15,12]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function f(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(m||(m={}));class p{constructor(B){this.buffer=B,this.pos=0}read(B){const V=this.buffer.slice(this.pos,this.pos+B);return this.pos+=V.byteLength,V}}class h{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var a;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(a||(a={}));function u(O){const B=w.VSBuffer.alloc(4);return B.writeUInt32BE(O,0),B}function n(O){return O.read(4).readUInt32BE(0)}function l(O){const B=w.VSBuffer.alloc(1);return B.writeUInt8(O,0),B}const i={Undefined:l(a.Undefined),String:l(a.String),Buffer:l(a.Buffer),VSBuffer:l(a.VSBuffer),Array:l(a.Array),Object:l(a.Object)},s=typeof Buffer!="undefined";function r(O,B){if(typeof B=="undefined")O.write(i.Undefined);else if(typeof B=="string"){const V=w.VSBuffer.fromString(B);O.write(i.String),O.write(u(V.byteLength)),O.write(V)}else if(s&&Buffer.isBuffer(B)){const V=w.VSBuffer.wrap(B);O.write(i.Buffer),O.write(u(V.byteLength)),O.write(V)}else if(B instanceof w.VSBuffer)O.write(i.VSBuffer),O.write(u(B.byteLength)),O.write(B);else if(Array.isArray(B)){O.write(i.Array),O.write(u(B.length));for(const V of B)r(O,V)}else{const V=w.VSBuffer.fromString(JSON.stringify(B));O.write(i.Object),O.write(u(V.byteLength)),O.write(V)}}function o(O){switch(O.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return O.read(n(O)).toString();case a.Buffer:return O.read(n(O)).buffer;case a.VSBuffer:return O.read(n(O));case a.Array:{const V=n(O),J=[];for(let se=0;se<V;se++)J.push(o(O));return J}case a.Object:return JSON.parse(O.read(n(O)).toString())}}class c{constructor(B,V,J=null,se=1e3){this.protocol=B,this.ctx=V,this.logger=J,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(me=>this.onRawMessage(me)),this.sendResponse({type:200})}registerChannel(B,V){this.channels.set(B,V),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const V=this.send([B.type]);this.logger?.logOutgoing(V,0,1,f(B.type));return}case 201:case 202:case 204:case 203:{const V=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(V,B.id,1,f(B.type),B.data);return}}}send(B,V=void 0){const J=new h;return r(J,B),r(J,V),this.sendBuffer(J.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const V=new p(B),J=o(V),se=o(V),me=J[0];switch(me){case 100:return this.logger?.logIncoming(B.byteLength,J[1],1,`${d(me)}: ${J[2]}.${J[3]}`,se),this.onPromise({type:me,id:J[1],channelName:J[2],name:J[3],arg:se});case 102:return this.logger?.logIncoming(B.byteLength,J[1],1,`${d(me)}: ${J[2]}.${J[3]}`,se),this.onEventListen({type:me,id:J[1],channelName:J[2],name:J[3],arg:se});case 101:return this.logger?.logIncoming(B.byteLength,J[1],1,`${d(me)}`),this.disposeActiveRequest({type:me,id:J[1]});case 103:return this.logger?.logIncoming(B.byteLength,J[1],1,`${d(me)}`),this.disposeActiveRequest({type:me,id:J[1]})}}onPromise(B){const V=this.channels.get(B.channelName);if(!V){this.collectPendingRequest(B);return}const J=new S.CancellationTokenSource;let se;try{se=V.call(this.ctx,B.name,B.arg,J.token)}catch(U){se=Promise.reject(U)}const me=B.id;se.then(U=>{this.sendResponse({id:me,data:U,type:201}),this.activeRequests.delete(B.id)},U=>{U instanceof Error?this.sendResponse({id:me,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:me,data:U,type:203}),this.activeRequests.delete(B.id)});const he=(0,P.toDisposable)(()=>J.cancel());this.activeRequests.set(B.id,he)}onEventListen(B){const V=this.channels.get(B.channelName);if(!V){this.collectPendingRequest(B);return}const J=B.id,me=V.listen(this.ctx,B.name,B.arg)(he=>this.sendResponse({id:J,data:he,type:204}));this.activeRequests.set(B.id,me)}disposeActiveRequest(B){const V=this.activeRequests.get(B.id);V&&(V.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let V=this.pendingRequests.get(B.channelName);V||(V=[],this.pendingRequests.set(B.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:B,timeoutTimer:J})}flushPendingRequests(B){const V=this.pendingRequests.get(B);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var g;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(B,V=null){this.protocol=B,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=V}getChannel(B){const V=this;return{call(J,se,me){return V.isDisposed?Promise.reject(E.canceled()):V.requestPromise(B,J,se,me)},listen(J,se){return V.isDisposed?v.Event.None:V.requestEvent(B,J,se)}}}requestPromise(B,V,J,se=S.CancellationToken.None){const me=this.lastRequestId++,U={id:me,type:100,channelName:B,name:V,arg:J};if(se.isCancellationRequested)return Promise.reject(E.canceled());let N;return new Promise((Y,ie)=>{if(se.isCancellationRequested)return ie(E.canceled());const de=()=>{const X=Z=>{switch(Z.type){case 201:this.handlers.delete(me),Y(Z.data);break;case 202:{this.handlers.delete(me);const G=new Error(Z.data.message);G.stack=Z.data.stack,G.name=Z.data.name,ie(G);break}case 203:this.handlers.delete(me),ie(Z.data);break}};this.handlers.set(me,X),this.sendRequest(U)};let le=null;this.state===m.Idle?de():(le=(0,t.createCancelablePromise)(X=>this.whenInitialized()),le.then(()=>{le=null,de()}));const ue=()=>{le?(le.cancel(),le=null):this.sendRequest({id:me,type:101}),ie(E.canceled())},pe=se.onCancellationRequested(ue);N=(0,P.combinedDisposable)((0,P.toDisposable)(ue),pe),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(B,V,J){const se=this.lastRequestId++,he={id:se,type:102,channelName:B,name:V,arg:J};let U=null;const N=new v.Emitter({onFirstListenerAdd:()=>{U=(0,t.createCancelablePromise)(Y=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(N),this.sendRequest(he)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(N),this.sendRequest({id:se,type:103}))}}),q=Y=>N.fire(Y.data);return this.handlers.set(se,q),N.event}sendRequest(B){switch(B.type){case 100:case 102:{const V=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(V,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const V=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(V,B.id,0,d(B.type));return}}}send(B,V=void 0){const J=new h;return r(J,B),r(J,V),this.sendBuffer(J.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const V=new p(B),J=o(V),se=o(V),me=J[0];switch(me){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,f(me)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,J[1],0,f(me),se),this.onResponse({type:J[0],id:J[1],data:se})}}onResponse(B){if(B.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(B.id);V&&V(B)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([T.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class _{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:V,onDidClientDisconnect:J})=>{v.Event.once(V.onMessage)(me=>{const he=new p(me),U=o(he),N=new c(V,U),q=new I(V);this.channels.forEach((ie,de)=>N.registerChannel(de,ie));const Y={channelServer:N,channelClient:q,ctx:U};this._connections.add(Y),this._onDidAddConnection.fire(Y),J(()=>{N.dispose(),q.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)})})})}get connections(){const B=[];return this._connections.forEach(V=>B.push(V)),B}getChannel(B,V){const J=this;return{call(se,me,he){let U;if((0,C.isFunction)(V)){let q=(0,k.getRandomElement)(J.connections.filter(V));U=q?Promise.resolve(q):v.Event.toPromise(v.Event.filter(J.onDidAddConnection,V))}else U=V.routeCall(J,se,me);const N=U.then(q=>q.channelClient.getChannel(B));return W(N).call(se,me,he)},listen(se,me){if((0,C.isFunction)(V))return J.getMulticastEvent(B,V,se,me);const he=V.routeEvent(J,se,me).then(U=>U.channelClient.getChannel(B));return W(he).listen(se,me)}}}getMulticastEvent(B,V,J,se){const me=this;let he=new P.DisposableStore;const U=new v.Emitter({onFirstListenerAdd:()=>{he=new P.DisposableStore;const N=new v.EventMultiplexer,q=new Map,Y=de=>{const ue=de.channelClient.getChannel(B).listen(J,se),pe=N.add(ue);q.set(de,pe)},ie=de=>{const le=q.get(de);!le||(le.dispose(),q.delete(de))};me.connections.filter(V).forEach(Y),v.Event.filter(me.onDidAddConnection,V)(Y,void 0,he),me.onDidRemoveConnection(ie,void 0,he),N.event(U.fire,U,he),he.add(N)},onLastListenerRemove:()=>{he.dispose()}});return U.event}registerChannel(B,V){this.channels.set(B,V),this._connections.forEach(J=>{J.channelServer.registerChannel(B,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class z{constructor(B,V,J=null){const se=new h;r(se,V),B.send(se.buffer),this.channelClient=new I(B,J),this.channelServer=new c(B,V,J)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,V){this.channelServer.registerChannel(B,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=z;function W(O){return{call(B,V,J){return O.then(se=>se.call(B,V,J))},listen(B,V){const J=new v.Relay;return O.then(se=>J.input=se.listen(B,V)),J.event}}}e.getDelayedChannel=W;function ee(O){let B=!1;return{call(V,J,se){return B?O.call(V,J,se):(0,t.timeout)(0).then(()=>B=!0).then(()=>O.call(V,J,se))},listen(V,J){if(B)return O.listen(V,J);const se=new v.Relay;return(0,t.timeout)(0).then(()=>B=!0).then(()=>se.input=O.listen(V,J)),se.event}}}e.getNextTickChannel=ee;class D{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const V of B.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await v.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=D;var H;(function(O){function B(me,he){const U=me,N=he&&he.disableMarshalling,q=new Map;for(const Y in U)J(Y)&&q.set(Y,v.Event.buffer(U[Y],!0));return new class{listen(Y,ie,de){const le=q.get(ie);if(le)return le;if(se(ie)){const ue=U[ie];if(typeof ue=="function")return ue.call(U,de)}throw new Error(`Event not found: ${ie}`)}call(Y,ie,de){const le=U[ie];if(typeof le=="function"){if(!N&&Array.isArray(de))for(let ue=0;ue<de.length;ue++)de[ue]=(0,R.revive)(de[ue]);return le.apply(U,de)}throw new Error(`Method not found: ${ie}`)}}}O.fromService=B;function V(me,he){const U=he&&he.disableMarshalling;return new Proxy({},{get(N,q){if(typeof q=="string")return he?.properties?.has(q)?he.properties.get(q):se(q)?function(Y){return me.listen(q,Y)}:J(q)?me.listen(q):async function(...Y){let ie;he&&!(0,C.isUndefinedOrNull)(he.context)?ie=[he.context,...Y]:ie=Y;const de=await me.call(q,ie);return U?de:(0,R.revive)(de)};throw new Error(`Property not found: ${String(q)}`)}})}O.toService=V;function J(me){return me[0]==="o"&&me[1]==="n"&&A.isUpperAsciiLetter(me.charCodeAt(2))}function se(me){return/^onDynamic/.test(me)&&A.isUpperAsciiLetter(me.charCodeAt(9))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let B=O.toString();if(B!=="[object Object]")return B}return O}function oe(O){return Array.isArray(O)?O.map($):$(O)}function K(O,B,V,J,se,me,he){he=oe(he);const U=F[se],N=U[J%U.length];let q=[`%c[${O}]%c[${String(B).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(me)?(q=q.concat(he),q.push(")")):q.push(he),console.log.apply(console,q)}e.logWithColors=K;class j{constructor(B,V){this._outgoingPrefix=B,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,V,J,se,me){this._totalOutgoing+=B,K(this._outgoingPrefix,this._totalOutgoing,B,V,J,se,me)}logIncoming(B,V,J,se,me){this._totalIncoming+=B,K(this._incomingPrefix,this._totalIncoming,B,V,J,se,me)}}e.IPCLogger=j}),define(we[88],ye([0,1,16,7,2,39]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(s){s.enableDiagnostics=!1,s.records=[];const r=new WeakMap;let o=0;function c(I,_){if(!r.has(I)){const z=String(++o);r.set(I,z)}return r.get(I)}function g(I,_,z,W){if(!s.enableDiagnostics)return;const ee=c(I,_);if(W instanceof k.VSBuffer||W instanceof Uint8Array||W instanceof ArrayBuffer||ArrayBuffer.isView(W)){const D=k.VSBuffer.alloc(W.byteLength);D.set(W),s.records.push({timestamp:Date.now(),id:ee,label:_,type:z,buff:D})}else s.records.push({timestamp:Date.now(),id:ee,label:_,type:z,data:W})}s.traceSocketEvent=g})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function R(){return P||(P=k.VSBuffer.alloc(0)),P}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return R();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const _=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),_}if(this._chunks[0].byteLength>r){const _=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),_}let c=k.VSBuffer.alloc(r),g=0,I=0;for(;r>0;){const _=this._chunks[I];if(_.byteLength>r){const z=_.slice(0,r);c.set(z,g),g+=r,o&&(this._chunks[I]=_.slice(r),this._totalLength-=r),r-=r}else c.set(_,g),g+=_.byteLength,o?(this._chunks.shift(),this._totalLength-=_.byteLength):I++,r-=_.byteLength}return c}}e.ChunkStream=A;var C;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(C||(C={}));function y(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(r,o,c,g){this.type=r,this.id=o,this.ack=c,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends w.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,g=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new b(c,g,I,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=k.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const c=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,c}_bufferTake(){const r=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class p extends w.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=p;class h extends S.IPCClient{constructor(r,o,c=null){super(r,o,c);this.protocol=r}static fromSocket(r,o){return new h(new p(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=h;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class u{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,c=this._first;for(;c;)r[o++]=c.data,c=c.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new u(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<l._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=l._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),o=(1+l._HISTORY_LENGTH)*1e3;let c=0;for(let g=0;g<l._HISTORY_LENGTH;g++)r-this.lastRuns[g]<=o&&c++;return 1-c/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(r,o=null,c=l.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,w.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,R());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,R());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,R());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,w.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let c=0,g=o.length;c<g;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new b(6,0,0,R())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,g=o.length;c<g;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new b(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(r){const o=new b(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,c=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const I=Math.max(2e4-o,2e4-c,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},I)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(we[142],ye([0,1,14,7,2,12]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(A){A[A.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function E(A){const C=A;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var v;(function(A){A[A.None=0]="None",A[A.Initialized=1]="Initialized",A[A.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class P extends w.Disposable{constructor(C,y=Object.create(null)){super();this.database=C,this.options=y,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((y,d)=>this.accept(d,y)),C.deleted?.forEach(y=>this.accept(y,void 0))}accept(C,y){if(this.state===v.Closed)return;let d=!1;(0,S.isUndefinedOrNull)(y)?d=this.cache.delete(C):this.cache.get(C)!==y&&(this.cache.set(C,y),d=!0),d&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,y){const d=this.cache.get(C);return(0,S.isUndefinedOrNull)(d)?y:d}getBoolean(C,y){const d=this.get(C);return(0,S.isUndefinedOrNull)(d)?y:d==="true"}getNumber(C,y){const d=this.get(C);return(0,S.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(C,y){if(this.state===v.Closed)return;if((0,S.isUndefinedOrNull)(y))return this.delete(C);const d=String(y);if(this.cache.get(C)!==d)return this.cache.set(C,d),this.pendingInserts.set(C,d),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===v.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert&&C.insert.forEach((y,d)=>this.items.set(d,y)),C.delete&&C.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=R}),define(we[89],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class k{constructor(w,S){this.lineNumber=w,this.column=S}with(w=this.lineNumber,S=this.column){return w===this.lineNumber&&S===this.column?this:new k(w,S)}delta(w=0,S=0){return this.with(this.lineNumber+w,this.column+S)}equals(w){return k.equals(this,w)}static equals(w,S){return!w&&!S?!0:!!w&&!!S&&w.lineNumber===S.lineNumber&&w.column===S.column}isBefore(w){return k.isBefore(this,w)}static isBefore(w,S){return w.lineNumber<S.lineNumber?!0:S.lineNumber<w.lineNumber?!1:w.column<S.column}isBeforeOrEqual(w){return k.isBeforeOrEqual(this,w)}static isBeforeOrEqual(w,S){return w.lineNumber<S.lineNumber?!0:S.lineNumber<w.lineNumber?!1:w.column<=S.column}static compare(w,S){const T=w.lineNumber|0,E=S.lineNumber|0;if(T===E){const v=w.column|0,P=S.column|0;return v-P}return T-E}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(w){return new k(w.lineNumber,w.column)}static isIPosition(w){return w&&typeof w.lineNumber=="number"&&typeof w.column=="number"}}e.Position=k}),define(we[46],ye([0,1,89]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(S,T,E,v){S>E||S===E&&T>v?(this.startLineNumber=E,this.startColumn=v,this.endLineNumber=S,this.endColumn=T):(this.startLineNumber=S,this.startColumn=T,this.endLineNumber=E,this.endColumn=v)}isEmpty(){return t.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return t.containsPosition(this,S)}static containsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<S.startColumn||T.lineNumber===S.endLineNumber&&T.column>S.endColumn)}static strictContainsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<=S.startColumn||T.lineNumber===S.endLineNumber&&T.column>=S.endColumn)}containsRange(S){return t.containsRange(this,S)}static containsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>S.endColumn)}strictContainsRange(S){return t.strictContainsRange(this,S)}static strictContainsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<=S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>=S.endColumn)}plusRange(S){return t.plusRange(this,S)}static plusRange(S,T){let E,v,P,R;return T.startLineNumber<S.startLineNumber?(E=T.startLineNumber,v=T.startColumn):T.startLineNumber===S.startLineNumber?(E=T.startLineNumber,v=Math.min(T.startColumn,S.startColumn)):(E=S.startLineNumber,v=S.startColumn),T.endLineNumber>S.endLineNumber?(P=T.endLineNumber,R=T.endColumn):T.endLineNumber===S.endLineNumber?(P=T.endLineNumber,R=Math.max(T.endColumn,S.endColumn)):(P=S.endLineNumber,R=S.endColumn),new t(E,v,P,R)}intersectRanges(S){return t.intersectRanges(this,S)}static intersectRanges(S,T){let E=S.startLineNumber,v=S.startColumn,P=S.endLineNumber,R=S.endColumn,A=T.startLineNumber,C=T.startColumn,y=T.endLineNumber,d=T.endColumn;return E<A?(E=A,v=C):E===A&&(v=Math.max(v,C)),P>y?(P=y,R=d):P===y&&(R=Math.min(R,d)),E>P||E===P&&v>R?null:new t(E,v,P,R)}equalsRange(S){return t.equalsRange(this,S)}static equalsRange(S,T){return!!S&&!!T&&S.startLineNumber===T.startLineNumber&&S.startColumn===T.startColumn&&S.endLineNumber===T.endLineNumber&&S.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(S){return new k.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(S){return new k.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,T){return new t(this.startLineNumber,this.startColumn,S,T)}setStartPosition(S,T){return new t(S,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(S){return new t(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,T=S){return new t(S.lineNumber,S.column,T.lineNumber,T.column)}static lift(S){return S?new t(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn)}static areIntersecting(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,T){if(S&&T){const P=S.startLineNumber|0,R=T.startLineNumber|0;if(P===R){const A=S.startColumn|0,C=T.startColumn|0;if(A===C){const y=S.endLineNumber|0,d=T.endLineNumber|0;if(y===d){const b=S.endColumn|0,f=T.endColumn|0;return b-f}return y-d}return A-C}return P-R}return(S?1:0)-(T?1:0)}static compareRangesUsingEnds(S,T){return S.endLineNumber===T.endLineNumber?S.endColumn===T.endColumn?S.startLineNumber===T.startLineNumber?S.startColumn-T.startColumn:S.startLineNumber-T.startLineNumber:S.endColumn-T.endColumn:S.endLineNumber-T.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[143],ye([0,1,7,2]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class w{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,v){return this._map.set(E,v),this.fire([E]),(0,t.toDisposable)(()=>{this._map.get(E)===v&&(this._map.delete(E),this.fire([E]))})}registerFactory(E,v){this._factories.get(E)?.dispose();const P=new S(this,E,v);return this._factories.set(E,P),(0,t.toDisposable)(()=>{const R=this._factories.get(E);!R||R!==P||(this._factories.delete(E),R.dispose())})}async getOrCreate(E){const v=this.get(E);if(v)return v;const P=this._factories.get(E);return!P||P.isResolved?null:(await P.resolve(),this.get(E))}get(E){return this._map.get(E)||null}isResolved(E){if(this.get(E))return!0;const P=this._factories.get(E);return!!(!P||P.isResolved)}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=w;class S extends t.Disposable{constructor(E,v,P){super();this._registry=E,this._languageId=v,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const E=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,E&&!this._isDisposed&&this._register(this._registry.register(this._languageId,E))}}}),define(we[144],ye([0,1,4,46,143,37]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(D){D[D.Null=0]="Null",D[D.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var E;(function(D){D[D.NotSet=-1]="NotSet",D[D.None=0]="None",D[D.Italic=1]="Italic",D[D.Bold=2]="Bold",D[D.Underline=4]="Underline",D[D.Strikethrough=8]="Strikethrough"})(E=e.FontStyle||(e.FontStyle={}));var v;(function(D){D[D.None=0]="None",D[D.DefaultForeground=1]="DefaultForeground",D[D.DefaultBackground=2]="DefaultBackground"})(v=e.ColorId||(e.ColorId={}));var P;(function(D){D[D.Other=0]="Other",D[D.Comment=1]="Comment",D[D.String=2]="String",D[D.RegEx=3]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var R;(function(D){D[D.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",D[D.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",D[D.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",D[D.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",D[D.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",D[D.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",D[D.ITALIC_MASK=2048]="ITALIC_MASK",D[D.BOLD_MASK=4096]="BOLD_MASK",D[D.UNDERLINE_MASK=8192]="UNDERLINE_MASK",D[D.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",D[D.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",D[D.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",D[D.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",D[D.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",D[D.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",D[D.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",D[D.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",D[D.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",D[D.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",D[D.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",D[D.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",D[D.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R=e.MetadataConsts||(e.MetadataConsts={}));class A{static getLanguageId(H){return(H&255)>>>0}static getTokenType(H){return(H&768)>>>8}static containsBalancedBrackets(H){return(H&1024)!=0}static getFontStyle(H){return(H&30720)>>>11}static getForeground(H){return(H&16744448)>>>15}static getBackground(H){return(H&4278190080)>>>24}static getClassNameFromMetadata(H){const F=this.getForeground(H);let $="mtk"+F;const oe=this.getFontStyle(H);return oe&1&&($+=" mtki"),oe&2&&($+=" mtkb"),oe&4&&($+=" mtku"),oe&8&&($+=" mtks"),$}static getInlineStyleFromMetadata(H,F){const $=this.getForeground(H),oe=this.getFontStyle(H);let K=`color: ${F[$]};`;oe&1&&(K+="font-style: italic;"),oe&2&&(K+="font-weight: bold;");let j="";return oe&4&&(j+=" underline"),oe&8&&(j+=" line-through"),j&&(K+=`text-decoration:${j};`),K}static getPresentationFromMetadata(H){const F=this.getForeground(H),$=this.getFontStyle(H);return{foreground:F,italic:Boolean($&1),bold:Boolean($&2),underline:Boolean($&4),strikethrough:Boolean($&8)}}}e.TokenMetadata=A;class C{constructor(H,F,$){this._tokenBrand=void 0,this.offset=H,this.type=F,this.language=$}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class y{constructor(H,F){this._tokenizationResultBrand=void 0,this.tokens=H,this.endState=F}}e.TokenizationResult=y;class d{constructor(H,F){this._encodedTokenizationResultBrand=void 0,this.tokens=H,this.endState=F}}e.EncodedTokenizationResult=d;var b;(function(D){D[D.Method=0]="Method",D[D.Function=1]="Function",D[D.Constructor=2]="Constructor",D[D.Field=3]="Field",D[D.Variable=4]="Variable",D[D.Class=5]="Class",D[D.Struct=6]="Struct",D[D.Interface=7]="Interface",D[D.Module=8]="Module",D[D.Property=9]="Property",D[D.Event=10]="Event",D[D.Operator=11]="Operator",D[D.Unit=12]="Unit",D[D.Value=13]="Value",D[D.Constant=14]="Constant",D[D.Enum=15]="Enum",D[D.EnumMember=16]="EnumMember",D[D.Keyword=17]="Keyword",D[D.Text=18]="Text",D[D.Color=19]="Color",D[D.File=20]="File",D[D.Reference=21]="Reference",D[D.Customcolor=22]="Customcolor",D[D.Folder=23]="Folder",D[D.TypeParameter=24]="TypeParameter",D[D.User=25]="User",D[D.Issue=26]="Issue",D[D.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var f;(function(D){const H=new Map;H.set(0,S.Codicon.symbolMethod),H.set(1,S.Codicon.symbolFunction),H.set(2,S.Codicon.symbolConstructor),H.set(3,S.Codicon.symbolField),H.set(4,S.Codicon.symbolVariable),H.set(5,S.Codicon.symbolClass),H.set(6,S.Codicon.symbolStruct),H.set(7,S.Codicon.symbolInterface),H.set(8,S.Codicon.symbolModule),H.set(9,S.Codicon.symbolProperty),H.set(10,S.Codicon.symbolEvent),H.set(11,S.Codicon.symbolOperator),H.set(12,S.Codicon.symbolUnit),H.set(13,S.Codicon.symbolValue),H.set(15,S.Codicon.symbolEnum),H.set(14,S.Codicon.symbolConstant),H.set(15,S.Codicon.symbolEnum),H.set(16,S.Codicon.symbolEnumMember),H.set(17,S.Codicon.symbolKeyword),H.set(27,S.Codicon.symbolSnippet),H.set(18,S.Codicon.symbolText),H.set(19,S.Codicon.symbolColor),H.set(20,S.Codicon.symbolFile),H.set(21,S.Codicon.symbolReference),H.set(22,S.Codicon.symbolCustomColor),H.set(23,S.Codicon.symbolFolder),H.set(24,S.Codicon.symbolTypeParameter),H.set(25,S.Codicon.account),H.set(26,S.Codicon.issues);function F(K){let j=H.get(K);return j||(console.info("No codicon found for CompletionItemKind "+K),j=S.Codicon.symbolProperty),j}D.toIcon=F;const $=new Map;$.set("method",0),$.set("function",1),$.set("constructor",2),$.set("field",3),$.set("variable",4),$.set("class",5),$.set("struct",6),$.set("interface",7),$.set("module",8),$.set("property",9),$.set("event",10),$.set("operator",11),$.set("unit",12),$.set("value",13),$.set("constant",14),$.set("enum",15),$.set("enum-member",16),$.set("enumMember",16),$.set("keyword",17),$.set("snippet",27),$.set("text",18),$.set("color",19),$.set("file",20),$.set("reference",21),$.set("customcolor",22),$.set("folder",23),$.set("type-parameter",24),$.set("typeParameter",24),$.set("account",25),$.set("issue",26);function oe(K,j){let O=$.get(K);return typeof O=="undefined"&&!j&&(O=9),O}D.fromString=oe})(f=e.CompletionItemKinds||(e.CompletionItemKinds={}));var m;(function(D){D[D.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(D){D[D.KeepWhitespace=1]="KeepWhitespace",D[D.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(D){D[D.Invoke=0]="Invoke",D[D.TriggerCharacter=1]="TriggerCharacter",D[D.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var a;(function(D){D[D.Automatic=0]="Automatic",D[D.Explicit=1]="Explicit"})(a=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(D){D[D.Invoke=1]="Invoke",D[D.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(D){D[D.Invoke=1]="Invoke",D[D.TriggerCharacter=2]="TriggerCharacter",D[D.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(D){D[D.Text=0]="Text",D[D.Read=1]="Read",D[D.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(D){return D&&k.URI.isUri(D.uri)&&t.Range.isIRange(D.range)&&(t.Range.isIRange(D.originSelectionRange)||t.Range.isIRange(D.targetSelectionRange))}e.isLocationLink=i;var s;(function(D){D[D.File=0]="File",D[D.Module=1]="Module",D[D.Namespace=2]="Namespace",D[D.Package=3]="Package",D[D.Class=4]="Class",D[D.Method=5]="Method",D[D.Property=6]="Property",D[D.Field=7]="Field",D[D.Constructor=8]="Constructor",D[D.Enum=9]="Enum",D[D.Interface=10]="Interface",D[D.Function=11]="Function",D[D.Variable=12]="Variable",D[D.Constant=13]="Constant",D[D.String=14]="String",D[D.Number=15]="Number",D[D.Boolean=16]="Boolean",D[D.Array=17]="Array",D[D.Object=18]="Object",D[D.Key=19]="Key",D[D.Null=20]="Null",D[D.EnumMember=21]="EnumMember",D[D.Struct=22]="Struct",D[D.Event=23]="Event",D[D.Operator=24]="Operator",D[D.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(D){D[D.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(D){const H=new Map;H.set(0,S.Codicon.symbolFile),H.set(1,S.Codicon.symbolModule),H.set(2,S.Codicon.symbolNamespace),H.set(3,S.Codicon.symbolPackage),H.set(4,S.Codicon.symbolClass),H.set(5,S.Codicon.symbolMethod),H.set(6,S.Codicon.symbolProperty),H.set(7,S.Codicon.symbolField),H.set(8,S.Codicon.symbolConstructor),H.set(9,S.Codicon.symbolEnum),H.set(10,S.Codicon.symbolInterface),H.set(11,S.Codicon.symbolFunction),H.set(12,S.Codicon.symbolVariable),H.set(13,S.Codicon.symbolConstant),H.set(14,S.Codicon.symbolString),H.set(15,S.Codicon.symbolNumber),H.set(16,S.Codicon.symbolBoolean),H.set(17,S.Codicon.symbolArray),H.set(18,S.Codicon.symbolObject),H.set(19,S.Codicon.symbolKey),H.set(20,S.Codicon.symbolNull),H.set(21,S.Codicon.symbolEnumMember),H.set(22,S.Codicon.symbolStruct),H.set(23,S.Codicon.symbolEvent),H.set(24,S.Codicon.symbolOperator),H.set(25,S.Codicon.symbolTypeParameter);function F($){let oe=H.get($);return oe||(console.info("No codicon found for SymbolKind "+$),oe=S.Codicon.symbolProperty),oe}D.toIcon=F})(o=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(H){this.value=H}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var g;(function(D){function H(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}D.is=H})(g=e.Command||(e.Command={}));var I;(function(D){D[D.Collapsed=0]="Collapsed",D[D.Expanded=1]="Expanded"})(I=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _;(function(D){D[D.Unresolved=0]="Unresolved",D[D.Resolved=1]="Resolved"})(_=e.CommentThreadState||(e.CommentThreadState={}));var z;(function(D){D[D.Editing=0]="Editing",D[D.Preview=1]="Preview"})(z=e.CommentMode||(e.CommentMode={}));var W;(function(D){D[D.Type=1]="Type",D[D.Parameter=2]="Parameter"})(W=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new w.TokenizationRegistry;var ee;(function(D){D[D.None=0]="None",D[D.Option=1]="Option",D[D.Default=2]="Default",D[D.Preferred=3]="Preferred"})(ee=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[145],ye([10,11]),function(te,e){return te.create("vs/base/common/date",e)}),define(we[146],ye([0,1,145]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,w=t*60,S=w*24,T=S*7,E=S*30,v=S*365;function P(A,C,y){typeof A!="number"&&(A=A.getTime());const d=Math.round((new Date().getTime()-A)/1e3);if(d<-30)return(0,k.localize)(0,null,P(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let b;return d<t?(b=d,C?b===1?y?(0,k.localize)(2,null,b):(0,k.localize)(3,null,b):y?(0,k.localize)(4,null,b):(0,k.localize)(5,null,b):b===1?y?(0,k.localize)(6,null,b):(0,k.localize)(7,null,b):y?(0,k.localize)(8,null,b):(0,k.localize)(9,null,b)):d<w?(b=Math.floor(d/t),C?b===1?y?(0,k.localize)(10,null,b):(0,k.localize)(11,null,b):y?(0,k.localize)(12,null,b):(0,k.localize)(13,null,b):b===1?y?(0,k.localize)(14,null,b):(0,k.localize)(15,null,b):y?(0,k.localize)(16,null,b):(0,k.localize)(17,null,b)):d<S?(b=Math.floor(d/w),C?b===1?y?(0,k.localize)(18,null,b):(0,k.localize)(19,null,b):y?(0,k.localize)(20,null,b):(0,k.localize)(21,null,b):b===1?y?(0,k.localize)(22,null,b):(0,k.localize)(23,null,b):y?(0,k.localize)(24,null,b):(0,k.localize)(25,null,b)):d<T?(b=Math.floor(d/S),C?b===1?(0,k.localize)(26,null,b):(0,k.localize)(27,null,b):b===1?(0,k.localize)(28,null,b):(0,k.localize)(29,null,b)):d<E?(b=Math.floor(d/T),C?b===1?y?(0,k.localize)(30,null,b):(0,k.localize)(31,null,b):y?(0,k.localize)(32,null,b):(0,k.localize)(33,null,b):b===1?y?(0,k.localize)(34,null,b):(0,k.localize)(35,null,b):y?(0,k.localize)(36,null,b):(0,k.localize)(37,null,b)):d<v?(b=Math.floor(d/E),C?b===1?y?(0,k.localize)(38,null,b):(0,k.localize)(39,null,b):y?(0,k.localize)(40,null,b):(0,k.localize)(41,null,b):b===1?y?(0,k.localize)(42,null,b):(0,k.localize)(43,null,b):y?(0,k.localize)(44,null,b):(0,k.localize)(45,null,b)):(b=Math.floor(d/v),C?b===1?y?(0,k.localize)(46,null,b):(0,k.localize)(47,null,b):y?(0,k.localize)(48,null,b):(0,k.localize)(49,null,b):b===1?y?(0,k.localize)(50,null,b):(0,k.localize)(51,null,b):y?(0,k.localize)(52,null,b):(0,k.localize)(53,null,b))}e.fromNow=P;function R(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(we[147],ye([10,11]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(we[36],ye([0,1,18,12,147]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function S(A,C){return C&&(A.stack||A.stacktrace)?w.localize(0,null,E(A),T(A.stack)||T(A.stacktrace)):E(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function E(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?w.localize(1,null,A.message):A.message||w.localize(2,null)}function v(A=null,C=!1){if(!A)return w.localize(3,null);if(Array.isArray(A)){const y=k.coalesce(A),d=v(y[0],C);return y.length>1?w.localize(4,null,d,y.length):d}if(t.isString(A))return A;if(A.detail){const y=A.detail;if(y.error)return S(y.error,C);if(y.exception)return S(y.exception,C)}return A.stack?S(A,C):A.message?A.message:w.localize(5,null)}e.toErrorMessage=v;function P(A){const C=A;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=P;function R(A,C){let y;return typeof A=="string"?y=new Error(A):y=A,y.actions=C,y}e.createErrorWithActions=R}),define(we[148],ye([10,11]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(we[149],ye([0,1,148]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(w){switch(w){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[150],ye([10,11]),function(te,e){return te.create("vs/base/node/processes",e)}),define(we[90],ye([0,1,38,33,8,22,5,3,25,53,12,136,20,150]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(u,n){if(E.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};n&&(l.cwd=n);const i=k.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],l);return new Promise(s=>{i.once("error",r=>{s({success:!1,error:r})}),i.once("exit",(r,o)=>{s(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(E.isLinux||E.isMacintosh)try{const l=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(i=>{k.execFile(l,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,r,o)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function f(u=v.env){return u.comspec||"cmd.exe"}e.getWindowsShell=f;class m{constructor(n,l,i,s){if(l!==void 0&&i!==void 0&&s!==void 0)this.cmd=n,this.args=l,this.shell=i,this.options=s;else{const r=n;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(v.env).forEach(o=>{r[o]=v.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const l=n.lastIndexOf(T.sep);return l!==-1&&(n=n.substring(l+1)),m.WellKnowCommands[n]?n:"other"}start(n){return E.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(v.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(l=>{let i,s;const r=new Promise((o,c)=>{i=o,s=c});if(l){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=k.exec(o,this.options,(c,g,I)=>{this.childProcess=null;const _=c;_&&_.killed?s({killed:this.terminateRequested,stdout:g.toString(),stderr:I.toString()}):this.handleExec(i,n,c,g,I)})}else{let o=null;const c=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,i,n,s);const I={terminated:this.terminateRequested};R.isNumber(g)&&(I.cmdCode=g),i(I)};if(this.shell&&E.isWindows){const g=S.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let I=!1,_=!1;const z=[];let W=this.ensureQuotes(this.cmd);z.push(W.value),I=W.quoted,this.args&&this.args.forEach(D=>{W=this.ensureQuotes(D),z.push(W.value),_=_&&W.quoted});const ee=["/s","/c"];I?_?ee.push('"'+z.join(" ")+'"'):z.length>1?ee.push('"'+z[0]+'" '+z.slice(1).join(" ")):ee.push('"'+z[0]+'"'):ee.push(z.join(" ")),o=k.spawn(f(),ee,g)}else this.cmd&&(o=k.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(R.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",g=>{this.childProcess=null,s({terminated:this.terminateRequested,error:g})}),o.pid&&(this.childProcess.on("close",c),this.handleSpawn(o,i,n,s,!0)))}return r})}handleClose(n,l,i,s){}ensureQuotes(n){return m.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,b(n,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!E.isWindows)return n(!1);const l=k.spawn(f(),["/s","/c"]);l.on("error",i=>n(!0)),l.on("exit",i=>n(!1))})}}e.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class p extends m{constructor(n,l,i,s){super(n,l,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,l,i,s,r){[s,r].forEach((o,c)=>{const g=new A.LineDecoder;g.write(o).forEach(z=>{l({line:z,source:c===0?0:1})});const _=g.end();_&&l({line:_,source:c===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,l,i,s,r){const o=new A.LineDecoder,c=new A.LineDecoder;n.stdout.on("data",g=>{o.write(g).forEach(_=>i({line:_,source:0}))}),n.stderr.on("data",g=>{c.write(g).forEach(_=>i({line:_,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=c}handleClose(n,l,i,s){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=p;function h(u){let n=[],l=!1;const i=function(s){if(l){n.push(s);return}(!u.send(s,o=>{if(o&&console.error(o),l=!1,n.length>0){const c=n.slice(0);n=[],c.forEach(g=>i(g))}})||E.isWindows)&&(l=!0)};return{send:i}}e.createQueuedSender=h;var a;(function(u){async function n(l,i,s){if(T.isAbsolute(l))return l;if(i===void 0&&(i=v.cwd()),T.dirname(l)!=="."||(s===void 0&&R.isString(v.env.PATH)&&(s=v.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(i,l);async function o(c){if(await C.Promises.exists(c)){let g;try{g=await C.Promises.stat(c)}catch(I){I.message.startsWith("EACCES")&&(g=await C.Promises.lstat(c))}return g?!g.isDirectory():!1}return!1}for(let c of s){let g;if(T.isAbsolute(c)?g=T.join(c,l):g=T.join(i,c,l),await o(g))return g;let I=g+".com";if(await o(I)||(I=g+".exe",await o(I)))return I}return T.join(i,l)}u.findExecutable=n})(a=e.win32||(e.win32={}))}),define(we[151],ye([0,1,27,3,86,90]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,d){return y===1?t.isWindows?A():S.getWindowsShell(d):P(y,d)}e.getSystemShell=T;function E(y,d){return y===1?t.isWindows?C(d):S.getWindowsShell(d):P(y,d)}e.getSystemShellSync=E;let v=null;function P(y,d){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!v){let b;if(t.isWindows)b="/bin/bash";else{if(b=d.SHELL,!b)try{b=(0,k.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}v=b}return v}let R=null;async function A(){return R||(R=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),R}function C(y){if(R)return R;const d=t.isWindows&&parseFloat((0,k.release)())>=10,b=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${y.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?f:S.getWindowsShell(y)}}),define(we[91],ye([0,1,38,14,16,21,80,9,7,2,22,90,53,39]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(m){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>w.VSBuffer.wrap(Buffer.from(p,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=d;class b{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new t.Delayer(h),this.child=null,this._client=null}getChannel(m){const p=this;return{call(h,a,u){return p.requestPromise(m,h,a,u)},listen(h,a){return p.requestEvent(m,h,a)}}}requestPromise(m,p,h,a=S.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(m),n=(0,t.createCancelablePromise)(s=>u.call(p,h,s)),l=a.onCancellationRequested(()=>n.cancel()),i=(0,P.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{l.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(m,p,h){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let a;const u=new v.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(m).listen(p,h)(u.fire,u),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,C.removeDangerousEnvVariables)(p.env),this.child=(0,k.fork)(this.modulePath,m,p);const h=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(r,"base64")))});const u=this.options.useQueue?(0,A.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&u.send(r.buffer.toString("base64")),l=h.event,i={send:n,onMessage:l};this._client=new y.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",s),this.activeRequests.forEach(c=>(0,P.dispose)(c)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(we[152],ye([10,11]),function(te,e){return te.create("vs/base/node/zip",e)}),define(we[153],ye([10,11]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[154],ye([10,11]),function(te,e){return te.create("vs/platform/environment/node/argv",e)}),define(we[155],ye([10,11]),function(te,e){return te.create("vs/platform/environment/node/argvHelper",e)}),define(we[156],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[157],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[158],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(we[159],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[160],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[161],ye([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[162],ye([10,11]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[163],ye([10,11]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(we[164],ye([10,11]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(we[165],ye([10,11]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(we[166],ye([10,11]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[167],ye([10,11]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(we[168],ye([10,11]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(we[169],ye([10,11]),function(te,e){return te.create("vs/platform/shell/node/shellEnv",e)}),define(we[170],ye([10,11]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[171],ye([10,11]),function(te,e){return te.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[172],ye([10,11]),function(te,e){return te.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[173],ye([10,11]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(we[174],ye([10,11]),function(te,e){return te.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(we[175],ye([10,11]),function(te,e){return te.create("vs/server/node/serverEnvironmentService",e)}),define(we[176],ye([10,11]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(we[177],ye([10,11]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[178],ye([0,1,7,2]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class w{constructor(){this._onCloseEmitter=new k.Emitter,this._onReloadEmitter=new k.Emitter,this._onTerminateEmitter=new k.Emitter,this._onAttachEmitter=new k.Emitter}call(E,v,P){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:P[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:P[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:P[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:P[0],port:P[1],subId:P[2]}))}throw new Error("Method not implemented.")}listen(E,v,P){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=w,w.ChannelName="extensionhostdebugservice";class S extends t.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,v,P){this.channel.call("attach",[E,v,P])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,v){this.channel.call("terminate",[E,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,v){return this.channel.call("openExtensionDevelopmentHostWindow",[E,v])}}e.ExtensionHostDebugChannelClient=S}),define(we[179],ye([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(T){this.service=T}listen(T,E,v){throw new Error("Invalid listen")}call(T,E,v){switch(E){case"download":return this.service.download(k.URI.revive(v[0]),k.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class w{constructor(T,E){this.channel=T,this.getUriTransformer=E}async download(T,E){const v=this.getUriTransformer();v&&(T=v.transformOutgoingURI(T),E=v.transformOutgoingURI(E)),await this.channel.call("download",[T,E])}}e.DownloadServiceChannelClient=w}),define(we[180],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var k;(function(E){E[E.ACTIVATE=1]="ACTIVATE",E[E.RESTORE=2]="RESTORE",E[E.PRESERVE=3]="PRESERVE"})(k=e.EditorActivation||(e.EditorActivation={}));var t;(function(E){E[E.PICK=0]="PICK",E[E.DISABLED=1]="DISABLED",E[E.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var w;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(w=e.EditorOpenSource||(e.EditorOpenSource={}));var S;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var T;(function(E){E.PROGRAMMATIC="api",E.NAVIGATION="code.navigation",E.JUMP="code.jump"})(T=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[181],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class k{constructor(w){this.machineId=w}encryption(){return new Promise((w,S)=>te(["vscode-encrypt"],w,S))}async encrypt(w){try{return(await this.encryption()).encrypt(this.machineId,w)}catch{return w}}async decrypt(w){try{return(await this.encryption()).decrypt(this.machineId,w)}catch{return w}}}e.EncryptionMainService=k}),define(we[92],ye([0,1,146,76,8,5,25,19,4]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(b,f,m){this._args=b,this.paths=f,this.productService=m}get appRoot(){return(0,S.dirname)(w.FileAccess.asFileUri("",te).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(v.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=T.env.VSCODE_PORTABLE;return b?v.URI.file((0,S.join)(b,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,S.resolve)(b):(0,S.normalize)((0,S.join)(w.FileAccess.asFileUri("",te).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,S.resolve)(b):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,S.resolve)(b);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const m=T.env.VSCODE_PORTABLE;return m?(0,S.join)(m,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(f=>/^[^:/?#]+?:\/\//.test(f)?v.URI.parse(f):v.URI.file((0,S.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?v.URI.parse(b):v.URI.file((0,S.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return v.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Re([t.memoize],P.prototype,"appRoot",null),Re([t.memoize],P.prototype,"userHome",null),Re([t.memoize],P.prototype,"userDataPath",null),Re([t.memoize],P.prototype,"appSettingsHome",null),Re([t.memoize],P.prototype,"tmpDir",null),Re([t.memoize],P.prototype,"cacheHome",null),Re([t.memoize],P.prototype,"userRoamingDataHome",null),Re([t.memoize],P.prototype,"settingsResource",null),Re([t.memoize],P.prototype,"userDataSyncHome",null),Re([t.memoize],P.prototype,"userDataSyncLogResource",null),Re([t.memoize],P.prototype,"sync",null),Re([t.memoize],P.prototype,"machineSettingsResource",null),Re([t.memoize],P.prototype,"globalStorageHome",null),Re([t.memoize],P.prototype,"workspaceStorageHome",null),Re([t.memoize],P.prototype,"localHistoryHome",null),Re([t.memoize],P.prototype,"keybindingsResource",null),Re([t.memoize],P.prototype,"keyboardLayoutResource",null),Re([t.memoize],P.prototype,"argvResource",null),Re([t.memoize],P.prototype,"snippetsHome",null),Re([t.memoize],P.prototype,"isExtensionDevelopment",null),Re([t.memoize],P.prototype,"untitledWorkspacesHome",null),Re([t.memoize],P.prototype,"installSourcePath",null),Re([t.memoize],P.prototype,"builtinExtensionsPath",null),Re([t.memoize],P.prototype,"extensionsPath",null),Re([t.memoize],P.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],P.prototype,"extensionDevelopmentKind",null),Re([t.memoize],P.prototype,"extensionTestsLocationURI",null),Re([t.memoize],P.prototype,"debugExtensionHost",null),Re([t.memoize],P.prototype,"serviceMachineIdResource",null),Re([t.memoize],P.prototype,"telemetryLogResource",null),Re([t.memoize],P.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=P;function R(d,b){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,b,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=R;function A(d,b){return y(d["inspect-search"],d["inspect-brk-search"],5876,b,d.extensionEnvironment)}e.parseSearchPort=A;function C(d,b){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,b,d.extensionEnvironment)}e.parsePtyHostPort=C;function y(d,b,f,m,p,h){const u=Number(b||d)||(m?null:f),n=u?Boolean(!!b):!1;let l;if(h)try{l=JSON.parse(h)}catch{}return{port:u,break:n,debugId:p,env:l}}}),define(we[54],ye([0,1,259,3,154]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(14,null)},category:{type:"string",cat:"e",description:(0,w.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,w.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,w.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,w.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function E(d,b,f=T){const m={},p=["_"],h=[];for(let l in b){const i=b[l];i.alias&&(m[l]=i.alias),i.type==="string"||i.type==="string[]"?(p.push(l),i.deprecates&&p.push(...i.deprecates)):i.type==="boolean"&&(h.push(l),i.deprecates&&h.push(...i.deprecates))}const a=k(d,{string:p,boolean:h,alias:m}),u={},n=a;u._=a._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(let l in b){const i=b[l];i.alias&&delete n[i.alias];let s=n[l];if(i.deprecates)for(const r of i.deprecates)n.hasOwnProperty(r)&&(s||(s=n[r],s&&f.onDeprecatedOption(r,i.deprecationMessage||(0,w.localize)(33,null,l))),delete n[r]);typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),f.onMultipleValues(l,s)),u[l]=s,i.deprecationMessage&&f.onDeprecatedOption(l,i.deprecationMessage)),delete n[l]}for(let l in n)f.onUnknownOption(l);return u}e.parseArgs=E;function v(d,b){let f="";return b.args&&(Array.isArray(b.args)?f=` <${b.args.join("> <")}>`:f=` <${b.args}>`),b.alias?`-${b.alias} --${d}${f}`:`--${d}${f}`}function P(d,b){let f=0,m=[];for(const u in d){const n=d[u],l=v(u,n);f=Math.max(f,l.length),m.push([l,n.description])}let p=f+2+1;if(b-p<25)return m.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let h=b-p-1,a=[];for(const u of m){let n=u[0],l=A(u[1],h),i=R(p-n.length-2);a.push("  "+n+i+l[0]);for(let s=1;s<l.length;s++)a.push(R(p)+l[s])}return a}e.formatOptions=P;function R(d){return" ".repeat(d)}function A(d,b){let f=[];for(;d.length;){let m=d.length<b?d.length:d.lastIndexOf(" ",b),p=d.slice(0,m).trim();d=d.slice(m),f.push(p)}return f}function C(d,b,f,m,p){const h=process.stdout.isTTY&&process.stdout.columns||80,a=p?.noInputFiles!==!0?`[${(0,w.localize)(34,null)}...]`:"",u=[`${d} ${f}`];u.push(""),u.push(`${(0,w.localize)(35,null)}: ${b} [${(0,w.localize)(36,null)}]${a}`),u.push(""),p?.noPipe!==!0&&(t.isWindows?u.push((0,w.localize)(37,null,b)):u.push((0,w.localize)(38,null,b)),u.push(""));const n={};for(const l in m){const i=m[l];if(i.description&&i.cat){let s=n[i.cat];s||(n[i.cat]=s={}),s[l]=i}}for(let l in n){const i=l;let s=n[i];s&&(u.push(S[i]),u.push(...P(s,h)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=C;function y(d,b){return`${d||(0,w.localize)(39,null)}
${b||(0,w.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(we[182],ye([0,1,260,155,54]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const S=2048;function T(C,y){const d={onUnknownOption:f=>{console.warn((0,t.localize)(0,null,f))},onMultipleValues:(f,m)=>{console.warn((0,t.localize)(1,null,f,m))},onDeprecatedOption:(f,m)=>{console.warn((0,t.localize)(2,null,f,m))}},b=(0,w.parseArgs)(C,w.OPTIONS,y?d:void 0);return b.goto&&b._.forEach(f=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(3,null))),b["max-memory"]&&k(parseInt(b["max-memory"])>=S,`The max-memory argument cannot be specified lower than ${S} MB.`),b}function E(C){const y=C.findIndex(d=>!/^-/.test(d));if(y>-1)return[...C.slice(0,y),...C.slice(y+1)]}function v(C){let[,...y]=C;process.env.VSCODE_DEV&&(y=E(y)||[]);const d=!A(process.env);return T(y,d)}e.parseMainProcessArgv=v;function P(C){const[,,...y]=C;return T(y,!0)}e.parseCLIProcessArgv=P;function R(C,...y){const d=C.indexOf("--");return d===-1?C.push(...y):C.splice(d,0,...y),C}e.addArg=R;function A(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=A}),function(){"use strict";function te(e,k,t,w){function S(E){const v=T(E),P=[v];return e.isAbsolute(v)||P.unshift(w),e.resolve(...P)}function T(E){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,t);const R=E["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const A=process.env.USERPROFILE;if(typeof A!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(A,"AppData","Roaming")}break;case"darwin":P=e.join(k.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,t)}return{getUserDataPath:S}}if(typeof define=="function")define(we[183],ye([0,83,27,8,19,25]),function(e,k,t,w,S,T){const E=S.dirname(w.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(S.joinPath(E,"package.json").fsPath);return te(k,t,v.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=te(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[184],ye([0,1,27,92,183]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends t.AbstractNativeEnvironmentService{constructor(E,v){super(E,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,w.getUserDataPath)(E)},v)}}e.NativeEnvironmentService=S}),define(we[66],ye([0,1,19,63,162,55]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function v(m){return m=m.trim(),m==="*"||T.test(m)}e.isValidVersionStr=v;function P(m){if(!v(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=m.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function R(m){if(!m)return null;let p=m.majorBase,h=m.majorMustEqual,a=m.minorBase,u=m.minorMustEqual,n=m.patchBase,l=m.patchMustEqual;m.hasCaret&&(p===0||(u=!1),l=!1);let i=0;if(m.preRelease){const s=E.exec(m.preRelease);if(s){const[,r,o,c]=s;i=Date.UTC(Number(r),Number(o)-1,Number(c))}}return{majorBase:p,majorMustEqual:h,minorBase:a,minorMustEqual:u,patchBase:n,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function A(m,p,h){let a;typeof m=="string"?a=R(P(m)):a=m;let u;p instanceof Date?u=p.getTime():typeof p=="string"&&(u=new Date(p).getTime());let n;if(typeof h=="string"?n=R(P(h)):n=h,!a||!n)return!1;let l=a.majorBase,i=a.minorBase,s=a.patchBase,r=n.majorBase,o=n.minorBase,c=n.patchBase,g=n.notBefore,I=n.majorMustEqual,_=n.minorMustEqual,z=n.patchMustEqual;return n.isMinimum?l>r?!0:l<r?!1:i>o?!0:i<o||u&&u<g?!1:s>=c:(l===1&&r===0&&(!I||!_||!z)&&(r=1,o=0,c=0,I=!0,_=!1,z=!1),l<r?!1:l>r?!I:i<o?!1:i>o?!_:s<c?!1:s>c?!z:!(u&&u<g))}e.isValidVersion=A;function C(m,p,h,a,u){const n=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return n.push([t.default.Error,w.localize(0,null)]),n;if(typeof a.name!="string")return n.push([t.default.Error,w.localize(1,null,"name")]),n;if(typeof a.version!="string")return n.push([t.default.Error,w.localize(2,null,"version")]),n;if(!a.engines)return n.push([t.default.Error,w.localize(3,null,"engines")]),n;if(typeof a.engines.vscode!="string")return n.push([t.default.Error,w.localize(4,null,"engines.vscode")]),n;if(typeof a.extensionDependencies!="undefined"&&!f(a.extensionDependencies))return n.push([t.default.Error,w.localize(5,null,"extensionDependencies")]),n;if(typeof a.activationEvents!="undefined"){if(!f(a.activationEvents))return n.push([t.default.Error,w.localize(6,null,"activationEvents")]),n;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return n.push([t.default.Error,w.localize(7,null,"activationEvents","main")]),n}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&n.push([t.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return n.push([t.default.Error,w.localize(9,null,"main")]),n;{const s=(0,k.joinPath)(h,a.main);(0,k.isEqualOrParent)(s,h)||n.push([t.default.Warning,w.localize(10,null,s.path,h.path)])}if(typeof a.activationEvents=="undefined")return n.push([t.default.Error,w.localize(11,null,"activationEvents","main")]),n}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return n.push([t.default.Error,w.localize(12,null,"browser")]),n;{const s=(0,k.joinPath)(h,a.browser);(0,k.isEqualOrParent)(s,h)||n.push([t.default.Warning,w.localize(13,null,s.path,h.path)])}if(typeof a.activationEvents=="undefined")return n.push([t.default.Error,w.localize(14,null,"activationEvents","browser")]),n}if(!S.valid(a.version))return n.push([t.default.Error,w.localize(15,null)]),n;const l=[];if(!y(m,p,a,u,l))for(const s of l)n.push([t.default.Error,s]);return n}e.validateExtensionManifest=C;function y(m,p,h,a,u){return a||typeof h.main=="undefined"&&typeof h.browser=="undefined"?!0:b(m,p,h.engines.vscode,u)}e.isValidExtensionVersion=y;function d(m,p,h){return m==="*"||b(p,h,m)}e.isEngineValid=d;function b(m,p,h,a=[]){let u=R(P(h));if(!u)return a.push(w.localize(16,null,h)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return a.push(w.localize(17,null,h)),!1}else if(!u.majorMustEqual)return a.push(w.localize(18,null,h)),!1;return A(m,p,u)?!0:(a.push(w.localize(19,null,m,h)),!1)}function f(m){if(!Array.isArray(m))return!1;for(let p=0,h=m.length;p<h;p++)if(typeof m[p]!="string")return!1;return!0}}),define(we[185],ye([0,1,16,26]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function w(S,T,E){let v=E&&E.get("storage.serviceMachineId",0)||null;if(v)return v;try{const R=(await T.readFile(S.serviceMachineIdResource)).value.toString();v=(0,t.isUUID)(R)?R:null}catch{v=null}if(!v){v=(0,t.generateUuid)();try{await T.writeFile(S.serviceMachineIdResource,k.VSBuffer.fromString(v))}catch{}}return E&&E.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=w}),define(we[56],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(w,S=[],T=!1){this.ctor=w,this.staticArguments=S,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(we[186],ye([0,1,56]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function w(T,E,v){E instanceof k.SyncDescriptor||(E=new k.SyncDescriptor(E,[],v)),t.push([T,E])}e.registerSingleton=w;function S(){return t}e.getSingletonServiceDescriptors=S}),define(we[187],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=k;class t{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const E=this.lookupOrInsertNode(S),v=this.lookupOrInsertNode(T);E.outgoing.set(this._hashFn(T),v),v.incoming.set(this._hashFn(S),E)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let E of this._nodes.values())E.outgoing.delete(T),E.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let E=this._nodes.get(T);return E||(E=new k(S),this._nodes.set(T,E)),E}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,E]of this._nodes)S.push(`${T}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,T]of this._nodes){const E=new Set([S]),v=this._findCycle(T,E);if(v)return v}}_findCycle(S,T){for(let[E,v]of S.outgoing){if(T.has(E))return[...T,E].join(" -> ");T.add(E);const P=this._findCycle(v,T);if(P)return P;T.delete(E)}}}e.Graph=t}),define(we[6],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function E(v){return v[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=E})(k=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function t(T,E,v){E[k.DI_TARGET]===E?E[k.DI_DEPENDENCIES].push({id:T,index:v}):(E[k.DI_DEPENDENCIES]=[{id:T,index:v}],E[k.DI_TARGET]=E)}function w(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const E=function(v,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,v,R)};return E.toString=()=>T,k.serviceIds.set(T,E),E}e.createDecorator=w;function S(T){return T}e.refineServiceDecorator=S}),define(we[28],ye([0,1,12,4,6]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function S(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=S;function T(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||k.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var E;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function P(m,p){const h=Object.create(null);for(let a in m)R(h,a,m[a],p);return h}e.toValuesTree=P;function R(m,p,h,a){const u=p.split("."),n=u.pop();let l=m;for(let i=0;i<u.length;i++){let s=u[i],r=l[s];switch(typeof r){case"undefined":r=l[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${p} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}l=r}if(typeof l=="object"&&l!==null)try{l[n]=h}catch{a(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(l)}`)}else a(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function A(m,p){const h=p.split(".");C(m,h)}e.removeFromValueTree=A;function C(m,p){const h=p.shift();if(p.length===0){delete m[h];return}if(Object.keys(m).indexOf(h)!==-1){const a=m[h];typeof a=="object"&&!Array.isArray(a)&&(C(a,p),Object.keys(a).length===0&&delete m[h])}}function y(m,p,h){function a(l,i){let s=l;for(const r of i){if(typeof s!="object"||s===null)return;s=s[r]}return s}const u=p.split("."),n=a(m,u);return typeof n=="undefined"?h:n}e.getConfigurationValue=y;function d(m,p,h){Object.keys(p).forEach(a=>{a!=="__proto__"&&(a in m?k.isObject(m[a])&&k.isObject(p[a])?d(m[a],p[a],h):h&&(m[a]=p[a]):m[a]=p[a])})}e.merge=d;function b(m,p,h){const a=m.inspect(p),u=m.inspect(h);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:a.defaultValue}e.getMigratedSettingValue=b;function f(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(we[93],ye([0,1,3,15,6]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",k.isMacintosh),S.set("isLinux",k.isLinux),S.set("isWindows",k.isWindows),S.set("isWeb",k.isWeb),S.set("isMacNative",k.isMacintosh&&!k.isWeb),S.set("isEdge",k.isEdge),S.set("isFirefox",k.isFirefox),S.set("isChrome",k.isChrome),S.set("isSafari",k.isSafari);const T=Object.prototype.hasOwnProperty;var E;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return A.INSTANCE}static true(){return C.INSTANCE}static has(D){return y.create(D)}static equals(D,H){return d.create(D,H)}static notEquals(D,H){return m.create(D,H)}static regex(D,H){return i.create(D,H)}static in(D,H){return b.create(D,H)}static not(D){return p.create(D)}static and(...D){return o.create(D,null)}static or(...D){return c.create(D,null,!0)}static greater(D,H){return a.create(D,H)}static greaterEquals(D,H){return u.create(D,H)}static smaller(D,H){return n.create(D,H)}static smallerEquals(D,H){return l.create(D,H)}static deserialize(D,H=!1){if(!!D)return this._deserializeOrExpression(D,H)}static _deserializeOrExpression(D,H){let F=D.split("||");return c.create(F.map($=>this._deserializeAndExpression($,H)),null,!0)}static _deserializeAndExpression(D,H){let F=D.split("&&");return o.create(F.map($=>this._deserializeOne($,H)),null)}static _deserializeOne(D,H){if(D=D.trim(),D.indexOf("!=")>=0){let F=D.split("!=");return m.create(F[0].trim(),this._deserializeValue(F[1],H))}if(D.indexOf("==")>=0){let F=D.split("==");return d.create(F[0].trim(),this._deserializeValue(F[1],H))}if(D.indexOf("=~")>=0){let F=D.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],H))}if(D.indexOf(" in ")>=0){let F=D.split(" in ");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const F=D.split(">=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const F=D.split(">");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const F=D.split("<=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const F=D.split("<");return n.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(D)?p.create(D.substr(1).trim()):y.create(D)}static _deserializeValue(D,H){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let F=/^'([^']*)'$/.exec(D);return F?F[1].trim():D}static _deserializeRegexValue(D,H){if((0,t.isFalsyOrWhitespace)(D)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=D.indexOf("/"),$=D.lastIndexOf("/");if(F===$||F<0){if(H)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let oe=D.slice(F+1,$),K=D[$+1]==="i"?"i":"";try{return new RegExp(oe,K)}catch(j){if(H)throw new Error(`bad regexp-value '${D}', parse error: ${j}`);return console.warn(`bad regexp-value '${D}', parse error: ${j}`),null}}}e.ContextKeyExpr=v;function P(ee,D){const H=ee?ee.substituteConstants():void 0,F=D?D.substituteConstants():void 0;return!H&&!F?!0:!H||!F?!1:H.equals(F)}e.expressionsAreEqualWithConstantSubstitution=P;function R(ee,D){return ee.cmp(D)}class A{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class C{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=C,C.INSTANCE=new C;class y{constructor(D,H){this.key=D,this.negated=H,this.type=2}static create(D,H=null){const F=S.get(D);return typeof F=="boolean"?F?C.INSTANCE:A.INSTANCE:new y(D,H)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=S.get(this.key);return typeof D=="boolean"?D?C.INSTANCE:A.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=4}static create(D,H,F=null){if(typeof H=="boolean")return H?y.create(D,F):p.create(D,F);const $=S.get(D);return typeof $=="boolean"?H===($?"true":"false")?C.INSTANCE:A.INSTANCE:new d(D,H,F)}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=S.get(this.key);if(typeof D=="boolean"){const H=D?"true":"false";return this.value===H?C.INSTANCE:A.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class b{constructor(D,H){this.key=D,this.valueKey=H,this.type=10,this.negated=null}static create(D,H){return new b(D,H)}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const H=D.getValue(this.valueKey),F=D.getValue(this.key);return Array.isArray(H)?H.indexOf(F)>=0:typeof F=="string"&&typeof H=="object"&&H!==null?T.call(H,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=b;class f{constructor(D){this._actual=D,this.type=11}static create(D){return new f(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new f(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class m{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=5}static create(D,H,F=null){if(typeof H=="boolean")return H?p.create(D,F):y.create(D,F);const $=S.get(D);return typeof $=="boolean"?H===($?"true":"false")?A.INSTANCE:C.INSTANCE:new m(D,H,F)}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=S.get(this.key);if(typeof D=="boolean"){const H=D?"true":"false";return this.value===H?A.INSTANCE:C.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class p{constructor(D,H){this.key=D,this.negated=H,this.type=3}static create(D,H=null){const F=S.get(D);return typeof F=="boolean"?F?A.INSTANCE:C.INSTANCE:new p(D,H)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=S.get(this.key);return typeof D=="boolean"?D?A.INSTANCE:C.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function h(ee,D){if(typeof ee=="string"){const H=parseFloat(ee);isNaN(H)||(ee=H)}return typeof ee=="string"||typeof ee=="number"?D(ee):A.INSTANCE}class a{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=12}static create(D,H,F=null){return h(H,$=>new a(D,$,F))}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class u{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=13}static create(D,H,F=null){return h(H,$=>new u(D,$,F))}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class n{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=14}static create(D,H,F=null){return h(H,$=>new n(D,$,F))}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class l{constructor(D,H,F){this.key=D,this.value=H,this.negated=F,this.type=15}static create(D,H,F=null){return h(H,$=>new l(D,$,F))}cmp(D){return D.type!==this.type?this.type-D.type:_(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class i{constructor(D,H){this.key=D,this.regexp=H,this.type=7,this.negated=null}static create(D,H){return new i(D,H)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const H=this.regexp?this.regexp.source:"",F=D.regexp?D.regexp.source:"";return H<F?-1:H>F?1:0}equals(D){if(D.type===this.type){const H=this.regexp?this.regexp.source:"",F=D.regexp?D.regexp.source:"";return this.key===D.key&&H===F}return!1}substituteConstants(){return this}evaluate(D){let H=D.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class s{constructor(D){this._actual=D,this.type=8}static create(D){return new s(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new s(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function r(ee){let D=null;for(let H=0,F=ee.length;H<F;H++){const $=ee[H].substituteConstants();if(ee[H]!==$&&D===null){D=[];for(let oe=0;oe<H;oe++)D[oe]=ee[oe]}D!==null&&(D[H]=$)}return D===null?ee:D}class o{constructor(D,H){this.expr=D,this.negated=H,this.type=6}static create(D,H){return o._normalizeArr(D,H)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let H=0,F=this.expr.length;H<F;H++){const $=R(this.expr[H],D.expr[H]);if($!==0)return $}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let H=0,F=this.expr.length;H<F;H++)if(!this.expr[H].equals(D.expr[H]))return!1;return!0}return!1}substituteConstants(){const D=r(this.expr);return D===this.expr?this:o.create(D,this.negated)}evaluate(D){for(let H=0,F=this.expr.length;H<F;H++)if(!this.expr[H].evaluate(D))return!1;return!0}static _normalizeArr(D,H){const F=[];let $=!1;for(const oe of D)if(!!oe){if(oe.type===1){$=!0;continue}if(oe.type===0)return A.INSTANCE;if(oe.type===6){F.push(...oe.expr);continue}F.push(oe)}if(F.length===0&&$)return C.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(R);for(let oe=1;oe<F.length;oe++)F[oe-1].equals(F[oe])&&(F.splice(oe,1),oe--);if(F.length===1)return F[0];for(;F.length>1;){const oe=F[F.length-1];if(oe.type!==9)break;F.pop();const K=F.pop(),j=F.length===0,O=c.create(oe.expr.map(B=>o.create([B,K],null)),null,j);O&&(F.push(O),F.sort(R))}return F.length===1?F[0]:new o(F,H)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let H of this.expr)D.push(...H.keys());return D}map(D){return new o(this.expr.map(H=>H.map(D)),null)}negate(){if(!this.negated){const D=[];for(let H of this.expr)D.push(H.negate());this.negated=c.create(D,this,!0)}return this.negated}}class c{constructor(D,H){this.expr=D,this.negated=H,this.type=9}static create(D,H,F){return c._normalizeArr(D,H,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let H=0,F=this.expr.length;H<F;H++){const $=R(this.expr[H],D.expr[H]);if($!==0)return $}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let H=0,F=this.expr.length;H<F;H++)if(!this.expr[H].equals(D.expr[H]))return!1;return!0}return!1}substituteConstants(){const D=r(this.expr);return D===this.expr?this:c.create(D,this.negated,!1)}evaluate(D){for(let H=0,F=this.expr.length;H<F;H++)if(this.expr[H].evaluate(D))return!0;return!1}static _normalizeArr(D,H,F){let $=[],oe=!1;if(D){for(let K=0,j=D.length;K<j;K++){const O=D[K];if(!!O){if(O.type===0){oe=!0;continue}if(O.type===1)return C.INSTANCE;if(O.type===9){$=$.concat(O.expr);continue}$.push(O)}}if($.length===0&&oe)return A.INSTANCE;$.sort(R)}if($.length!==0){if($.length===1)return $[0];for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];if(F){for(let K=0;K<$.length;K++)for(let j=K+1;j<$.length;j++)z($[K],$[j])&&($.splice(j,1),j--);if($.length===1)return $[0]}return new c($,H)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let H of this.expr)D.push(...H.keys());return D}map(D){return new c(this.expr.map(H=>H.map(D)),null)}negate(){if(!this.negated){let D=[];for(let H of this.expr)D.push(H.negate());for(;D.length>1;){const H=D.shift(),F=D.shift(),$=[];for(const K of W(H))for(const j of W(F))$.push(o.create([K,j],null));const oe=D.length===0;D.unshift(c.create($,null,oe))}this.negated=D[0]}return this.negated}}class g extends y{constructor(D,H,F){super(D,null);this._defaultValue=H,typeof F=="object"?g._info.push({...F,key:D}):F!==!0&&g._info.push({key:D,description:F,type:H!=null?typeof H:void 0})}static all(){return g._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return d.create(this.key,D)}notEqualsTo(D){return m.create(this.key,D)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(ee,D){return ee<D?-1:ee>D?1:0}function _(ee,D,H,F){return ee<H?-1:ee>H?1:D<F?-1:D>F?1:0}function z(ee,D){if(D.type===6&&ee.type!==9&&ee.type!==6){for(const $ of D.expr)if(ee.equals($))return!0}const H=ee.negate(),F=W(H).concat(W(D));F.sort(R);for(let $=0;$<F.length;$++){const K=F[$].negate();for(let j=$+1;j<F.length;j++){const O=F[j];if(K.equals(O))return!0}}return!1}e.implies=z;function W(ee){return ee.type===9?ee.expr:[ee]}}),define(we[67],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,k.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,k.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(S,T){return this.secretVault[S]?.[T]??null}async setPassword(S,T,E){this.secretVault[S]=this.secretVault[S]??{},this.secretVault[S][T]=E}async deletePassword(S,T){return this.secretVault[S]?.[T]?(delete this.secretVault[S][T],Object.keys(this.secretVault[S]).length===0&&delete this.secretVault[S],!0):!1}async findPassword(S){return JSON.stringify(this.secretVault[S])??null}async findCredentials(S){const T=[];for(const E of Object.keys(this.secretVault[S]||{}))T.push({account:E,password:this.secretVault[S][E]});return T}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[188],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(S){return!!S.hostName&&!!S.errorMessage}e.isRemoteDiagnosticError=t;class w{async getPerformanceInfo(T,E){return{}}async getSystemInfo(T,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,E){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=w}),define(we[68],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(we[189],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,k.createDecorator)("encryptionMainService")}),define(we[23],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(we[31],ye([0,1,157,6]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function S(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=S;function T(m,p){switch(m){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function E(m,p){return p==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function v(m,p,h){return E(p,h)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===h?!0:P(h).includes(m)}e.isTargetPlatformCompatible=v;function P(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=R;var A;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(m){m.Unsupported="Unsupported",m.UnsupportedPreRelease="UnsupportedPreRelease",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(p,h){super(p);this.code=h,this.name=h}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(we[190],ye([0,1,7,2,22,4,65,31]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(b,f){return S.URI.revive(f?f.transformIncoming(b):b)}function P(b,f){return f?f.transformOutgoingURI(b):b}function R(b,f){f=f||T.DefaultURITransformer;const m=b.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...b,manifest:void 0},f),manifest:m}}function A(b,f){return f?(0,w.cloneAndChange)(b,m=>m instanceof S.URI?f.transformOutgoingURI(m):void 0):b}class C{constructor(f,m){this.service=f,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,m){const p=this.getUriTransformer(f);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,h=>h.map(a=>({...a,local:a.local?A(a.local,p):a.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,m,p){const h=this.getUriTransformer(f);switch(m){case"zip":return this.service.zip(R(p[0],h)).then(a=>P(a,h));case"unzip":return this.service.unzip(v(p[0],h));case"install":return this.service.install(v(p[0],h),p[1]);case"getManifest":return this.service.getManifest(v(p[0],h));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(R(p[0],h),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(R(p[0],h));case"getInstalled":return this.service.getInstalled(p[0]).then(a=>a.map(u=>A(u,h)));case"updateMetadata":return this.service.updateMetadata(R(p[0],h),p[1]).then(a=>A(a,h));case"updateExtensionScope":return this.service.updateExtensionScope(R(p[0],h),p[1]).then(a=>A(a,h));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class y extends t.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?S.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(p=>({...p,local:p.local?R(p.local,null):p.local,source:this.isUriComponents(p.source)?S.URI.revive(p.source):p.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const m=await this.getTargetPlatform();return f.allTargetPlatforms.some(p=>(0,E.isTargetPlatformCompatible)(p,f.allTargetPlatforms,m))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(m=>S.URI.revive(m)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,m){return Promise.resolve(this.channel.call("install",[f,m])).then(p=>R(p,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,m){return Promise.resolve(this.channel.call("installFromGallery",[f,m])).then(p=>R(p,null))}uninstall(f,m){return Promise.resolve(this.channel.call("uninstall",[f,m]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(m=>m.map(p=>R(p,null)))}updateMetadata(f,m){return Promise.resolve(this.channel.call("updateMetadata",[f,m])).then(p=>R(p,null))}updateExtensionScope(f,m){return Promise.resolve(this.channel.call("updateExtensionScope",[f,m])).then(p=>R(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class d{constructor(f){this.service=f}listen(f,m){throw new Error("Invalid listen")}call(f,m,p){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(S.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(we[17],ye([0,1,9,29,5,15,12,4,164,6]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function R(j){return j.create===!0}e.isFileOpenForWriteOptions=R;var A;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var C;(function(j){j[j.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var y;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=d;function b(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=b;function f(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=f;function m(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function p(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=p;function h(j){return d(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=h;var a;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(O,B){super(O);this.code=B}}e.FileSystemProviderError=u;function n(j,O){const B=new u(j.toString(),O);return i(B,O),B}e.createFileSystemProviderError=n;function l(j){return j||n((0,v.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=l;function i(j,O){return j.name=O?`${O} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=i;function s(j){if(!j)return a.Unknown;if(j instanceof u)return j.code;const O=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!O)return a.Unknown;switch(O[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=s;function r(j){if(j instanceof z)return j.fileOperationResult;switch(s(j)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(O,B,V){this.resource=O,this.operation=B,this.target=V}isOperation(O){return this.operation===O}}e.FileOperationEvent=c;var g;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class I{constructor(O,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const V=new Map;for(const J of O){const se=V.get(J.type);switch(se?se.push([J.resource,J]):V.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,se]of V)switch(J){case 1:this.added=t.TernarySearchTree.forUris(()=>B),this.added.fill(se);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>B),this.updated.fill(se);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>B),this.deleted.fill(se);break}}contains(O,...B){return this.doContains(O,{includeChildren:!1},...B)}affects(O,...B){return this.doContains(O,{includeChildren:!0},...B)}doContains(O,B,...V){if(!O)return!1;const J=V.length>0;return!!((!J||V.includes(1))&&(this.added?.get(O)||B.includeChildren&&this.added?.findSuperstr(O))||(!J||V.includes(0))&&(this.updated?.get(O)||B.includeChildren&&this.updated?.findSuperstr(O))||(!J||V.includes(2))&&(this.deleted?.findSubstr(O)||B.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=I;function _(j,O,B){return!j||!O||j===O||O.length>j.length?!1:(O.charAt(O.length-1)!==w.sep&&(O+=w.sep),B?(0,S.startsWithIgnoreCase)(j,O):j.indexOf(O)===0)}e.isParent=_;class z extends k.ErrorNoTelemetry{constructor(O,B,V){super(O);this.fileOperationResult=B,this.options=V}}e.FileOperationError=z;class W extends z{constructor(O,B,V){super(O,2,V);this.stat=B}}e.NotModifiedSinceFileOperationError=W;var ee;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ee=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=H;async function F(j,O){if(!O.hasProvider(E.URI.from({scheme:j.scheme})))return new Promise(B=>{const V=O.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===j.scheme&&J.added&&(V.dispose(),B())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(O){return(0,T.isNumber)(O)||(O=0),O<$.KB?(0,v.localize)(1,null,O.toFixed(0)):O<$.MB?(0,v.localize)(2,null,(O/$.KB).toFixed(2)):O<$.GB?(0,v.localize)(3,null,(O/$.MB).toFixed(2)):O<$.TB?(0,v.localize)(4,null,(O/$.GB).toFixed(2)):(0,v.localize)(5,null,(O/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var oe;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function K(j){return{maxFileSize:j===0?300*$.MB:16*$.GB,maxHeapSize:j===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=K}),define(we[191],ye([0,1,16,36,9,7,2,43,4,26,17]),function(te,e,k,t,w,S,T,E,v,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class A extends T.Disposable{constructor(y,d){super();this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=S.Event.None,this._onDidChange=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new S.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:b}=await this.channel.call("readFile",[y,d]);return b}readFileStream(y,d,b){const f=(0,E.newWriteableStream)(p=>k.VSBuffer.concat(p.map(h=>k.VSBuffer.wrap(h))).buffer),m=this.channel.listen("readFileStream",[y,d])(p=>{if(p instanceof k.VSBuffer)f.write(p.buffer);else{if(p==="end")f.end();else{let h=p;h instanceof Error||(h=(0,R.createFileSystemProviderError)((0,t.toErrorMessage)(h),R.FileSystemProviderErrorCode.Unknown)),f.error(h),f.end()}m.dispose()}});return b.onCancellationRequested(()=>{f.error((0,w.canceled)()),f.end(),m.dispose()}),f}writeFile(y,d,b){return this.channel.call("writeFile",[y,k.VSBuffer.wrap(d),b])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,b,f,m){const[p,h]=await this.channel.call("read",[y,d,m]);return b.set(p.buffer.slice(0,h),f),h}write(y,d,b,f,m){return this.channel.call("write",[y,d,k.VSBuffer.wrap(b),f,m])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,b){return this.channel.call("rename",[y,d,b])}copy(y,d,b){return this.channel.call("copy",[y,d,b])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const b=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,b,y,d]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=A}),define(we[94],ye([0,1,16,9,165,17]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,A,C,y,d,b){let f;try{await E(R,A,C,y,d,b)}catch(m){f=m}finally{f&&d.errorTransformer&&(f=d.errorTransformer(f)),typeof f!="undefined"&&C.error(f),C.end()}}e.readFileIntoStream=T;async function E(R,A,C,y,d,b){v(b);const f=await R.open(A,{create:!1});try{v(b);let m=0,p=0,h=d&&typeof d.length=="number"?d.length:void 0,a=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,n=0;do p=await R.read(f,u,a.buffer,n,a.byteLength-n),u+=p,n+=p,m+=p,typeof h=="number"&&(h-=p),n===a.byteLength&&(await C.write(y(a)),a=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),n=0);while(p>0&&(typeof h!="number"||h>0)&&v(b)&&P(m,d));if(n>0){let l=n;typeof h=="number"&&(l=Math.min(n,h)),C.write(y(a.slice(0,l)))}}catch(m){throw(0,S.ensureFileSystemProviderError)(m)}finally{await R.close(f)}}function v(R){if(R.isCancellationRequested)throw(0,t.canceled)();return!0}function P(R,A){if(A?.limits){if(typeof A.limits.memory=="number"&&R>A.limits.memory)throw(0,S.createFileSystemProviderError)((0,w.localize)(0,null),S.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof A.limits.size=="number"&&R>A.limits.size)throw(0,S.createFileSystemProviderError)((0,w.localize)(1,null),S.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[57],ye([0,1,64,2,5,3,4,17]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(f){return f.recursive===!0}e.isRecursiveWatchRequest=v;class P extends t.Disposable{constructor(m,p,h,a){super();this.onFileChanges=m,this.onLogMessage=p,this.verboseLogging=h,this.options=a,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),m.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),m.add(this.watcher.onDidError(p=>this.onError(p)))}onError(m){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class R extends P{constructor(m,p,h){super(m,p,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class A extends P{constructor(m,p,h){super(m,p,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=A;function C(f){return f.map(m=>({type:m.type,resource:T.URI.file(m.path)}))}e.toFileChanges=C;function y(f){const m=new b;for(const p of f)m.processEvent(p);return m.coalesce()}e.coalesceEvents=y;function d(f,m){const p=[];for(const h of m){let a=h;typeof a=="string"&&!a.startsWith(k.GLOBSTAR)&&!(0,w.isAbsolute)(a)&&(a={base:f,pattern:a}),p.push((0,k.parse)(a))}return p}e.parseWatcherPatterns=d;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return S.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.mapPathToChange.get(this.toKey(m));let h=!1;if(p){const a=p.type,u=m.type;p.path!==m.path&&(m.type===2||m.type===1)?h=!0:a===1&&u===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(p)):a===2&&u===1?p.type=0:a===1&&u===0||(p.type=u)}else h=!0;h&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],p=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(m.push(h),!1):!0).sort((h,a)=>h.path.length-a.path.length).filter(h=>p.some(a=>(0,E.isParent)(h.path,a,!S.isLinux))?!1:(p.push(h.path),!0)).concat(m)}}}),define(we[192],ye([0,1,30,14,21,33,2,79,5,3,140,20,57]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends T.Disposable{constructor(f,m,p,h){super();this.request=f,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=h,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.onDidFilesChange(a)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new w.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await A.Promises.stat(f);this._register(await this.doWatch(f,m.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let m=f.path;try{m=await A.Promises.realpath(f.path),f.path===m&&(m=await(0,R.realcase)(f.path)??f.path),f.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${m})`)}catch{}return m}async doWatch(f,m){if(P.isMacintosh&&(0,S.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const p=new w.CancellationTokenSource(this.cts.token);let h=new T.DisposableStore;try{const a=(0,v.basename)(f),u=(0,k.watch)(f);h.add((0,T.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${f}'`);const n=new Set;if(m)try{for(const i of await A.Promises.readdir(f))n.add(i)}catch(i){this.error(i)}const l=new Map;h.add((0,T.toDisposable)(()=>{for(const[,i]of l)i.dispose();l.clear()})),u.on("error",(i,s)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),u.on("change",(i,s)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let r="";if(s&&(r=s.toString(),P.isMacintosh&&(r=(0,E.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(m)if(i==="rename"){l.get(r)?.dispose();const o=setTimeout(async()=>{if(l.delete(r),r===a&&!await A.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,v.join)(f,r));if(p.token.isCancellationRequested)return;let g;c?n.has(r)?g=0:(g=1,n.add(r)):(n.delete(r),g=2),this.onFileChange({path:(0,v.join)(this.request.path,r),type:g})},y.FILE_DELETE_HANDLER_DELAY);l.set(r,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(r)?o=0:(o=1,n.add(r)),this.onFileChange({path:(0,v.join)(this.request.path,r),type:o})}else if(i==="rename"||r!==a){const o=setTimeout(async()=>{const c=await A.Promises.exists(f);p.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),h.add(await this.doWatch(f,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);h.clear(),h.add((0,T.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(a){await A.Promises.exists(f)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${a.toString()})`)}return(0,T.toDisposable)(()=>{p.dispose(!0),h.dispose()})}async onFileChange(f,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!m&&this.excludes.some(p=>p(f.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(f.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.path}`):this.fileChangesBuffer.push(f);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const h=(0,C.coalesceEvents)(p);if(h.length>0){if(this.verboseLogging)for(const u of h)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(h)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(f){if(P.isLinux)return A.Promises.exists(f);try{const m=(0,v.basename)(f);return(await A.Promises.readdir((0,v.dirname)(f))).some(h=>h===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(b,f,m,p,h=512){const a=await A.Promises.open(b,"r"),u=Buffer.allocUnsafe(h),n=new w.CancellationTokenSource(p);let l,i=!1;const s={path:b,excludes:[],recursive:!1},r=new y(s,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await A.Promises.read(a,u,0,h,null);if(!g||n.token.isCancellationRequested)break;f(u.slice(0,g))}}catch(g){l=new Error(g),n.dispose(!0)}finally{i=!1}}})()});return await r.ready,m(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await A.Promises.close(a)}catch(g){l=new Error(g)}l?c(l):o()})})}e.watchFileContents=d}),define(we[193],ye([0,1,7,64,2,3,192]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const R=this.normalizeRequests(P),A=R.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,t.patternsEquals)(d.request.excludes,y.excludes)||!(0,t.patternsEquals)(d.request.includes,y.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:y})=>!R.find(d=>d.path===y.path&&(0,t.patternsEquals)(d.excludes,y.excludes)&&(0,t.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);A.length&&this.trace(`Request to start watching: ${A.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const y of C)this.stopWatching(y);for(const y of A)this.startWatching(y)}startWatching(P){const R=new T.NodeJSFileWatcherLibrary(P,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),A={request:P,instance:R};this.watchers.set(P.path,A)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const R=this.watchers.get(P);R&&(this.watchers.delete(P),R.instance.dispose())}normalizeRequests(P){const R=new Map;for(const A of P){const C=S.isLinux?A.path:A.path.toLowerCase();R.set(C,A)}return Array.from(R.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,R]of this.watchers)R.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,R){return R?`[File Watcher (node.js)] ${P} (path: ${R.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=E}),define(we[194],ye([0,1,57,193]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends k.AbstractNonRecursiveWatcherClient{constructor(T,E,v){super(T,E,v);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=w}),define(we[195],ye([0,1,8,39,91,57]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends S.AbstractUniversalWatcherClient{constructor(v,P,R){super(v,P,R);this.init()}createWatcher(v){const P=v.add(new w.Client(k.FileAccess.asFileUri("bootstrap-fork",te).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(P.onDidProcessExit(({code:R,signal:A})=>this.onError(`terminated by itself with code ${R}, signal: ${A}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(we[69],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...w){this._entries=new Map;for(let[S,T]of w)this.set(S,T)}set(w,S){const T=this._entries.get(w);return this._entries.set(w,S),T}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=k}),define(we[95],ye([0,1,14,9,56,187,6,69]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class P extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class R{constructor(d=new E.ServiceCollection,b=!1,f){this._activeInstantiations=new Set,this._services=d,this._strict=b,this._parent=f,this._services.set(T.IInstantiationService,this)}createChild(d){return new R(d,this._strict,this)}invokeFunction(d,...b){let f=C.traceInvocation(d),m=!1;try{return d({get:h=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(h,f);if(!a)throw new Error(`[invokeFunction] unknown service '${h}'`);return a}},...b)}finally{m=!0,f.stop()}}createInstance(d,...b){let f,m;return d instanceof w.SyncDescriptor?(f=C.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(b),f)):(f=C.traceCreation(d),m=this._createInstance(d,b,f)),f.stop(),m}_createInstance(d,b=[],f){let m=T._util.getServiceDependencies(d).sort((a,u)=>a.index-u.index),p=[];for(const a of m){let u=this._getOrCreateServiceInstance(a.id,f);u||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`,!1),p.push(u)}let h=m.length>0?m[0].index:b.length;if(b.length!==h){console.trace(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${b.length} static arguments`);let a=h-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,h)}return new d(...[...b,...p])}_setServiceInstance(d,b){if(this._services.get(d)instanceof w.SyncDescriptor)this._services.set(d,b);else if(this._parent)this._parent._setServiceInstance(d,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let b=this._services.get(d);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):b}_getOrCreateServiceInstance(d,b){let f=this._getServiceInstanceOrDescriptor(d);return f instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,f,b.branch(d,!0)):(b.branch(d,!1),f)}_safeCreateAndCacheServiceInstance(d,b,f){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,b,f)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,b,f){const m=new S.Graph(a=>a.id.toString());let p=0;const h=[{id:d,desc:b,_trace:f}];for(;h.length;){const a=h.pop();if(m.lookupOrInsertNode(a),p++>1e3)throw new P(m);for(let u of T._util.getServiceDependencies(a.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(u.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),n instanceof w.SyncDescriptor){const l={id:u.id,desc:n,_trace:a._trace.branch(u.id,!0)};m.insertEdge(a,l),h.push(l)}}}for(;;){const a=m.roots();if(a.length===0){if(!m.isEmpty())throw new P(m);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof w.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,b,f=[],m,p){if(this._services.get(d)instanceof w.SyncDescriptor)return this._createServiceInstance(b,f,m,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,b,f,m,p);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(d,b=[],f,m){if(f){const p=new k.IdleValue(()=>this._createInstance(d,b,m));return new Proxy(Object.create(null),{get(h,a){if(a in h)return h[a];let u=p.value,n=u[a];return typeof n!="function"||(n=n.bind(u),h[a]=n),n},set(h,a,u){return p.value[a]=u,!0}})}else return this._createInstance(d,b,m)}_throwIfStrict(d,b){if(b&&console.warn(b),this._strict)throw new Error(d)}}e.InstantiationService=R;var A;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(A||(A={}));class C{constructor(d,b){this.type=d,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return v?new C(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):C._None}static traceCreation(d){return v?new C(0,d.name):C._None}branch(d,b){let f=new C(2,d.toString());return this._dep.push([d,b,f]),f}stop(){let d=Date.now()-this._start;C._totals+=d;let b=!1;function f(p,h){let a=[],u=new Array(p+1).join("	");for(const[n,l,i]of h._dep)if(l&&i){b=!0,a.push(`${u}CREATES -> ${n}`);let s=f(p+1,i);s&&a.push(s)}else a.push(`${u}uses -> ${n}`);return a.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(d>2||b)&&console.log(m.join(`
`))}}e.Trace=C,C._None=new class extends C{constructor(){super(-1,null)}stop(){}branch(){return this}},C._totals=0}),define(we[196],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,k.createDecorator)("labelService")}),define(we[70],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function t(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const S of w.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}e.isValidLocalization=t}),define(we[13],ye([0,1,36,7,2,3,6]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function E(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function P(l,i,s){switch(i){case v.Trace:l.trace(s);break;case v.Debug:l.debug(s);break;case v.Info:l.info(s);break;case v.Warning:l.warn(s);break;case v.Error:l.error(s);break;case v.Critical:l.critical(s);break;default:throw new Error("Invalid log level")}}e.log=P;function R(l){let i="";for(let s=0;s<l.length;s++){let r=l[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(s>0?" ":"")+r}return i}e.format=R;class A extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class C extends A{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(v.Trace)&&this.log(v.Trace,R([i,...s]))}debug(i,...s){this.checkLogLevel(v.Debug)&&this.log(v.Debug,R([i,...s]))}info(i,...s){this.checkLogLevel(v.Info)&&this.log(v.Info,R([i,...s]))}warn(i,...s){this.checkLogLevel(v.Warning)&&this.log(v.Warning,R([i,...s]))}error(i,...s){if(this.checkLogLevel(v.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(v.Error,R(r))}else this.log(v.Error,R([i,...s]))}critical(i,...s){this.checkLogLevel(v.Critical)&&this.log(v.Critical,R([i,...s]))}flush(){}}e.AbstractMessageLogger=C;class y extends A{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!S.isWindows}trace(i,...s){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...s):console.log(`[main ${E()}]`,i,...s))}debug(i,...s){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...s):console.log(`[main ${E()}]`,i,...s))}info(i,...s){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...s):console.log(`[main ${E()}]`,i,...s))}warn(i,...s){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,i,...s):console.warn(`[main ${E()}]`,i,...s))}error(i,...s){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,i,...s):console.error(`[main ${E()}]`,i,...s))}critical(i,...s){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,i,...s):console.error(`[main ${E()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends A{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=d;class b extends A{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends A{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const r of this.logServices)r.trace(i,...s)}debug(i,...s){for(const r of this.logServices)r.debug(i,...s)}info(i,...s){for(const r of this.logServices)r.info(i,...s)}warn(i,...s){for(const r of this.logServices)r.warn(i,...s)}error(i,...s){for(const r of this.logServices)r.error(i,...s)}critical(i,...s){for(const r of this.logServices)r.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class m extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=m;class p extends w.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,s?.always?v.Trace:this.logLevel,s),this.loggers.set(i.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return v.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=h;function a(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const i=u(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=u;function n(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=n});var Oe=this&&this.__param||function(te,e){return function(k,t){e(k,t,te)}};define(we[197],ye([0,1,67,7,2,13,3]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class Ut extends w.Disposable{constructor(P){super();this.logService=P,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(P,R){let A;try{A=await this.withKeytar()}catch{return null}const C=await A.getPassword(P,R);if(C)try{let{content:y,hasNextChunk:d}=JSON.parse(C);if(!y||!d)return C;let b=1;for(;d;){const f=await A.getPassword(P,`${R}-${b}`),m=JSON.parse(f);y+=m.content,d=m.hasNextChunk,b++}return y}catch{return C}return C}async setPassword(P,R,A){let C;try{C=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const y=3,d=async(b,f,m)=>{let p=0,h;for(;p<y;)try{await C.setPassword(b,f,m);return}catch(a){h=a,this.logService.warn("Error attempting to set a password: ",a?.message??a),p++,await new Promise(u=>setTimeout(u,200))}throw h};if(T.isWindows&&A.length>Ut.MAX_PASSWORD_LENGTH){let b=0,f=0,m=!0;for(;m;){const p=A.substring(b,b+Ut.PASSWORD_CHUNK_SIZE);b+=Ut.PASSWORD_CHUNK_SIZE,m=A.length-b>0;const h={content:p,hasNextChunk:m};await d(P,f?`${R}-${f}`:R,JSON.stringify(h)),f++}}else await d(P,R,A);this._onDidChangePassword.fire({service:P,account:R})}async deletePassword(P,R){let A;try{A=await this.withKeytar()}catch(f){throw this.surfaceKeytarLoadError?.(f),f}const C=await A.getPassword(P,R);if(!C)return!1;const y=await A.deletePassword(P,R);let{content:d,hasNextChunk:b}=JSON.parse(C);if(d&&b){let f=1;for(;b;){const m=`${R}-${f}`,p=await A.getPassword(P,m);await A.deletePassword(P,m),b=JSON.parse(p).hasNextChunk,f++}}return y&&this._onDidChangePassword.fire({service:P,account:R}),y}async findPassword(P){let R;try{R=await this.withKeytar()}catch{return null}return R.findPassword(P)}async findCredentials(P){let R;try{R=await this.withKeytar()}catch{return[]}return R.findCredentials(P)}clear(){return this._keytarCache instanceof k.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Re([Oe(0,S.ILogService)],E),e.BaseCredentialsMainService=E}),define(we[198],ye([0,1,38,14,36,7,2,8,5,20,23,13]),function(te,e,k,t,w,S,T,E,v,P,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let C=class extends T.Disposable{constructor(d,b){super();this.environmentService=d,this.logService=b,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const b=this.parseScript(d,"uninstall");return b&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(b.script,"uninstall",b.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${f}`)))),P.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(d,b){const f=`vscode:${b}`;if(d.location.scheme===E.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[f]=="string"){const m=d.manifest.scripts[f].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${f} should be a node script`),null):{script:(0,v.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,b,f,m,p){return new Promise((h,a)=>{const u=this.start(d,b,f,p);let n;const l=i=>{n&&(clearTimeout(n),n=null),i?a(i):h(void 0)};u.on("error",i=>{l((0,w.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,s)=>{l(i?`post-${b} process exited with code ${i}`:void 0)}),m&&(n=setTimeout(()=>{n=null,u.kill(),a("timed out")},5e3))})}start(d,b,f,m){const p={silent:!0,execArgv:void 0},h=(0,k.fork)(d,[`--type=extension-post-${b}`,...f],p);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const a=S.Event.fromNodeEventEmitter(h.stdout,"data"),u=S.Event.fromNodeEventEmitter(h.stderr,"data");a(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${b}`,i)),u(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${b}`,i));const n=S.Event.any(S.Event.map(a,i=>({data:`%c${i}`,format:[""]})),S.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return S.Event.debounce(n,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),h}getExtensionStoragePath(d){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};C=Re([Oe(0,R.IEnvironmentService),Oe(1,A.ILogService)],C),e.ExtensionsLifecycle=C}),define(we[199],ye([0,1,18,14,9,7,2,5,57,13]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(C,y){super();this.logService=C,this.options=y,this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new S.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,y):this.watchNonRecursive(C,y)}watchUniversal(C,y){const d={path:this.toFilePath(C),excludes:y.excludes,includes:y.includes,recursive:y.recursive},b=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,w.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,v.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const y of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const y of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(y)&&C.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,y){const d={path:this.toFilePath(C),excludes:y.excludes,includes:y.includes,recursive:!1},b=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,w.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,v.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,E.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(we[96],ye([0,1,18,14,16,21,7,133,52,2,29,8,45,19,43,163,17,94,13]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends P.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,n){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${u}`);const l=new P.DisposableStore;return this.provider.set(u,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:n}),l.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&l.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:u}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:n}),this.provider.delete(u),(0,P.dispose)(l)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(l){n.push(l)}}),!this.provider.has(u)&&await t.Promises.settled(n)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,n){const l=this.provider.get(u.scheme);return!!(l&&l.capabilities&n)}listCapabilities(){return v.Iterable.map(this.provider,([u,n])=>({scheme:u,capabilities:n.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new f.FileOperationError((0,b.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const n=this.provider.get(u.scheme);if(!n){const l=new Error;throw l.name="ENOPRO",l.message=(0,b.localize)(1,null,u.toString()),l}return n}async withReadProvider(u){const n=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)||(0,f.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const n=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,n){try{return await this.doResolveFile(u,n)}catch(l){throw(0,f.toFileSystemProviderErrorCode)(l)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,b.localize)(2,null,this.resourceForError(u)),1):(0,f.ensureFileSystemProviderError)(l)}}async doResolveFile(u,n){const l=await this.withProvider(u),i=this.isPathCaseSensitive(l),s=n?.resolveTo,r=n?.resolveSingleChildDescendants,o=n?.resolveMetadata,c=await l.stat(u);let g;return this.toFileStat(l,u,c,void 0,!!o,(I,_)=>(g||(g=R.TernarySearchTree.forUris(()=>!i),g.set(u,!0),s&&g.fill(!0,s)),g.get(I.resource)||g.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&r?_===1:!1))}async toFileStat(u,n,l,i,s,r){const{providerExtUri:o}=this.getExtUri(u),c={resource:n,name:o.basename(n),isFile:(l.type&f.FileType.File)!=0,isDirectory:(l.type&f.FileType.Directory)!=0,isSymbolicLink:(l.type&f.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&f.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,f.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(c.isDirectory&&r(c,i)){try{const g=await u.readdir(n),I=await t.Promises.settled(g.map(async([_,z])=>{try{const W=o.joinPath(n,_),ee=s?await u.stat(W):{type:z};return await this.toFileStat(u,W,ee,g.length,s,r)}catch(W){return this.logService.trace(W),null}}));c.children=(0,k.coalesce)(I)}catch(g){this.logService.trace(g),c.children=[]}return c}return c}async resolveAll(u){return t.Promises.settled(u.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(u){const n=await this.withProvider(u),l=await n.stat(u);return this.toFileStat(n,u,l,void 0,!0,()=>!1)}async exists(u){const n=await this.withProvider(u);try{return!!await n.stat(u)}catch{return!1}}async canCreateFile(u,n){try{await this.doValidateCreateFile(u,n)}catch(l){return l}return!0}async doValidateCreateFile(u,n){if(!n?.overwrite&&await this.exists(u))throw new f.FileOperationError((0,b.localize)(3,null,this.resourceForError(u)),3,n)}async createFile(u,n=w.VSBuffer.fromString(""),l){await this.doValidateCreateFile(u,l);const i=await this.writeFile(u,n);return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,i)),i}async writeFile(u,n,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,u,l)||await this.mkdirp(i,s.dirname(u));let o;if((0,f.hasReadWriteCapability)(i)&&!(n instanceof w.VSBuffer))if((0,d.isReadableStream)(n)){const c=await(0,d.peekStream)(n,3);c.ended?o=w.VSBuffer.concat(c.buffer):o=c}else o=(0,d.peekReadable)(n,c=>w.VSBuffer.concat(c),3);else o=n;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&o instanceof w.VSBuffer?await this.doWriteUnbuffered(i,u,l,o):await this.doWriteBuffered(i,u,l,o instanceof w.VSBuffer?(0,w.bufferToReadable)(o):o),this._onDidRunOperation.fire(new f.FileOperationEvent(u,4))}catch(r){throw new f.FileOperationError((0,b.localize)(4,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),l)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,n,l){if(!!l?.unlock&&!(u.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(n)));let s;try{s=await u.stat(n)}catch{return}if((s.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,b.localize)(6,null,this.resourceForError(n)),0,l);if(this.throwIfFileIsReadonly(n,s),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==f.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&l.mtime<s.mtime&&l.etag!==(0,f.etag)({mtime:l.mtime,size:s.size}))throw new f.FileOperationError((0,b.localize)(7,null),3,l);return s}async readFile(u,n,l){const i=await this.withReadProvider(u);return n?.atomic?this.doReadFileAtomic(i,u,n,l):this.doReadFile(i,u,n,l)}async doReadFileAtomic(u,n,l,i){return new Promise((s,r)=>{this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(u,n,l,i);s(o)}catch(o){r(o)}})})}async doReadFile(u,n,l,i){const s=await this.doReadFileStream(u,n,{...l,preferUnbuffered:!0},i);return{...s,value:await(0,w.streamToBuffer)(s.value)}}async readFileStream(u,n,l){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,n,l)}async doReadFileStream(u,n,l,i){const s=new S.CancellationTokenSource(i),r=this.validateReadFile(n,l).then(c=>c,c=>{throw s.cancel(),c});let o;try{return typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&await r,l?.atomic&&(0,f.hasFileAtomicReadCapability)(u)||!((0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasFileReadStreamCapability)(u))||(0,f.hasReadWriteCapability)(u)&&l?.preferUnbuffered?o=this.readFileUnbuffered(u,n,l):(0,f.hasFileReadStreamCapability)(u)?o=this.readFileStreamed(u,n,s.token,l):o=this.readFileBuffered(u,n,s.token,l),{...await r,value:o}}catch(c){o&&await(0,d.consumeStream)(o);const g=(0,b.localize)(8,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(c).toString());throw c instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(g,c.stat,l):new f.FileOperationError(g,(0,f.toFileOperationResult)(c),l)}}readFileStreamed(u,n,l,i=Object.create(null)){const s=u.readFileStream(n,i,l);return(0,d.transform)(s,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,b.localize)(9,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(u,n,l,i=Object.create(null)){const s=(0,w.newWriteableBufferStream)();return(0,m.readFileIntoStream)(u,n,s,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,b.localize)(10,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},l),s}readFileUnbuffered(u,n,l){const i=(0,d.newWriteableStream)(s=>w.VSBuffer.concat(s));return(async()=>{try{let s;l?.atomic&&(0,f.hasFileAtomicReadCapability)(u)?s=await u.readFile(n,{atomic:!0}):s=await u.readFile(n),typeof l?.position=="number"&&(s=s.slice(l.position)),typeof l?.length=="number"&&(s=s.slice(0,l.length)),this.validateReadFileLimits(n,s.byteLength,l),i.end(w.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(u,n){const l=await this.resolve(u,{resolveMetadata:!0});if(l.isDirectory)throw new f.FileOperationError((0,b.localize)(11,null,this.resourceForError(u)),0,n);if(typeof n?.etag=="string"&&n.etag!==f.ETAG_DISABLED&&n.etag===l.etag)throw new f.NotModifiedSinceFileOperationError((0,b.localize)(12,null),l,n);return this.validateReadFileLimits(u,l.size,n),l}validateReadFileLimits(u,n,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&n>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&n>l.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,b.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,n,l){return this.doCanMoveCopy(u,n,"move",l)}async canCopy(u,n,l){return this.doCanMoveCopy(u,n,"copy",l)}async doCanMoveCopy(u,n,l,i){if(u.toString()!==n.toString())try{const s=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(s,u,r,n,l,i)}catch(s){return s}return!0}async move(u,n,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,u,s,n,"move",!!l),o=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,r==="move"?2:3,o)),o}async copy(u,n,l){const i=await this.withReadProvider(u),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,u,s,n,"copy",!!l),o=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,r==="copy"?3:2,o)),o}async doMoveCopy(u,n,l,i,s,r){if(n.toString()===i.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(u,n,l,i,s,r);if(o&&!c&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),s==="copy"){if(u===l&&(0,f.hasFileFolderCopyCapability)(u))await u.copy(n,i,{overwrite:r});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(u,g,l,i):await this.doCopyFile(u,n,l,i)}return s}else return u===l?(await u.rename(n,i,{overwrite:r}),s):(await this.doMoveCopy(u,n,l,i,"copy",r),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(u,n,l,i){if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(u,n,l,i);if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(u,n,l,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(u,n,l,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasReadWriteCapability)(l))return this.doPipeUnbuffered(u,n,l,i)}async doCopyFolder(u,n,l,i){await l.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async s=>{const r=this.getExtUri(l).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(u,await this.resolve(s.resource),l,r):this.doCopyFile(u,s.resource,l,r)}))}async doValidateMoveCopy(u,n,l,i,s,r){let o=!1;if(u===l){const{providerExtUri:g,isPathCaseSensitive:I}=this.getExtUri(u);if(I||(o=g.isEqual(n,i)),o&&s==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!o&&g.isEqualOrParent(i,n))throw new Error((0,b.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!o){if(!r)throw new f.FileOperationError((0,b.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(u===l){const{providerExtUri:g}=this.getExtUri(u);if(g.isEqualOrParent(n,i))throw new Error((0,b.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:o}}getExtUri(u){const n=this.isPathCaseSensitive(u);return{providerExtUri:n?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(n,u);const l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,l)),l}async mkdirp(u,n){const l=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(n,i.dirname(n));)try{if(((await u.stat(n)).type&f.FileType.Directory)==0)throw new Error((0,b.localize)(18,null,this.resourceForError(n)));break}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileNotFound)throw s;l.push(i.basename(n)),n=i.dirname(n)}for(let s=l.length-1;s>=0;s--){n=i.joinPath(n,l[s]);try{await u.mkdir(n)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(u,n){try{await this.doValidateDelete(u,n)}catch(l){return l}return!0}async doValidateDelete(u,n){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!n?.useTrash&&!(l.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(u)));let s;try{s=await l.stat(u)}catch{}if(s)this.throwIfFileIsReadonly(u,s);else throw new f.FileOperationError((0,b.localize)(20,null,this.resourceForError(u)),1);if(!!!n?.recursive){const o=await this.resolve(u);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(u)))}return l}async del(u,n){const l=await this.doValidateDelete(u,n),i=!!n?.useTrash,s=!!n?.recursive;await l.delete(u,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(u,1))}async cloneFile(u,n){const l=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(l===i&&this.getExtUri(l).providerExtUri.isEqual(u,n))return;if(l===i&&(0,f.hasFileCloneCapability)(l))return l.cloneFile(u,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const s=this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri);return l===i&&(0,f.hasFileFolderCopyCapability)(l)?s.queue(()=>l.copy(u,n,{overwrite:!0})):s.queue(()=>this.doCopyFile(l,u,i,n))}watch(u,n={recursive:!1,excludes:[]}){const l=new P.DisposableStore;let i=!1,s=()=>{i=!0};return l.add((0,P.toDisposable)(()=>s())),(async()=>{try{const r=await this.doWatch(u,n);i?(0,P.dispose)(r):s=()=>(0,P.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(u,n){const l=await this.withProvider(u),i=(0,E.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(u),n]);let s=this.activeWatchers.get(i);return s||(s={count:0,disposable:l.watch(u,n)},this.activeWatchers.set(i,s)),s.count+=1,(0,P.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,P.dispose)(s.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,P.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,n,l,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{const s=await u.open(n,{create:!0,unlock:l?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,s,i):await this.doWriteReadableBufferedQueued(u,s,i)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await u.close(s)}})}async doWriteStreamBufferedQueued(u,n,l){let i=0,s;if((0,d.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=w.VSBuffer.concat(l.buffer);await this.doWriteBuffer(u,n,r,r.byteLength,i,0),i+=r.byteLength}if(l.ended)return;s=l.stream}else s=l;return new Promise((r,o)=>{(0,d.listenStream)(s,{onData:async c=>{s.pause();try{await this.doWriteBuffer(u,n,c,c.byteLength,i,0)}catch(g){return o(g)}i+=c.byteLength,setTimeout(()=>s.resume())},onError:c=>o(c),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(u,n,l){let i=0,s;for(;(s=l.read())!==null;)await this.doWriteBuffer(u,n,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(u,n,l,i,s,r){let o=0;for(;o<i;)o+=await u.write(n,s+o,l.buffer,r+o,i-o)}async doWriteUnbuffered(u,n,l,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,n,l,i))}async doWriteUnbufferedQueued(u,n,l,i){let s;i instanceof w.VSBuffer?s=i:(0,d.isReadableStream)(i)?s=await(0,w.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?s=await(0,w.bufferedStreamToBuffer)(i):s=(0,w.readableToBuffer)(i),await u.writeFile(n,s.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(u,n,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,n,l,i))}async doPipeBufferedQueued(u,n,l,i){let s,r;try{s=await u.open(n,{create:!1}),r=await l.open(i,{create:!0,unlock:!1});const o=w.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,g=0,I=0;do I=await u.read(s,c,o.buffer,g,o.byteLength-g),await this.doWriteBuffer(l,r,o,I,c,g),c+=I,g+=I,g===o.byteLength&&(g=0);while(I>0)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await t.Promises.settled([typeof s=="number"?u.close(s):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(u,n,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,n,l,i))}async doPipeUnbufferedQueued(u,n,l,i){return l.writeFile(i,await u.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,n,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,n,l,i))}async doPipeUnbufferedToBufferedQueued(u,n,l,i){const s=await l.open(i,{create:!0,unlock:!1});try{const r=await u.readFile(n);await this.doWriteBuffer(l,s,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await l.close(s)}}async doPipeBufferedToUnbuffered(u,n,l,i){const s=await(0,w.streamToBuffer)(this.readFileBuffered(u,n,S.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,s)}throwIfFileSystemIsReadonly(u,n){if(u.capabilities&2048)throw new f.FileOperationError((0,b.localize)(22,null,this.resourceForError(n)),6);return u}throwIfFileIsReadonly(u,n){if((n.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,b.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===A.Schemas.file?u.fsPath:u.toString(!0)}};h=Re([Oe(0,p.ILogService)],h),e.FileService=h}),define(we[58],ye([0,1,30,261,14,29,16,7,33,2,5,3,19,43,20,166,17,94,199,36,195,194]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(l){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(l)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new S.ResourceMap(r=>C.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:r}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,r),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(s.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,C.joinPath)(i,o.name))).type:c=this.toType(o),r.push([o.name,c])}catch(c){this.logService.trace(c)}})),r}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let r;return s?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,s&&(r|=f.FileType.SymbolicLink),r}async createResourceLock(i){const s=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await r.wait();const o=new w.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(i,s){let r;try{s?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const o=this.toFilePath(i);return await d.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}readFileStream(i,s,r){const o=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(g=>T.VSBuffer.wrap(g))).buffer);return(0,m.readFileIntoStream)(this,i,o,c=>c.buffer,{...s,bufferSize:256*1024},r),o}async writeFile(i,s,r){let o;try{const c=this.toFilePath(i);if(!r.create||!r.overwrite){if(await d.Promises.exists(c)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,b.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,b.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,s,0,s.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}async open(i,s){const r=this.toFilePath(i);let o;(0,f.isFileOpenForWriteOptions)(s)&&(o=await this.createResourceLock(i));let c;try{if((0,f.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:I}=await d.SymlinkSupport.stat(r);I.mode&128||await d.Promises.chmod(r,I.mode|128)}catch(I){this.logService.trace(I)}let g;if((0,f.isFileOpenForWriteOptions)(s)){if(A.isWindows)try{await d.Promises.truncate(r,0),g="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}g||(g="w")}else g="r";c=await d.Promises.open(r,g)}catch(g){throw o?.dispose(),(0,f.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(c,0),(0,f.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(c,i),o){const g=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.mapHandleToLock.set(c,o),g&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),g.dispose())}return c}async close(i){const s=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{s&&(this.mapHandleToLock.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,r,o,c){const g=this.normalizePos(i,s);let I=null;try{I=(await d.Promises.read(i,r,o,c,g)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(i,g,I)}return I}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,r){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof s=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,o+r):this.mapHandleToPos.delete(i)))}async write(i,s,r,o,c){return(0,w.retry)(()=>this.doWrite(i,s,r,o,c),100,3)}async doWrite(i,s,r,o,c){const g=this.normalizePos(i,s);let I=null;try{I=(await d.Promises.write(i,r,o,c,g)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),_)}finally{this.updatePos(i,g,I)}return I}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const r=this.toFilePath(i);s.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,s,r){const o=this.toFilePath(i),c=this.toFilePath(s);if(o!==c)try{await this.validateTargetDeleted(i,s,"move",r.overwrite),await d.Promises.move(o,c)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,s,r){const o=this.toFilePath(i),c=this.toFilePath(s);if(o!==c)try{await this.validateTargetDeleted(i,s,"copy",r.overwrite),await d.Promises.copy(o,c,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,s,r,o){const c=this.toFilePath(i),g=this.toFilePath(s);let I=!1;if(!!(this.capabilities&1024)||(I=(0,v.isEqual)(c,g,!0)),I&&r==="copy")throw(0,f.createFileSystemProviderError)((0,b.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!I&&await d.Promises.exists(g)){if(!o)throw(0,f.createFileSystemProviderError)((0,b.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.doCloneFile(i,s,!1)}async doCloneFile(i,s,r){const o=this.toFilePath(i),c=this.toFilePath(s),g=!!(this.capabilities&1024);if((0,v.isEqual)(o,c,!g))return;const I=new P.DisposableStore;try{const[_,z]=await Promise.all([this.createResourceLock(i),this.createResourceLock(s)]);I.add(_),I.add(z),r&&await d.Promises.mkdir((0,R.dirname)(c),{recursive:!0}),await d.Promises.copyFile(o,c)}catch(_){if(_.code==="ENOENT"&&!r)return this.doCloneFile(i,s,!0);throw this.toFileSystemProviderError(_)}finally{I.dispose()}}createUniversalWatcher(i,s,r){return new a.UniversalWatcherClient(o=>i(o),o=>s(o),r)}createNonRecursiveWatcher(i,s,r){return new u.NodeJSWatcherClient(o=>i(o),o=>s(o),r)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let r=this.toFileSystemProviderError(s);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(r=(0,f.createFileSystemProviderError)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=n}),define(we[200],ye([0,1,7,58,2,16,43,21]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends w.Disposable{constructor(A,C){super();this.provider=A,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(A,C,y){const d=this.getUriTransformer(A);switch(C){case"stat":return this.stat(d,y[0]);case"readdir":return this.readdir(d,y[0]);case"open":return this.open(d,y[0],y[1]);case"close":return this.close(y[0]);case"read":return this.read(y[0],y[1],y[2]);case"readFile":return this.readFile(d,y[0],y[1]);case"write":return this.write(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.writeFile(d,y[0],y[1],y[2]);case"rename":return this.rename(d,y[0],y[1],y[2]);case"copy":return this.copy(d,y[0],y[1],y[2]);case"cloneFile":return this.cloneFile(d,y[0],y[1]);case"mkdir":return this.mkdir(d,y[0]);case"delete":return this.delete(d,y[0],y[1]);case"watch":return this.watch(d,y[0],y[1],y[2],y[3]);case"unwatch":return this.unwatch(y[0],y[1])}throw new Error(`IPC Command ${C} not found`)}listen(A,C,y){const d=this.getUriTransformer(A);switch(C){case"fileChange":return this.onFileChange(d,y[0]);case"readFileStream":return this.onReadFileStream(d,y[0],y[1])}throw new Error(`Unknown event ${C}`)}stat(A,C){const y=this.transformIncoming(A,C,!0);return this.provider.stat(y)}readdir(A,C){const y=this.transformIncoming(A,C);return this.provider.readdir(y)}async readFile(A,C,y){const d=this.transformIncoming(A,C,!0),b=await this.provider.readFile(d,y);return S.VSBuffer.wrap(b)}onReadFileStream(A,C,y){const d=this.transformIncoming(A,C,!0),b=new E.CancellationTokenSource,f=new k.Emitter({onLastListenerRemove:()=>{b.cancel()}}),m=this.provider.readFileStream(d,y,b.token);return(0,T.listenStream)(m,{onData:p=>f.fire(S.VSBuffer.wrap(p)),onError:p=>f.fire(p),onEnd:()=>{f.fire("end"),f.dispose(),b.dispose()}}),f.event}writeFile(A,C,y,d){const b=this.transformIncoming(A,C);return this.provider.writeFile(b,y.buffer,d)}open(A,C,y){const d=this.transformIncoming(A,C,!0);return this.provider.open(d,y)}close(A){return this.provider.close(A)}async read(A,C,y){const d=S.VSBuffer.alloc(y),b=0,f=await this.provider.read(A,C,d.buffer,b,y);return[d,f]}write(A,C,y,d,b){return this.provider.write(A,C,y.buffer,d,b)}mkdir(A,C){const y=this.transformIncoming(A,C);return this.provider.mkdir(y)}delete(A,C,y){const d=this.transformIncoming(A,C);return this.provider.delete(d,y)}rename(A,C,y,d){const b=this.transformIncoming(A,C),f=this.transformIncoming(A,y);return this.provider.rename(b,f,d)}copy(A,C,y,d){const b=this.transformIncoming(A,C),f=this.transformIncoming(A,y);return this.provider.copy(b,f,d)}cloneFile(A,C,y){const d=this.transformIncoming(A,C),b=this.transformIncoming(A,y);return this.provider.cloneFile(d,b)}onFileChange(A,C){const y=new k.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(A,y))},onLastListenerRemove:()=>{(0,w.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return y.event}async watch(A,C,y,d,b){const f=this.sessionToWatcher.get(C);if(f){const m=this.transformIncoming(A,d),p=f.watch(y,m,b);this.watchRequests.set(C+y,p)}}async unwatch(A,C){const y=A+C,d=this.watchRequests.get(y);d&&((0,w.dispose)(d),this.watchRequests.delete(y))}dispose(){super.dispose();for(const[,A]of this.watchRequests)A.dispose();this.watchRequests.clear();for(const[,A]of this.sessionToWatcher)A.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class P extends w.Disposable{constructor(A,C,y,d){super();this.uriTransformer=A,this.logService=y,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(A){const C=this._register(new k.Emitter);this._register(C.event(y=>{A.fire(y.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(y=>C.fire(y))),this._register(this.fileWatcher.onDidWatchError(y=>A.fire(y)))}getRecursiveWatcherOptions(A){}getExtraExcludes(A){}watch(A,C,y){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(y.excludes=[...y.excludes,...d]),this.watcherRequests.set(A,this.fileWatcher.watch(C,y)),(0,w.toDisposable)(()=>{(0,w.dispose)(this.watcherRequests.get(A)),this.watcherRequests.delete(A)})}dispose(){super.dispose();for(const[,A]of this.watcherRequests)A.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=P}),define(we[97],ye([0,1,7,4,13]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(C){this.service=C,this.onDidChangeLogLevel=k.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(C,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class T{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C){T.setLevel(this.channel,C)}static setLevel(C,y){return C.call("setLevel",y)}}e.LogLevelChannelClient=T;class E{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,y){throw new Error(`Event not found: ${y}`)}async call(C,y,d){switch(y){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(C,y){this.loggers.set(C.toString(),this.loggerService.createLogger(C,y))}consoleLog(C,y){let d=console.log;switch(C){case w.LogLevel.Error:d=console.error;break;case w.LogLevel.Warning:d=console.warn;break;case w.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(C,y){const d=this.loggers.get(C.toString());if(!d)throw new Error("Create the logger before logging");for(const[b,f]of y)(0,w.log)(d,b,f)}}e.LoggerChannel=E;class v extends w.AbstractLoggerService{constructor(C,y,d){super(C,y);this.channel=d}createConsoleMainLogger(){return new w.AdapterLogger({log:(C,y)=>{this.channel.call("consoleLog",[C,y])}})}doCreateLogger(C,y,d){return new P(this.channel,C,y,d)}}e.LoggerChannelClient=v;class P extends w.AbstractMessageLogger{constructor(C,y,d,b){super(b?.always);this.channel=C,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,y){const d=[[C,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(C){this.channel.call("log",[this.file,C])}}class R extends w.LogService{constructor(C,y){super(y);this.parent=C,this._register(C.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=R}),define(we[98],ye([0,1,17,13]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function w(E,v,P,R,A){try{const C=await new Promise((d,b)=>{te(["spdlog"],d,b)});C.setFlushOn(t.LogLevel.Trace);const y=await C.createAsyncRotatingLogger(E,v,P,R);return A&&y.clearFormatters(),y}catch(C){console.error(C)}return null}function S(E,v,P){switch(v){case t.LogLevel.Trace:E.trace(P);break;case t.LogLevel.Debug:E.debug(P);break;case t.LogLevel.Info:E.info(P);break;case t.LogLevel.Warning:E.warn(P);break;case t.LogLevel.Error:E.error(P);break;case t.LogLevel.Critical:E.critical(P);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(v,P,R,A,C){super();this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(v,P,R,A),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(v,P,R,A){const C=R?6:1,y=30/C*k.ByteSize.MB,d=await w(v,P,y,C,A);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:b,message:f}of this.buffer)S(this._logger,b,f);this.buffer=[]}}log(v,P){this._logger?S(this._logger,v,P):this.getLevel()<=v&&this.buffer.push({level:v,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(we[201],ye([0,1,63,167,6]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var T;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function P(d,b){return b-d}v.compare=P;const R=Object.create(null);R[v.Error]=(0,t.localize)(0,null),R[v.Warning]=(0,t.localize)(1,null),R[v.Info]=(0,t.localize)(2,null);function A(d){return R[d]||""}v.toString=A;function C(d){switch(d){case k.default.Error:return v.Error;case k.default.Warning:return v.Warning;case k.default.Info:return v.Info;case k.default.Ignore:return v.Hint}}v.fromSeverity=C;function y(d){switch(d){case v.Error:return k.default.Error;case v.Warning:return k.default.Warning;case v.Info:return k.default.Info;case v.Hint:return k.default.Ignore}}v.toSeverity=y}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(v){const P="";function R(C){return A(C,!0)}v.makeKey=R;function A(C,y){let d=[P];return C.source?d.push(C.source.replace("\xA6","\\\xA6")):d.push(P),C.code?typeof C.code=="string"?d.push(C.code.replace("\xA6","\\\xA6")):d.push(C.code.value.replace("\xA6","\\\xA6")):d.push(P),C.severity!==void 0&&C.severity!==null?d.push(T.toString(C.severity)):d.push(P),C.message&&y?d.push(C.message.replace("\xA6","\\\xA6")):d.push(P),C.startLineNumber!==void 0&&C.startLineNumber!==null?d.push(C.startLineNumber.toString()):d.push(P),C.startColumn!==void 0&&C.startColumn!==null?d.push(C.startColumn.toString()):d.push(P),C.endLineNumber!==void 0&&C.endLineNumber!==null?d.push(C.endLineNumber.toString()):d.push(P),C.endColumn!==void 0&&C.endColumn!==null?d.push(C.endColumn.toString()):d.push(P),d.push(P),d.join("\xA6")}v.makeKeyOptionalMessage=A})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[47],ye([0,1,8,3,25,19]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const E=t.globals.vscode.context.configuration();if(E)T=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const E=(0,S.dirname)(k.FileAccess.asFileUri("",te));T=te.__$__nodeRequire((0,S.joinPath)(E,"product.json").fsPath);const v=te.__$__nodeRequire((0,S.joinPath)(E,"package.json").fsPath);w.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),Object.assign(T,{version:v.version})}else T={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","matklad.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","matklad.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletions","inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textDocumentNotebook","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookContentProvider","notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookLiveShare","notebookMessaging","notebookMime","textDocumentNotebook"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","resolvers","textSearchProvider"],"ms-vscode.remote-repositories":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"tanhakabir.rest-book":["notebookEditor"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState"],"GitHub.copilot":["inlineCompletions","inlineCompletionsNew","inlineCompletionsAdditions","textDocumentNotebook"],"GitHub.copilot-nightly":["inlineCompletions","inlineCompletionsNew","inlineCompletionsAdditions","textDocumentNotebook"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel"],"ms-toolsai.vscode-jupyter-powertoys":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookMessaging","notebookMime","notebookCellExecutionState"],"dbaeumer.vscode-eslint":["notebookEditor","notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.89",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.67.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.1",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.15",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.67.0",commit:"57fd6d0195bb9b9d1b49f6da5db789060795de47",date:"2022-05-04T11:52:05.758Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(we[24],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[202],ye([0,1,67,13,23,24,197]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let E=class extends T.BaseCredentialsMainService{constructor(P,R,A){super(P);this.environmentMainService=R,this.productService=A}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new k.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((P,R)=>{te(["keytar"],P,R)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(P){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${P.message??P}`),this._keytarCache=new k.InMemoryCredentialsProvider}return this._keytarCache}};E=Re([Oe(0,t.ILogService),Oe(1,w.INativeEnvironmentService),Oe(2,S.IProductService)],E),e.CredentialsWebMainService=E}),define(we[34],ye([0,1,126,12]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(T,E){k.ok(t.isString(T)),k.ok(t.isObject(E)),k.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,E)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new w}),define(we[203],ye([0,1,7,34]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class S{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,P){this.schemasById[w(v)]=P,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;t.Registry.add(e.Extensions.JSONContribution,T)}),define(we[48],ye([0,1,18,7,12,153,28,203,34]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const A=v.Registry.as(E.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,l=!0){this.registerConfigurations([n],l)}registerConfigurations(n,l=!0){const i=this.doRegisterConfigurations(n,l);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const l=this.doDeregisterConfigurations(n);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:n,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(n,!1)),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(n){const l=[],i=[];for(const{overrides:s,source:r}of n)for(const o in s)if(l.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c={...this.configurationDefaultsOverrides.get(o)?.value||{},...s[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:c});const g=(0,T.getLanguageTagSettingPlainKey)(o),I={type:"object",default:c,description:S.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:w.isString(r)?void 0:r};i.push(...b(o)),this.configurationProperties[o]=I,this.defaultLanguageConfigurationOverridesNode.properties[o]=I}else{this.configurationDefaultsOverrides.set(o,{value:s[o],source:r});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const l=[];for(const{overrides:i,source:s}of n)for(const r in i){const o=this.configurationDefaultsOverrides.get(r),c=w.isString(s)?s:s?.id,g=w.isString(o?.source)?o?.source:o?.source?.id;if(c===g)if(l.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const I=this.configurationProperties[r];I&&(this.updatePropertyDefaultValue(r,I),this.updateSchema(r,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const l of n)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,l){const i=[];return n.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,l,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(n){const l=[],i=s=>{if(s.properties)for(const r in s.properties)l.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>i(r))};for(const s of n){i(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}return l}validateAndRegisterProperties(n,l=!0,i,s,r=3){r=w.isUndefinedOrNull(n.scope)?r:n.scope;let o=[],c=n.properties;if(c)for(let I in c){if(l&&h(I)){delete c[I];continue}const _=c[I];if(_.source=i,_.defaultDefaultValue=c[I].default,this.updatePropertyDefaultValue(I,_),e.OVERRIDE_PROPERTY_REGEX.test(I)?_.scope=void 0:(_.scope=w.isUndefinedOrNull(_.scope)?r:_.scope,_.restricted=w.isUndefinedOrNull(_.restricted)?!!s?.includes(I):_.restricted),c[I].hasOwnProperty("included")&&!c[I].included){this.excludedConfigurationProperties[I]=c[I],delete c[I];continue}else this.configurationProperties[I]=c[I];!c[I].deprecationMessage&&c[I].markdownDeprecationMessage&&(c[I].deprecationMessage=c[I].markdownDeprecationMessage),o.push(I)}let g=n.allOf;if(g)for(let I of g)o.push(...this.validateAndRegisterProperties(I,l,i,s,r));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const l=i=>{let s=i.properties;if(s)for(const o in s)this.updateSchema(o,s[o]);let r=i.allOf;r&&r.forEach(l)};l(n)}updateSchema(n,l){switch(e.allSettings.properties[n]=l,l.scope){case 1:e.applicationSettings.properties[n]=l;break;case 2:e.machineSettings.properties[n]=l;break;case 6:e.machineOverridableSettings.properties[n]=l;break;case 3:e.windowSettings.properties[n]=l;break;case 4:e.resourceSettings.properties[n]=l;break;case 5:e.resourceSettings.properties[n]=l,this.resourceLanguageSettingsSchema.properties[n]=l;break}}removeFromSchema(n,l){switch(delete e.allSettings.properties[n],l.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const l=`[${n}]`,i={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:S.localize(4,null),errorMessage:S.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,l){const i=this.configurationDefaultsOverrides.get(n);let s=i?.value,r=i?.source;w.isUndefined(s)&&(s=l.defaultDefaultValue,r=void 0),w.isUndefined(s)&&(s=m(l.type)),l.default=s,l.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(u){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let l=d.exec(u);for(;l?.length;){const i=l[1].trim();i&&n.push(i),l=d.exec(u)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=b;function f(u){return u.reduce((n,l)=>`${n}[${l}]`,"")}e.keyFromOverrideIdentifiers=f;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const p=new C;v.Registry.add(e.Extensions.Configuration,p);function h(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?S.localize(7,null,u):p.getConfigurationProperties()[u]!==void 0?S.localize(8,null,u):null:S.localize(6,null)}e.validateProperty=h;function a(){const u=[],n=p.getConfigurationProperties();for(const l of Object.keys(n))u.push([l,n[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=a}),define(we[204],ye([0,1,18,7,61,2,29,22,12,4,28,48,34]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},s=[],r=[]){this._contents=i,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const r=this.getContentsForOverrideIdentifer(s);return r?i?(0,R.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const r of this.overrides)r.identifiers.includes(i)&&s.push(...r.keys);return k.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return k.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=E.deepClone(this.contents),r=E.deepClone(this.overrides),o=[...this.keys];for(const c of i){this.mergeContents(s,c.contents);for(const g of c.overrides){const[I]=r.filter(_=>k.equals(_.identifiers,g.identifiers));I?(this.mergeContents(I.contents,g.contents),I.keys.push(...g.keys),I.keys=k.distinct(I.keys)):r.push(E.deepClone(g))}for(const g of c.keys)o.indexOf(g)===-1&&o.push(g)}return new y(s,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[o],g=s[o];g&&(typeof c=="object"&&typeof g=="object"?(c=E.deepClone(c),this.mergeContents(c,g)):c=g),r[o]=c}return new y(r,this.keys,this.overrides)}mergeContents(i,s){for(const r of Object.keys(s)){if(r in i&&v.isObject(i[r])&&v.isObject(s[r])){this.mergeContents(i[r],s[r]);continue}i[r]=E.deepClone(s[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?E.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=E.deepClone(c))};for(const c of this.overrides)k.equals(c.identifiers,[i])?s=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,R.addToValueTree)(this.contents,i,s,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let r=0;r<s;r++)i.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(i={}){const s=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(s),o=Object.create(null),c=[];for(const g in s){const I=i[g],_=I!==void 0?I:s[g].default;(0,R.addToValueTree)(o,g,_,z=>console.error(`Conflict in default settings: ${z}`))}for(const g of Object.keys(o))A.OVERRIDE_PROPERTY_REGEX.test(g)&&c.push({identifiers:(0,A.overrideIdentifiersFromKey)(g),keys:Object.keys(o[g]),contents:(0,R.toValuesTree)(o[g],I=>console.error(`Conflict in default settings file: ${I}`))});super(o,r,c)}}e.DefaultConfigurationModel=d;class b{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!v.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:r,keys:o,overrides:c,restricted:g}=this.doParseRaw(i,s);this._configurationModel=new y(r,o,c),this._restrictedConfigurations=g||[]}doParseContent(i){let s={},r=null,o=[],c=[],g=[];function I(z){Array.isArray(o)?o.push(z):r!==null&&(o[r]=z)}let _={onObjectBegin:()=>{let z={};I(z),c.push(o),o=z,r=null},onObjectProperty:z=>{r=z},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let z=[];I(z),c.push(o),o=z,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:I,onError:(z,W,ee)=>{g.push({error:z,offset:W,length:ee})}};if(i)try{w.visit(i,_),s=o[0]||{}}catch(z){console.error(`Error while parsing settings file ${this._name}: ${z}`),this._parseErrors=[z]}return s}doParseRaw(i,s){const r=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,s);i=o.raw;const c=(0,R.toValuesTree)(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),g=Object.keys(i),I=this.toOverrides(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:c,keys:g,overrides:I,restricted:o.restricted}}filter(i,s,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const c={},g=[];for(let I in i)if(A.OVERRIDE_PROPERTY_REGEX.test(I)&&r){const _=this.filter(i[I],s,!1,o);c[I]=_.raw,g.push(..._.restricted)}else{const _=s[I],z=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&g.push(I),(z===void 0||o.scopes===void 0||o.scopes.includes(z))&&(o.skipRestricted&&_?.restricted||(c[I]=i[I]))}return{raw:c,restricted:g}}toOverrides(i,s){const r=[];for(const o of Object.keys(i))if(A.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const g in i[o])c[g]=i[o][g];r.push({identifiers:(0,A.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,s)})}return r}}e.ConfigurationModelParser=b;class f extends S.Disposable{constructor(i,s,r,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class m{constructor(i,s,r=new y,o=new y,c=new T.ResourceMap,g=new y,I=new T.ResourceMap,_=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=g,this._memoryConfigurationByResource=I,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(i)}updateValue(i,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,r){const o=this.getConsolidateConfigurationModel(s,r),c=this.getFolderConfigurationModelForResource(s.resource,r),g=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,I=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),z=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),W=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),ee=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,H=s.overrideIdentifier?g.override(s.overrideIdentifier).getValue(i):g.getValue(i),F=o.getValue(i),$=k.distinct(k.flatten(o.overrides.map(oe=>oe.identifiers))).filter(oe=>o.getOverrideValue(i,oe)!==void 0);return{defaultValue:I,userValue:_,userLocalValue:z,userRemoteValue:W,workspaceValue:ee,workspaceFolderValue:D,memoryValue:H,value:F,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:z!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:c?.freeze().getValue(i),override:s.overrideIdentifier?c?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(i),override:s.overrideIdentifier?g.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const r=[];if(!s){const{added:o,updated:c,removed:g}=u(this._defaultConfiguration,i);s=[...o,...c,...g]}for(const o of s)for(const c of(0,A.overrideIdentifiersFromKey)(o)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(c),I=i.getKeysForOverrideIdentifier(c),_=[...I.filter(z=>g.indexOf(z)===-1),...g.filter(z=>I.indexOf(z)===-1),...g.filter(z=>!E.equals(this._defaultConfiguration.override(c).getValue(z),i.override(c).getValue(z)))];r.push([c,_])}return this.updateDefaultConfiguration(i),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:c}=u(this.localUserConfiguration,i),g=[...s,...r,...o];return g.length&&this.updateLocalUserConfiguration(i),{keys:g,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:c}=u(this.remoteUserConfiguration,i);let g=[...s,...r,...o];return g.length&&this.updateRemoteUserConfiguration(i),{keys:g,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:r,removed:o,overrides:c}=u(this.workspaceConfiguration,i);let g=[...s,...r,...o];return g.length&&this.updateWorkspaceConfiguration(i),{keys:g,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const r=this.folderConfigurations.get(i),{added:o,updated:c,removed:g,overrides:I}=u(r,s);let _=[...o,...c,...g];return(_.length||!r)&&this.updateFolderConfiguration(i,s),{keys:_,overrides:I}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:c,overrides:g}=u(s,void 0);return{keys:[...r,...o,...c],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let r=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(i);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=r.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=r}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const r=s.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(s);return i.push([s,{contents:r,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((g,I)=>(g.set(P.URI.revive(I[0]),this.parseConfigurationModel(I[1])),g),new T.ResourceMap);return new m(s,r,new y,o,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const o of l)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,g])=>{const I=(0,T.getOrSet)(s,c,new Set);g.forEach(_=>I.add(_))});const r=[];return s.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class h{constructor(i,s,r,o){this.change=i,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(I=>c.add(I)),i.overrides.forEach(([,I])=>I.forEach(_=>c.add(_))),this.affectedKeys=[...c.values()];const g=new y;this.affectedKeys.forEach(I=>g.setValue(I,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!E.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let r=(0,R.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=h;class a extends h{constructor(i,s,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a;function u(l,i){const{added:s,removed:r,updated:o}=n(i,l),c=[],g=l?.getAllOverrideIdentifiers()||[],I=i?.getAllOverrideIdentifiers()||[];if(i){const _=I.filter(z=>!g.includes(z));for(const z of _)c.push([z,i.getKeysForOverrideIdentifier(z)])}if(l){const _=g.filter(z=>!I.includes(z));for(const z of _)c.push([z,l.getKeysForOverrideIdentifier(z)])}if(i&&l){for(const _ of g)if(I.includes(_)){const z=n({contents:l.getOverrideValue(void 0,_)||{},keys:l.getKeysForOverrideIdentifier(_)},{contents:i.getOverrideValue(void 0,_)||{},keys:i.getKeysForOverrideIdentifier(_)});c.push([_,[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:r,updated:o,overrides:c}}function n(l,i){const s=l?i?l.keys.filter(c=>i.keys.indexOf(c)===-1):[...l.keys]:[],r=i?l?i.keys.filter(c=>l.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(l&&i){for(const c of i.keys)if(l.keys.indexOf(c)!==-1){const g=(0,R.getConfigurationValue)(i.contents,c),I=(0,R.getConfigurationValue)(l.contents,c);E.equals(g,I)||o.push(c)}}return{added:s,removed:r,updated:o}}}),define(we[99],ye([0,1,14,7,2,19,28,204,48,34]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends w.Disposable{constructor(C,y){super();this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,S.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(P.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const C=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,C)}getConfigurationData(){return this.configuration.toData()}getValue(C,y){const d=typeof C=="string"?C:void 0,b=(0,T.isConfigurationOverrides)(C)?C:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,b,void 0)}updateValue(C,y,d,b){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(d,y,1)}onDidDefaultConfigurationChange(C){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,C);this.trigger(d,y,6)}trigger(C,y,d){const b=new E.ConfigurationChangeEvent(C,{data:y},this.configuration);b.source=d,b.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(C){switch(C){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(we[100],ye([0,1,9,6]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var w;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends k.ErrorNoTelemetry{constructor(E,v=w.Unknown,P){super(E);this._message=E,this._code=v,this._detail=P,this.isHandled=v===w.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===w.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===w.NoResolverFound}static isHandled(E){return E instanceof S&&E.isHandled}}e.RemoteAuthorityResolverError=S}),define(we[205],ye([0,1,8]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=t;function w(S){if(!S)return;const T=S.indexOf("+");return T<0?S:S.substr(0,T)}e.getRemoteName=w}),define(we[40],ye([0,1,15,6,205]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=S;function T(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var v;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,b){if(typeof d=="undefined"||d===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof d=="string"||typeof b=="string"){let f=typeof d=="string"?d:d.value,m=typeof b=="string"?b:b.value;return k.equalsIgnoreCase(f,m)}return d._lower===b._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=P;function R(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function A(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=A;function C(y,d){if(d){const b=`onResolveRemoteAuthority:${(0,w.getRemoteName)(d)}`;return y.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[35],ye([0,1,15,31,40,3,4,9,25]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,k.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class A{constructor(s,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=s.id}static create(s){const r=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new A(s.identifier,r,o)}static parse(s){const r=R.exec(s);return r&&r[1]&&r[2]?new A({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof A?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=A;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const s=C.exec(i);return s&&s[1]?[b(s[1]),s[2]]:[b(i),void 0]}e.getIdAndVersion=y;function d(i,s){return`${i}.${s}`}e.getExtensionId=d;function b(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function f(i,s){return b(d(i,s))}e.getGalleryExtensionId=f;function m(i,s){const r=[],o=c=>{for(const g of r)if(g.some(I=>P(s(I),s(c))))return g;return null};for(const c of i){const g=o(c);g?g.push(c):r.push([c])}return r}e.groupByExtension=m;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function h(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(i){const s=new Set;if(i.malicious)for(const r of i.malicious)s.add(r.id);return s}e.getMaliciousExtensionsSet=a;function u(i,s){const r=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(g=>!P(g.identifier,{id:c}))){const g=i.filter(I=>P(I.identifier,{id:c}));g.length===1&&(r.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=u;async function n(i,s){if(!S.isLinux)return!1;let r;try{r=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function l(i,s){const r=await n(i,s),o=(0,t.getTargetPlatform)(r?"alpine":S.platform,v.arch);return s.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=l}),define(we[101],ye([0,1,21,9,82,8,55,4,158,31,35,40]),function(te,e,k,t,w,S,T,E,v,P,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const C=f=>(0,v.localize)(0,null,f),y=(0,v.localize)(1,null,"ms-dotnettools.csharp");function d(f,m){return m?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let b=class{constructor(m,p){this.extensionManagementService=m,this.extensionGalleryService=p}get location(){}async listExtensions(m,p,h=console){let a=await this.extensionManagementService.getInstalled(1);const u=A.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(p&&p!==""){if(u.indexOf(p.toLowerCase())<0){h.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(l=>l.manifest.categories?l.manifest.categories.map(s=>s.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){h.log("Possible Categories: "),u.forEach(l=>{h.log(l)});return}this.location&&h.log((0,v.localize)(2,null,this.location)),a=a.sort((l,i)=>l.identifier.id.localeCompare(i.identifier.id));let n;for(let l of a)n!==l.identifier.id&&(n=l.identifier.id,h.log(d(l.manifest,m)))}async installExtensions(m,p,h,a,u=console){const n=[],l=[];m.length&&u.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),s=(g,I)=>{const _=i.find(z=>(0,R.areSameExtensions)(z.identifier,{id:g}));if(_){if(!a&&(!I||I==="prerelease"&&_.preRelease))return u.log((0,v.localize)(5,null,g,_.manifest.version,g)),!1;if(I&&_.manifest.version===I)return u.log((0,v.localize)(6,null,`${g}@${I}`)),!1}return!0},r=(g,I,_)=>{c.push({id:g,version:I!=="prerelease"?I:void 0,installOptions:{...h,isBuiltin:_,installPreReleaseVersion:I==="prerelease"||h.installPreReleaseVersion}})},o=[],c=[];for(const g of m)if(g instanceof E.URI)o.push(g);else{const[I,_]=(0,R.getIdAndVersion)(g);s(I,_)&&r(I,_,!1)}for(const g of p){const[I,_]=(0,R.getIdAndVersion)(g);s(I,_)&&r(I,_,!0)}if(o.length&&await Promise.all(o.map(async g=>{try{const I=await this.installVSIX(g,{...h,isBuiltin:!1},a,u);I&&l.push(I)}catch(I){u.error(I.message||I.stack||I),n.push(g.toString())}})),c.length){const g=await this.getGalleryExtensions(c);await Promise.all(c.map(async I=>{const _=g.get(I.id.toLowerCase());if(_)try{const z=await this.installFromGallery(I,_,i,a,u);z&&l.push(z)}catch(z){u.error(z.message||z.stack||z),n.push(I.id)}else u.error(`${C(I.version?`${I.id}@${I.version}`:I.id)}
${y}`),n.push(I.id)}))}if(n.length)throw new Error((0,v.localize)(7,null,n.join(", ")))}async installVSIX(m,p,h,a){const u=await this.extensionManagementService.getManifest(m);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,h,a))try{return await this.extensionManagementService.install(m,p),a.log((0,v.localize)(8,null,(0,w.getBaseLabel)(m))),u}catch(l){if((0,t.isCancellationError)(l))return a.log((0,v.localize)(9,null,(0,w.getBaseLabel)(m))),null;throw l}return null}async getGalleryExtensions(m){const p=new Map,h=m.some(u=>u.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(m.map(u=>({...u,preRelease:h})),k.CancellationToken.None);for(const u of a)p.set(u.identifier.id.toLowerCase(),u);return p}async installFromGallery({id:m,version:p,installOptions:h},a,u,n,l){const i=await this.extensionGalleryService.getManifest(a,k.CancellationToken.None);if(i&&!this.validateExtensionKind(i,l))return null;const s=u.find(r=>(0,R.areSameExtensions)(r.identifier,a.identifier));if(s){if(a.version===s.manifest.version)return l.log((0,v.localize)(10,null,p?`${m}@${p}`:m)),null;l.log((0,v.localize)(11,null,m,a.version))}try{return h.isBuiltin?l.log(p?(0,v.localize)(12,null,m,p):(0,v.localize)(13,null,m)):l.log(p?(0,v.localize)(14,null,m,p):(0,v.localize)(15,null,m)),await this.extensionManagementService.installFromGallery(a,{...h,installGivenVersion:!!p}),l.log((0,v.localize)(16,null,m,a.version)),i}catch(r){if((0,t.isCancellationError)(r))return l.log((0,v.localize)(17,null,m)),null;throw r}}validateExtensionKind(m,p){return!0}async validateVSIX(m,p,h){const a={id:(0,R.getGalleryExtensionId)(m.publisher,m.name)},n=(await this.extensionManagementService.getInstalled(1)).find(l=>(0,R.areSameExtensions)(a,l.identifier)&&(0,T.gt)(l.manifest.version,m.version));return n&&!p?(h.log((0,v.localize)(18,null,n.identifier.id,n.manifest.version,m.version)),!1):this.validateExtensionKind(m,h)}async uninstallExtensions(m,p,h=console){const a=async n=>{if(n instanceof E.URI){const l=await this.extensionManagementService.getManifest(n);return d(l)}return n},u=[];for(const n of m){const l=await a(n),s=(await this.extensionManagementService.getInstalled()).filter(r=>(0,R.areSameExtensions)(r.identifier,{id:l}));if(!s.length)throw new Error(`${this.notInstalled(l)}
${y}`);if(s.some(r=>r.type===0)){h.log((0,v.localize)(19,null,l));return}if(!p&&s.some(r=>r.isBuiltin)){h.log((0,v.localize)(20,null,l));return}h.log((0,v.localize)(21,null,l));for(const r of s)await this.extensionManagementService.uninstall(r),u.push(r);this.location?h.log((0,v.localize)(22,null,l,this.location)):h.log((0,v.localize)(23,null,l))}}async locateExtension(m,p=console){const h=await this.extensionManagementService.getInstalled();m.forEach(a=>{h.forEach(u=>{if(u.identifier.id===a&&u.location.scheme===S.Schemas.file){p.log(u.location.fsPath);return}})})}notInstalled(m){return this.location?(0,v.localize)(24,null,m,this.location):(0,v.localize)(25,null,m)}};b=Re([Oe(0,P.IExtensionManagementService),Oe(1,P.IExtensionGalleryService)],b),e.ExtensionManagementCLIService=b}),define(we[49],ye([0,1,18,14,22,16,9,61,149,2,8,5,3,19,55,63,12,4,159,23,35,40,66,17,6,13,24,7,44]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var g;(function(H){function F($,oe){if($===oe)return!0;let K=Object.keys($),j=new Set;for(let O of Object.keys(oe))j.add(O);if(K.length!==j.size)return!1;for(let O of K){if($[O]!==oe[O])return!1;j.delete(O)}return j.size===0}H.equals=F})(g=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let I=class extends P.Disposable{constructor(F,$,oe,K,j,O,B,V){super();this.systemExtensionsLocation=F,this.userExtensionsLocation=$,this.extensionsControlLocation=oe,this.cacheLocation=K,this.fileService=j,this.logService=O,this.environmentService=B,this.productService=V,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new W((0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new W((0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new z(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(F){const[$,oe,K]=await Promise.all([this.scanSystemExtensions(F),this.scanUserExtensions(F),this.scanExtensionsUnderDevelopment(F)]);return this.dedupExtensions([...$,...oe,...K],await this.getTargetPlatform(),!0)}async scanSystemExtensions(F){const $=[];$.push(this.scanDefaultSystemExtensions(!!F.useCache,F.language)),$.push(this.scanDevSystemExtensions(F.language,!!F.checkControlFile));const[oe,K]=await Promise.all($);return this.applyScanOptions([...oe,...K],F,!1)}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");const $=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!F.includeUninstalled,F.language);let K=await(F.useCache&&!$.devMode&&$.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions($);return K=await this.applyScanOptions(K,F,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const $=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(oe=>oe.scheme===R.Schemas.file).map(async oe=>this.extensionsScanner.scanOneOrMultipleExtensions(await this.createExtensionScannerInput(oe,1,!0,F.language))))).flat();return this.applyScanOptions($,F,!0)}return[]}async scanExistingExtension(F,$,oe){const K=await this.createExtensionScannerInput(F,$,!0,oe.language),j=await this.extensionsScanner.scanExtension(K);return!j||!oe.includeInvalid&&!j.isValid?null:j}async scanOneOrMultipleExtensions(F,$,oe){const K=await this.createExtensionScannerInput(F,$,!0,oe.language),j=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(j,oe,!0)}async updateMetadata(F,$){const oe=(0,y.joinPath)(F,"package.json"),K=(await this.fileService.readFile(oe)).value.toString(),j=JSON.parse(K);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,$.installedTimestamp=$.installedTimestamp||void 0,j.__metadata={...j.__metadata,...$},await this.fileService.writeFile((0,y.joinPath)(F,"package.json"),S.VSBuffer.fromString(JSON.stringify(j,null,"	")))}async applyScanOptions(F,$,oe){return $.includeAllVersions||(F=this.dedupExtensions(F,await this.getTargetPlatform(),oe)),$.includeInvalid||(F=F.filter(K=>K.isValid)),F.sort((K,j)=>{const O=A.basename(K.location.fsPath),B=A.basename(j.location.fsPath);return O<B?-1:O>B?1:0})}dedupExtensions(F,$,oe){const K=new Map;for(const j of F){const O=u.ExtensionIdentifier.toKey(j.identifier.id),B=K.get(O);if(B){if(B.isValid&&!j.isValid)continue;if(B.isValid===j.isValid){if(oe&&d.gt(B.manifest.version,j.manifest.version)){this.logService.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version}.`);continue}if(d.eq(B.manifest.version,j.manifest.version)&&B.targetPlatform===$){this.logService.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`);continue}}B.type===0?this.logService.debug(`Overwriting system extension ${B.location.path} with ${j.location.path}.`):this.logService.warn(`Overwriting user extension ${B.location.path} with ${j.location.path}.`)}K.set(O,j)}return[...K.values()]}async scanDefaultSystemExtensions(F,$){this.logService.trace("Started scanning system extensions");const oe=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,$),j=await(F&&!oe.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(oe);return this.logService.trace("Scanned system extensions:",j.length),j}async scanDevSystemExtensions(F,$){const oe=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!oe?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=$?await this.getBuiltInExtensionControl():{},j=[],O=m.URI.file(A.normalize(A.join(R.FileAccess.asFileUri("",te).fsPath,"..",".build","builtInExtensions")));for(const V of oe){const J=K[V.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":j.push((0,y.joinPath)(O,V.name));break;default:j.push(m.URI.file(J));break}}const B=await Promise.all(j.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,0,!0,F))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,k.coalesce)(B)}async getBuiltInExtensionControl(){try{const F=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(F.value.toString())}catch{return{}}}async createExtensionScannerInput(F,$,oe,K){const j=await this.getTranslations(K??C.language);let O;try{const B=await this.fileService.stat(F);typeof B.mtime=="number"&&(O=B.mtime)}catch{}return new _(F,O,$,oe,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,K,j)}};I=Re([Oe(4,l.IFileService),Oe(5,s.ILogService),Oe(6,h.IEnvironmentService),Oe(7,r.IProductService)],I),e.AbstractExtensionsScannerService=I;class _{constructor(F,$,oe,K,j,O,B,V,J,se){this.location=F,this.mtime=$,this.type=oe,this.excludeObsolete=K,this.productVersion=j,this.productDate=O,this.productCommit=B,this.devMode=V,this.language=J,this.translations=se}static createNlsConfiguration(F){return{language:F.language,pseudo:F.language==="pseudo",devMode:F.devMode,translations:F.translations}}static equals(F,$){return(0,y.isEqual)(F.location,$.location)&&F.mtime===$.mtime&&F.type===$.type&&F.excludeObsolete===$.excludeObsolete&&F.productVersion===$.productVersion&&F.productDate===$.productDate&&F.productCommit===$.productCommit&&F.devMode===$.devMode&&F.language===$.language&&g.equals(F.translations,$.translations)}}class z extends P.Disposable{constructor(F,$){super();this.fileService=F,this.logService=$}async scanExtensions(F){const $=await this.fileService.resolve(F.location);if($.children){let oe={};if(F.excludeObsolete&&F.type===1)try{const j=(await this.fileService.readFile((0,y.joinPath)(F.location,".obsolete"))).value.toString();oe=JSON.parse(j)}catch{}const K=await Promise.all($.children.map(async j=>{if(!j.isDirectory||F.type===1&&(0,y.basename)(j.resource).indexOf(".")===0)return null;const O=new _(j.resource,F.mtime,F.type,F.excludeObsolete,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations),B=await this.scanExtension(O);return B&&!oe[a.ExtensionKey.create(B).toString()]?B:null}));return(0,k.coalesce)(K)}return[]}async scanOneOrMultipleExtensions(F){try{if(await this.fileService.exists((0,y.joinPath)(F.location,"package.json"))){const $=await this.scanExtension(F);return $?[$]:[]}else return await this.scanExtensions(F)}catch($){return this.logService.error(`Error scanning extensions at ${F.location.path}:`,(0,T.getErrorMessage)($)),[]}}async scanExtension(F){try{let $=await this.scanExtensionManifest(F.location);if($){$.publisher||($.publisher=u.UNDEFINED_PUBLISHER);const oe=$.__metadata;delete $.__metadata;const K=(0,a.getGalleryExtensionId)($.publisher,$.name),j=oe?.id?{id:K,uuid:oe.id}:{id:K},O=oe?.isSystem?0:F.type,B=O===0||!!oe?.isBuiltin,V=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,$,B);let J=!0;for(const[se,me]of V)se===b.default.Error&&(J=!1,this.logService.error(this.formatMessage(F.location,me)));return $=await this.translateManifest(F.location,$,_.createNlsConfiguration(F)),{type:O,identifier:j,manifest:$,location:F.location,isBuiltin:B,targetPlatform:oe?.targetPlatform??"undefined",metadata:oe,isValid:J,validations:V}}}catch($){F.type!==0&&this.logService.error($)}return null}async scanExtensionManifest(F){const $=(0,y.joinPath)(F,"package.json");let oe;try{oe=(await this.fileService.readFile($)).value.toString()}catch(j){return(0,l.toFileOperationResult)(j)!==1&&this.logService.error(this.formatMessage(F,(0,p.localize)(0,null,$.path,j.message))),null}let K;try{K=JSON.parse(oe)}catch{const O=[];(0,E.parse)(oe,O);for(const B of O)this.logService.error(this.formatMessage(F,(0,p.localize)(1,null,$.path,B.offset,B.length,(0,v.getParseErrorMessage)(B.error))));return null}return(0,E.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(F,(0,p.localize)(2,null,$.path))),null):K}async translateManifest(F,$,oe){const K=await this.getLocalizedMessages(F,$,oe);if(K)try{const j=[],O=await this.resolveOriginalMessageBundle(K.default,j);if(j.length>0)return j.forEach(V=>{this.logService.error(this.formatMessage(F,(0,p.localize)(3,null,K.default?.path,(0,v.getParseErrorMessage)(V.error))))}),$;if((0,E.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(F,(0,p.localize)(4,null,K.default?.path))),$;const B=K.values||Object.create(null);this.replaceNLStrings(oe.pseudo,$,B,O,F)}catch{}return $}async getLocalizedMessages(F,$,oe){const K=(0,y.joinPath)(F,"package.nls.json"),j=(J,se)=>{se.forEach(me=>{this.logService.error(this.formatMessage(F,(0,p.localize)(5,null,J?.path,(0,v.getParseErrorMessage)(me.error))))})},O=J=>{this.logService.error(this.formatMessage(F,(0,p.localize)(6,null,J?.path)))},B=`${$.publisher}.${$.name}`,V=oe.translations[B];if(V)try{const J=m.URI.file(V),se=(await this.fileService.readFile(J)).value.toString();let me=[],he=(0,E.parse)(se,me);return me.length>0?(j(J,me),{values:void 0,default:K}):(0,E.getNodeType)(he)!=="object"?(O(J),{values:void 0,default:K}):{values:he.contents?he.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let se;try{se=await this.findMessageBundles(F,oe)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const me=(await this.fileService.readFile(se.localized)).value.toString();let he=[],U=(0,E.parse)(me,he);return he.length>0?(j(se.localized,he),{values:void 0,default:se.original}):(0,E.getNodeType)(U)!=="object"?(O(se.localized),{values:void 0,default:se.original}):{values:U,default:se.original}}catch{return{values:void 0,default:se.original}}}}async resolveOriginalMessageBundle(F,$){if(F)try{const oe=(await this.fileService.readFile(F)).value.toString();return(0,E.parse)(oe,$)}catch{return null}else return null}findMessageBundles(F,$){return new Promise((oe,K)=>{const j=O=>{let B=(0,y.joinPath)(F,`package.nls.${O}.json`);this.fileService.exists(B).then(V=>{V&&oe({localized:B,original:(0,y.joinPath)(F,"package.nls.json")});let J=O.lastIndexOf("-");J===-1?oe({localized:(0,y.joinPath)(F,"package.nls.json"),original:null}):(O=O.substring(0,J),j(O))})};if($.devMode||$.pseudo||!$.language)return oe({localized:(0,y.joinPath)(F,"package.nls.json"),original:null});j($.language)})}replaceNLStrings(F,$,oe,K,j){const O=(B,V,J)=>{const se=B[V];if((0,f.isString)(se)){const me=se,he=me.length;if(he>1&&me[0]==="%"&&me[he-1]==="%"){const U=me.substr(1,he-2);let N=oe[U];N===void 0&&K&&(N=K[U]);let q=typeof N=="string"?N:typeof N?.message=="string"?N.message:void 0;q!==void 0?(F&&(q="\uFF3B"+q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),B[V]=J&&(V==="title"||V==="category")&&K?{value:q,original:K[U]}:q):this.logService.warn(this.formatMessage(j,(0,p.localize)(7,null,U)))}}else if((0,f.isObject)(se))for(let me in se)se.hasOwnProperty(me)&&(me==="commands"?O(se,me,!0):O(se,me,J));else if((0,f.isArray)(se))for(let me=0;me<se.length;me++)O(se,me,J)};for(let B in $)$.hasOwnProperty(B)&&O($,B)}formatMessage(F,$){return`[${F.path}]: ${$}`}}class W extends z{constructor(F,$,oe){super($,oe);this.cacheFile=F,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(F){const $=await this.readExtensionCache();if(this.input=F,$&&$.input&&_.equals($.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),$.result.map(K=>(K.location=m.URI.revive(K.location),K));const oe=await super.scanExtensions(F);return await this.writeExtensionCache({input:F,result:oe}),oe}async readExtensionCache(){try{const F=await this.fileService.readFile(this.cacheFile),$=JSON.parse(F.value.toString());return{result:$.result,input:(0,c.revive)($.input)}}catch(F){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(F))}return null}async writeExtensionCache(F){try{await this.fileService.writeFile(this.cacheFile,S.VSBuffer.fromString(JSON.stringify(F)))}catch($){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)($))}}async validateCache(){if(!this.input)return;const F=await this.readExtensionCache();if(!F)return;const $=F.result,oe=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(oe,$))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}}function ee(H,F){const $=(0,a.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:$,identifier:new u.ExtensionIdentifier($),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:F,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=ee;class D extends I{constructor(F,$,oe,K,j,O,B,V){super(F,$,(0,y.joinPath)(oe,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(K,u.MANIFEST_CACHE_FOLDER),j,O,B,V);this.translationsPromise=(async()=>{if(C.translationsConfigFile)try{const J=await this.fileService.readFile(m.URI.file(C.translationsConfigFile));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}getTranslations(F){return this.translationsPromise}}e.NativeExtensionsScannerService=D}),define(we[206],ye([0,1,14,9,2,3,19,55,4,26,20,23,31,35,17,13]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends w.Disposable{constructor(p,h,a,u){super();this.fileService=h,this.extensionGalleryService=a,this.logService=u,this.extensionsDownloadDir=v.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,h){await this.cleanUpPromise;const a=this.getName(p),u=(0,T.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(u)){const n=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(p,n,h);try{await this.rename(n,u,Date.now()+2*60*1e3)}catch(l){try{await this.fileService.del(n)}catch{}if(l.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(l)}. Deleted the vsix from downloaded location`,n.path),l}}return u}async delete(p){await this.cleanUpPromise,await this.fileService.del(p)}async rename(p,h,a){try{await R.Promises.rename(p.fsPath,h.fsPath)}catch(u){if(S.isWindows&&u&&u.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${p} to ${h} with 'EPERM' error. Trying again...`),this.rename(p,h,a);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const h=[],a=[];for(const l of p.children){const i=y.ExtensionKey.parse(l.name);i&&a.push([i,l])}const u=(0,y.groupByExtension)(a,([l])=>l),n=[];for(const l of u)l.sort((i,s)=>E.rcompare(i[0].version,s[0].version)),h.push(...l.slice(1).map(i=>i[1].resource)),n.push(l[0][1]);n.sort((l,i)=>l.mtime-i.mtime),h.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(l=>l.resource)),await k.Promises.settled(h.map(l=>(this.logService.trace("Deleting vsix from cache",l.path),this.fileService.del(l))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?y.ExtensionKey.create(p).toString().toLowerCase():(0,P.generateUuid)()}};f=Re([Oe(0,A.INativeEnvironmentService),Oe(1,d.IFileService),Oe(2,C.IExtensionGalleryService),Oe(3,b.ILogService)],f),e.ExtensionsDownloader=f}),define(we[207],ye([0,1,2,5,20,40]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(v,P){super();this.environmentService=v,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,S.MANIFEST_CACHE_FOLDER,S.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(P.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(v){v.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(we[102],ye([0,1,71,18,14,2,8,5,20,23,31,35,70,13]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends S.Disposable{constructor(m,p,h){super();this.extensionManagementService=m,this.logService=h,this.cache=this._register(new b(p,h)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),p=["en",...Object.keys(m)];return(0,t.distinct)(p)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const p=await this.cache.getLanguagePacks();Object.keys(p).some(h=>p[h]&&p[h].extensions.some(a=>(0,A.areSameExtensions)(a.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(p);return!(0,t.equals)(Object.keys(m),Object.keys(h))}};d=Re([Oe(0,R.IExtensionManagementService),Oe(1,P.INativeEnvironmentService),Oe(2,y.ILogService)],d),e.LocalizationsService=d;let b=class extends S.Disposable{constructor(m,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(p=>{Object.keys(p).forEach(h=>delete p[h]),this.createLanguagePacksFromExtensions(p,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...p){for(const h of p)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,h);Object.keys(m).forEach(h=>this.updateHash(m[h]))}createLanguagePacksFromExtension(m,p){const h=p.identifier,a=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const u of a)if(p.location.scheme===T.Schemas.file&&(0,C.isValidLocalization)(u)){let n=m[u.languageId];n||(n={hash:"",extensions:[],translations:{}},m[u.languageId]=n);let l=n.extensions.filter(i=>(0,A.areSameExtensions)(i.extensionIdentifier,h))[0];l?l.version=p.manifest.version:n.extensions.push({extensionIdentifier:h,version:p.manifest.version});for(const i of u.translations)n.translations[i.id]=(0,E.join)(p.location.fsPath,i.path)}}updateHash(m){if(m){const p=(0,k.createHash)("md5");for(const h of m.extensions)p.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=p.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(p=m(h),h)).then(h=>{for(const u of Object.keys(h))h[u]||delete h[u];this.languagePacks=h,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),v.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>p,h=>this.logService.error(h))})}};b=Re([Oe(0,P.INativeEnvironmentService),Oe(1,y.ILogService)],b)}),define(we[50],ye([0,1,16,168,48,6,34]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,S.createDecorator)("requestService");function E(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=E;function v(b){return b.res.statusCode===204}async function P(b){return v(b)?null:(await(0,k.streamToBuffer)(b.stream)).toString()}e.asText=P;async function R(b){if(!E(b))throw new Error("Server returned "+b.res.statusCode);return P(b)}e.asTextOrError=R;async function A(b){if(!E(b))throw new Error("Server returned "+b.res.statusCode);if(v(b))return null;const m=(await(0,k.streamToBuffer)(b.stream)).toString();try{return JSON.parse(m)}catch(p){throw p.message+=`:
`+m,p}}e.asJson=A;function C(b){d(b)}e.updateProxyConfigurationsScope=C;let y;function d(b){const f=T.Registry.as(w.Extensions.Configuration),m=y;y={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[y],remove:m?[m]:[]})}d(2)}),define(we[208],ye([0,1,21,8,17,50]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(v,P){this.requestService=v,this.fileService=P}async download(v,P,R=k.CancellationToken.None){if(v.scheme===t.Schemas.file||v.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(v,P);return}const A={type:"GET",url:v.toString()},C=await this.requestService.request(A,R);if(C.res.statusCode===200)await this.fileService.writeFile(P,C.stream);else{const y=await(0,S.asTextOrError)(C);throw new Error(`Expected 200, got back ${C.res.statusCode} instead.

${y}`)}}};T=Re([Oe(0,S.IRequestService),Oe(1,w.IFileService)],T),e.DownloadService=T}),define(we[209],ye([0,1,16,21]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class w{constructor(E){this.service=E}listen(E,v){throw new Error("Invalid listen")}call(E,v,P){switch(v){case"request":return this.service.request(P[0],t.CancellationToken.None).then(async({res:R,stream:A})=>{const C=await(0,k.streamToBuffer)(A);return[{statusCode:R.statusCode,headers:R.headers},C]})}throw new Error("Invalid call")}}e.RequestChannel=w;class S{constructor(E){this.channel=E}async request(E,v){return S.request(this.channel,E,v)}static async request(E,v,P){const[R,A]=await E.call("request",[v]);return{res:R,stream:(0,k.bufferToStream)(A)}}}e.RequestChannelClient=S}),define(we[210],ye([0,1,72,12]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function w(T,E){return T.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:T.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function S(T,E,v={}){const P=(0,k.parse)(T),R=v.proxyUrl||w(P,E);if(!R)return null;const A=(0,k.parse)(R);if(!/^https?:$/.test(A.protocol||""))return null;const C={host:A.hostname||"",port:A.port||(A.protocol==="https"?"443":"80"),auth:A.auth,rejectUnauthorized:(0,t.isBoolean)(v.strictSSL)?v.strictSSL:!0};return P.protocol==="http:"?new(await new Promise((y,d)=>{te(["http-proxy-agent"],y,d)}))(C):new(await new Promise((y,d)=>{te(["https-proxy-agent"],y,d)}))(C)}e.getProxyAgent=S}),define(we[73],ye([0,1,38,5,169,21,36,9,3,26,151,182,14]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function b(m,p,h){return p["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,A.isLaunchedFromCli)(h)&&!p["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,A.isLaunchedFromCli)(h)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=C.Promises.withAsyncBody(async(a,u)=>{const n=new S.CancellationTokenSource,l=setTimeout(()=>{n.dispose(!0),u(new Error((0,w.localize)(0,null)))},y);try{a(await f(m,n.token))}catch(i){!(0,E.isCancellationError)(i)&&!n.token.isCancellationRequested?u(new Error((0,w.localize)(1,null,(0,T.toErrorMessage)(i)))):a({})}finally{clearTimeout(l),n.dispose()}})),d)}e.getResolvedShellEnv=b;async function f(m,p){const h=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",h);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",a);const u=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",l);const i=await(0,R.getSystemShell)(v.OS,l);return m.trace("getUnixShellEnvironment#shell",i),new Promise((s,r)=>{if(p.isCancellationRequested)return r((0,E.canceled)());const o=(0,t.basename)(i);let c,g;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${I} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,g=["-Login","-Command"]):(c=`'${process.execPath}' ${I} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),c);const _=(0,k.spawn)(i,[...g,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});p.onCancellationRequested(()=>(_.kill(),r((0,E.canceled)()))),_.on("error",ee=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(ee)),r(ee)});const z=[];_.stdout.on("data",ee=>z.push(ee));const W=[];_.stderr.on("data",ee=>W.push(ee)),_.on("close",(ee,D)=>{const H=Buffer.concat(z).toString("utf8");m.trace("getUnixShellEnvironment#raw",H);const F=Buffer.concat(W).toString("utf8");if(F.trim()&&m.trace("getUnixShellEnvironment#stderr",F),ee||D)return r(new Error((0,w.localize)(2,null,ee,D)));const $=n.exec(H),oe=$?$[1]:"{}";try{const K=JSON.parse(oe);h?K.ELECTRON_RUN_AS_NODE=h:delete K.ELECTRON_RUN_AS_NODE,a?K.ELECTRON_NO_ATTACH_CONSOLE=a:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",K),s(K)}catch(K){m.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(K)),r(K)}})})}}),define(we[211],ye([0,1,14,7,2,45,12,142,6]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const P="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var R;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var A;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(A=e.StorageScope||(e.StorageScope={}));var C;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class y extends w.Disposable{constructor(m={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,S.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,S.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,p){p===P?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:p,target:this.getKeyTargets(m)[p]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,p,h){return this.getStorage(p)?.get(m,h)}getBoolean(m,p,h){return this.getStorage(p)?.getBoolean(m,h)}getNumber(m,p,h){return this.getStorage(p)?.getNumber(m,h)}store(m,p,h,a){if((0,T.isUndefinedOrNull)(p)){this.remove(m,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,h,a),this.getStorage(h)?.set(m,p)})}remove(m,p){this.withPausedEmitters(()=>{this.updateKeyTarget(m,p,void 0),this.getStorage(p)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,p){const h=[],a=this.getKeyTargets(m);for(const u of Object.keys(a))a[u]===p&&h.push(u);return h}updateKeyTarget(m,p,h){const a=this.getKeyTargets(p);typeof h=="number"?a[m]!==h&&(a[m]=h,this.getStorage(p)?.set(P,JSON.stringify(a))):typeof a[m]=="number"&&(delete a[m],this.getStorage(p)?.set(P,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const p=this.get(P,m);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=R.NONE){this._onWillSaveState.fire({reason:m});const p=this.getStorage(0),h=this.getStorage(1);switch(m){case R.NONE:await k.Promises.settled([p?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await k.Promises.settled([p?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return b(m,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends y{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=d;async function b(f,m,p,h){const a=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,n=new Map;f.forEach((o,c)=>{u.set(c,o),n.set(c,a(o))});const l=new Map,i=new Map;m.forEach((o,c)=>{l.set(c,o),i.set(c,a(o))}),console.group(`Storage: Global (path: ${p})`);let s=[];u.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${h})`);let r=[];l.forEach((o,c)=>{r.push({key:c,value:o})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=b}),define(we[212],ye([0,1,3,25,4,26]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function E(P,R,A,C,y,d,b,f,m,p){const h=Object.create(null);h["common.machineId"]=b,h.sessionID=(0,S.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,k.PlatformToString)(k.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=C,h["common.product"]=p||"desktop";const a=v(f||[]);a&&(h["common.msftInternal"]=a);let u=0;const n=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),k.isLinuxSnap&&(h["common.snap"]="true");const l=T(A);l&&(h["common.platformDetail"]=l);try{const i=await P.readFile(w.URI.file(m));h["common.source"]=i.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=E;function v(P){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const A=R.toLowerCase();return P.some(C=>A===C)}e.verifyMicrosoftInternalDomain=v}),define(we[213],ye([0,1,18,9,2,22]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var T;(function(v){function P(R,A){return R.callstack<A.callstack?-1:R.callstack>A.callstack?1:0}v.compare=P})(T=e.ErrorEvent||(e.ErrorEvent={}));class E{constructor(P,R=E.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new w.DisposableStore,this._telemetryService=P,this._flushDelay=R;const A=t.errorHandler.addListener(C=>this._onErrorEvent(C));this._disposables.add((0,w.toDisposable)(A)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(P){if(!P||(P.detail&&P.detail.stack&&(P=P.detail),P instanceof t.ErrorNoTelemetry))return;let R=Array.isArray(P.stack)?P.stack.join(`
`):P.stack,A=P.message?P.message:(0,S.safeStringify)(P);!R||this._enqueue({msg:A,callstack:R})}_enqueue(P){const R=(0,k.binarySearch)(this._buffer,P,T.compare);R<0?(P.count=1,this._buffer.splice(~R,0,P)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let P of this._buffer)this._telemetryService.publicLogError2("UnhandledError",P);this._buffer.length=0}}e.default=E,E.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[214],ye([0,1,2]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends k.Disposable{constructor(S,T){super();this.telemetryService=S,this.telemetryAppender=T}async call(S,T,E){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:v}=E;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:P}=E;return this.telemetryAppender?this.telemetryAppender.log(v,P):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${T} not found`)}listen(S,T,E){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[32],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(S){S[S.NONE=0]="NONE",S[S.CRASH=1]="CRASH",S[S.ERROR=2]="ERROR",S[S.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(S){S.OFF="off",S.CRASH="crash",S.ERROR="error",S.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[215],ye([0,1,27,52,14,61,8,5,3,4,84,20,87,188,17,24,32]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function p(l,i){const s=`${l}::${i.join(":")}`,r=m.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,g=new Map,I=2e4;function _(W,ee,D,H){const F=ee.substring(W.length+1);return w.Promises.withAsyncBody(async $=>{let oe;try{oe=await A.Promises.readdir(ee,{withFileTypes:!0})}catch{$();return}if(H.count>=I){H.count+=oe.length,H.maxReached=!0,$();return}let K=oe.length;if(K===0){$();return}let j=oe;H.count+oe.length>I&&(H.maxReached=!0,K=I-H.count,j=oe.slice(0,K)),H.count+=oe.length;for(const O of j)if(O.isDirectory()){if(D.includes(O.name)||await _(W,(0,E.join)(ee,O.name),D,H),--K==0){$();return}}else{const B=O.name.lastIndexOf(".");if(B>=0){const V=O.name.substring(B+1);V&&c.set(V,(c.get(V)??0)+1)}for(const V of o)V.relativePathPattern?.test(F)!==!1&&V.filePattern.test(O.name)&&g.set(V.tag,(g.get(V.tag)??0)+1);if(--K==0){$();return}}})}const z=w.Promises.withAsyncBody(async W=>{const ee={count:0,maxReached:!1};await _(l,l,i,ee);const D=await u(l);W({configFiles:h(g),fileTypes:h(c),fileCount:ee.count,maxFilesReached:ee.maxReached,launchConfigFiles:D})});return m.set(s,z),z}e.collectWorkspaceStats=p;function h(l){return[...t.Iterable.map(l.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function a(){const l={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=a;async function u(l){try{const i=new Map,s=(0,E.join)(l,".vscode","launch.json"),r=await A.Promises.readFile(s),o=[],c=(0,S.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,S.getNodeType)(c)==="object"&&c.configurations)for(const g of c.configurations){const I=g.type;I&&(i.has(I)?i.set(I,i.get(I)+1):i.set(I,1))}return h(i)}catch{return[]}}e.collectLaunchConfigs=u;let n=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const r=k.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||s.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,C.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[o,c]=r,g=this.formatProcessList(i,o);return s.forEach(I=>{if((0,y.isRemoteDiagnosticError)(I))g+=`
${I.errorMessage}`,c+=`
${I.errorMessage}`;else if(g+=`

Remote: ${I.hostName}`,I.processes&&(g+=`
${this.formatProcessList(i,I.processes)}`),I.workspaceMetadata){c+=`
|  Remote: ${I.hostName}`;for(const _ of Object.keys(I.workspaceMetadata)){const z=I.workspaceMetadata[_];let W=`${z.fileCount} files`;z.maxFilesReached&&(W=`more than ${W}`),c+=`|    Folder (${_}): ${W}`,c+=this.formatWorkspaceStats(z)}}}),{processInfo:g,workspaceInfo:c}})}async getSystemInfo(i,s){const{memory:r,vmHint:o,os:c,cpus:g}=a(),I={os:c,memory:r,cpus:g,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return v.isWindows||(I.load=`${k.loadavg().map(_=>Math.round(_)).join(", ")}`),v.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(i,s){const r=[];return(0,C.listProcesses)(i.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,o)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),s.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.formatMachineInfo(c.machineInfo)),c.processes&&r.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const g of Object.keys(c.workspaceMetadata)){const I=c.workspaceMetadata[g];let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),r.push(`Folder (${g}): ${_}`),r.push(this.formatWorkspaceStats(I))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const s=[],r=60;let o=0;const c=(z,W)=>{const ee=` ${z}(${W})`;o+ee.length>r?(s.push(g),g="|                 ",o=g.length):o+=ee.length,g+=ee};let g="|      File types:";const I=10;let _=i.fileTypes.length>I?I:i.fileTypes.length;for(let z=0;z<_;z++){const W=i.fileTypes[z];c(W.name,W.count)}if(s.push(g),i.configFiles.length>=0&&(g="|      Conf files:",o=0,i.configFiles.forEach(z=>{c(z.name,z.count)}),s.push(g)),i.launchConfigFiles.length>0){let z="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{z+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(z)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],r=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const g=P.URI.revive(c);if(g.scheme===T.Schemas.file){const I=g.fsPath;r.push(p(I,["node_modules",".git"]).then(_=>{let z=`${_.fileCount} files`;_.maxFilesReached&&(z=`more than ${z}`),s.push(`|    Folder (${(0,E.basename)(I)}): ${z}`),s.push(this.formatWorkspaceStats(_))}).catch(_=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${_.toString()})`)}))}else s.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,s){const r=new Map;i.windows.forEach(c=>r.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(i,s,r,o,c){const g=c===0;let I;g?I=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(I=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(I=`${I} (${s.get(o.pid)})`));const _=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(_/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(o.children)&&o.children.forEach(z=>this.formatProcessItem(i,s,r,z,c+1))}async getWorkspaceFileExtensions(i){const s=new Set;for(const{uri:r}of i.folders){const o=P.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const c=o.fsPath;try{(await p(c,["node_modules",".git"])).fileTypes.forEach(I=>s.add(I.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const r=P.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const c=await p(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),c.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),c.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};n=Re([Oe(0,f.ITelemetryService),Oe(1,b.IProductService)],n),e.DiagnosticsService=n}),define(we[216],ye([0,1,18,14,21,9,7,2,3,4,156,31,35,13,24,32]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends E.Disposable{constructor(n,l,i,s){super();this.galleryService=n,this.telemetryService=l,this.logService=i,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const l=await this.getTargetPlatform();return n.allTargetPlatforms.some(i=>(0,A.isTargetPlatformCompatible)(i,n.allTargetPlatforms,l))}async installFromGallery(n,l={}){try{if(!this.galleryService.isEnabled())throw new A.ExtensionManagementError(R.localize(0,null),A.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(n,!l.installGivenVersion,!!l.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,l)}catch(i){throw h(this.telemetryService,"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(n),error:i}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(i),p(i)}}async uninstall(n,l={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.unininstallExtension(n,l)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const l=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:l,compatible:!0},w.CancellationToken.None);if(!i)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,l,i){if(!P.URI.isUri(l)){let g=this.installingExtensions.get(C.ExtensionKey.create(l).toString());if(g)return this.logService.info("Extensions is already requested to install",l.identifier.id),g.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],r=[],o=this.createInstallExtensionTask(n,l,i);P.URI.isUri(l)||this.installingExtensions.set(C.ExtensionKey.create(l).toString(),o),this._onInstallExtension.fire({identifier:o.identifier,source:l}),this.logService.info("Installing extension:",o.identifier.id),s.push({task:o,manifest:n});let c=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,n,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:_,manifest:z}of I){c=c||!!z.extensionDependencies?.some(ee=>(0,C.areSameExtensions)({id:ee},o.identifier));const W=C.ExtensionKey.create(_).toString();if(this.installingExtensions.has(W))this.logService.info("Extension is already requested to install",_.identifier.id);else{const ee=this.createInstallExtensionTask(z,_,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(W,ee),this._onInstallExtension.fire({identifier:ee.identifier,source:_}),this.logService.info("Installing extension:",ee.identifier.id),s.push({task:ee,manifest:z})}}}catch(I){if(P.URI.isUri(o.source))(0,k.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,I.message),(0,k.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),I}const g=s.reduce((I,{task:_,manifest:z})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:z}),I),new Map);for(;g.size;){let I;const _=[...g.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(W=>g.has(W.toLowerCase())));_.length?I=g.size===1?_:_.filter(({task:z})=>!(z===o&&!c)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:z})=>z.identifier.id)),I=[...g.values()]),await this.joinAllSettled(I.map(async({task:z})=>{const W=new Date().getTime();try{const ee=await z.run();if(await this.joinAllSettled(this.participants.map(D=>D.postInstall(ee,z.source,i,w.CancellationToken.None))),!P.URI.isUri(z.source)){const D=z.operation===3;if(h(this.telemetryService,D?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-W,durationSinceUpdate:D?void 0:new Date().getTime()-z.source.lastUpdated}),v.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}}r.push({local:ee,identifier:z.identifier,operation:z.operation,source:z.source})}catch(ee){throw P.URI.isUri(z.source)||h(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-W,error:ee}),this.logService.error("Error while installing the extension:",z.identifier.id),ee}finally{g.delete(z.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:I})=>(0,C.areSameExtensions)(I,o.identifier))[0].local}catch(g){if(s.forEach(({task:I})=>I.cancel()),r.length)try{const I=await Promise.allSettled(r.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const z=I[_],{identifier:W}=r[_];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",W.id):this.logService.warn("Rollback: Error while uninstalling extension",W.id,(0,S.getErrorMessage)(z.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,S.getErrorMessage)(I),r.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),g}finally{for(const{task:g}of s)if(!P.URI.isUri(g.source)){const I=C.ExtensionKey.create(g.source).toString();this.installingExtensions.delete(I)||this.logService.warn("Installation task is not found in the cache",I)}}}async joinAllSettled(n){const l=[],i=[],s=await Promise.allSettled(n);for(const r of s)r.status==="fulfilled"?l.push(r.value):i.push(r.reason);if(i.length)throw m(i);return l}async getAllDepsAndPackExtensionsToInstall(n,l,i,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const o=[n,...r.map(I=>I.identifier)],c=[],g=async(I,_)=>{const z=_.extensionDependencies||[],W=[...z];if(_.extensionPack){const ee=i?r.find(D=>(0,C.areSameExtensions)(D.identifier,I)):void 0;for(const D of _.extensionPack)ee&&ee.manifest.extensionPack&&ee.manifest.extensionPack.some(H=>(0,C.areSameExtensions)({id:H},{id:D}))||W.every(H=>!(0,C.areSameExtensions)({id:H},{id:D}))&&W.push(D)}if(W.length){const ee=[...o,...c.map(H=>H.gallery.identifier)],D=W.filter(H=>ee.every(F=>!(0,C.areSameExtensions)(F,{id:H})));if(D.length){const H=await this.galleryService.getExtensions(D.map(F=>({id:F,preRelease:s})),w.CancellationToken.None);for(const F of H){if(ee.find(K=>(0,C.areSameExtensions)(K,F.identifier)))continue;const $=z.some(K=>(0,C.areSameExtensions)({id:K},F.identifier));let oe;try{oe=await this.checkAndGetCompatibleVersion(F,!0,s)}catch(K){if(K instanceof A.ExtensionManagementError&&K.code===A.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}else throw K}c.push({gallery:oe.extension,manifest:oe.manifest}),await g(oe.extension.identifier,oe.manifest)}}}};return await g(n,l),r=await this.getInstalled(),c.filter(I=>!r.some(_=>(0,C.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(n,l,i){const s=await this.getExtensionsControlManifest();if((0,C.getMaliciousExtensionsSet)(s).has(n.identifier.id))throw new A.ExtensionManagementError(R.localize(3,null,n.identifier.id),A.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[n.identifier.id])throw new A.ExtensionManagementError(R.localize(4,null,n.identifier.id,s.unsupportedPreReleaseExtensions[n.identifier.id].displayName),A.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(n)){const c=await this.getTargetPlatform();throw new A.ExtensionManagementError(R.localize(5,null,n.identifier.id,this.productService.nameLong,(0,A.TargetPlatformToString)(c)),A.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const r=await this.getCompatibleVersion(n,l,i);if(r){if(i&&l&&n.hasPreReleaseVersion&&!r.properties.isPreReleaseVersion)throw new A.ExtensionManagementError(R.localize(6,null,n.identifier.id,this.productService.nameLong,this.productService.version),A.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],w.CancellationToken.None))[0]?new A.ExtensionManagementError(R.localize(7,null,n.identifier.id),A.ExtensionManagementErrorCode.ReleaseVersionNotFound):new A.ExtensionManagementError(R.localize(8,null,n.identifier.id,this.productService.nameLong,this.productService.version),A.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",r.identifier.id);const o=await this.galleryService.getManifest(r,w.CancellationToken.None);if(o===null)throw new A.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,A.ExtensionManagementErrorCode.Invalid);if(o.version!==r.version)throw new A.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,A.ExtensionManagementErrorCode.Invalid);return{extension:r,manifest:o}}async getCompatibleVersion(n,l,i){const s=await this.getTargetPlatform();let r=null;return l&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==i&&(r=(await this.galleryService.getExtensions([{...n.identifier,preRelease:i}],{targetPlatform:s,compatible:!0},w.CancellationToken.None))[0]||null),!r&&await this.galleryService.isExtensionCompatible(n,i,s)&&(r=n),!r&&l&&(r=await this.galleryService.getCompatibleExtension(n,i,s)),r}async unininstallExtension(n,l){const i=this.uninstallingExtensions.get(n.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),i.waitUntilTaskIsFinished();const s=(g,I)=>{const _=this.createUninstallExtensionTask(g,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),_},r=(g,I)=>{I?this.logService.error("Failed to uninstall extension:",g.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),h(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,C.getLocalExtensionTelemetryData)(g),error:I}),this._onDidUninstallExtension.fire({identifier:g.identifier,error:I?.code})},o=[],c=[];try{o.push(s(n,{}));const g=await this.getInstalled(1);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",n.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(n,g);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):o.push(s(_,{}))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",n.identifier.id):this.checkForDependents(o.map(I=>I.extension),g,n),await this.joinAllSettled(o.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,l,w.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}r(I.extension)}catch(_){const z=_ instanceof A.ExtensionManagementError?_:new A.ExtensionManagementError((0,S.getErrorMessage)(_),A.ExtensionManagementErrorCode.Internal);throw r(I.extension,z),z}finally{c.push(I)}}))}catch(g){const I=g instanceof A.ExtensionManagementError?g:new A.ExtensionManagementError((0,S.getErrorMessage)(g),A.ExtensionManagementErrorCode.Internal);for(const _ of o){try{_.cancel()}catch{}c.includes(_)||r(_.extension,I)}throw I}finally{for(const g of o)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(n,l,i){for(const s of n){const r=this.getDependents(s,l);if(r.length){const o=r.filter(c=>!n.some(g=>(0,C.areSameExtensions)(g.identifier,c.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(s,o,i))}}}getDependentsErrorMessage(n,l,i){return i===n?l.length===1?R.localize(9,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?R.localize(10,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):R.localize(11,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?R.localize(12,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?R.localize(13,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):R.localize(14,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}getAllPackExtensionsToUninstall(n,l,i=[]){if(i.indexOf(n)!==-1)return[];i.push(n);const s=n.manifest.extensionPack?n.manifest.extensionPack:[];if(s.length){const r=l.filter(c=>!c.isBuiltin&&s.some(g=>(0,C.areSameExtensions)({id:g},c.identifier))),o=[];for(const c of r)o.push(...this.getAllPackExtensionsToUninstall(c,l,i));return[...r,...o]}return[]}getDependents(n,l){return l.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(s=>(0,C.areSameExtensions)({id:s},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=Re([Oe(0,A.IExtensionGalleryService),Oe(1,b.ITelemetryService),Oe(2,y.ILogService),Oe(3,d.IProductService)],f),e.AbstractExtensionManagementService=f;function m(u){const n=Array.isArray(u)?u:[u];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((l,i)=>new Error(`${l.message}${l.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=m;function p(u){if(u instanceof A.ExtensionManagementError)return u;const n=new A.ExtensionManagementError(u.message,A.ExtensionManagementErrorCode.Internal);return n.stack=u.stack,n}function h(u,n,{extensionData:l,duration:i,error:s,durationSinceUpdate:r}){const o=s?s instanceof A.ExtensionManagementError?s.code:A.ExtensionManagementErrorCode.Internal:void 0;u.publicLog(n,{...l,success:!s,duration:i,errorcode:o,durationSinceUpdate:r})}e.reportTelemetry=h;class a{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((l,i)=>{const s=n.onCancellationRequested(()=>{s.dispose(),i(new S.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a}),define(we[41],ye([0,1,22,78,12,28,32]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(h,a){return Promise.resolve(void 0)}publicLog2(h,a){return this.publicLog(h,a)}publicLogError(h,a){return Promise.resolve(void 0)}publicLogError2(h,a){return this.publicLogError(h,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class v{async publicLog(h,a,u){}async publicLogError(h,a,u){}}e.NullEndpointTelemetryService=v,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(p,h){return h.onDidChangeConfiguration(a=>{a.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(a.source),configurationKeys:b(a.sourceConfig)})})}e.configurationTelemetry=P;function R(p,h){return!(h.disableTelemetry||!p.enableTelemetry||h.extensionTestsLocationURI)}e.supportsTelemetry=R;function A(p){const h=p.getValue(T.TELEMETRY_SETTING_ID),a=p.getValue("telemetry.enableCrashReporter");if(p.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function C(p){const h=Object.create(null),a=Object.create(null),u=Object.create(null);d(p,u);for(let n in u){n=n.length>150?n.substr(n.length-149):n;const l=u[n];typeof l=="number"?a[n]=l:typeof l=="boolean"?a[n]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${l.length}`),h[n]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(h[n]=l)}return{properties:h,measurements:a}}e.validateTelemetryData=C;function y(p){if(!p)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{p.indexOf(`${u}+`)===0&&(h=u)}),h}e.cleanRemoteAuthority=y;function d(p,h,a=0,u){if(!!p)for(let n of Object.getOwnPropertyNames(p)){const l=p[n],i=u?u+n:n;Array.isArray(l)?h[i]=(0,k.safeStringify)(l):l instanceof Date?h[i]=l.toISOString():(0,w.isObject)(l)?a<2?d(l,h,a+1,i+"."):h[i]=(0,k.safeStringify)(l):h[i]=l}}function b(p){if(!p)return[];const h=[];return f(h,"",p),h}function f(p,h,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(u=>f(p,h?`${h}.${u}`:u,a[u])):p.push(h)}function m(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}e.getPiiPathsFromEnvironment=m}),define(we[217],ye([0,1,185,41]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function w(S,T,E,v,P,R){const A={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S} (${T.nameShort})`},C=await(0,k.getServiceMachineId)(E,P,R);return(0,t.supportsTelemetry)(T,E)&&(0,t.getTelemetryLevel)(v)===3&&(A["X-Market-User-Id"]=C),A}e.resolveMarketplaceHeaders=w}),define(we[103],ye([0,1,18,21,9,22,3,25,12,4,28,23,31,35,66,17,13,24,50,217,211,32]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,E.arch);var l;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(l||(l={}));function i(...U){return String(U.reduce((N,q)=>N|q,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class I{constructor(N=g){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new I({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const Y=[...this.state.criteria,...q.length?q.map(ie=>({filterType:N,value:ie})):[{filterType:N}]];return new I({...this.state,criteria:Y})}withSortBy(N){return new I({...this.state,sortBy:N})}withSortOrder(N){return new I({...this.state,sortOrder:N})}withFlags(...N){return new I({...this.state,flags:N.reduce((q,Y)=>q|Y,0)})}withAssetTypes(...N){return new I({...this.state,assetTypes:N})}withSource(N){return new I({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:Y,sortBy:ie,sortOrder:de,flags:le,assetTypes:ue}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:Y,sortBy:ie,sortOrder:de}],assetTypes:ue,flags:le}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source}}}function _(U,N){const q=(U||[]).filter(Y=>Y.statisticName===N)[0];return q?q.value:0}function z(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(Y=>Y.assetType.indexOf(N)===0).reduce((Y,ie)=>{const de=D(U,ie.assetType);return de&&Y.push([ie.assetType.substring(N.length),de]),Y},[])}function W(U){if(U.properties){const N=U.properties.filter(ie=>ie.key===r.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=N.filter(ie=>q.test(ie.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return D(U,r.Repository)}function ee(U){return{uri:`${U.fallbackAssetUri}/${r.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${r.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function D(U,N){return U.files.filter(Y=>Y.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function H(U,N){const q=U.properties?U.properties.filter(ie=>ie.key===N):[],Y=q.length>0&&q[0].value;return Y?Y.split(",").map(ie=>(0,y.adoptToGalleryExtensionId)(ie)):[]}function F(U){const N=U.properties?U.properties.filter(q=>q.key===o.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(q=>q.key===o.PreRelease):[];return N.length>0&&N[0].value==="true"}function oe(U){const N=U.properties?U.properties.filter(Y=>Y.key===o.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function K(U){return U.indexOf("preview")!==-1}function j(U){return U.targetPlatform?(0,C.toTargetPlatform)(U.targetPlatform):"undefined"}function O(U){const N=(0,k.distinct)(U.versions.map(j)),q=!!U.tags?.includes(C.WEB_EXTENSION_TAG),Y=N.indexOf("web");return q?Y===-1&&N.push("web"):Y!==-1&&N.splice(Y,1),N}function B(U,N){const q=(0,C.getFallbackTargetPlarforms)(N);for(let Y=0;Y<U.length;Y++){const ie=U[Y];if(ie.version===U[Y-1]?.version){let de=Y;const le=j(ie);if(le===N)for(;de>0&&U[de-1].version===ie.version;)de--;else if(q.includes(le))for(;de>0&&U[de-1].version===ie.version&&j(U[de-1])!==N;)de--;de!==Y&&(U.splice(Y,1),U.splice(de,0,ie))}}return U}e.sortExtensionVersions=B;function V(U,N,q){U.telemetryData={index:N,querySource:q}}function J(U,N,q){const Y=U.versions[0],ie={manifest:D(N,r.Manifest),readme:D(N,r.Details),changelog:D(N,r.Changelog),license:D(N,r.License),repository:W(N),download:ee(N),icon:D(N,r.Icon),coreTranslations:z(N)};return{identifier:{id:(0,y.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:_(U.statistics,"install"),rating:_(U.statistics,"averagerating"),ratingCount:_(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:ie,properties:{dependencies:H(N,o.Dependency),extensionPack:H(N,o.ExtensionPack),engine:F(N),localizedLanguages:oe(N),targetPlatform:j(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(Y),hasReleaseVersion:!0,preview:K(U.flags)}}let se=class{constructor(N,q,Y,ie,de,le,ue,pe){this.requestService=q,this.logService=Y,this.environmentService=ie,this.telemetryService=de,this.fileService=le,this.productService=ue,this.configurationService=pe;const X=ue.extensionsGallery;this.extensionsGalleryUrl=X&&X.serviceUrl,this.extensionsControlUrl=X&&X.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q,Y){const ie=t.CancellationToken.isCancellationToken(q)?{}:q,de=t.CancellationToken.isCancellationToken(q)?q:Y,le=[],ue=[],pe=[],X=[];let Z=!0;for(const ae of N){ae.uuid?ue.push(ae.uuid):le.push(ae.id);const ve=!!(ae.version||ae.preRelease);pe.push({id:ae.id,uuid:ae.uuid,includePreRelease:ve}),ae.version&&X.push({id:ae.id,uuid:ae.uuid,version:ae.version}),Z=Z&&!!ae.hasPreRelease&&!ve}if(!ue.length&&!le.length)return[];let G=new I().withPage(1,N.length);ue.length&&(G=G.withFilter(s.ExtensionId,...ue)),le.length&&(G=G.withFilter(s.ExtensionName,...le)),(ie.queryAllVersions||Z)&&(G=G.withFlags(G.flags,l.IncludeVersions)),ie.source&&(G=G.withSource(ie.source));const{extensions:Q}=await this.queryGalleryExtensions(G,{targetPlatform:ie.targetPlatform??n,includePreRelease:pe,versions:X,compatible:!!ie.compatible},de);return ie.source&&Q.forEach((ae,ve)=>V(ae,ve,ie.source)),Q}async getCompatibleExtension(N,q,Y){if((0,C.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(N,q,Y))return N;const ie=new I().withFlags(l.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,N.identifier.uuid),{extensions:de}=await this.queryGalleryExtensions(ie,{targetPlatform:Y,compatible:!0,includePreRelease:q},t.CancellationToken.None);return de[0]||null}async isExtensionCompatible(N,q,Y){if(!(0,C.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Y)||!q&&N.properties.isPreReleaseVersion)return!1;let ie=N.properties.engine;if(!ie){const de=await this.getManifest(N,t.CancellationToken.None);if(!de)throw new Error("Manifest was not found");ie=de.engines.vscode}return(0,d.isEngineValid)(ie,this.productService.version,this.productService.date)}async isValidVersion(N,q,Y,ie,de){if(!(0,C.isTargetPlatformCompatible)(j(N),ie,de)||q!=="any"&&$(N)!==(q==="prerelease"))return!1;if(Y){const le=await this.getEngine(N);if(!(0,d.isEngineValid)(le,this.productService.version,this.productService.date))return!1}return!0}async query(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Y=N.text||"";const ie=(0,S.getOrDefault)(N,Z=>Z.pageSize,50);let de=new I().withPage(1,ie);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,G,Q)=>(de=de.withFilter(s.Category,Q||G),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,G,Q)=>(de=de.withFilter(s.Tag,Q||G),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(s.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),de=de.withFilter(s.SearchText,Y)),de=de.withSortBy(0)):N.ids?de=de.withFilter(s.ExtensionId,...N.ids):N.names?de=de.withFilter(s.ExtensionName,...N.names):de=de.withSortBy(4),typeof N.sortBy=="number"&&(de=de.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(de=de.withSortOrder(N.sortOrder)),N.source&&(de=de.withSource(N.source));const le=async(Z,G)=>{const{extensions:Q,total:ae}=await this.queryGalleryExtensions(Z,{targetPlatform:n,compatible:!1,includePreRelease:!!N.includePreRelease},G);return Q.forEach((ve,ke)=>V(ve,(Z.pageNumber-1)*Z.pageSize+ke,N.source)),{extensions:Q,total:ae}},{extensions:ue,total:pe}=await le(de,q),X=async(Z,G)=>{if(G.isCancellationRequested)throw new w.CancellationError;const{extensions:Q}=await le(de.withPage(Z+1),G);return Q};return{firstPage:ue,total:pe,pageSize:de.pageSize,getPage:X}}async queryGalleryExtensions(N,q,Y){const ie=N.flags;!!(N.flags&l.IncludeLatestVersionOnly)&&!!(N.flags&l.IncludeVersions)&&(N=N.withFlags(N.flags&~l.IncludeVersions,l.IncludeLatestVersionOnly)),!(N.flags&l.IncludeLatestVersionOnly)&&!(N.flags&l.IncludeVersions)&&(N=N.withFlags(N.flags,l.IncludeLatestVersionOnly)),q.versions?.length&&(N=N.withFlags(N.flags&~l.IncludeLatestVersionOnly,l.IncludeVersions)),N=N.withFlags(N.flags,l.IncludeAssetUri,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeStatistics,l.IncludeVersionProperties);const{galleryExtensions:de,total:le}=await this.queryRawGalleryExtensions(N,Y);if(!(N.flags&l.IncludeLatestVersionOnly)){const Z=[];for(const G of de){const Q=await this.toGalleryExtensionWithCriteria(G,q);Q&&Z.push(Q)}return{extensions:Z,total:le}}const pe=[],X=new Map;for(let Z=0;Z<de.length;Z++){const G=de[Z],Q={id:(0,y.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},ae=(0,v.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ke=>(0,y.areSameExtensions)(ke,Q))?.includePreRelease;if(q.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(O(G),q.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(G,q);!ve||ve.properties.isPreReleaseVersion&&(!ae||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==q.targetPlatform&&ve.hasPreReleaseVersion?X.set(G.extensionId,Z):pe.push([Z,ve])}if(X.size){const Z=new Date().getTime(),G=new I().withFlags(ie&~l.IncludeLatestVersionOnly,l.IncludeVersions).withPage(1,X.size).withFilter(s.ExtensionId,...X.keys()),{extensions:Q}=await this.queryGalleryExtensions(G,q,Y);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Z,count:X.size});for(const ae of Q){const ve=X.get(ae.identifier.uuid);pe.push([ve,ae])}}return{extensions:pe.sort((Z,G)=>Z[0]-G[0]).map(([,Z])=>Z),total:le}}async toGalleryExtensionWithCriteria(N,q){const Y={id:(0,y.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},ie=q.versions?.find(pe=>(0,y.areSameExtensions)(pe,Y))?.version,de=(0,v.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(pe=>(0,y.areSameExtensions)(pe,Y))?.includePreRelease,le=O(N),ue=B(N.versions,q.targetPlatform);if(q.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(le,q.targetPlatform))return null;for(let pe=0;pe<ue.length;pe++){const X=ue[pe];if(!(ie&&X.version!==ie)){if(await this.isValidVersion(X,de?"any":"release",q.compatible,le,q.targetPlatform))return J(N,X,le);if(ie&&X.version===ie)return null}}return ie||q.compatible?null:J(N,N.versions[0],le)}async queryRawGalleryExtensions(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,l.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(l.Unpublished));const Y=await this.commonHeadersPromise,ie=JSON.stringify(N.raw),de={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},le=new Date().getTime();let ue,pe,X=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ie,headers:de},q),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:X};const Z=await(0,p.asJson)(ue);if(Z){const G=Z.results[0],Q=G.extensions,ae=G.resultMetadata&&G.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return X=ae&&ae.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:Q,total:X}}return{galleryExtensions:[],total:X}}catch(Z){throw pe=Z,Z}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-le,success:!!ue&&(0,p.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(N,q,Y,ie){if(!this.isEnabled())return;const de=T.isWeb?this.api(`/itemName/${N}.${q}/version/${Y}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${Y}/stats?statType=${ie}`),le=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:de,headers:pe},t.CancellationToken.None)}catch{}}async download(N,q,Y){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const ie=(0,y.getGalleryExtensionTelemetryData)(N),de=new Date().getTime(),le=Z=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ie,duration:Z}),ue=Y===2?"install":Y===3?"update":"",pe=ue?{uri:`${N.assets.download.uri}${P.URI.parse(N.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${N.assets.download.fallbackUri}${P.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:N.assets.download,X=await this.getAsset(pe);await this.fileService.writeFile(q,X.stream),le(new Date().getTime()-de)}async getReadme(N,q){if(N.assets.readme){const Y=await this.getAsset(N.assets.readme,{},q);return await(0,p.asTextOrError)(Y)||""}return""}async getManifest(N,q){if(N.assets.manifest){const Y=await this.getAsset(N.assets.manifest,{},q),ie=await(0,p.asTextOrError)(Y);return ie?JSON.parse(ie):null}return null}async getManifestFromRawExtensionVersion(N,q){const Y=D(N,r.Manifest);if(!Y)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},de=await this.getAsset(Y,{headers:ie});return await(0,p.asJson)(de)}async getCoreTranslation(N,q){const Y=N.assets.coreTranslations.filter(ie=>ie[0]===q.toUpperCase())[0];if(Y){const ie=await this.getAsset(Y[1]),de=await(0,p.asTextOrError)(ie);return de?JSON.parse(de):null}return null}async getChangelog(N,q){if(N.assets.changelog){const Y=await this.getAsset(N.assets.changelog,{},q);return await(0,p.asTextOrError)(Y)||""}return""}async getAllCompatibleVersions(N,q,Y){let ie=new I().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?ie=ie.withFilter(s.ExtensionId,N.identifier.uuid):ie=ie.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:de}=await this.queryRawGalleryExtensions(ie,t.CancellationToken.None);if(!de.length)return[];const le=O(de[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(le,Y))return[];const ue=[];await Promise.all(de[0].versions.map(async Z=>{try{await this.isValidVersion(Z,q?"any":"release",!0,le,Y)&&ue.push(Z)}catch{}}));const pe=[],X=new Set;for(const Z of B(ue,Y))X.has(Z.version)||(X.add(Z.version),pe.push({version:Z.version,date:Z.lastUpdated,isPreReleaseVersion:$(Z)}));return pe}async getAsset(N,q={},Y=t.CancellationToken.None){const ie=await this.commonHeadersPromise,de={type:"GET"},le={...ie,...q.headers||{}};q={...q,...de,headers:le};const ue=N.uri,pe=N.fallbackUri,X={...q,url:ue};try{const Z=await this.requestService.request(X,Y);if(Z.res.statusCode===200)return Z;const G=await(0,p.asTextOrError)(Z);throw new Error(`Expected 200, got back ${Z.res.statusCode} instead.

${G}`)}catch(Z){if((0,w.isCancellationError)(Z))throw Z;const G=(0,w.getErrorMessage)(Z);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:G});const Q={...q,url:pe};return this.requestService.request(Q,Y)}}async getEngine(N){let q=F(N);if(!q){const Y=await this.getManifestFromRawExtensionVersion(N,t.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");q=Y.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(N),Y=[],ie={};if(q){for(const de of q.malicious)Y.push({id:de});if(q.unsupported)for(const de of Object.keys(q.unsupported)){const le=q.unsupported[de];(0,v.isBoolean)(le)||(ie[de.toLowerCase()]=le.preReleaseExtension)}if(q.migrateToPreRelease)for(const[de,le]of Object.entries(q.migrateToPreRelease))(!le.engine||(0,d.isEngineValid)(le.engine,this.productService.version,this.productService.date))&&(ie[de.toLowerCase()]=le)}return{malicious:Y,unsupportedPreReleaseExtensions:ie}}};se=Re([Oe(1,p.IRequestService),Oe(2,f.ILogService),Oe(3,A.IEnvironmentService),Oe(4,u.ITelemetryService),Oe(5,b.IFileService),Oe(6,m.IProductService),Oe(7,R.IConfigurationService)],se);let me=class extends se{constructor(N,q,Y,ie,de,le,ue,pe){super(N,q,Y,ie,de,le,ue,pe)}};me=Re([Oe(0,a.IStorageService),Oe(1,p.IRequestService),Oe(2,f.ILogService),Oe(3,A.IEnvironmentService),Oe(4,u.ITelemetryService),Oe(5,b.IFileService),Oe(6,m.IProductService),Oe(7,R.IConfigurationService)],me),e.ExtensionGalleryService=me;let he=class extends se{constructor(N,q,Y,ie,de,le,ue){super(void 0,N,q,Y,ie,de,le,ue)}};he=Re([Oe(0,p.IRequestService),Oe(1,f.ILogService),Oe(2,A.IEnvironmentService),Oe(3,u.ITelemetryService),Oe(4,b.IFileService),Oe(5,m.IProductService),Oe(6,R.IConfigurationService)],he),e.ExtensionGalleryServiceWithNoStorageService=he}),define(we[218],ye([0,1,2,22,78,3,15,170,28,48,47,24,34,32,41]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(p,h,a){this._configurationService=h,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,h){this._experimentProperties[p]=h}_updateTelemetryLevel(){let p=(0,d.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const a=h.usage?3:h.error?2:0;p=Math.min(p,a)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties;let h=p.sessionID,a=p["common.machineId"],u=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:h,machineId:a,firstSessionDate:u,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,h,a,u){return this.telemetryLevel.value<h?Promise.resolve(void 0):this._commonProperties.then(n=>{a=(0,t.mixin)(a,n),a=(0,t.mixin)(a,this._experimentProperties),a=(0,t.cloneAndChange)(a,l=>{if(typeof l=="string")return this._cleanupInfo(l,u)}),this._appenders.forEach(l=>l.log(p,a))},n=>{console.error(n)})}publicLog(p,h,a){return this._log(p,3,h,a)}publicLog2(p,h,a){return this.publicLog(p,h,a)}publicLogError(p,h){return this._sendErrorTelemetry?this._log(p,2,h,!0):Promise.resolve(void 0)}publicLogError2(p,h){return this.publicLogError(p,h)}_anonymizeFilePaths(p){let h=p;const a=[];for(let i of this._cleanupPatterns)for(;;){const s=i.exec(p);if(!s)break;a.push([s.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(h="";;){const i=n.exec(p);if(!i)break;!u.test(i[0])&&a.every(([s,r])=>i.index<s||i.index>=r)&&(h+=p.substring(l,i.index)+"<REDACTED: user-file-path>",l=n.lastIndex)}return l<p.length&&(h+=p.substr(l)),h}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const h=p.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of a)if(u.regex.test(h))return`<REDACTED: ${u.label}`;return p}_cleanupInfo(p,h){let a=p;h&&(a=this._anonymizeFilePaths(a));for(let u of this._cleanupPatterns)a=a.replace(u,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=Re([Oe(1,v.IConfigurationService),Oe(2,A.IProductService)],b),e.TelemetryService=b;function f(){const m=(0,E.localize)(0,null,R.default.nameLong),p=R.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",R.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=S.isWeb?"":(0,E.localize)(3,null),a=(0,E.localize)(4,null),u=(0,E.localize)(5,null),n=(0,E.localize)(6,null),l=(0,E.localize)(7,null),i=`
|       | ${a} | ${u} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,E.localize)(8,null);return`
${m} ${p} ${h}

&nbsp;

${l}
${i}

&nbsp;

${s}
`}C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:R.default.privacyStatementUrl?(0,E.localize)(16,null,R.default.nameLong,R.default.privacyStatementUrl):(0,E.localize)(15,null,R.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[219],ye([0,1,28,6,24,32,218,41]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends T.TelemetryService{constructor(R,A,C,y){super(R,C,y);this._injectedTelemetryLevel=A}publicLog(R,A,C){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(R,A,C)}publicLog2(R,A,C){return this.publicLog(R,A,C)}publicLogError(R,A){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(R,A)}publicLogError2(R,A){return this.publicLogError(R,A)}async updateInjectedTelemetryLevel(R){if(R===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,R):R,this._injectedTelemetryLevel===0&&this.dispose()}};v=Re([Oe(2,k.IConfigurationService),Oe(3,w.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends E.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(S.ITelemetryService)}),define(we[220],ye([0,1,9,22,41]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function S(E){const v=await new Promise((R,A)=>{te(["applicationinsights"],R,A)});let P;return v.defaultClient?(P=new v.TelemetryClient(E),P.channel.setUseDiskRetryCaching(!0)):(v.setup(E).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=v.defaultClient),E.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class T{constructor(v,P,R){this._eventPrefix=v,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=S(this._aiClient)),this._asyncAIClient.then(P=>{v(P)},P=>{(0,k.onUnexpectedError)(P),console.error(P)})}}log(v,P){if(!!this._aiClient){P=(0,t.mixin)(P,this._defaultData),P=(0,w.validateTelemetryData)(P);try{this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+v,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(we[221],ye([0,1,9,213]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class w extends t.default{installErrorListeners(){(0,k.setUnexpectedErrorHandler)(E=>console.error(E));const T=[];process.on("unhandledRejection",(E,v)=>{T.push(v),setTimeout(()=>{const P=T.indexOf(v);P>=0&&v.catch(R=>{T.splice(P,1),(0,k.isCancellationError)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),E&&(0,k.onUnexpectedError)(E))})},1e3)}),process.on("rejectionHandled",E=>{const v=T.indexOf(E);v>=0&&T.splice(v,1)}),process.on("uncaughtException",E=>{(0,k.onUnexpectedError)(E)})}}e.default=w}),define(we[222],ye([0,1,14,21,7,2,13]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let E=class extends S.Disposable{constructor(P,R){super();this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new w.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((R,A)=>{const C=++this._lastRequestId;this._pendingRequests.set(C,R),this._onCreateRequest.fire({requestId:C,...P});const y=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,y.token).then(()=>A(`Request ${C} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(C,[(0,S.toDisposable)(()=>y.cancel())])})}acceptReply(P,R){const A=this._pendingRequests.get(P);A?(this._pendingRequests.delete(P),(0,S.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),A(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};E=Re([Oe(1,T.ILogService)],E),e.RequestStore=E}),define(we[104],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var w;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(w=e.TerminalSettingId||(e.TerminalSettingId={}));var S;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(S=e.PosixShellType||(e.PosixShellType={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var P;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var A;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(A=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(f){f.TerminalView="view",f.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var d;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(d=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(we[223],ye([0,1,27,8,22,5,3,25,15,12,20]),function(te,e,k,t,w,S,T,E,v,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function A(){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let u=0;return a&&a.length===4&&(u=parseInt(a[3])),u}e.getWindowsBuildNumber=A;async function C(a,u,n,l=E.env,i=R.Promises.exists){if(S.isAbsolute(a))return await i(a)?a:void 0;if(u===void 0&&(u=E.cwd()),S.dirname(a)!=="."){const c=S.join(u,a);return await i(c)?c:void 0}const r=(0,w.getCaseInsensitive)(l,"PATH");if(n===void 0&&(0,P.isString)(r)&&(n=r.split(S.delimiter)),n===void 0||n.length===0){const c=S.join(u,a);return await i(c)?c:void 0}for(let c of n){let g;if(S.isAbsolute(c)?g=S.join(c,a):g=S.join(u,c,a),await i(g))return g;if(T.isWindows){let I=g+".com";if(await i(I)||(I=g+".exe",await i(I)))return I}}const o=S.join(u,a);return await i(o)?o:void 0}e.findExecutable=C;function y(a,u,n){if(!u.enabled||!a.executable||a.isFeatureTerminal||a.hideFromUser)return;const l=a.args,i=E.platform==="win32"?S.basename(a.executable).toLowerCase():S.basename(a.executable),s=S.dirname(t.FileAccess.asFileUri("",te).fsPath);let r;if(T.isWindows){if(i==="pwsh.exe"){if(!l||p(l)?r=e.shellIntegrationArgs.get(d.WindowsPwsh):m(l)&&(r=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),!r)return;if(r){const c=u.showWelcome?"":" -HideWelcome";r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],s,c)}return{newArgs:r}}n.warn(`Shell integration cannot be enabled for executable "${a.executable}" and args`,a.args);return}const o={};switch(i){case"bash":return!l||l.length===0?r=e.shellIntegrationArgs.get(d.Bash):h(l)&&(o.VSCODE_SHELL_LOGIN="1",r=e.shellIntegrationArgs.get(d.Bash)),r?(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],s),u.showWelcome||(o.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:r,envMixin:o}):void 0;case"pwsh":{if(!l||p(l)?r=e.shellIntegrationArgs.get(d.Pwsh):m(l)&&(r=e.shellIntegrationArgs.get(d.PwshLogin)),!r)return;const c=u.showWelcome?"":" -HideWelcome";return r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],s,c),{newArgs:r}}case"zsh":{if(!l||l.length===0?r=e.shellIntegrationArgs.get(d.Zsh):h(l)?r=e.shellIntegrationArgs.get(d.ZshLogin):(l===e.shellIntegrationArgs.get(d.Zsh)||l===e.shellIntegrationArgs.get(d.ZshLogin))&&(r=l),!r)return;r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],s);const c=S.join(k.tmpdir(),"vscode-zsh");o.ZDOTDIR=c;const g=[];return g.push({source:S.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:S.join(c,".zshrc")}),g.push({source:S.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:S.join(c,".zprofile")}),g.push({source:S.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:S.join(c,".zshenv")}),u.showWelcome||(o.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:r,envMixin:o,filesToCopy:g}}}n.warn(`Shell integration cannot be enabled for executable "${a.executable}" and args`,a.args)}e.getShellIntegrationInjection=y;var d;(function(a){a.WindowsPwsh="windows-pwsh",a.WindowsPwshLogin="windows-pwsh-login",a.Pwsh="pwsh",a.PwshLogin="pwsh-login",a.Zsh="zsh",a.ZshLogin="zsh-login",a.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],f=["-nol","-nologo"];function m(a){return typeof a=="string"?b.includes(a.toLowerCase()):a.length===1&&b.includes(a[0].toLowerCase())||a.length===2&&(b.includes(a[0].toLowerCase())||b.includes(a[1].toLowerCase()))&&(f.includes(a[0].toLowerCase())||f.includes(a[1].toLowerCase()))}function p(a){return typeof a=="string"?f.includes(a.toLowerCase()):a.length===0||a?.length===1&&f.includes(a[0].toLowerCase())}function h(a){return a==="string"&&b.includes(a.toLowerCase())||typeof a!="string"&&a.length===1&&b.includes(a[0].toLowerCase())}}),define(we[224],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var k;(function(w){w.DARK="dark",w.LIGHT="light",w.HIGH_CONTRAST_DARK="hcDark",w.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function t(w){return w===k.HIGH_CONTRAST_DARK||w===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=t}),define(we[105],ye([0,1,37,7,2,6,34,224]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var v;(function(f){function m(p){return p&&typeof p=="object"&&typeof p.id=="string"}f.isThemeColor=m})(v=e.ThemeColor||(e.ThemeColor={}));function P(f){return{id:f}}e.themeColorFromId=P;var R;(function(f){function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||v.isThemeColor(s.color))}f.isThemeIcon=m;const p=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function h(s){const r=p.exec(s);if(!r)return;let[,o]=r;return{id:o}}f.fromString=h;function a(s){return{id:s}}f.fromId=a;function u(s,r){let o=s.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),r&&(o=`${o}~${r}`),{id:o}}f.modify=u;function n(s){const r=s.id.lastIndexOf("~");if(r!==-1)return s.id.substring(r+1)}f.getModifier=n;function l(s,r){return s.id===r.id&&s.color?.id===r.color?.id}f.isEqual=l;function i(s,r){return{id:s.id,color:r?P(r):void 0}}f.asThemeIcon=i,f.asClassNameArray=k.CSSIcon.asClassNameArray,f.asClassName=k.CSSIcon.asClassName,f.asCSSSelector=k.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function A(f){switch(f){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,w.toDisposable)(()=>{const p=this.themingParticipants.indexOf(m);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new C;T.Registry.add(e.Extensions.ThemingContribution,y);function d(f){return y.onColorThemeChange(f)}e.registerThemingParticipant=d;class b extends w.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,p){let h=this.theme.getColor(m);return h&&p&&(h=p(h,this.theme)),h?h.toString():null}}e.Themable=b}),define(we[225],ye([0,1,37,4,172,105]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(C,y){const d=[{name:null,description:(0,w.localize)(0,null)}];return d.push(...C.map(b=>({name:b.profileName,description:E(b)}))),y&&d.push(...y.map(b=>({name:b.title,description:v(b)}))),{values:d.map(b=>b.name),markdownDescriptions:d.map(b=>b.description)}}e.createProfileSchemaEnums=T;function E(C){let y=`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:k.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?y+=`
- args: "${C.args}"`:y+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(y+=`
- overrideName: ${C.overrideName}`),C.color&&(y+=`
- color: ${C.color}`),C.env&&(y+=`
- env: ${JSON.stringify(C.env)}`),y}function v(C){return`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:k.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function P(C,y){if(!C&&!y)return!0;if(typeof C=="string"&&typeof y=="string")return C===y;if(Array.isArray(C)&&Array.isArray(y)){if(C.length!==y.length)return!1;for(let d=0;d<C.length;d++)if(C[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=P;function R(C,y){if(!C&&!y)return!0;if(!C||!y)return!1;if(S.ThemeIcon.isThemeIcon(C)&&S.ThemeIcon.isThemeIcon(y))return C.id===y.id&&C.color===y.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=C,b=y;if((t.URI.isUri(d.light)||A(d.light))&&(t.URI.isUri(d.dark)||A(d.dark))&&(t.URI.isUri(b.light)||A(b.light))&&(t.URI.isUri(b.dark)||A(b.dark)))return d.light.path===b.light.path&&d.dark.path===b.dark.path}if(t.URI.isUri(C)&&t.URI.isUri(y)||A(C)||A(y)){const d=C,b=y;return d.path===b.path&&d.scheme===b.scheme}return!1}e.terminalIconsEqual=R;function A(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=A}),define(we[226],ye([0,1,37,171,48,34,225]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const E={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),a=>a.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),a=>`$(${a.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...E}},P={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...E}},R=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),A=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...E}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){S.Registry.as(w.Extensions.Configuration).registerConfiguration(f),h()}e.registerTerminalPlatformConfiguration=m;let p;function h(a,u){const n=S.Registry.as(w.Extensions.Configuration);let l;a&&(l=(0,T.createProfileSchemaEnums)(a?.profiles,u));const i=p;p={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:a?.os===3?l?.values:void 0,markdownEnumDescriptions:a?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:a?.os===2?l?.values:void 0,markdownEnumDescriptions:a?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:a?.os===1?l?.values:void 0,markdownEnumDescriptions:a?.os===1?l?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[p],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=h}),define(we[227],ye([0,1,38,37,5,3,20,86,223,105]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,A=!0;function C(l,i,s,r,o=process.env,c,g,I,_){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},S.isWindows?y(s,c,o,g,r.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),_,I):a(c,g,s,l&&typeof l=="object"?{...l}:r.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,I,o)}e.detectAvailableProfiles=C;async function y(l,i,s,r,o,c,g,I,_){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),W=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ee=!1;(0,v.getWindowsBuildNumber)()>=16299&&(ee=!0),await f(I);const D=new Map;l&&(D.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${W}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${W}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(c,D);const H=await d(D.entries(),g,i,s,r,_);if(l||!l&&o)try{const F=await p(`${W}\\${ee?"wsl":"bash"}.exe`,g);for(const $ of F)(!c||!($.profileName in c))&&H.push($)}catch{A&&(r?.info("WSL is not installed, so could not detect WSL profiles"),A=!1)}return H}async function d(l,i,s,r=process.env,o,c){const g=[];for(const[I,_]of l){if(_===null)continue;let z,W,ee;if("source"in _){const F=R?.get(_.source);if(!F)continue;z=F.paths,W=_.args||F.args,_.icon?ee=b(_.icon):F.icon&&(ee=F.icon)}else z=Array.isArray(_.path)?_.path:[_.path],W=S.isWindows||Array.isArray(_.args)?_.args:void 0,ee=b(_.icon);const D=await c?.(z)||z.slice(),H=await n(I,i,D,s,r,W,_.env,_.overrideName,_.isAutoDetected,o);H?(H.isAutoDetected=_.isAutoDetected,H.icon=ee,H.color=_.color,g.push(H)):o?.trace("profile not validated",I,z)}return g}function b(l){return typeof l=="string"?{id:l}:l}async function f(l){R&&!l||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:l||await m(),icon:P.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const l=[];for await(const i of(0,E.enumeratePowerShellInstallations)())l.push(i.exePath);return l}async function p(l,i){const s=[],r=await new Promise((g,I)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,z)=>{if(_)return I("Problem occurred when getting wsl distros");g(z)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),c=r.split(o).filter(g=>g.trim().length>0&&g!=="");for(const g of c){if(g===""||g.startsWith("docker-desktop"))continue;const I=`${g} (WSL)`,_={profileName:I,path:l,args:["-d",`${g}`],isDefault:I===i,icon:h(g),isAutoDetected:!1};s.push(_)}return s}function h(l){return l.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):l.includes("Debian")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function a(l,i,s,r,o,c,g,I){const _=new Map;if(s){const z=(await l.readFile("/etc/shells")).toString(),W=c||z.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),ee=new Map;for(const D of W){let H=(0,w.basename)(D),F=ee.get(H)||0;F++,F>1&&(H=`${H} (${F})`),ee.set(H,F),_.set(H,{path:D,isAutoDetected:!0})}}return u(r,_),await d(_.entries(),o,l,I,i,g)}function u(l,i){if(!!l)for(const[s,r]of Object.entries(l))r===null||!("path"in r)&&!("source"in r)?i.delete(s):(r.icon=r.icon||i.get(s)?.icon,i.set(s,r))}async function n(l,i,s,r,o,c,g,I,_,z){if(s.length===0)return Promise.resolve(void 0);const W=s.shift();if(W==="")return n(l,i,s,r,o,c,g,I,_);const ee={profileName:l,path:W,args:c,env:g,overrideName:I,isAutoDetected:_,isDefault:l===i};if((0,w.basename)(W)===W){const H=o.PATH?o.PATH.split(w.delimiter):void 0,F=await(0,v.findExecutable)(W,void 0,H,void 0,r.existsFile);return F?(ee.path=F,ee.isFromPath=!0,ee):n(l,i,s,r,o,c)}return await r.existsFile((0,w.normalize)(W))?ee:n(l,i,s,r,o,c,g,I,_)}}),define(we[228],ye([0,1,7,2,8,3,39,91,28,23,92,73,13,97,222,104,226,227]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let h=0,a=class extends t.Disposable{constructor(n,l,i,s){super();this._reconnectConstants=n,this._configurationService=l,this._environmentService=i,this._logService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(S.isWindows)return process.env;try{return await(0,A.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:h,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},l=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);l&&(l.break&&l.port?n.debugBrk=l.port:!l.break&&l.port&&(n.debug=l.port));const i=new E.Client(w.FileAccess.asFileUri("bootstrap-fork",te).fsPath,n);this._onPtyHostStart.fire(),T.ProxyChannel.toService(i.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const r=i.getChannel(b.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const o=T.ProxyChannel.toService(i.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(o.onProcessData(c=>this._onProcessData.fire(c))),this._register(o.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(o.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(o.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(o.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(o.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(o.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[i,o]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,l,i,s,r,o,c,g,I,_,z){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),ee=await this._proxy.createProcess(n,l,i,s,r,o,c,g,I,_,z);return clearTimeout(W),h=Math.max(h,ee),ee}updateTitle(n,l,i){return this._proxy.updateTitle(n,l,i)}updateIcon(n,l,i){return this._proxy.updateIcon(n,l,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n){return this._proxy.detachFromProcess(n)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,l){return this._proxy.shutdown(n,l)}input(n,l){return this._proxy.input(n,l)}processBinary(n,l){return this._proxy.processBinary(n,l)}resize(n,l,i){return this._proxy.resize(n,l,i)}acknowledgeDataEvent(n,l){return this._proxy.acknowledgeDataEvent(n,l)}setUnicodeVersion(n,l){return this._proxy.setUnicodeVersion(n,l)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,l){return this._proxy.installAutoReply(n,l)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,l,i,s=!1){const r=await this._shellEnv;return(0,m.detectAvailableProfiles)(l,i,s,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,l){return this._proxy.requestDetachInstance(n,l)}async acceptDetachInstanceReply(n,l){return this._proxy.acceptDetachInstanceReply(n,l)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,l){return this._proxy.reviveTerminalProcesses(n,l)}async refreshProperty(n,l){return this._proxy.refreshProperty(n,l)}async updateProperty(n,l,i){return this._proxy.updateProperty(n,l,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,l){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:l})}async acceptPtyHostResolvedVariables(n,l){this._resolveVariablesRequestStore.acceptReply(n,l)}};a=Re([Oe(1,v.IConfigurationService),Oe(2,P.IEnvironmentService),Oe(3,C.ILogService)],a),e.PtyHostService=a}),define(we[51],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(we[229],ye([0,1,7,2,4,23,35,17,13,51]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends t.Disposable{constructor(C,y,d,b,f){super();this.extensionsManagementService=C,this.logService=b,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(p=>{this.installedExtensions=p.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(C.onInstallExtension(p=>this.onInstallExtension(p))),this._register(C.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(C.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const m=w.URI.file(d.extensionsPath);this._register(y.watch(m)),this._register(k.Event.filter(y.onDidFilesChange,p=>p.rawChanges.some(h=>this.doesChangeAffects(h,m)))(()=>this.onDidChange()))}doesChangeAffects(C,y){return C.type!==1&&C.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(C.resource),y)?!1:this.uriIdentityService.extUri.isEqual(C.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(C.resource).startsWith(".")}onInstallExtension(C){this.addInstallingExtension(C.identifier)}onDidInstallExtensions(C){for(const y of C)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(C){C.error||this.removeInstalledExtension(C.identifier)}addInstallingExtension(C){this.removeInstallingExtension(C),this.installingExtensions.push(C)}removeInstallingExtension(C){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,C))}addInstalledExtension(C){this.installedExtensions&&(this.removeInstalledExtension(C),this.installedExtensions.push(C))}removeInstalledExtension(C){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,C)))}async onDidChange(){if(this.installedExtensions){const C=await this.extensionsManagementService.getInstalled(),y=C.filter(b=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,T.areSameExtensions)(f,b.identifier))?!1:b.installedTimestamp&&b.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",b.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",b.identifier.id),!1)),d=this.installedExtensions.filter(b=>this.installingExtensions.some(f=>(0,T.areSameExtensions)(f,b))?!1:C.every(f=>!(0,T.areSameExtensions)(f.identifier,b))?(this.logService.info("Detected extension removed from another source",b.id),!0):!1);this.installedExtensions=C.map(b=>b.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};R=Re([Oe(1,E.IFileService),Oe(2,S.INativeEnvironmentService),Oe(3,v.ILogService),Oe(4,P.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(we[106],ye([0,1,51,186,17,19,130,7,2]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(C){this.uri=C,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let R=class{constructor(C){this._fileService=C,this._dispooables=new v.DisposableStore,this._limit=2**16;const y=new Map,d=b=>{let f=y.get(b.scheme);return f===void 0&&(f=C.hasProvider(b)&&!this._fileService.hasCapability(b,1024),y.set(b.scheme,f)),f};this._dispooables.add(E.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(b=>{y.delete(b.scheme)})),this.extUri=new S.ExtUri(d),this._canonicalUris=new T.SkipList((b,f)=>this.extUri.compare(b,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(C){this._fileService.hasProvider(C)&&(C=(0,S.normalizePath)(C));let y=this._canonicalUris.get(C);return y?y.touch().uri.with({fragment:C.fragment}):(this._canonicalUris.set(C,new P(C)),this._checkTrim(),C)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const C=[...this._canonicalUris.entries()].sort((d,b)=>d[1].touch<b[1].touch?1:d[1].touch>b[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(C[d][0],C[d][1].touch())}};R=Re([Oe(0,w.IFileService)],R),e.UriIdentityService=R,(0,t.registerSingleton)(k.IUriIdentityService,R,!0)}),define(we[107],ye([0,1,173,5,29,19,4,6,8]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function P(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=P;function R(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function A(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=A;function C(i){const s=i;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=C;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=d;function b(i){const s=i;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=b;class f{constructor(s,r,o,c,g){this._id=s,this._transient=o,this._configuration=c,this._ignorePathCasing=g,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class m{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,S.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function p(i){return new m({uri:i,index:0,name:(0,S.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(i,s){return S.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function u(i){let s;return T.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=u;function n(i,s){return!a(i,s)&&!u(i)}e.isSavedWorkspace=n;function l(i){return(typeof i=="string"?(0,t.extname)(i):(0,S.extname)(i))===h}e.hasWorkspaceFileExtension=l}),define(we[108],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,k.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(S,T){this._exitInfo.set(S,T)}getExitInfo(S){return this._exitInfo.get(S)||null}}e.ExtensionHostStatusService=t}),define(we[230],ye([0,1,7,14]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function w(T){let E=0,v=0,P=0;T>=1e3&&(P=Math.floor(T/1e3),T-=P*1e3),P>=60&&(v=Math.floor(P/60),P-=v*60),v>=60&&(E=Math.floor(v/60),v-=E*60);const R=E?`${E}h`:"",A=v?`${v}m`:"",C=P?`${P}s`:"",y=T?`${T}ms`:"";return`${R}${A}${C}${y}`}e.printTime=w;class S{constructor(E,v,P,R){this._logService=E,this._reconnectionToken=v,this._onClose=new k.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=P,this.protocol=R,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${w(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${w(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${w(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(E){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${E}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${w(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const E=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),E.end(),this._onClose.fire(void 0)}acceptReconnection(E,v,P){this._remoteAddress=E,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,P),this.protocol.endAcceptReconnection()}}e.ManagementConnection=S}),define(we[109],ye([0,1,30,8,5,137,47]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const E=w.join(t.FileAccess.asFileUri("",te).fsPath,"nls.metadata.json"),v=new Map;function P(C){return new Promise(y=>k.exists(C,y))}function R(C,y){return P(E).then(d=>{if(!d||!T.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let b=`${C}||${y}`,f=v.get(b);return f||(f=S.getNLSConfiguration(T.default.commit,y,E,C).then(m=>(A.is(m)&&(m._languagePackSupport=!0),m)),v.set(b,f)),f})}e.getNLSConfiguration=R;var A;(function(C){function y(d){let b=d;return b&&typeof b._languagePackId=="string"}C.is=y})(A=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(we[110],ye([0,1,19,4,23,49,40,17,13,24,109]),function(te,e,k,t,w,S,T,E,v,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let A=class extends S.AbstractExtensionsScannerService{constructor(y,d,b,f){super(t.URI.file(b.builtinExtensionsPath),t.URI.file(b.extensionsPath),(0,k.joinPath)(b.userHome,".vscode-oss-dev","extensions","control.json"),(0,k.joinPath)(t.URI.file(b.userDataPath),T.MANIFEST_CACHE_FOLDER),y,d,b,f);this.nativeEnvironmentService=b}async getTranslations(y){const d=await(0,R.getNLSConfiguration)(y,this.nativeEnvironmentService.userDataPath);if(R.InternalNLSConfiguration.is(d))try{const b=await this.fileService.readFile(t.URI.file(d._translationsConfigFile));return JSON.parse(b.value.toString())}catch{}return Object.create(null)}};A=Re([Oe(0,E.IFileService),Oe(1,v.ILogService),Oe(2,w.INativeEnvironmentService),Oe(3,P.IProductService)],A),e.ExtensionsScannerService=A}),define(we[231],ye([0,1,232,30,5,26,8,20]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var P;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(P=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class R{constructor(){this.type=0}validate(p){return!0}}e.NoneServerConnectionToken=R;class A{constructor(p){this.value=p,this.type=1}validate(p){return p===this.value}}e.OptionalServerConnectionToken=A;class C{constructor(p){this.value=p,this.type=2}validate(p){return p===this.value}}e.MandatoryServerConnectionToken=C;class y{constructor(p){this.message=p}}e.ServerConnectionTokenParseError=y;async function d(m,p){const h=m["without-connection-token"],a=m["connection-token"],u=m["connection-token-file"],n=m.compatibility==="1.63";if(h)return typeof a!="undefined"||typeof u!="undefined"?new y("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new R;if(typeof u!="undefined"){if(typeof a!="undefined")return new y("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=t.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new y(`Unable to read the connection token file at '${u}'.`)}return v.test(l)?new C(l):new y(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof a!="undefined"?v.test(a)?n?new A(a):new C(a):new y(`The connection token '${a} does not adhere to the characters 0-9, a-z, A-Z or -.`):n?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new A(await p())):new C(await p())}e.parseServerConnectionToken=d;async function b(m){return d(m,async()=>{if(!m["user-data-dir"])return(0,S.generateUuid)();const h=w.join(m["user-data-dir"],"token");try{const n=(await E.Promises.readFile(h)).toString().replace(/\r?\n$/,"");if(v.test(n))return n}catch{}const a=(0,S.generateUuid)();try{await E.Promises.writeFile(h,a,{mode:384})}catch{}return a})}e.determineServerConnectionToken=b;function f(m,p,h){if(m.validate(h.query[T.connectionTokenQueryName]))return!0;const a=k.parse(p.headers.cookie||"");return m.validate(a[T.connectionTokenCookieName])}e.requestHasValidConnectionToken=f}),define(we[42],ye([0,1,175,184,54,6,23]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:k.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:k.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:k.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:k.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:k.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:k.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:k.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:k.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:k.localize(8,null)},"user-data-dir":w.OPTIONS["user-data-dir"],"enable-smoke-test-driver":w.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":w.OPTIONS["disable-telemetry"],"disable-workspace-trust":w.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:w.OPTIONS.log,logsPath:w.OPTIONS.logsPath,"force-disable-user-env":w.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:k.localize(9,null)},"default-workspace":{type:"string",description:k.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":w.OPTIONS["extensions-dir"],"extensions-download-dir":w.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":w.OPTIONS["builtin-extensions-dir"],"install-extension":w.OPTIONS["install-extension"],"install-builtin-extension":w.OPTIONS["install-builtin-extension"],"uninstall-extension":w.OPTIONS["uninstall-extension"],"list-extensions":w.OPTIONS["list-extensions"],"locate-extension":w.OPTIONS["locate-extension"],"show-versions":w.OPTIONS["show-versions"],category:w.OPTIONS.category,force:w.OPTIONS.force,"do-not-sync":w.OPTIONS["do-not-sync"],"pre-release":w.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:k.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:w.OPTIONS.help,version:w.OPTIONS.version,compatibility:{type:"string"},_:w.OPTIONS._},e.IServerEnvironmentService=(0,S.refineServiceDecorator)(T.IEnvironmentService);class E extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=E}),define(we[233],ye([0,1,30,83,72,139,232,71,33,62,3,13,42,5,8,26,24,50,21,4,16,12]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function l(o,c,g,I){c.writeHead(g,{"Content-Type":"text/plain"}),c.end(I)}e.serveError=l;async function i(o,c,g,I,_=Object.create(null)){try{const z=await S.promisify(k.stat)(I),W=`W/"${[z.ino,z.size,z.mtime.getTime()].join("-")}"`;if(c.headers["if-none-match"]===W)return g.writeHead(304),g.end();_["Content-Type"]=n[(0,y.extname)(I)]||(0,P.getMediaMime)(I)||"text/plain",_.Etag=W,g.writeHead(200,_),k.createReadStream(I).pipe(g)}catch(z){return z.code!=="ENOENT"&&(o.error(z),console.error(z.toString())),g.writeHead(404,{"Content-Type":"text/plain"}),g.end("Not found")}}e.serveFile=i;const s=(0,y.dirname)(d.FileAccess.asFileUri("",te).fsPath);let r=class{constructor(c,g,I,_,z){this._connectionToken=c,this._environmentService=g,this._logService=I,this._requestService=_,this._productService=z,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?h.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(c,g,I){try{const _=I.pathname;return _==="/favicon.ico"||_==="/manifest.json"||_==="/code-192.png"||_==="/code-512.png"?i(this._logService,c,g,(0,y.join)(s,"resources","server",_.substr(1))):/^\/static\//.test(_)?this._handleStatic(c,g,I):_==="/"?this._handleRoot(c,g,I):_==="/callback"?this._handleCallback(g):/^\/web-extension-resource\//.test(_)?this._handleWebExtensionResource(c,g,I):l(c,g,404,"Not found.")}catch(_){return this._logService.error(_),console.error(_.toString()),l(c,g,500,"Internal Server Error.")}}async _handleStatic(c,g,I){const _=Object.create(null),z=decodeURIComponent(I.pathname),W=(0,y.normalize)(z.substr("/static/".length)),ee=(0,y.join)(s,W);return(0,v.isEqualOrParent)(ee,s,!R.isLinux)?i(this._logService,c,g,ee,_):l(c,g,400,"Bad request.")}_getResourceURLTemplateAuthority(c){const g=c.authority.indexOf(".");return g!==-1?c.authority.substring(g+1):void 0}async _handleWebExtensionResource(c,g,I){if(!this._webExtensionResourceUrlTemplate)return l(c,g,500,"No extension gallery service configured.");const _=decodeURIComponent(I.pathname),z=(0,y.normalize)(_.substr("/web-extension-resource/".length)),W=h.URI.parse(z).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:z.substring(0,z.indexOf("/")),path:z.substring(z.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(W))return l(c,g,403,"Request Forbidden");const ee={},D=j=>{const O=c.headers[j];O&&((0,u.isString)(O)||O[0])?ee[j]=(0,u.isString)(O)?O:O[0]:j!==j.toLowerCase()&&D(j.toLowerCase())};D("X-Client-Name"),D("X-Client-Version"),D("X-Machine-Id"),D("X-Client-Commit");const H=await this._requestService.request({type:"GET",url:W.toString(!0),headers:ee},p.CancellationToken.None),F=H.res.statusCode||500;if(F!==200){let j=null;try{j=await(0,m.asTextOrError)(H)}catch{}return l(c,g,F,j||`Request failed with status ${F}`)}const $=Object.create(null),oe=j=>{const O=H.res.headers[j];O?$[j]=O:j!==j.toLowerCase()&&oe(j.toLowerCase())};oe("Cache-Control"),oe("Content-Type"),g.writeHead(200,$);const K=await(0,a.streamToBuffer)(H.stream);return g.end(K.buffer)}async _handleRoot(c,g,I){const _=I.query[d.connectionTokenQueryName];if(typeof _=="string"){const O=Object.create(null);O["Set-Cookie"]=T.serialize(d.connectionTokenCookieName,_,{sameSite:"lax",maxAge:60*60*24*7});const B=Object.create(null);for(let J in I.query)J!==d.connectionTokenQueryName&&(B[J]=I.query[J]);const V=w.format({pathname:"/",query:B});return O.Location=V,g.writeHead(302,O),g.end()}let z=c.headers["x-original-host"];Array.isArray(z)&&(z=z[0]);const W=z||c.headers.host;if(!W)return l(c,g,400,"Bad request.");function ee(O){return O.replace(/"/g,"&quot;")}let D;this._environmentService.args["enable-smoke-test-driver"]&&(D=!1);const H=O=>O&&h.URI.file(t.resolve(O)).with({scheme:d.Schemas.vscodeRemote,authority:W}),F=d.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",te).fsPath,$=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,b.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,oe=(await S.promisify(k.readFile)(F)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",ee(JSON.stringify({remoteAuthority:W,_wrapWebWorkerExtHostInIframe:D,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:H(this._environmentService.args["default-folder"]),workspaceUri:H(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:W,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>$?ee(JSON.stringify($)):""),K=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(oe).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${W};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),j={"Content-Type":"text/html","Content-Security-Policy":K};return this._connectionToken.type!==0&&(j["Set-Cookie"]=T.serialize(d.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),g.writeHead(200,j),g.end(oe)}_getScriptCspHashes(c){const g=/<script>([\s\S]+?)<\/script>/img,I=[];let _;for(;_=g.exec(c);){const z=E.createHash("sha256"),W=_[1].replace(/\r\n/g,`
`),ee=z.update(Buffer.from(W)).digest().toString("base64");I.push(`'sha256-${ee}'`)}return I}async _handleCallback(c){const g=d.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",te).fsPath,I=(await S.promisify(k.readFile)(g)).toString(),_=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(I).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return c.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":_}),c.end(I)}};r=Re([Oe(1,C.IServerEnvironmentService),Oe(2,A.ILogService),Oe(3,m.IRequestService),Oe(4,f.IProductService)],r),e.WebClientServer=r}),define(we[234],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,k.createDecorator)("IExtHostRpcService");class t{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.dispose=S.dispose.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=t});var Et=this&&this.__classPrivateFieldSet||function(te,e,k,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(te,k):w?w.value=k:e.set(te,k),k},et=this&&this.__classPrivateFieldGet||function(te,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(te):t?t.value:e.get(te)};define(we[111],ye([0,1,18,9,81,29,62,15,12,4,26,17,100]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";var y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c,g,I,_,z;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function W(M){function L(){return Reflect.construct(M,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(M,"name")),Object.setPrototypeOf(L,M),Object.setPrototypeOf(L.prototype,M.prototype),L}let ee=m=class{constructor(L){y.set(this,void 0),Et(this,y,L,"f")}static from(...L){let ne=L;return new m(function(){if(ne){for(const Ce of ne)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ne=void 0}})}dispose(){typeof et(this,y,"f")=="function"&&(et(this,y,"f").call(this),Et(this,y,void 0,"f"))}};y=new WeakMap,ee=m=Re([W],ee),e.Disposable=ee;let D=p=class{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const $e=L[Ce];$e.isBefore(ne)&&(ne=$e)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const $e=L[Ce];$e.isAfter(ne)&&(ne=$e)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof p)return!0;let{line:ne,character:Ce}=L;return typeof ne=="number"&&typeof Ce=="number"}static of(L){if(L instanceof p)return L;if(this.isPosition(L))return new p(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=0:typeof L=="number"?Ce=L:(Ce=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Ce===0&&ne===0?this:new p(this.line+Ce,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=this.line:typeof L=="number"?Ce=L:(Ce=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Ce===this.line&&ne===this.character?this:new p(Ce,ne)}toJSON(){return{line:this.line,character:this.character}}};D=p=Re([W],D),e.Position=D;let H=h=class{constructor(L,ne,Ce,$e){let Ve,Xe;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof $e=="number"?(Ve=new D(L,ne),Xe=new D(Ce,$e)):D.isPosition(L)&&D.isPosition(ne)&&(Ve=D.of(L),Xe=D.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");Ve.isBefore(Xe)?(this._start=Ve,this._end=Xe):(this._start=Xe,this._end=Ve)}static isRange(L){return L instanceof h?!0:L?D.isPosition(L.start)&&D.isPosition(L.end):!1}static of(L){if(L instanceof h)return L;if(this.isRange(L))return new h(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return h.isRange(L)?this.contains(L.start)&&this.contains(L.end):D.isPosition(L)?!(D.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=D.Max(L.start,this._start),Ce=D.Min(L.end,this._end);if(!ne.isAfter(Ce))return new h(ne,Ce)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=D.Min(L.start,this._start),Ce=D.Max(L.end,this.end);return new h(ne,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return L?D.isPosition(L)?Ce=L:(Ce=L.start||this.start,ne=L.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ne.isEqual(this.end)?this:new h(Ce,ne)}toJSON(){return[this.start,this.end]}};H=h=Re([W],H),e.Range=H;let F=a=class extends H{constructor(L,ne,Ce,$e){let Ve,Xe;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof $e=="number"?(Ve=new D(L,ne),Xe=new D(Ce,$e)):D.isPosition(L)&&D.isPosition(ne)&&(Ve=D.of(L),Xe=D.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");super(Ve,Xe);this._anchor=Ve,this._active=Xe}static isSelection(L){return L instanceof a?!0:L?H.isRange(L)&&D.isPosition(L.anchor)&&D.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=a=Re([W],F),e.Selection=F;class ${constructor(L,ne,Ce){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=Ce}}e.ResolvedAuthority=$;class oe extends Error{constructor(L,ne=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(L);this._message=L,this._code=ne,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(L,ne){return new oe(L,C.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new oe(L,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var K;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var j;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let O=u=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof u?!0:L?H.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new u(L,ne)}static insert(L,ne){return u.replace(new H(L,L),ne)}static delete(L){return u.replace(L,"")}static setEndOfLine(L){const ne=new u(new H(new D(0,0),new D(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!H.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};O=u=Re([W],O),e.TextEdit=O;class B{constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=B;var V;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let J=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Ce,$e){this._edits.push({_type:1,from:L,to:ne,options:Ce,metadata:$e})}createFile(L,ne,Ce){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Ce})}deleteFile(L,ne,Ce){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Ce})}replaceNotebookMetadata(L,ne,Ce){this._edits.push({_type:3,metadata:Ce,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Ce,$e,Ve){let Xe,Je,it=[],lt;if(Lt.isNotebookRange(ne)&&It.isNotebookCellDataArray(Ce)&&!It.isNotebookCellDataArray($e)?(Xe=ne.start,Je=ne.end,it=Ce,lt=$e):typeof ne=="number"&&typeof Ce=="number"&&It.isNotebookCellDataArray($e)&&(Xe=ne,Je=Ce,it=$e,lt=Ve),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||it.length>0)&&this._edits.push({_type:5,uri:L,index:Xe,count:Je-Xe,cells:it,metadata:lt})}replaceNotebookCellMetadata(L,ne,Ce,$e){this._edits.push({_type:3,metadata:$e,uri:L,edit:{editType:8,index:ne,metadata:Ce}})}replace(L,ne,Ce,$e){this._edits.push({_type:2,uri:L,edit:new O(ne,Ce),metadata:$e})}insert(L,ne,Ce,$e){this.replace(L,new H(ne,ne),Ce,$e)}delete(L,ne,Ce){this.replace(L,ne,"",Ce)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Ce of ne)Ce&&this._edits.push({_type:2,uri:L,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const $e=this._edits[Ce];$e._type===2&&$e.uri.toString()===L.toString()&&(this._edits[Ce]=void 0)}(0,k.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===L.toString()&&ne.push(Ce.edit);return ne}entries(){const L=new S.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ce=L.get(ne.uri);Ce||(Ce=[ne.uri,[]],L.set(ne.uri,Ce)),Ce[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};J=Re([W],J),e.WorkspaceEdit=J;let se=n=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof n?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=n._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Ce=new n;Ce._tabstop=this._tabstop,L(Ce),this._tabstop=Ce._tabstop,L=Ce.value}else L=n._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Ce=L.map($e=>$e.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Ce=new n;Ce._tabstop=this._tabstop,ne(Ce),this._tabstop=Ce._tabstop,ne=Ce.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};se=n=Re([W],se),e.SnippetString=se;var me;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(me=e.DiagnosticTag||(e.DiagnosticTag={}));var he;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(he=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let U=l=class{constructor(L,ne){if(this.uri=L,ne)if(H.isRange(ne))this.range=H.of(ne);else if(D.isPosition(ne))this.range=new H(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof l?!0:L?H.isRange(L.range)&&P.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};U=l=Re([W],U),e.Location=U;let N=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&H.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};N=Re([W],N),e.DiagnosticRelatedInformation=N;let q=class{constructor(L,ne,Ce=he.Error){if(!H.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Ce}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,k.equals)(L.tags,ne.tags)&&(0,k.equals)(L.relatedInformation,ne.relatedInformation,N.isEqual)}};q=Re([W],q),e.Diagnostic=q;let Y=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};Y=Re([W],Y),e.Hover=Y;var ie;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let de=class{constructor(L,ne=ie.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:ie[this.kind]}}};de=Re([W],de),e.DocumentHighlight=de;var le;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(le=e.SymbolKind||(e.SymbolKind={}));var ue;(function(M){M[M.Deprecated=1]="Deprecated"})(ue=e.SymbolTag||(e.SymbolTag={}));let pe=i=class{constructor(L,ne,Ce,$e,Ve){this.name=L,this.kind=ne,this.containerName=Ve,typeof Ce=="string"&&(this.containerName=Ce),$e instanceof U?this.location=$e:Ce instanceof H&&(this.location=new U($e,Ce)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};pe=i=Re([W],pe),e.SymbolInformation=pe;let X=s=class{constructor(L,ne,Ce,$e,Ve){this.name=L,this.detail=ne,this.kind=Ce,this.range=$e,this.selectionRange=Ve,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};X=s=Re([W],X),e.DocumentSymbol=X;var Z;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(L,ne){this.title=L,this.kind=ne}};G=Re([W],G),e.CodeAction=G;let Q=r=class{constructor(L){this.value=L}append(L){return new r(this.value?this.value+r.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+r.sep)}};Q.sep=".",Q=r=Re([W],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let ae=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Re([W],ae),e.SelectionRange=ae;class ve{constructor(L,ne,Ce,$e,Ve,Xe){this.kind=L,this.name=ne,this.detail=Ce,this.uri=$e,this.range=Ve,this.selectionRange=Xe}}e.CallHierarchyItem=ve;class ke{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=ke;class Te{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=Te;var Ne;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Ne=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ue=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};Ue=Re([W],Ue),e.CodeLens=Ue;let fe=o=class{constructor(L,ne=!1){d.set(this,void 0),Et(this,d,new w.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof o?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return et(this,d,"f").value}set value(L){et(this,d,"f").value=L}get isTrusted(){return et(this,d,"f").isTrusted}set isTrusted(L){et(this,d,"f").isTrusted=L}get supportThemeIcons(){return et(this,d,"f").supportThemeIcons}set supportThemeIcons(L){et(this,d,"f").supportThemeIcons=L}get supportHtml(){return et(this,d,"f").supportHtml}set supportHtml(L){et(this,d,"f").supportHtml=L}get baseUri(){return et(this,d,"f").baseUri}set baseUri(L){et(this,d,"f").baseUri=L}appendText(L){return et(this,d,"f").appendText(L),this}appendMarkdown(L){return et(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return et(this,d,"f").appendCodeblock(ne??"",L),this}};d=new WeakMap,fe=o=Re([W],fe),e.MarkdownString=fe;let Ee=class{constructor(L,ne){this.label=L,this.documentation=ne}};Ee=Re([W],Ee),e.ParameterInformation=Ee;let ge=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};ge=Re([W],ge),e.SignatureInformation=ge;let Fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Fe=Re([W],Fe),e.SignatureHelp=Fe;var _e;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(_e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var qe;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(qe=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(L){this.value=L}};Be=Re([W],Be),e.InlayHintLabelPart=Be;let Ge=class{constructor(L,ne,Ce){this.position=L,this.label=ne,this.kind=Ce}};Ge=Re([W],Ge),e.InlayHint=Ge;var je;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(M){M[M.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let be=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};be=Re([W],be),e.CompletionItem=be;let Pe=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};Pe=Re([W],Pe),e.CompletionList=Pe;let Le=class{constructor(L,ne,Ce){this.insertText=L,this.range=ne,this.command=Ce}};Le=Re([W],Le),e.InlineSuggestion=Le;let ze=class{constructor(L){this.items=L}};ze=Re([W],ze),e.InlineSuggestions=ze;let Me=class{constructor(L,ne,Ce){this.insertText=L,this.range=ne,this.command=Ce}};Me=Re([W],Me),e.InlineSuggestionNew=Me;let He=class{constructor(L,ne){this.items=L,this.commands=ne}};He=Re([W],He),e.InlineSuggestionsNew=He;var Ye;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var Qe;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Qe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var xe;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(nt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ot;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var pt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(pt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var at;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(at=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function L(ne){switch(ne){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=L}(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(L,ne){if(ne&&!P.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!H.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=ne}};ut=Re([W],ut),e.DocumentLink=ut;let ct=class{constructor(L,ne,Ce,$e){this.red=L,this.green=ne,this.blue=Ce,this.alpha=$e}};ct=Re([W],ct),e.Color=ct;let vt=class{constructor(L,ne){if(ne&&!(ne instanceof ct))throw(0,t.illegalArgument)("color");if(!H.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=ne}};vt=Re([W],vt),e.ColorInformation=vt;let bt=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};bt=Re([W],bt),e.ColorPresentation=bt;var kt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(kt=e.ColorFormat||(e.ColorFormat={}));var Tt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Rt{constructor(L,ne,Ce){if(this.startIndex=L,this.length=ne,this.tooltip=Ce,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Rt;var At;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(At=e.TerminalLocation||(e.TerminalLocation={}));class _t{constructor(L){if(this.options=L,typeof L!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=_t;var Se;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Se=e.TaskRevealKind||(e.TaskRevealKind={}));var Ie;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ie=e.TaskPanelKind||(e.TaskPanelKind={}));let ce=c=class{constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ce.Clean=new c("clean","Clean"),ce.Build=new c("build","Build"),ce.Rebuild=new c("rebuild","Rebuild"),ce.Test=new c("test","Test"),ce=c=Re([W],ce),e.TaskGroup=ce;function x(M){let L="";for(let ne=0;ne<M.length;ne++)L+=M[ne].replace(/,/g,",,")+",";return L}let De=class{constructor(L,ne,Ce){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ce):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return x(L)}};De=Re([W],De),e.ProcessExecution=De;let Ae=class{constructor(L,ne,Ce){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=ne,this._options=Ce}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return x(L)}};Ae=Re([W],Ae),e.ShellExecution=Ae;var Ze;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var We;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(We=e.TaskScope||(e.TaskScope={}));class rt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=rt;let st=g=class{constructor(L,ne,Ce,$e,Ve,Xe){this.__deprecated=!1,this._definition=this.definition=L;let Je;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ce,this.execution=$e,Je=Ve,this.__deprecated=!0):ne===We.Global||ne===We.Workspace?(this.target=ne,this._name=this.name=Ce,this._source=this.source=$e,this.execution=Ve,Je=Xe):(this.target=ne,this._name=this.name=Ce,this._source=this.source=$e,this.execution=Ve,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof De?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof rt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(g.EmptyType===ne||g.ProcessType===ne||g.ShellType===ne||g.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};st.ExtensionCallbackType="customExecution",st.ProcessType="process",st.ShellType="shell",st.EmptyType="$empty",st=g=Re([W],st),e.Task=st;var Ct;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(L,ne=ft.None){this.collapsibleState=ne,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};ht=Re([W],ht),e.TreeItem=ht;var ft;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(ft=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let dt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};dt=Re([W],dt),e.DataTransferItem=dt;let Bt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,ne){this._items.set(L,ne)}forEach(L){this._items.forEach(L)}};Bt=Re([W],Bt),e.DataTransfer=Bt;let St=class{constructor(L,ne){this.id=L,this.color=ne}};St=Re([W],St),e.ThemeIcon=St,St.File=new St("file"),St.Folder=new St("folder");let zt=class{constructor(L){this.id=L}};zt=Re([W],zt),e.ThemeColor=zt;var gn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(gn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let $t=class{constructor(L,ne){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?this.baseUri=P.URI.file(L):P.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}get base(){return this._base}set base(L){this._base=L,this._baseUri=P.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};$t=Re([W],$t),e.RelativePattern=$t;let Dt=class{constructor(L,ne,Ce,$e){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Ce=="string"&&(this.hitCondition=Ce),typeof $e=="string"&&(this.logMessage=$e)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Dt=Re([W],Dt),e.Breakpoint=Dt;let Wt=class extends Dt{constructor(L,ne,Ce,$e,Ve){super(ne,Ce,$e,Ve);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};Wt=Re([W],Wt),e.SourceBreakpoint=Wt;let Ht=class extends Dt{constructor(L,ne,Ce,$e,Ve){super(ne,Ce,$e,Ve);this.functionName=L}};Ht=Re([W],Ht),e.FunctionBreakpoint=Ht;let jt=class extends Dt{constructor(L,ne,Ce,$e,Ve,Xe,Je){super($e,Ve,Xe,Je);if(!ne)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=Ce}};jt=Re([W],jt),e.DataBreakpoint=jt;let qt=class{constructor(L,ne,Ce){this.command=L,this.args=ne||[],this.options=Ce}};qt=Re([W],qt),e.DebugAdapterExecutable=qt;let Vt=class{constructor(L,ne){this.port=L,this.host=ne}};Vt=Re([W],Vt),e.DebugAdapterServer=Vt;let xt=class{constructor(L){this.path=L}};xt=Re([W],xt),e.DebugAdapterNamedPipeServer=xt;let Gt=class{constructor(L){this.implementation=L}};Gt=Re([W],Gt),e.DebugAdapterInlineImplementation=Gt;let Kt=class{constructor(L,ne){this.range=L,this.expression=ne}};Kt=Re([W],Kt),e.EvaluatableExpression=Kt;var pn;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Qt=class{constructor(L,ne){this.range=L,this.text=ne}};Qt=Re([W],Qt),e.InlineValueText=Qt;let Yt=class{constructor(L,ne,Ce=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Ce}};Yt=Re([W],Yt),e.InlineValueVariableLookup=Yt;let Xt=class{constructor(L,ne){this.range=L,this.expression=ne}};Xt=Re([W],Xt),e.InlineValueEvaluatableExpression=Xt;let Jt=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};Jt=Re([W],Jt),e.InlineValueContext=Jt;var wn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(wn=e.FileChangeType||(e.FileChangeType={}));let Zt=I=class extends Error{constructor(L,ne=A.FileSystemProviderErrorCode.Unknown,Ce){super(P.URI.isUri(L)?L.toString(!0):L);this.code=Ce?.name??"Unknown",(0,A.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(L){return new I(L,A.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(L){return new I(L,A.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(L){return new I(L,A.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(L){return new I(L,A.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(L){return new I(L,A.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(L){return new I(L,A.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}};Zt=I=Re([W],Zt),e.FileSystemError=Zt;let en=class{constructor(L,ne,Ce){this.start=L,this.end=ne,this.kind=Ce}};en=Re([W],en),e.FoldingRange=en;var yn;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var En;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(En=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var bn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(bn=e.CommentMode||(e.CommentMode={}));var Sn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(Sn=e.CommentThreadState||(e.CommentThreadState={}));class Cn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Cn;function In(M){return typeof M=="undefined"||(0,v.isStringArray)(M)}class tn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Ce=L.tokenTypes.length;ne<Ce;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Ce=L.tokenModifiers.length;ne<Ce;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Ce,$e,Ve){if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof $e=="number"&&(typeof Ve=="number"||typeof Ve=="undefined"))return typeof Ve=="undefined"&&(Ve=0),this._pushEncoded(L,ne,Ce,$e,Ve);if(H.isRange(L)&&typeof ne=="string"&&In(Ce))return this._push(L,ne,Ce);throw(0,t.illegalArgument)()}_push(L,ne,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const $e=L.start.line,Ve=L.start.character,Xe=L.end.character-L.start.character,Je=this._tokenTypeStrToInt.get(ne);let it=0;if(Ce)for(const lt of Ce){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const gt=this._tokenModifierStrToInt.get(lt);it|=1<<gt>>>0}this._pushEncoded($e,Ve,Xe,Je,it)}_pushEncoded(L,ne,Ce,$e,Ve){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const it=this._data.length/5|0;let lt=0,gt=0;for(let wt=0;wt<it;wt++){let yt=this._data[5*wt],Ft=this._data[5*wt+1];yt===0?(yt=lt,Ft+=gt):yt+=lt,this._data[5*wt]=yt,this._data[5*wt+1]=Ft,lt=yt,gt=Ft}}let Xe=L,Je=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=$e,this._data[this._dataLen++]=Ve,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const Ce=L.length/5|0;for(let Je=0;Je<Ce;Je++)ne[Je]=Je;ne.sort((Je,it)=>{const lt=L[5*Je],gt=L[5*it];if(lt===gt){const wt=L[5*Je+1],yt=L[5*it+1];return wt-yt}return lt-gt});const $e=new Uint32Array(L.length);let Ve=0,Xe=0;for(let Je=0;Je<Ce;Je++){const it=5*ne[Je],lt=L[it+0],gt=L[it+1],wt=L[it+2],yt=L[it+3],Ft=L[it+4],mn=lt-Ve,si=mn===0?gt-Xe:gt,Ot=5*Je;$e[Ot+0]=mn,$e[Ot+1]=si,$e[Ot+2]=wt,$e[Ot+3]=yt,$e[Ot+4]=Ft,Ve=lt,Xe=gt}return $e}build(L){return this._dataIsSortedAndDeltaEncoded?new nn(new Uint32Array(this._data),L):new nn(tn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=tn;class nn{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=nn;class Dn{constructor(L,ne,Ce){this.start=L,this.deleteCount=ne,this.data=Ce}}e.SemanticTokensEdit=Dn;class Pn{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=Pn;var kn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(kn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Nt=class{constructor(){}};Nt.Back={iconPath:new St("arrow-left")},Nt=Re([W],Nt),e.QuickInputButtons=Nt;var Tn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Tn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Rn;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Rn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var An;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(An=e.ExtensionKind||(e.ExtensionKind={}));class _n{constructor(L,ne,Ce){this.badge=L,this.tooltip=ne,this.color=Ce}static validate(L){if(L.badge){let ne=(0,E.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,E.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=_n;let rn=class{constructor(L){this.kind=L}};rn=Re([W],rn),e.ColorTheme=rn;var Ln;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Ln=e.ColorThemeKind||(e.ColorThemeKind={}));class Lt{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof Lt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,Ce=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Ce=L.end),ne===this._start&&Ce===this._end?this:new Lt(ne,Ce)}}e.NotebookRange=Lt;class It{constructor(L,ne,Ce,$e,Ve,Xe,Je){this.kind=L,this.value=ne,this.languageId=Ce,this.mime=$e,this.outputs=Ve??[],this.metadata=Xe,this.executionSummary=Je,It.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>It.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=It;class Fn{constructor(L){this.cells=L}}e.NotebookData=Fn;class mt{constructor(L,ne){this.data=L,this.mime=ne;const Ce=(0,T.normalizeMimeType)(ne,!0);if(!Ce)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return mt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new mt(L,ne)}static text(L,ne=T.Mimes.text){const Ce=et(mt,b,"f",f).encode(String(L));return new mt(Ce,ne)}static json(L,ne="text/x-json"){const Ce=JSON.stringify(L,void 0,"	");return mt.text(Ce,ne)}}e.NotebookCellOutputItem=mt,b=mt,f={value:new TextEncoder};class Mt{constructor(L,ne,Ce){this.items=Mt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=ne??Ce)}static isNotebookCellOutput(L){return L instanceof Mt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,v.isArray)(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Ce=new Set,$e=new Set;for(let Ve=0;Ve<L.length;Ve++){const Xe=L[Ve],Je=(0,T.normalizeMimeType)(Xe.mime);if(!Ce.has(Je)){Ce.add(Je);continue}$e.add(Ve),ne&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return $e.size===0?L:L.filter((Ve,Xe)=>!$e.has(Xe))}}e.NotebookCellOutput=Mt;var On;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(On=e.NotebookCellKind||(e.NotebookCellKind={}));var Nn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Nn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Mn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Mn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Un;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Un=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Bn{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=Bn;var zn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(zn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class $n{constructor(L,ne=[]){this.uri=L,this.provides=(0,k.asArray)(ne)}}e.NotebookRendererScript=$n;let sn=class{constructor(L,ne){this.label=L,this.timestamp=ne}};sn=Re([W],sn),e.TimelineItem=sn;var Wn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Wn=e.ExtensionMode||(e.ExtensionMode={}));var Hn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Hn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var jn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(jn=e.StandardTokenType||(e.StandardTokenType={}));class qn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=qn;class Vn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Vn;var xn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(xn=e.TestResultState||(e.TestResultState={}));var Gn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Gn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let on=class{constructor(L=void 0,ne=void 0,Ce=void 0){this.include=L,this.exclude=ne,this.profile=Ce}};on=Re([W],on),e.TestRunRequest=on;let an=_=class{constructor(L){this.message=L}static diff(L,ne,Ce){const $e=new _(L);return $e.expectedOutput=ne,$e.actualOutput=Ce,$e}};an=_=Re([W],an),e.TestMessage=an;let ln=class{constructor(L){this.id=L}};ln=Re([W],ln),e.TestTag=ln;let Pt=class{constructor(L,ne){this.covered=L,this.total=ne}};Pt=Re([W],Pt),e.CoveredCount=Pt;let cn=z=class{constructor(L,ne,Ce,$e){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Ce,this.functionCoverage=$e}static fromDetails(L,ne){const Ce=new Pt(0,0),$e=new Pt(0,0),Ve=new Pt(0,0);for(const Je of ne)if("branches"in Je){Ce.total+=1,Ce.covered+=Je.executionCount>0?1:0;for(const it of Je.branches)$e.total+=1,$e.covered+=it.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=Je.executionCount>0?1:0;const Xe=new z(L,Ce,$e.total>0?$e:void 0,Ve.total>0?Ve:void 0);return Xe.detailedCoverage=ne,Xe}};cn=z=Re([W],cn),e.FileCoverage=cn;let un=class{constructor(L,ne,Ce=[]){this.executionCount=L,this.location=ne,this.branches=Ce}};un=Re([W],un),e.StatementCoverage=un;let fn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};fn=Re([W],fn),e.BranchCoverage=fn;let hn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};hn=Re([W],hn),e.FunctionCoverage=hn;var Kn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(Kn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qn;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(Qn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yn;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xn{constructor(L,ne,Ce,$e,Ve,Xe){this.kind=L,this.name=ne,this.detail=Ce,this.uri=$e,this.range=Ve,this.selectionRange=Xe}}e.TypeHierarchyItem=Xn;class Jn{constructor(L){this.uri=L}}e.TextTabInput=Jn;class Zn{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=Zn;class ei{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=ei;class ti{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ti;class ni{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=ni;class ii{constructor(L,ne,Ce){this.original=L,this.modified=ne,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=ii;class ri{constructor(){}}e.TerminalEditorTabInput=ri}),define(we[59],ye([0,1,65]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(S){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:S,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function w(S){return new k.URITransformer(t(S))}e.createURITransformer=w}),define(we[235],ye([0,1,3,45,4,59,174,8,40,65,93,87,215,5,25,49]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class f{constructor(p,h,a,u,n,l){if(this._connectionToken=p,this._environmentService=h,this._logService=u,this._extensionHostStatusService=n,this._extensionsScannerService=l,h.args["install-builtin-extension"]){const s={isMachineScoped:!!h.args["do-not-sync"],installPreReleaseVersion:!!h.args["pre-release"]};this.whenExtensionsReady=a.installExtensions([],h.args["install-builtin-extension"],s,!!h.args.force).then(null,r=>{u.error(r)})}else this.whenExtensionsReady=Promise.resolve();const i=h.args["install-extension"];if(i){const s=i.map(r=>/\.vsix$/i.test(r)?w.URI.file((0,y.isAbsolute)(r)?r:(0,y.join)((0,d.cwd)(),r)):r);this.whenExtensionsReady.then(()=>a.installExtensions(s,[],{isMachineScoped:!!h.args["do-not-sync"],installPreReleaseVersion:!!h.args["pre-release"]},!!h.args.force)).then(null,r=>{u.error(r)})}}async call(p,h,a){switch(h){case"getEnvironmentData":{const u=a,n=(0,S.createURITransformer)(u.remoteAuthority);let l=await this._getEnvironmentData();return l=(0,P.transformOutgoingURIs)(l,n),l}case"getExtensionHostExitInfo":{const u=a;return this._extensionHostStatusService.getExitInfo(u.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const u=a,n=u.language;this._logService.trace(`Scanning extensions using UI language: ${n}`);const l=(0,S.createURITransformer)(u.remoteAuthority),i=u.extensionDevelopmentPath&&u.extensionDevelopmentPath.map(o=>w.URI.revive(l.transformIncoming(o))),s=i?i.filter(o=>o.scheme===E.Schemas.file).map(o=>o.fsPath):void 0;let r=await this._scanExtensions(n,s);return r=(0,P.transformOutgoingURIs)(r,l),this._logService.trace("Scanned Extensions",r),f._massageWhenConditions(r),r}case"scanSingleExtension":{await this.whenExtensionsReady;const u=a,n=u.language,l=u.isBuiltin,i=(0,S.createURITransformer)(u.remoteAuthority),s=w.URI.revive(i.transformIncoming(u.extensionLocation)),r=s.scheme===E.Schemas.file?s.fsPath:null;if(!r)return null;let o=await this._scanSingleExtension(r,l,n);return o?(o=(0,P.transformOutgoingURIs)(o,i),f._massageWhenConditions([o]),o):null}case"getDiagnosticInfo":{const u=a,n={machineInfo:(0,C.getMachineInfo)()},l=u.includeProcesses?(0,A.listProcesses)(process.pid):Promise.resolve();let i=[];const s={};if(u.folders){const r=(0,S.createURITransformer)("");i=u.folders.map(c=>w.URI.revive(r.transformIncoming(c))).filter(c=>c.scheme==="file").map(c=>(0,C.collectWorkspaceStats)(c.fsPath,["node_modules",".git"]).then(g=>{s[(0,y.basename)(c.fsPath)]=g}))}return Promise.all([l,...i]).then(([r,o])=>(n.processes=r||void 0,n.workspaceMetadata=u.folders?s:void 0,n))}}throw new Error(`IPC Command ${h} not found`)}listen(p,h,a){throw new Error("Not supported")}static _massageWhenConditions(p){const h=(s,r)=>s.replace(/file/g,"vscode-remote"),a=s=>{let r="";return r+=s.global?"g":"",r+=s.ignoreCase?"i":"",r+=s.multiline?"m":"",new RegExp(h(s.source,!0),r)},u=new class{mapDefined(s){return R.ContextKeyDefinedExpr.create(s)}mapNot(s){return R.ContextKeyNotExpr.create(s)}mapEquals(s,r){return s==="resourceScheme"&&typeof r=="string"?R.ContextKeyEqualsExpr.create(s,h(r,!1)):R.ContextKeyEqualsExpr.create(s,r)}mapNotEquals(s,r){return s==="resourceScheme"&&typeof r=="string"?R.ContextKeyNotEqualsExpr.create(s,h(r,!1)):R.ContextKeyNotEqualsExpr.create(s,r)}mapGreater(s,r){return R.ContextKeyGreaterExpr.create(s,r)}mapGreaterEquals(s,r){return R.ContextKeyGreaterEqualsExpr.create(s,r)}mapSmaller(s,r){return R.ContextKeySmallerExpr.create(s,r)}mapSmallerEquals(s,r){return R.ContextKeySmallerEqualsExpr.create(s,r)}mapRegex(s,r){return s==="resourceScheme"&&r?R.ContextKeyRegexExpr.create(s,a(r)):R.ContextKeyRegexExpr.create(s,r)}mapIn(s,r){return R.ContextKeyInExpr.create(s,r)}},n=s=>{if(!s||!s.when||!/resourceScheme/.test(s.when))return;const r=R.ContextKeyExpr.deserialize(s.when);if(!r)return;const o=r.map(u);s.when=o.serialize()},l=s=>{if(Array.isArray(s))for(let r of s)n(r);else n(s)},i=s=>{for(let r in s)l(s[r])};p.forEach(s=>{s.contributes&&(s.contributes.menus&&i(s.contributes.menus),s.contributes.keybindings&&l(s.contributes.keybindings),s.contributes.views&&i(s.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:w.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:w.URI.file(this._environmentService.logsPath),extensionsPath:w.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:w.URI.file((0,y.join)(this._environmentService.logsPath,`exthost${f._namePool++}`)),globalStorageHome:this._environmentService.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:k.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(p,h){const[a,u,n]=await Promise.all([this._scanBuiltinExtensions(p),this._scanInstalledExtensions(p),this._scanDevelopedExtensions(p,h)]);let l=new Map;a.forEach(s=>{!s||l.set(v.ExtensionIdentifier.toKey(s.identifier),s)}),u.forEach(s=>{!s||(l.has(v.ExtensionIdentifier.toKey(s.identifier))&&console.warn(T.localize(0,null,l.get(v.ExtensionIdentifier.toKey(s.identifier)).extensionLocation.fsPath,s.extensionLocation.fsPath)),l.set(v.ExtensionIdentifier.toKey(s.identifier),s))}),n.forEach(s=>{!s||l.set(v.ExtensionIdentifier.toKey(s.identifier),s)});const i=[];return l.forEach(s=>i.push(s)),i}async _scanDevelopedExtensions(p,h){return h?(await Promise.all(h.map(a=>this._extensionsScannerService.scanOneOrMultipleExtensions(w.URI.file((0,y.resolve)(a)),1,{language:p})))).flat().map(a=>(0,b.toExtensionDescription)(a,!0)):[]}async _scanBuiltinExtensions(p){return(await this._extensionsScannerService.scanSystemExtensions({language:p,useCache:!0})).map(a=>(0,b.toExtensionDescription)(a,!1))}async _scanInstalledExtensions(p){return(await this._extensionsScannerService.scanUserExtensions({language:p,useCache:!0})).map(a=>(0,b.toExtensionDescription)(a,!1))}async _scanSingleExtension(p,h,a){const u=w.URI.file((0,y.resolve)(p)),n=h?0:1,l=await this._extensionsScannerService.scanExistingExtension(u,n,{language:a});return l?(0,b.toExtensionDescription)(l,!1):null}}e.RemoteAgentEnvironmentChannel=f,f._namePool=1}),define(we[236],ye([0,1,4,59,58,5,200]),function(te,e,k,t,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class E extends T.AbstractDiskFileSystemProviderChannel{constructor(R,A){super(new w.DiskFileSystemProvider(R),R);this.environmentService=A,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(R){let A=this.uriTransformerCache.get(R.remoteAuthority);return A||(A=(0,t.createURITransformer)(R.remoteAuthority),this.uriTransformerCache.set(R.remoteAuthority,A)),A}transformIncoming(R,A,C=!1){if(C&&A.path==="/vscode-resource"&&A.query){const y=JSON.parse(A.query).requestResourcePath;return k.URI.from({scheme:"file",path:y})}return k.URI.revive(R.transformIncoming(A))}createSessionFileWatcher(R,A){return new v(R,A,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=E;class v extends T.AbstractSessionFileWatcher{constructor(R,A,C,y){super(R,A,C,y)}getRecursiveWatcherOptions(R){const A=R.args["file-watcher-polling"];if(A){const C=A.split(S.delimiter),y=Number(C[0]);if(y>0)return{usePolling:C.length>1?C.slice(1):!0,pollingInterval:y}}}getExtraExcludes(R){if(R.extensionsPath)return[S.posix.join(R.extensionsPath,"**")]}}}),define(we[112],ye([0,1,176,12,4,2,6,34,17,18,8]),function(te,e,k,t,w,S,T,E,v,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function y(K){const j=K;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=y;function d(K,j,O){for(const B of O.visibleEditorPanes)if(B.group.id===j&&K.matches(B.input))return B.getViewState()}e.findViewStateForEditor=d;function b(K){if(i(K))return!1;const j=K;return w.URI.isUri(j?.resource)}e.isResourceEditorInput=b;function f(K){if(i(K))return!1;const j=K;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=f;function m(K){if(i(K)||f(K))return!1;const j=K;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function p(K){if(i(K))return!1;const j=K;return j?j.resource===void 0||j.resource.scheme===R.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var h;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var a;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(j,O){let B=this.mapIdToSaveSource.get(j);return B||(B={source:j,label:O},this.mapIdToSaveSource.set(j,B)),B.source}getSourceLabel(j){return this.mapIdToSaveSource.get(j)?.label??j}}e.SaveSourceRegistry=new u;var n;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends S.Disposable{}e.AbstractEditorInput=l;function i(K){return K instanceof l}e.isEditorInput=i;function s(K){const j=K;return w.URI.isUri(j?.preferredResource)}function r(K){const j=K;return i(j?.primary)&&i(j?.secondary)}e.isSideBySideEditorInput=r;function o(K){const j=K;return i(j?.modified)&&i(j?.original)}e.isDiffEditorInput=o;function c(K){return i(K?.editor)}e.isEditorInputWithOptions=c;function g(K){const j=K;return c(K)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function I(K){const j=K;return typeof j?.groupId=="number"&&i(j.editor)}e.isEditorIdentifier=I;var _;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(_=e.EditorCloseContext||(e.EditorCloseContext={}));var z;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var W;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(W=e.SideBySideEditor||(e.SideBySideEditor={}));class ee{getOriginalUri(j,O){if(!j)return;if(O?.supportSideBySide){const{primary:V,secondary:J}=this.getSideEditors(j);if(V&&J){if(O?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===W.ANY)return this.getOriginalUri(V,{filterByScheme:O.filterByScheme})??this.getOriginalUri(J,{filterByScheme:O.filterByScheme});j=O.supportSideBySide===W.PRIMARY?V:J}}if(f(j)||m(j))return;const B=s(j)?j.preferredResource:j.resource;return!B||!O||!O.filterByScheme?B:this.filterUri(B,O.filterByScheme)}getSideEditors(j){return r(j)||m(j)?{primary:j.primary,secondary:j.secondary}:o(j)||f(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,O){if(!j)return;if(O?.supportSideBySide){const{primary:V,secondary:J}=this.getSideEditors(j);if(V&&J){if(O?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===W.ANY)return this.getCanonicalUri(V,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:O.filterByScheme});j=O.supportSideBySide===W.PRIMARY?V:J}}if(f(j)||m(j))return;const B=j.resource;return!B||!O||!O.filterByScheme?B:this.filterUri(B,O.filterByScheme)}filterUri(j,O){if(Array.isArray(O)){if(O.some(B=>j.scheme===B))return j}else if(O===j.scheme)return j}}e.EditorResourceAccessor=new ee;var D;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(D=e.CloseDirection||(e.CloseDirection={}));class H{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(j){const O=this.instantiationService=j.get(T.IInstantiationService);for(const[B,V]of this.editorSerializerConstructors)this.createEditorSerializer(B,V,O);this.editorSerializerConstructors.clear()}createEditorSerializer(j,O,B){const V=B.createInstance(O);this.editorSerializerInstances.set(j,V)}registerFileEditorFactory(j){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=j}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(j,O){if(this.editorSerializerConstructors.has(j)||this.editorSerializerInstances.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.instantiationService?this.createEditorSerializer(j,O,this.instantiationService):this.editorSerializerConstructors.set(j,O),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(j),this.editorSerializerInstances.delete(j)})}getEditorSerializer(j){return this.editorSerializerInstances.get(typeof j=="string"?j:j.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new H);async function F(K,j){if(!K||!K.length)return[];const O=await Promise.all(K.map(async B=>{const V=w.URI.revive(B.fileUri);if(!V||!await j.canHandleResource(V))return;let se=B.exists,me=B.type;if(typeof se!="boolean"||typeof me!="number")try{me=(await j.stat(V)).isDirectory?v.FileType.Directory:v.FileType.Unknown,se=!0}catch{se=!1}if(!se&&B.openOnlyIfExists||me===v.FileType.Directory)return;const he={...B.options,pinned:!0};let U;return se?U={resource:V,options:he}:U={resource:V,options:he,forceUntitled:!0},U}));return(0,P.coalesce)(O)}e.pathsToEditors=F;var $;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function oe(K){const j=K;if(!j)return!1;const O=j;if(O.modified)return oe(O.modified);const B=j;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.isTextEditorViewState=oe}),define(we[237],ye([0,1,64,52,62,8,5,3,93]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var A;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(A=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var m;(function(r){r.scheme=S.Schemas.vscodeNotebookCell;const o=/^ch(\d{7,})/;function c(ee,D){return ee.with({scheme:r.scheme,fragment:`ch${D.toString().padStart(7,"0")}${ee.scheme!==S.Schemas.file?ee.scheme:""}`})}r.generate=c;function g(ee){if(ee.scheme!==r.scheme)return;const D=o.exec(ee.fragment);return D?{handle:Number(D[1]),notebook:ee.with({scheme:ee.fragment.substring(D[0].length)||S.Schemas.file,fragment:null})}:void 0}r.parse=g;function I(ee,D){return ee.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${D??""},${ee.scheme!==S.Schemas.file?ee.scheme:""}`})}r.generateCellOutputUri=I;function _(ee){if(ee.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const D=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!D)return;const H=D[1]&&D[1]!==""?D[1]:void 0,F=D[2];return{outputId:H,notebook:ee.with({scheme:F||S.Schemas.file,fragment:null})}}r.parseCellOutputUri=_;function z(ee,D,H){return ee.with({scheme:H,fragment:`ch${D.toString().padStart(7,"0")}${ee.scheme!==S.Schemas.file?ee.scheme:""}`})}r.generateCellUri=z;function W(ee,D){if(ee.scheme!==D)return;const H=o.exec(ee.fragment);return H?{handle:Number(H[1]),notebook:ee.with({scheme:ee.fragment.substring(H[0].length)||S.Schemas.file,fragment:null})}:void 0}r.parseCellUri=W})(m=e.CellUri||(e.CellUri={}));const p=r=>E.isWindows?r.replace(/\//g,"\\"):r;class h{constructor(o=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(o)].map(g=>({pattern:g,matches:k.parse(p(g))}))}sort(o){const c=new Map(t.Iterable.map(o,I=>[I,p(I)]));let g=[];for(const{matches:I}of this.order)for(const[_,z]of c)if(I(z)){g.push(_),c.delete(_);break}return c.size&&(g=g.concat([...c.keys()].sort((I,_)=>this.defaultOrder.indexOf(I)-this.defaultOrder.indexOf(_)))),g}prioritize(o,c){const g=this.findIndex(o);if(g===-1){this.order.unshift({pattern:o,matches:k.parse(p(o))});return}const I=new Set(c.map(z=>this.findIndex(z,g)));I.delete(-1);const _=Array.from(I).sort();this.order.splice(g+1,0,..._.map(z=>this.order[z]));for(let z=_.length-1;z>=0;z--)this.order.splice(_[z],1)}toArray(){return this.order.map(o=>o.pattern)}findIndex(o,c=this.order.length){const g=p(o);for(let I=0;I<c;I++)if(this.order[I].matches(g))return I;return-1}}e.MimeTypeDisplayOrder=h;function a(r,o,c,g=(I,_)=>I===_){const I=[];function _(ee,D,H){if(D===0&&H.length===0)return;const F=I[I.length-1];F&&F.start+F.deleteCount===ee?(F.deleteCount+=D,F.toInsert.push(...H)):I.push({start:ee,deleteCount:D,toInsert:H})}let z=0,W=0;for(;;){if(z===r.length){_(z,0,o.slice(W));break}if(W===o.length){_(z,r.length-z,[]);break}const ee=r[z],D=o[W];if(g(ee,D)){z+=1,W+=1;continue}c(D)?(_(z,1,[]),z+=1):(_(z,0,[D]),W+=1)}return I}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(r){r.default="default",r.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(r){const o=r;return!!((typeof o.include=="string"||k.isRelativePattern(o.include))&&(typeof o.exclude=="string"||k.isRelativePattern(o.exclude)))}e.isDocumentExcludePattern=n;function l(r,o,c){if(Array.isArray(r.viewType)&&r.viewType.indexOf(o)>=0||r.viewType===o)return!0;if(r.filenamePattern){const g=n(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,I=n(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(k.match(g,(0,T.basename)(c.fsPath).toLowerCase()))return!(I&&k.match(I,(0,T.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(o){return`${s._prefix}${o}`}static parse(o){if(o.startsWith(s._prefix))return o.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(we[113],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,k.createDecorator)("environmentVariableService");var t;(function(w){w[w.Replace=1]="Replace",w[w.Append=2]="Append",w[w.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[238],ye([0,1,3,113]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class w{constructor(v){this.map=new Map,v.forEach((P,R)=>{const A=P.map.entries();let C=A.next();for(;!C.done;){const y=C.value[0];let d=this.map.get(y);if(d||(d=[],this.map.set(y,d)),d.length>0&&d[0].type===t.EnvironmentVariableMutatorType.Replace){C=A.next();continue}const b=C.value[1];d.unshift({extensionIdentifier:R,value:b.value,type:b.type}),C=A.next()}})}async applyToProcessEnvironment(v,P){let R;k.isWindows&&(R={},Object.keys(v).forEach(A=>R[A.toLowerCase()]=A));for(const[A,C]of this.map){const y=k.isWindows&&R[A.toLowerCase()]||A;for(const d of C){const b=P?await P(d.value):d.value;switch(d.type){case t.EnvironmentVariableMutatorType.Append:v[y]=(v[y]||"")+b;break;case t.EnvironmentVariableMutatorType.Prepend:v[y]=b+(v[y]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[y]=b;break}}}}diff(v){const P=new Map,R=new Map,A=new Map;if(v.map.forEach((C,y)=>{const d=this.map.get(y),b=S(C,d);b&&P.set(y,b)}),this.map.forEach((C,y)=>{const d=v.map.get(y),b=S(C,d);b&&A.set(y,b)}),this.map.forEach((C,y)=>{const d=v.map.get(y),b=T(C,d);b&&R.set(y,b)}),!(P.size===0&&R.size===0&&A.size===0))return{added:P,changed:R,removed:A}}}e.MergedEnvironmentVariableCollection=w;function S(E,v){if(!v)return E;const P=new Set;v.forEach(A=>P.add(A.extensionIdentifier));const R=[];return E.forEach(A=>{P.has(A.extensionIdentifier)||R.push(A)}),R.length===0?void 0:R}function T(E,v){if(!v)return;const P=new Map;v.forEach(A=>P.set(A.extensionIdentifier,A));const R=[];return E.forEach(A=>{const C=P.get(A.extensionIdentifier);C&&(A.type!==C.type||A.value!==C.value)&&R.push(C)}),R.length===0?void 0:R}}),define(we[114],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function k(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=k;function t(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=t}),define(we[239],ye([0,1,5,53,3]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function S(a,u){if(!!u)if(w.isWindows)for(const n in u){let l=n;for(const s in a)if(n.toLowerCase()===s.toLowerCase()){l=s;break}const i=u[n];i!==void 0&&T(a,l,i)}else Object.keys(u).forEach(n=>{const l=u[n];l!==void 0&&T(a,n,l)})}e.mergeEnvironments=S;function T(a,u,n){typeof n=="string"?a[u]=n:delete a[u]}function E(a,u,n,l){a.TERM_PROGRAM="vscode",u&&(a.TERM_PROGRAM_VERSION=u),R(a,l)&&(a.LANG=A(n)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function v(a,u){if(!!u)for(const n of Object.keys(u)){const l=u[n];l&&(a[n]=l)}}async function P(a,u){return await Promise.all(Object.entries(u).map(async([n,l])=>{if(typeof l=="string")try{u[n]=await a(l)}catch{u[n]=l}})),u}function R(a,u){if(u==="on")return!0;if(u==="auto"){const n=a.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function A(a){const u=a?a.split("-"):[],n=u.length;if(n===0)return"en_US.UTF-8";if(n===1){const l={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};u[0]in l&&u.push(l[u[0]])}else u[1]=u[1].toUpperCase();return u.join("_")+".UTF-8"}e.getLangEnvVariable=A;async function C(a,u,n,l,i,s){if(a.cwd){const o=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,c=await y(o,n);return d(c||o)}let r;return!a.ignoreConfigurationCwd&&i&&(n&&(i=await y(i,n,s)),i&&(k.isAbsolute(i)?r=i:l&&(r=k.join(l.fsPath,i)))),r||(r=l?l.fsPath:u||""),d(r)}e.getCwd=C;async function y(a,u,n){if(u)try{return await u(a)}catch(l){n?.error("Could not resolve terminal cwd",l);return}return a}function d(a){return w.OS===1&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function b(a,u,n){if(!!n)return l=>n.resolveWithEnvironment(u,a,l)}e.createVariableResolver=b;async function f(a,u,n,l,i,s,r,o=w.platform){let c;r&&(c=p(a,"automationShell",o)),c||(c=p(a,"shell",o));let g=c||u;if(o===3&&!n&&l){const I=k.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();g&&g.toLowerCase().indexOf(I)===0&&(g=k.join(l,"System32",g.substr(I.length+1)))}if(g&&o===3&&(g=g.replace(/\//g,"\\")),i)try{g=await i(g)}catch(I){s.error("Could not resolve shell",I)}return g}e.getDefaultShell=f;async function m(a,u,n,l,i=w.platform){if(u&&p(a,"automationShell",i))return[];const s=i===3?"windows":i===1?"osx":"linux";let r=a(`terminal.integrated.shellArgs.${s}`);if(!r)return[];if(typeof r=="string"&&i===3)return n?await n(r):r;if(n){const o=[];for(const c of r)try{o.push(await n(c))}catch(g){l.error(`Could not resolve terminal.integrated.shellArgs.${s}`,g),o.push(c)}r=o}return r}e.getDefaultShellArgs=m;function p(a,u,n=w.platform){return a(`terminal.integrated.${u}.${n===3?"windows":n===1?"osx":"linux"}`)}async function h(a,u,n,l,i,s){const r={};if(a.strictEnv)v(r,a.env);else{v(r,s);const o={...u};n&&(o&&await P(n,o),a.env&&await P(n,a.env)),(0,t.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI"),S(r,o),S(r,a.env),E(r,l,w.locale,i)}return r}e.createTerminalEnvironment=h}),define(we[74],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(S){S.Delimiter="\0"})(k=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class w{constructor(T,E=T.length){if(this.path=T,this.viewEnd=E,T.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,E,v=T.parent){if(T.id===E)return new w([E]);let P=[T.id];for(let R=v;R&&R.id!==E;R=R.parent)P.push(R.id);return P.push(E),new w(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const E=T.indexOf("\0");return E===-1?T:T.slice(0,E)}static fromString(T){return new w(T.split("\0"))}static join(T,E){return new w([...T.path,E])}static joinToString(T,E){return T.toString()+"\0"+E}static compare(T,E){return T===E?0:E.startsWith(T+"\0")?2:T.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new w(this.path,T)}compare(T){if(typeof T=="string")return w.compare(this.toString(),T);for(let E=0;E<T.viewEnd&&E<this.viewEnd;E++)if(T.path[E]!==this.path[E])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=w}),define(we[75],ye([0,1,4,46]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var S;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(r){r.serialize=o=>({range:o.range.toJSON(),uri:o.uri.toJSON()}),r.deserialize=o=>({range:t.Range.lift(o.range),uri:k.URI.revive(o.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var E;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,location:o.location&&T.serialize(o.location)}),r.deserialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,location:o.location&&T.deserialize(o.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=o=>({message:o.message,type:1,offset:o.offset,location:o.location&&T.serialize(o.location)}),r.deserialize=o=>({message:o.message,type:1,offset:o.offset,location:o.location&&T.deserialize(o.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=o=>o.type===0?v.serialize(o):P.serialize(o),r.deserialize=o=>o.type===0?v.deserialize(o):P.deserialize(o)})(R=e.ITestMessage||(e.ITestMessage={}));var A;(function(r){r.serialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(R.serialize)}),r.deserialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(R.deserialize)})})(A=e.ITestTaskState||(e.ITestTaskState={}));const C="\0",y=(r,o)=>r+C+o;e.namespaceTestTag=y;const d=r=>{const o=r.indexOf(C);return{ctrlId:r.slice(0,o),tagId:r.slice(o+1)}};e.denamespaceTestTag=d;var b;(function(r){r.serialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?.toJSON(),range:o.range?.toJSON()||null,description:o.description,error:o.error,sortText:o.sortText}),r.deserialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?k.URI.revive(o.uri):void 0,range:o.range?t.Range.lift(o.range):null,description:o.description,error:o.error,sortText:o.sortText})})(b=e.ITestItem||(e.ITestItem={}));var f;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(r){r.serialize=o=>({controllerId:o.controllerId,expand:o.expand,parent:o.parent,item:b.serialize(o.item)}),r.deserialize=o=>({controllerId:o.controllerId,expand:o.expand,parent:o.parent,item:b.deserialize(o.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=o=>{let c;return o.item&&(c={},o.item.label!==void 0&&(c.label=o.item.label),o.item.tags!==void 0&&(c.tags=o.item.tags),o.item.busy!==void 0&&(c.busy=o.item.busy),o.item.uri!==void 0&&(c.uri=o.item.uri?.toJSON()),o.item.range!==void 0&&(c.range=o.item.range?.toJSON()),o.item.description!==void 0&&(c.description=o.item.description),o.item.error!==void 0&&(c.error=o.item.error),o.item.sortText!==void 0&&(c.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:c}},r.deserialize=o=>{let c;return o.item&&(c={},o.item.label!==void 0&&(c.label=o.item.label),o.item.tags!==void 0&&(c.tags=o.item.tags),o.item.busy!==void 0&&(c.busy=o.item.busy),o.item.range!==void 0&&(c.range=o.item.range?t.Range.lift(o.item.range):null),o.item.description!==void 0&&(c.description=o.item.description),o.item.error!==void 0&&(c.error=o.item.error),o.item.sortText!==void 0&&(c.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:c}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(r,o)=>{o.expand!==void 0&&(r.expand=o.expand),o.item!==void 0&&(r.item=r.item?Object.assign(r.item,o.item):o.item)};e.applyTestItemUpdate=h;var a;(function(r){r.serialize=(o,c)=>({...m.serialize(o),children:c,ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(A.serialize)})})(a=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=o=>o.op===0?{op:o.op,item:m.deserialize(o.item)}:o.op===1?{op:o.op,item:p.deserialize(o.item)}:o,r.serialize=o=>o.op===0?{op:o.op,item:m.serialize(o.item)}:o.op===1?{op:o.op,item:p.serialize(o.item)}:o})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(o){}update(o){}remove(o,c){}complete(){}}e.IncrementalChangeCollector=i;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(o){const c=this.createChangeCollector();for(const g of o)switch(g.op){case 0:{const I=m.deserialize(g.item);if(I.parent){if(this.items.has(I.parent)){const _=this.items.get(I.parent);_.children.add(I.item.extId);const z=this.createItem(I,_);this.items.set(I.item.extId,z),c.add(z)}}else{const _=this.createItem(I);this.roots.add(_),this.items.set(I.item.extId,_),c.add(_)}I.expand===2&&this.busyControllerCount++;break}case 1:{const I=p.deserialize(g.item),_=this.items.get(I.extId);if(!_)break;I.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,I.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,I),c.update(_);break}case 2:{const I=this.items.get(g.itemId);if(!I)break;I.parent?this.items.get(I.parent).children.delete(I.item.extId):this.roots.delete(I);const _=[[g.itemId]];for(;_.length;)for(const z of _.pop()){const W=this.items.get(z);W&&(_.push(W.children),this.items.delete(z),c.remove(W,W!==I),W.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}c.complete()}retireTest(o){}updatePendingRoots(o){this.pendingRootCount+=o}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=s}),define(we[115],ye([0,1,14,7,2,12,75,74]),function(te,e,k,t,w,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk"})(v=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(m,p)=>m===p,R={range:(m,p)=>m===p?!0:!m||!p?!1:m.equalsRange(p),busy:P,label:P,description:P,error:P,tags:(m,p)=>!(m.length!==p.length||m.some(h=>!p.includes(h)))},A=(m,p)=>{let h;for(const[a,u]of Object.entries(R))u(m[a],p[a])||(h?h[a]=p[a]:h={[a]:p[a]});return h};class C extends w.Disposable{constructor(p){super();this.options=p,this.debounceSendDiff=this._register(new k.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(p){this._resolveHandler=p;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const h=this.diff[this.diff.length-1];if(h&&p.op===1){if(h.op===1&&h.item.extId===p.item.extId){(0,T.applyTestItemUpdate)(h.item,p.item);return}if(h.op===0&&h.item.item.extId===p.item.extId){(0,T.applyTestItemUpdate)(h.item,p.item);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,h){const a=this.tree.get(p);if(!!a){if((a.expandLevels===void 0||h>a.expandLevels)&&(a.expandLevels=h),a.expand===1){const u=this.resolveChildren(a);return u.isOpen()?this.expandChildren(a,h-1):u.wait().then(()=>this.expandChildren(a,h-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,h-1)):this.expandChildren(a,h-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,h){switch(h.op){case 3:this.removeItem(E.TestId.joinToString(p.fullId,h.id));break;case 0:this.upsertItem(h.item,p);break;case 5:for(const a of h.ops)this.onTestItemEvent(p,a);break;case 1:this.diffTagRefs(h.new,h.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:h.update}});break;default:(0,S.assertNever)(h)}}upsertItem(p,h){const a=E.TestId.fromExtHostTestItem(p,this.root.id,h?.actual),u=this.options.getApiFor(p);u.parent&&u.parent!==h?.actual&&this.options.getChildren(u.parent).delete(p.id);let n=this.tree.get(a.toString());if(!n){n={fullId:a,actual:p,parent:h?a.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(p,h),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,n,h);return}if(n.actual===p){this.connectItem(p,n,h);return}const l=this.options.getChildren(n.actual),i=n.actual,s=A(this.options.toITestItem(i),this.options.toITestItem(p));this.options.getApiFor(i).listener=void 0,n.actual=p,n.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,i.tags,a.toString()),delete s.tags),this.onTestItemEvent(n,{op:4,update:s})),this.connectItemAndChildren(p,n,h);for(const r of l)this.options.getChildren(p).get(r.id)||this.removeItem(E.TestId.joinToString(a,r.id))}diffTagRefs(p,h,a){const u=new Set(h.map(n=>n.id));for(const n of p)u.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:a,item:{tags:p.map(n=>(0,T.namespaceTestTag)(this.options.controllerId,n.id))}}}),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const h=this.tags.get(p.id);h?h.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const h=this.tags.get(p);h&&!--h.refCount&&(this.tags.delete(p),this.pushDiff({op:6,id:(0,T.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,h){this.options.getApiFor(p).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(p,h,a){this.setItemParent(p,a);const u=this.options.getApiFor(p);u.parent=a?.actual,u.listener=n=>this.onTestItemEvent(h,n),this.updateExpandability(h)}connectItemAndChildren(p,h,a){this.connectItem(p,h,a);for(const u of this.options.getChildren(p))this.upsertItem(u,h)}updateExpandability(p){let h;this._resolveHandler?p.resolveBarrier?h=p.resolveBarrier.isOpen()?3:2:h=p.actual.canResolveChildren?1:0:h=0,h!==p.expand&&(p.expand=h,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:h}}),h===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,h){if(h<0)return;const a=[];for(const u of this.options.getChildren(p.actual)){const n=this.expand(E.TestId.joinToString(p.fullId,u.id),h);(0,k.isThenable)(n)&&a.push(n)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const n=new k.Barrier;return n.open(),n}p.expand=2,this.pushExpandStateUpdate(p);const h=p.resolveBarrier=new k.Barrier,a=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let u;try{u=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(n){a(n)}return(0,k.isThenable)(u)?u.catch(a).then(()=>{h.open(),this.updateExpandability(p)}):(h.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const h=this.tree.get(p);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:p});const a=[h];for(;a.length;){const u=a.pop();if(!!u){this.options.getApiFor(u.actual).listener=void 0;for(const n of u.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(u.fullId.toString());for(const n of this.options.getChildren(u.actual))a.push(this.tree.get(E.TestId.joinToString(u.fullId,n.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=C;class y extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=y;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class b extends Error{constructor(p,h,a){super(`TestItem with ID "${p}" is from controller "${h}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=b;const f=(m,p,h)=>{let a=new Map;return{get size(){return a.size},forEach(u,n){for(const l of a.values())u.call(n,l,this)},replace(u){const n=new Map,l=new Set(a.keys()),i={op:5,ops:[]};for(const s of u){if(!(s instanceof h))throw new d(s.id);const r=p(s).controllerId;if(r!==m.controllerId)throw new b(s.id,r,m.controllerId);if(n.has(s.id))throw new y(s.id);n.set(s.id,s),l.delete(s.id),i.ops.push({op:0,item:s})}for(const s of l.keys())i.ops.push({op:3,id:s});m.listener?.(i),a=n},add(u){if(!(u instanceof h))throw new d(u.id);a.set(u.id,u),m.listener?.({op:0,item:u})},delete(u){a.delete(u)&&m.listener?.({op:3,id:u})},get(u){return a.get(u)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};e.createTestItemChildren=f}),define(we[116],ye([0,1,115]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,w=(T,E)=>{const v={controllerId:E};return t.set(T,v),v};e.createPrivateApiFor=w;const S=T=>{const E=t.get(T);if(!E)throw new k.InvalidTestItemError(T?.id||"<unknown>");return E};e.getPrivateApiFor=S}),define(we[240],ye([0,1,28,6]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(k.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[241],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,k.createDecorator)("configurationResolverService")}),define(we[242],ye([0,1,5,25,12,22,3,82,177,15]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(C,y,d,b){this._contributedVariables=new Map,this._context=C,this._labelService=y,this._userHomePromise=d,b&&(this._envVariablesPromise=b.then(f=>this.prepareEnv(f)))}prepareEnv(C){if(T.isWindows){const y=Object.create(null);return Object.keys(C).forEach(d=>{y[d.toLowerCase()]=C[d]}),y}return C}resolveWithEnvironment(C,y,d){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},y?y.uri:void 0,d)}async resolveAsync(C,y){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,C?C.uri:void 0,y)}async resolveAnyBase(C,y,d,b){const f=S.deepClone(y);T.isWindows&&f.windows?Object.keys(f.windows).forEach(p=>f[p]=f.windows[p]):T.isMacintosh&&f.osx?Object.keys(f.osx).forEach(p=>f[p]=f.osx[p]):T.isLinux&&f.linux&&Object.keys(f.linux).forEach(p=>f[p]=f.linux[p]),delete f.windows,delete f.osx,delete f.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,C?C.uri:void 0,f,d,b)}async resolveAnyAsync(C,y,d){return this.resolveAnyBase(C,y,d)}async resolveAnyMap(C,y,d){const b=new Map;return{newConfig:await this.resolveAnyBase(C,y,d,b),resolvedVariables:b}}resolveWithInteractionReplace(C,y,d,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,y,d,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,y){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,y)}async recursiveResolve(C,y,d,b,f){if(w.isString(d))return this.resolveString(C,y,d,b,f);if(w.isArray(d))return Promise.all(d.map(m=>this.recursiveResolve(C,y,m,b,f)));if(w.isObject(d)){let m=Object.create(null);const p=await Promise.all(Object.keys(d).map(async h=>[await this.resolveString(C,y,h,b,f),await this.recursiveResolve(C,y,d[h],b,f)]));for(const[h,a]of p)m[h]=a;return m}return d}resolveString(C,y,d,b,f){return(0,P.replaceAsync)(d,R.VARIABLE_REGEXP,async(m,p)=>{if(p.includes(R.VARIABLE_LHS))return m;let h=await this.evaluateSingleVariable(C,m,p,y,b);return f&&f.set(p,h),h!==m&&w.isString(h)&&h.match(R.VARIABLE_REGEXP)&&(h=await this.resolveString(C,y,h,b,f)),h})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,y,d,b,f){let m;const p=d.split(":");p.length>1&&(d=p[0],m=p[1]);const h=()=>{const n=this._context.getFilePath();if(n)return n;throw new Error((0,v.localize)(0,null,y))},a=()=>{const n=h();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,v.localize)(1,null,y,k.basename(n)))},u=()=>{if(m){const n=this._context.getFolderUri(m);if(n)return n;throw new Error((0,v.localize)(2,null,y,m))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,y)):new Error((0,v.localize)(4,null,y))};switch(d){case"env":if(m){if(C.env){const n=C.env[T.isWindows?m.toLowerCase():m];if(w.isString(n))return n}return""}throw new Error((0,v.localize)(5,null,y));case"config":if(m){const n=this._context.getConfigurationValue(b,m);if(w.isUndefinedOrNull(n))throw new Error((0,v.localize)(6,null,y,m));if(w.isObject(n))throw new Error((0,v.localize)(7,null,y,m));return n}throw new Error((0,v.localize)(8,null,y));case"command":return this.resolveFromMap(y,m,f,"command");case"input":return this.resolveFromMap(y,m,f,"input");case"extensionInstallFolder":if(m){const n=await this._context.getExtension(m);if(!n)throw new Error((0,v.localize)(9,null,y,m));return this.fsPath(n.extensionLocation)}throw new Error((0,v.localize)(10,null,y));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return b||m?(0,E.normalizeDriveLetter)(this.fsPath(u())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return k.basename(this.fsPath(u()));case"userHome":{if(C.userHome)return C.userHome;throw new Error((0,v.localize)(11,null,y))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new Error((0,v.localize)(12,null,y))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new Error((0,v.localize)(13,null,y))}case"file":return h();case"fileWorkspaceFolder":return a();case"relativeFile":return b||m?k.relative(this.fsPath(u()),h()):h();case"relativeFileDirname":{const n=k.dirname(h());if(b||m){const l=k.relative(this.fsPath(u()),n);return l.length===0?".":l}return n}case"fileDirname":return k.dirname(h());case"fileExtname":return k.extname(h());case"fileBasename":return k.basename(h());case"fileBasenameNoExtension":{const n=k.basename(h());return n.slice(0,n.length-k.extname(n).length)}case"fileDirnameBasename":return k.basename(k.dirname(h()));case"execPath":{const n=this._context.getExecPath();return n||y}case"execInstallFolder":{const n=this._context.getAppRoot();return n||y}case"pathSeparator":return k.sep;default:try{const n=m?`${d}:${m}`:d;return this.resolveFromMap(y,n,f,void 0)}catch{return y}}}}resolveFromMap(C,y,d,b){if(y&&d){const f=b===void 0?d[y]:d[b+":"+y];if(typeof f=="string")return f;throw new Error((0,v.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[243],ye([0,1,6,112]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,k.createDecorator)("editorGroupsService");var w;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var S;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var E;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function P(d){const b=d;return(0,t.isEditorInput)(b?.editor)&&(0,t.isEditorInput)(b?.replacement)}e.isEditorReplacement=P;var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function C(d){const b=d;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=C;function y(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(we[117],ye([0,1,6,243]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,k.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(S){const T=S;return typeof S=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=w}),define(we[118],ye([0,1,18,16,81,29,129,44,22,12,4,46,144,180,201,116,237,74,75,117,111]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Se){function Ie(x){const{selectionStartLineNumber:De,selectionStartColumn:Ae,positionLineNumber:Ze,positionColumn:We}=x,rt=new a.Position(De-1,Ae-1),st=new a.Position(Ze-1,We-1);return new a.Selection(rt,st)}Se.to=Ie;function ce(x){const{anchor:De,active:Ae}=x;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}Se.from=ce})(u=e.Selection||(e.Selection={}));var n;(function(Se){function Ie(x){if(!x)return;const{start:De,end:Ae}=x;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}Se.from=Ie;function ce(x){if(!x)return;const{startLineNumber:De,startColumn:Ae,endLineNumber:Ze,endColumn:We}=x;return new a.Range(De-1,Ae-1,Ze-1,We-1)}Se.to=ce})(n=e.Range||(e.Range={}));var l;(function(Se){function Ie(ce){switch(ce){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Se.to=Ie})(l=e.TokenType||(e.TokenType={}));var i;(function(Se){function Ie(x){return new a.Position(x.lineNumber-1,x.column-1)}Se.to=Ie;function ce(x){return{lineNumber:x.line+1,column:x.character+1}}Se.from=ce})(i=e.Position||(e.Position={}));var s;(function(Se){function Ie(De,Ae){return(0,k.coalesce)((0,k.asArray)(De).map(Ze=>ce(Ze,Ae)))}Se.from=Ie;function ce(De,Ae){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:x(De.scheme,Ae),pattern:be.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function x(De,Ae){return Ae&&typeof De=="string"?Ae.transformOutgoingScheme(De):De}})(s=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Se){function Ie(x){switch(x){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function ce(x){switch(x){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Se.to=ce})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function Ie(x){let De;return x.code&&((0,P.isString)(x.code)||(0,P.isNumber)(x.code)?De=String(x.code):De={value:String(x.code.value),target:x.code.target}),{...n.from(x.range),message:x.message,source:x.source,code:De,severity:g.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(c.from),tags:Array.isArray(x.tags)?(0,k.coalesce)(x.tags.map(r.from)):void 0}}Se.from=Ie;function ce(x){const De=new a.Diagnostic(n.to(x),x.message,g.to(x.severity));return De.source=x.source,De.code=(0,P.isString)(x.code)?x.code:x.code?.value,De.relatedInformation=x.relatedInformation&&x.relatedInformation.map(c.to),De.tags=x.tags&&(0,k.coalesce)(x.tags.map(r.to)),De}Se.to=ce})(o=e.Diagnostic||(e.Diagnostic={}));var c;(function(Se){function Ie(x){return{...n.from(x.location.range),message:x.message,resource:x.location.uri}}Se.from=Ie;function ce(x){return new a.DiagnosticRelatedInformation(new a.Location(x.resource,n.to(x)),x.message)}Se.to=ce})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(Se){function Ie(x){switch(x){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Se.from=Ie;function ce(x){switch(x){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Se.to=ce})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var I;(function(Se){function Ie(x){return typeof x=="number"&&x>=a.ViewColumn.One?x-1:x===a.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Se.from=Ie;function ce(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=ce})(I=e.ViewColumn||(e.ViewColumn={}));function _(Se){return typeof Se.range!="undefined"}function z(Se){return Se.length===0?!0:!!_(Se[0])}e.isDecorationOptionsArr=z;var W;(function(Se){function Ie(We){return We.map(Se.from)}Se.fromMany=Ie;function ce(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function x(We){let rt;if(ce(We)){const{language:ft,value:dt}=We;rt={value:"```"+ft+`
`+dt+"\n```\n"}}else a.MarkdownString.isMarkdownString(We)?rt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?rt={value:We}:rt={value:""};const st=Object.create(null);rt.uris=st;const Ct=ft=>{try{let dt=R.URI.parse(ft,!0);dt=dt.with({query:De(dt.query,st)}),st[ft]=dt}catch{}return""},ht=new T.marked.Renderer;return ht.link=Ct,ht.image=ft=>typeof ft=="string"?Ct(w.parseHrefAndDimensions(ft).href):"",(0,T.marked)(rt.value,{renderer:ht}),rt}Se.from=x;function De(We,rt){if(!We)return We;let st;try{st=(0,E.parse)(We)}catch{}if(!st)return We;let Ct=!1;return st=(0,v.cloneAndChange)(st,ht=>{if(R.URI.isUri(ht)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[ft]=ht,Ct=!0,ft}else return}),Ct?JSON.stringify(st):We}function Ae(We){const rt=new a.MarkdownString(We.value,We.supportThemeIcons);return rt.isTrusted=We.isTrusted,rt.supportHtml=We.supportHtml,rt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,rt}Se.to=Ae;function Ze(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Ze})(W=e.MarkdownString||(e.MarkdownString={}));function ee(Se){return z(Se)?Se.map(Ie=>({range:n.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?W.fromMany(Ie.hoverMessage):Ie.hoverMessage?W.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:n.from(Ie)}))}e.fromRangeOrRangeWithMessage=ee;function D(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?R.URI.file(Se):Se}e.pathOrURIToURI=D;var H;(function(Se){function Ie(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?D(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Se.from=Ie})(H=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Se){function Ie(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?D(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?H.from(ce.before):void 0,after:ce.after?H.from(ce.after):void 0}}Se.from=Ie})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(Se){function Ie(ce){if(typeof ce=="undefined")return ce;switch(ce){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var oe;(function(Se){function Ie(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?$.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?D(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?H.from(ce.before):void 0,after:ce.after?H.from(ce.after):void 0}}Se.from=Ie})(oe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(Se){function Ie(x){return{text:x.newText,eol:x.newEol&&Be.from(x.newEol),range:n.from(x.range)}}Se.from=Ie;function ce(x){const De=new a.TextEdit(n.to(x.range),x.text);return De.newEol=typeof x.eol=="undefined"?void 0:Be.to(x.eol),De}Se.to=ce})(K=e.TextEdit||(e.TextEdit={}));var j;(function(Se){function Ie(ce){return{range:n.from(ce.range),snippet:ce.snippet.value}}Se.from=Ie})(j=e.SnippetTextEdit||(e.SnippetTextEdit={}));var O;(function(Se){function Ie(x,De){const Ae={edits:[]};if(x instanceof a.WorkspaceEdit){const Ze=new S.ResourceSet;for(const We of x._allEntries())We._type===1&&R.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of x._allEntries())We._type===1?Ae.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata}):We._type===2?Ae.edits.push({_type:2,resource:We.uri,edit:K.from(We.edit),modelVersionId:Ze.has(We.uri)?void 0:De?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:De?.getNotebookDocumentVersion(We.uri),edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Qe.from)}})}return Ae}Se.from=Ie;function ce(x){const De=new a.WorkspaceEdit;for(const Ae of x.edits)Ae.edit?De.replace(R.URI.revive(Ae.resource),n.to(Ae.edit.range),Ae.edit.text):De.renameFile(R.URI.revive(Ae.oldUri),R.URI.revive(Ae.newUri),Ae.options);return De}Se.to=ce})(O=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(Se){const Ie=Object.create(null);Ie[a.SymbolKind.File]=0,Ie[a.SymbolKind.Module]=1,Ie[a.SymbolKind.Namespace]=2,Ie[a.SymbolKind.Package]=3,Ie[a.SymbolKind.Class]=4,Ie[a.SymbolKind.Method]=5,Ie[a.SymbolKind.Property]=6,Ie[a.SymbolKind.Field]=7,Ie[a.SymbolKind.Constructor]=8,Ie[a.SymbolKind.Enum]=9,Ie[a.SymbolKind.Interface]=10,Ie[a.SymbolKind.Function]=11,Ie[a.SymbolKind.Variable]=12,Ie[a.SymbolKind.Constant]=13,Ie[a.SymbolKind.String]=14,Ie[a.SymbolKind.Number]=15,Ie[a.SymbolKind.Boolean]=16,Ie[a.SymbolKind.Array]=17,Ie[a.SymbolKind.Object]=18,Ie[a.SymbolKind.Key]=19,Ie[a.SymbolKind.Null]=20,Ie[a.SymbolKind.EnumMember]=21,Ie[a.SymbolKind.Struct]=22,Ie[a.SymbolKind.Event]=23,Ie[a.SymbolKind.Operator]=24,Ie[a.SymbolKind.TypeParameter]=25;function ce(De){return typeof Ie[De]=="number"?Ie[De]:6}Se.from=ce;function x(De){for(const Ae in Ie)if(Ie[Ae]===De)return Number(Ae);return a.SymbolKind.Property}Se.to=x})(B=e.SymbolKind||(e.SymbolKind={}));var V;(function(Se){function Ie(x){switch(x){case a.SymbolTag.Deprecated:return 1}}Se.from=Ie;function ce(x){switch(x){case 1:return a.SymbolTag.Deprecated}}Se.to=ce})(V=e.SymbolTag||(e.SymbolTag={}));var J;(function(Se){function Ie(x){return{name:x.name,kind:B.from(x.kind),tags:x.tags&&x.tags.map(V.from),containerName:x.containerName,location:N.from(x.location)}}Se.from=Ie;function ce(x){const De=new a.SymbolInformation(x.name,B.to(x.kind),x.containerName,N.to(x.location));return De.tags=x.tags&&x.tags.map(V.to),De}Se.to=ce})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var se;(function(Se){function Ie(x){const De={name:x.name||"!!MISSING: name!!",detail:x.detail,range:n.from(x.range),selectionRange:n.from(x.selectionRange),kind:B.from(x.kind),tags:x.tags?.map(V.from)??[]};return x.children&&(De.children=x.children.map(Ie)),De}Se.from=Ie;function ce(x){const De=new a.DocumentSymbol(x.name,x.detail,B.to(x.kind),n.to(x.range),n.to(x.selectionRange));return(0,k.isNonEmptyArray)(x.tags)&&(De.tags=x.tags.map(V.to)),x.children&&(De.children=x.children.map(ce)),De}Se.to=ce})(se=e.DocumentSymbol||(e.DocumentSymbol={}));var me;(function(Se){function Ie(x){const De=new a.CallHierarchyItem(B.to(x.kind),x.name,x.detail||"",R.URI.revive(x.uri),n.to(x.range),n.to(x.selectionRange));return De._sessionId=x._sessionId,De._itemId=x._itemId,De}Se.to=Ie;function ce(x,De,Ae){if(De=De??x._sessionId,Ae=Ae??x._itemId,De===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ae,name:x.name,detail:x.detail,kind:B.from(x.kind),uri:x.uri,range:n.from(x.range),selectionRange:n.from(x.selectionRange),tags:x.tags?.map(V.from)}}Se.from=ce})(me=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Se){function Ie(ce){return new a.CallHierarchyIncomingCall(me.to(ce.from),ce.fromRanges.map(x=>n.to(x)))}Se.to=Ie})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var U;(function(Se){function Ie(ce){return new a.CallHierarchyOutgoingCall(me.to(ce.to),ce.fromRanges.map(x=>n.to(x)))}Se.to=Ie})(U=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var N;(function(Se){function Ie(x){return{range:x.range&&n.from(x.range),uri:x.uri}}Se.from=Ie;function ce(x){return new a.Location(R.URI.revive(x.uri),n.to(x.range))}Se.to=ce})(N=e.location||(e.location={}));var q;(function(Se){function Ie(x){const De=x,Ae=x;return{originSelectionRange:De.originSelectionRange?n.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Ae.uri,range:n.from(De.targetRange?De.targetRange:Ae.range),targetSelectionRange:De.targetSelectionRange?n.from(De.targetSelectionRange):void 0}}Se.from=Ie;function ce(x){return{targetUri:R.URI.revive(x.uri),targetRange:n.to(x.range),targetSelectionRange:x.targetSelectionRange?n.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?n.to(x.originSelectionRange):void 0}}Se.to=ce})(q=e.DefinitionLink||(e.DefinitionLink={}));var Y;(function(Se){function Ie(x){return{range:n.from(x.range),contents:W.fromMany(x.contents)}}Se.from=Ie;function ce(x){return new a.Hover(x.contents.map(W.to),n.to(x.range))}Se.to=ce})(Y=e.Hover||(e.Hover={}));var ie;(function(Se){function Ie(x){return{range:n.from(x.range),expression:x.expression}}Se.from=Ie;function ce(x){return new a.EvaluatableExpression(n.to(x.range),x.expression)}Se.to=ce})(ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Se){function Ie(x){if(x instanceof a.InlineValueText)return{type:"text",range:n.from(x.range),text:x.text};if(x instanceof a.InlineValueVariableLookup)return{type:"variable",range:n.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:n.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function ce(x){switch(x.type){case"text":return{range:n.to(x.range),text:x.text};case"variable":return{range:n.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:n.to(x.range),expression:x.expression}}}Se.to=ce})(de=e.InlineValue||(e.InlineValue={}));var le;(function(Se){function Ie(x){return{frameId:x.frameId,stoppedLocation:n.from(x.stoppedLocation)}}Se.from=Ie;function ce(x){return new a.InlineValueContext(x.frameId,n.to(x.stoppedLocation))}Se.to=ce})(le=e.InlineValueContext||(e.InlineValueContext={}));var ue;(function(Se){function Ie(x){return{range:n.from(x.range),kind:x.kind}}Se.from=Ie;function ce(x){return new a.DocumentHighlight(n.to(x.range),x.kind)}Se.to=ce})(ue=e.DocumentHighlight||(e.DocumentHighlight={}));var pe;(function(Se){function Ie(ce){switch(ce){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Se.to=Ie})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var X;(function(Se){function Ie(ce){return{triggerKind:pe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Se.to=Ie})(X=e.CompletionContext||(e.CompletionContext={}));var Z;(function(Se){function Ie(x){switch(x){case a.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function ce(x){switch(x){case 1:return a.CompletionItemTag.Deprecated}}Se.to=ce})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(Se){const Ie=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ce(Ae){return Ie.get(Ae)??9}Se.from=ce;const x=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function De(Ae){return x.get(Ae)??a.CompletionItemKind.Property}Se.to=De})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Se){function Ie(ce,x){const De=new a.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=G.to(ce.kind),De.tags=ce.tags?.map(Z.to),De.detail=ce.detail,De.documentation=w.isMarkdownString(ce.documentation)?W.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,A.Range.isIRange(ce.range)?De.range=n.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:n.to(ce.range.insert),replacing:n.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new a.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof a.Range?new a.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(Ae=>K.to(Ae))),De.command=x&&ce.command?x.fromInternal(ce.command):void 0,De}Se.to=Ie})(Q=e.CompletionItem||(e.CompletionItem={}));var ae;(function(Se){function Ie(x){return{label:x.label,documentation:W.fromStrict(x.documentation)}}Se.from=Ie;function ce(x){return{label:x.label,documentation:w.isMarkdownString(x.documentation)?W.to(x.documentation):x.documentation}}Se.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var ve;(function(Se){function Ie(x){return{label:x.label,documentation:W.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(ae.from):[],activeParameter:x.activeParameter}}Se.from=Ie;function ce(x){return{label:x.label,documentation:w.isMarkdownString(x.documentation)?W.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(ae.to):[],activeParameter:x.activeParameter}}Se.to=ce})(ve=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Se){function Ie(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ve.from):[]}}Se.from=Ie;function ce(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ve.to):[]}}Se.to=ce})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function Ie(ce,x){const De=new a.InlayHint(i.to(x.position),typeof x.label=="string"?x.label:x.label.map(Ne.to.bind(void 0,ce)),x.kind&&Ue.to(x.kind));return De.textEdits=x.textEdits&&x.textEdits.map(K.to),De.tooltip=w.isMarkdownString(x.tooltip)?W.to(x.tooltip):x.tooltip,De.paddingLeft=x.paddingLeft,De.paddingRight=x.paddingRight,De}Se.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(Se){function Ie(ce,x){const De=new a.InlayHintLabelPart(x.label);return De.tooltip=w.isMarkdownString(x.tooltip)?W.to(x.tooltip):x.tooltip,C.Command.is(x.command)&&(De.command=ce.fromInternal(x.command)),x.location&&(De.location=N.to(x.location)),De}Se.to=Ie})(Ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ue;(function(Se){function Ie(x){return x}Se.from=Ie;function ce(x){return x}Se.to=ce})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var fe;(function(Se){function Ie(x){return{range:n.from(x.range),url:x.target,tooltip:x.tooltip}}Se.from=Ie;function ce(x){let De;if(x.url)try{De=typeof x.url=="string"?R.URI.parse(x.url,!0):R.URI.revive(x.url)}catch{}return new a.DocumentLink(n.to(x.range),De)}Se.to=ce})(fe=e.DocumentLink||(e.DocumentLink={}));var Ee;(function(Se){function Ie(x){const De=new a.ColorPresentation(x.label);return x.textEdit&&(De.textEdit=K.to(x.textEdit)),x.additionalTextEdits&&(De.additionalTextEdits=x.additionalTextEdits.map(Ae=>K.to(Ae))),De}Se.to=Ie;function ce(x){return{label:x.label,textEdit:x.textEdit?K.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(De=>K.from(De)):void 0}}Se.from=ce})(Ee=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(Se){function Ie(x){return new a.Color(x[0],x[1],x[2],x[3])}Se.to=Ie;function ce(x){return[x.red,x.green,x.blue,x.alpha]}Se.from=ce})(ge=e.Color||(e.Color={}));var Fe;(function(Se){function Ie(x){return{range:n.from(x.range)}}Se.from=Ie;function ce(x){return new a.SelectionRange(n.to(x.range))}Se.to=ce})(Fe=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Se){function Ie(ce){switch(ce){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(Se){function Ie(x){switch(x){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function ce(x){switch(x){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Se.to=ce})(qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Be;(function(Se){function Ie(x){if(x===a.EndOfLine.CRLF)return 1;if(x===a.EndOfLine.LF)return 0}Se.from=Ie;function ce(x){if(x===1)return a.EndOfLine.CRLF;if(x===0)return a.EndOfLine.LF}Se.to=ce})(Be=e.EndOfLine||(e.EndOfLine={}));var Ge;(function(Se){function Ie(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(Ge=e.ProgressLocation||(e.ProgressLocation={}));var je;(function(Se){function Ie(ce){const x={start:ce.start+1,end:ce.end+1};return ce.kind&&(x.kind=Ke.from(ce.kind)),x}Se.from=Ie})(je=e.FoldingRange||(e.FoldingRange={}));var Ke;(function(Se){function Ie(ce){if(ce)switch(ce){case a.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Se.from=Ie})(Ke=e.FoldingRangeKind||(e.FoldingRangeKind={}));var re;(function(Se){function Ie(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?n.from(ce.selection):void 0,override:typeof ce.override=="boolean"?y.EditorResolution.DISABLED:void 0}}Se.from=Ie})(re=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var be;(function(Se){function Ie(Ae){return Ae instanceof a.RelativePattern?Ae.toJSON():typeof Ae=="string"?Ae:ce(Ae)||x(Ae)?new a.RelativePattern(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}Se.from=Ie;function ce(Ae){const Ze=Ae;return Ze?R.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function x(Ae){const Ze=Ae;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function De(Ae){return typeof Ae=="string"?Ae:new a.RelativePattern(R.URI.revive(Ae.baseUri),Ae.pattern)}Se.to=De})(be=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(Se){function Ie(ce){if(ce){if(Array.isArray(ce))return ce.map(Ie);if(typeof ce=="string")return ce;{const x=ce;return{language:x.language,scheme:x.scheme,pattern:be.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Se.from=Ie})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(Se){function Ie(x){return{start:x.start,end:x.end}}Se.from=Ie;function ce(x){return new a.NotebookRange(x.start,x.end)}Se.to=ce})(Le=e.NotebookRange||(e.NotebookRange={}));var ze;(function(Se){function Ie(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Se.to=Ie;function ce(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Se.from=ce})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Me;(function(Se){function Ie(ce){if(ce===f.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(ce===f.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(ce===f.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ce}`)}Se.to=Ie})(Me=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var He;(function(Se){function Ie(x){switch(x){case a.NotebookCellKind.Markup:return f.CellKind.Markup;case a.NotebookCellKind.Code:default:return f.CellKind.Code}}Se.from=Ie;function ce(x){switch(x){case f.CellKind.Markup:return a.NotebookCellKind.Markup;case f.CellKind.Code:default:return a.NotebookCellKind.Code}}Se.to=ce})(He=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(Se){function Ie(x){const De={metadata:x.metadata??Object.create(null),cells:[]};for(let Ae of x.cells)a.NotebookCellData.validate(Ae),De.cells.push(Qe.from(Ae));return De}Se.from=Ie;function ce(x){const De=new a.NotebookData(x.cells.map(Qe.to));return(0,P.isEmptyObject)(x.metadata)||(De.metadata=x.metadata),De}Se.to=ce})(Ye=e.NotebookData||(e.NotebookData={}));var Qe;(function(Se){function Ie(x){return{cellKind:He.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ze.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(nt.from):[]}}Se.from=Ie;function ce(x){return new a.NotebookCellData(He.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(nt.to):void 0,x.metadata,x.internalMetadata?ze.to(x.internalMetadata):void 0)}Se.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var xe;(function(Se){function Ie(x){return{mime:x.mime,valueBytes:t.VSBuffer.wrap(x.data)}}Se.from=Ie;function ce(x){return new a.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}Se.to=ce})(xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Se){function Ie(x){return{outputId:x.id,items:x.items.map(xe.from),metadata:x.metadata}}Se.from=Ie;function ce(x){const De=x.items.map(xe.to);return new a.NotebookCellOutput(De,x.outputId,x.metadata)}Se.to=ce})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var tt;(function(Se){function Ie(De){return x(De)?{include:(0,P.withNullAsUndefined)(be.from(De.include)),exclude:(0,P.withNullAsUndefined)(be.from(De.exclude))}:(0,P.withNullAsUndefined)(be.from(De))}Se.from=Ie;function ce(De){return x(De)?{include:be.to(De.include),exclude:be.to(De.exclude)}:be.to(De)}Se.to=ce;function x(De){const Ae=De;return Ae?!(0,P.isUndefinedOrNull)(Ae.include)&&!(0,P.isUndefinedOrNull)(Ae.exclude):!1}})(tt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ot;(function(Se){function Ie(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?H.from(ce.top):void 0}}Se.from=Ie})(ot=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var pt;(function(Se){function Ie(ce,x,De){const Ae=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Ae,De),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Se.from=Ie})(pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var at;(function(Se){function Ie(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}Se.from=Ie})(at=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ut;(function(Se){function Ie(x){return{uri:x.uri,provides:x.provides}}Se.from=Ie;function ce(x){return new a.NotebookRendererScript(R.URI.revive(x.uri),x.provides)}Se.to=ce})(ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ct;(function(Se){function Ie(x){return{message:W.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:n.from(x.location.range),uri:x.location.uri}}}Se.from=Ie;function ce(x){const De=new a.TestMessage(typeof x.message=="string"?x.message:W.to(x.message));return De.actualOutput=x.actual,De.expectedOutput=x.expected,De.location=x.location?N.to(x.location):void 0,De}Se.to=ce})(ct=e.TestMessage||(e.TestMessage={}));var vt;(function(Se){Se.namespace=p.namespaceTestTag,Se.denamespace=p.denamespaceTestTag})(vt=e.TestTag||(e.TestTag={}));var bt;(function(Se){function Ie(x){const De=(0,b.getPrivateApiFor)(x).controllerId;return{extId:m.TestId.fromExtHostTestItem(x,De).toString(),label:x.label,uri:R.URI.revive(x.uri),busy:!1,tags:x.tags.map(Ae=>vt.namespace(De,Ae.id)),range:A.Range.lift(n.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&W.fromStrict(x.error)||null}}Se.from=Ie;function ce(x){return{parent:void 0,error:void 0,id:m.TestId.fromString(x.extId).localId,label:x.label,uri:R.URI.revive(x.uri),tags:(x.tags||[]).map(De=>{const{tagId:Ae}=vt.denamespace(De);return new a.TestTag(Ae)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:n.to(x.range||void 0),canResolveChildren:!1,busy:!1,description:x.description||void 0,sortText:x.sortText||void 0}}Se.toPlain=ce})(bt=e.TestItem||(e.TestItem={})),function(Se){function Ie(x){return{id:x.id}}Se.from=Ie;function ce(x){return new a.TestTag(x.id)}Se.to=ce}(vt=e.TestTag||(e.TestTag={}));var kt;(function(Se){const Ie=(x,De)=>{const Ae={...bt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(We=>We.type===0).map(ct.to)})),children:x.children.map(Ze=>De.get(Ze)).filter(P.isDefined).map(Ze=>Ie(Ze,De))};for(const Ze of Ae.children)Ze.parent=Ae;return Ae};function ce(x){const De=[],Ae=new Map;for(const Ze of x.items)Ae.set(Ze.item.extId,Ze),x.request.targets.some(We=>We.controllerId===Ze.controllerId&&We.testIds.includes(Ze.item.extId))&&De.push(Ze);return{completedAt:x.completedAt,results:De.map(Ze=>Ie(Ze,Ae))}}Se.to=ce})(kt=e.TestResults||(e.TestResults={}));var Tt;(function(Se){function Ie(Ae){return{covered:Ae.covered,total:Ae.covered}}function ce(Ae){return"line"in Ae?i.from(Ae):n.from(Ae)}function x(Ae){return"branches"in Ae?{count:Ae.executionCount,location:ce(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Ae.executionCount,location:ce(Ae.location)}}Se.fromDetailed=x;function De(Ae){return{uri:Ae.uri,statement:Ie(Ae.statementCoverage),branch:Ae.branchCoverage&&Ie(Ae.branchCoverage),function:Ae.functionCoverage&&Ie(Ae.functionCoverage),details:Ae.detailedCoverage?.map(x)}}Se.fromFile=De})(Tt=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(Se){function Ie(ce){switch(ce){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Se.to=Ie})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(Se){function Ie(x){const De=new a.TypeHierarchyItem(B.to(x.kind),x.name,x.detail||"",R.URI.revive(x.uri),n.to(x.range),n.to(x.selectionRange));return De._sessionId=x._sessionId,De._itemId=x._itemId,De}Se.to=Ie;function ce(x,De,Ae){if(De=De??x._sessionId,Ae=Ae??x._itemId,De===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ae,kind:B.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:n.from(x.range),selectionRange:n.from(x.selectionRange),tags:x.tags?.map(V.from)}}Se.from=ce})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var _t;(function(Se){function Ie(ce){if(!!ce)return{value:ce.value,tooltip:ce.tooltip}}Se.from=Ie})(_t=e.ViewBadge||(e.ViewBadge={}))}),define(we[244],ye([0,1,46,116,74,115,75,118,4]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(h,a,u,n)=>{let l=a;return{enumerable:!0,configurable:!1,get(){return l},set(i){if(!u(l,i)){const s=l;l=i,h.listener?.(n(i,s))}}}},R=(h,a)=>h===a,A={range:(h,a)=>h===a?!0:!h||!a?!1:h.isEqual(a),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(h,a)=>!(h.length!==a.length||h.some(u=>!a.find(n=>u.id===n.id)))},C=h=>a=>({op:4,update:h(a)}),y=(h,a)=>({range:P(h,void 0,A.range,C(u=>({range:k.Range.lift(E.Range.from(u))}))),label:P(h,a,A.label,C(u=>({label:u}))),description:P(h,void 0,A.description,C(u=>({description:u}))),sortText:P(h,void 0,A.sortText,C(u=>({sortText:u}))),canResolveChildren:P(h,!1,A.canResolveChildren,u=>({op:2,state:u})),busy:P(h,!1,A.busy,C(u=>({busy:u}))),error:P(h,void 0,A.error,C(u=>({error:E.MarkdownString.fromStrict(u)||null}))),tags:P(h,[],A.tags,(u,n)=>({op:1,new:u.map(E.TestTag.from),old:n.map(E.TestTag.from)}))}),d=h=>{const a=w.TestId.fromString(h.extId),u=new f(a.controllerId,a.localId,h.label,v.URI.revive(h.uri)||void 0);return u.range=E.Range.to(h.range||void 0),u.description=h.description||void 0,u.sortText=h.sortText||void 0,u.tags=h.tags.map(n=>E.TestTag.to({id:(0,T.denamespaceTestTag)(n).tagId})),u},b=h=>{let a;for(const u of h.tests){const n=d(u.item);(0,t.getPrivateApiFor)(n).parent=a,a=n}return a};e.toItemFromContext=b;class f{constructor(a,u,n,l){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const i=(0,t.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof m?void 0:i.parent}},children:{value:(0,S.createTestItemChildren)(i,t.getPrivateApiFor,f),enumerable:!0,writable:!1},...y(i,n)})}}e.TestItemImpl=f;class m extends f{constructor(a,u){super(a,a,u,void 0)}}e.TestItemRootImpl=m;class p extends S.TestItemCollection{constructor(a,u){super({controllerId:a,getApiFor:t.getPrivateApiFor,getChildren:n=>n.children,root:new m(a,u),toITestItem:E.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(we[245],ye([0,1,12,240,13,100,107,114,241,112,117,8,196,113]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{constructor(f,m,p,h,a,u,n,l,i,s){this._remoteAuthority=f,this._channel=m,this._configurationService=p,this._workspaceContextService=h,this._resolverService=a,this._environmentVariableService=u,this._remoteAuthorityResolverService=n,this._logService=l,this._editorService=i,this._labelService=s}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(f,m,p,h,a,u,n,l){await this._configurationService.whenRemoteConfigurationLoaded();const i=Object.create(null),s=p?(0,k.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(p)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(s,{shellLaunchConfig:f,configuration:m})).resolvedVariables}catch(D){this._logService.error(D)}if(r)for(const[D,H]of r.entries())(/^config:/.test(D)||D==="selectedText"||D==="lineNumber")&&(i[D]=H);const o=[];for(const[D,H]of this._environmentVariableService.collections.entries())o.push([D,(0,E.serializeEnvironmentVariableCollection)(H.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),g=c.options&&c.options.extensionHostEnv,I=this._workspaceContextService.getWorkspace(),_=I.folders,z=p?this._workspaceContextService.getWorkspaceFolder(p):null,W=P.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[A.Schemas.file,A.Schemas.vscodeUserData,A.Schemas.vscodeRemote]}),ee={configuration:m,resolvedVariables:i,envVariableCollections:o,shellLaunchConfig:f,workspaceId:I.id,workspaceName:this._labelService.getWorkspaceLabel(I),workspaceFolders:_,activeWorkspaceFolder:z,activeFileResource:W,shouldPersistTerminal:a,options:h,cols:u,rows:n,unicodeVersion:l,resolverEnv:g};return await this._channel.call("$createProcess",ee)}requestDetachInstance(f,m){return this._channel.call("$requestDetachInstance",[f,m])}acceptDetachInstanceReply(f,m){return this._channel.call("$acceptDetachInstanceReply",[f,m])}attachToProcess(f){return this._channel.call("$attachToProcess",[f])}detachFromProcess(f){return this._channel.call("$detachFromProcess",[f])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(f,m){return this._channel.call("$processBinary",[f,m])}start(f){return this._channel.call("$start",[f])}input(f,m){return this._channel.call("$input",[f,m])}acknowledgeDataEvent(f,m){return this._channel.call("$acknowledgeDataEvent",[f,m])}setUnicodeVersion(f,m){return this._channel.call("$setUnicodeVersion",[f,m])}shutdown(f,m){return this._channel.call("$shutdown",[f,m])}resize(f,m,p){return this._channel.call("$resize",[f,m,p])}getInitialCwd(f){return this._channel.call("$getInitialCwd",[f])}getCwd(f){return this._channel.call("$getCwd",[f])}orphanQuestionReply(f){return this._channel.call("$orphanQuestionReply",[f])}sendCommandResult(f,m,p){return this._channel.call("$sendCommandResult",[f,m,p])}installAutoReply(f,m){return this._channel.call("$installAutoReply",[f,m])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(f){return this._channel.call("$getDefaultSystemShell",[f])}getProfiles(f,m,p){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,f,m,p])}acceptPtyHostResolvedVariables(f,m){return this._channel.call("$acceptPtyHostResolvedVariables",[f,m])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(f){return this._channel.call("$getWslPath",[f])}setTerminalLayoutInfo(f){const p={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:f?f.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",p)}updateTitle(f,m,p){return this._channel.call("$updateTitle",[f,m,p])}updateIcon(f,m,p){return this._channel.call("$updateIcon",[f,m,p])}refreshProperty(f,m){return this._channel.call("$refreshProperty",[f,m])}updateProperty(f,m,p){return this._channel.call("$updateProperty",[f,m,p])}getTerminalLayoutInfo(){const m={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(f,m){return this._channel.call("$reviveTerminalProcesses",[f,m])}serializeTerminalState(f){return this._channel.call("$serializeTerminalState",[f])}};d=Re([Oe(2,t.IWorkbenchConfigurationService),Oe(3,T.IWorkspaceContextService),Oe(4,v.IConfigurationResolverService),Oe(5,y.IEnvironmentVariableService),Oe(6,S.IRemoteAuthorityResolverService),Oe(7,w.ILogService),Oe(8,R.IEditorService),Oe(9,C.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(we[119],ye([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class k{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++k.count}}e.ProxyIdentifier=k,k.count=0;const t=[];function w(E){const v=new k(E);return t[v.nid]=v,v}e.createProxyIdentifier=w;function S(E){return t[E].sid}e.getStringIdentifierForProxy=S;class T{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=T}),define(we[246],ye([0,1,44,4,119]),function(te,e,k,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var S;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.NotebookInput=3]="NotebookInput",h[h.NotebookDiffInput=4]="NotebookDiffInput",h[h.CustomEditorInput=5]="CustomEditorInput",h[h.WebviewEditorInput=6]="WebviewEditorInput",h[h.TerminalEditorInput=7]="TerminalEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var E;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(E=e.TabModelOperationKind||(e.TabModelOperationKind={}));var v;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(v=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));class y{static mixin(a){return a._id=y._n++,a}}e.IdObject=y,y._n=0;var d;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(f=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(h){if(h&&h.edits)for(const a of h.edits)typeof a.resource=="object"?a.resource=t.URI.revive(a.resource):(a.newUri=t.URI.revive(a.newUri),a.oldUri=t.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,k.revive)(a.metadata));return h}e.reviveWorkspaceEditDto=m;var p;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookProxyKernels:(0,w.createProxyIdentifier)("MainThreadNotebookProxyKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookProxyKernels:(0,w.createProxyIdentifier)("ExtHostNotebookProxyKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}});var Et=this&&this.__classPrivateFieldSet||function(te,e,k,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(te,k):w?w.value=k:e.set(te,k),k},et=this&&this.__classPrivateFieldGet||function(te,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(te):t?t.value:e.get(te)};define(we[247],ye([0,1,12,111,118,22,246,18,13,44,46,89,4,2,6,234,244,16,119,36]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h){"use strict";var a,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(c,g){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,u.set(this,void 0),Et(this,a,c.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=g,Et(this,u,c.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,I=>{const _=this._apiCommands.get(I);return _?.result===s.Void?_:void 0},g),this._argumentProcessors=[{processArgument(I){return(0,P.revive)(I)}},{processArgument(I){return(0,S.cloneAndChange)(I,function(_){if(R.Range.isIRange(_))return w.Range.to(_);if(A.Position.isIPosition(_))return w.Position.to(_);if(R.Range.isIRange(_.range)&&C.URI.isUri(_.uri))return w.location.to(_);if(_ instanceof m.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const g=this.registerCommand(!1,c.id,async(...I)=>{const _=c.args.map((W,ee)=>{if(!W.validate(I[ee]))throw new Error(`Invalid argument '${W.name}' when running '${c.id}', received: ${I[ee]}`);return W.convert(I[ee])}),z=await this.executeCommand(c.internalId,..._);return c.result.convert(z,I,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{g.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,g,I,_,z,W){if(this._logService.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this._commands.has(g))throw new Error(`command '${g}' already exists`);return this._commands.set(g,{callback:I,thisArg:_,description:z,extension:W}),c&&et(this,a,"f").$registerCommand(g),new t.Disposable(()=>{this._commands.delete(g)&&c&&et(this,a,"f").$unregisterCommand(g)})}executeCommand(c,...g){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,g,!0)}async _doExecuteCommand(c,g,I){if(this._commands.has(c))return this._executeContributedCommand(c,g,!1);{let _=!1;const z=(0,S.cloneAndChange)(g,function(W){if(W instanceof t.Position)return w.Position.from(W);if(W instanceof t.Range)return w.Range.from(W);if(W instanceof t.Location)return w.location.from(W);if(t.NotebookRange.isNotebookRange(W))return w.NotebookRange.from(W);if(W instanceof ArrayBuffer)return _=!0,m.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return _=!0,m.VSBuffer.wrap(W);if(W instanceof m.VSBuffer)return _=!0,W;if(!Array.isArray(W))return W});try{const W=await et(this,a,"f").$executeCommand(c,_?new p.SerializableObjectWithBuffers(z):z,I);return(0,P.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this._doExecuteCommand(c,g,!1);throw W}}}async _executeContributedCommand(c,g,I){const _=this._commands.get(c);if(!_)throw new Error("Unknown command");this._reportTelemetry(_,c);let{callback:z,thisArg:W,description:ee}=_;if(ee)for(let D=0;D<ee.args.length;D++)try{(0,k.validateConstraint)(g[D],ee.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${ee.args[D].name}' - ${ee.args[D].description}`)}try{return await z.apply(W,g)}catch(D){if(c===this.converter.delegatingCommandId){const H=this.converter.getActualCommand(...g);H&&(c=H.command)}throw this._logService.error(D,c,_.extension?.identifier),I?new class extends Error{constructor(){super((0,h.toErrorMessage)(D));this.id=c,this.source=_.extension?.displayName??_.extension?.name}}:D}}_reportTelemetry(c,g){!c.extension||c.extension.isBuiltin||et(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:g})}$executeContributedCommand(c,...g){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(g=g.map(I=>this._argumentProcessors.reduce((_,z)=>z.processArgument(_),I)),this._executeContributedCommand(c,g,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),et(this,a,"f").$getCommands().then(g=>(c&&(g=g.filter(I=>I[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[g,I]of this._commands){let{description:_}=I;_&&(c[g]=_)}return Promise.resolve(c)}};a=new WeakMap,u=new WeakMap,n=Re([Oe(0,b.IExtHostRpcService),Oe(1,v.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class l{constructor(c,g,I){this._commands=c,this._lookupApiCommand=g,this._logService=I,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,g){if(!c)return;const I={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return I;const _=this._lookupApiCommand(c.command);if(_)I.id=_.internalId,I.arguments=_.args.map((z,W)=>z.convert(c.arguments&&c.arguments[W]));else if((0,E.isNonEmptyArray)(c.arguments)){const z=++this._cachIdPool;this._cache.set(z,c),g.add((0,y.toDisposable)(()=>{this._cache.delete(z),this._logService.trace("CommandsConverter#DISPOSE",z)})),I.$ident=z,I.id=this.delegatingCommandId,I.arguments=[z],this._logService.trace("CommandsConverter#CREATE",c.command,z)}return I}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const g=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],g?g.command:"MISSING"),g?this._commands.executeCommand(g.command,...g.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class i{constructor(c,g,I,_){this.name=c,this.description=g,this.validate=I,this.convert=_}optional(){return new i(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,g){return new i(c??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",o=>C.URI.isUri(o),o=>o),i.Position=new i("position","A position in a text document",o=>t.Position.isPosition(o),w.Position.from),i.Range=new i("range","A range in a text document",o=>t.Range.isRange(o),w.Range.from),i.Selection=new i("selection","A selection in a text document",o=>t.Selection.isSelection(o),w.Selection.from),i.Number=new i("number","",o=>typeof o=="number",o=>o),i.String=new i("string","",o=>typeof o=="string",o=>o),i.CallHierarchyItem=new i("item","A call hierarchy item",o=>o instanceof t.CallHierarchyItem,w.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",o=>o instanceof t.TypeHierarchyItem,w.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",o=>o instanceof f.TestItemImpl,w.TestItem.from);class s{constructor(c,g){this.description=c,this.convert=g}}e.ApiCommandResult=s,s.Void=new s("no result",o=>o);class r{constructor(c,g,I,_,z){this.id=c,this.internalId=g,this.description=I,this.args=_,this.result=z}}e.ApiCommand=r}),define(we[248],ye([0,1,80]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(S,T,E=null){const v=(0,k.parse)(T).args;let P=v.shift();if(typeof P=="string")switch(T.severity||(T.severity="info"),E&&(/^\[/.test(E)||(E=`[${E}]`),/ $/.test(E)||(E=`${E} `),P=E+P),T.severity){case"log":case"info":S.info(P,...v);break;case"warn":S.warn(P,...v);break;case"error":S.error(P,...v);break}}e.logRemoteEntry=t;function w(S,T,E){const v=(0,k.parse)(T).args,P=v.shift();typeof P!="string"||T.severity!=="error"||(/^\[/.test(E)||(E=`[${E}]`),/ $/.test(E)||(E=`${E} `),S.error(E+P,...v))}e.logRemoteEntryIfError=w}),define(we[120],ye([0,1,6]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,k.createDecorator)("remoteAgentService")}),define(we[249],ye([0,1,9,2,8,191]),function(te,e,k,t,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class T extends S.DiskFileSystemProviderClient{static register(v,P,R){const A=v.getConnection();if(!A)return t.Disposable.None;const C=new t.DisposableStore,y=(async()=>{try{const d=await v.getRawEnvironment();d?P.registerProvider(w.Schemas.vscodeRemote,C.add(new T(d,A))):R.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){R.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,k.getErrorMessage)(d))}})();return C.add(P.onWillActivateFileSystemProvider(d=>{d.scheme===w.Schemas.vscodeRemote&&d.join(y)})),C}constructor(v,P){super(P.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=T}),define(we[121],ye([0,1,30,14,5,12,20,152,262,263]),function(te,e,k,t,w,S,T,E,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(n,l){let i=l.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=l}}e.ExtractError=R;function A(u){const n=u.externalFileAttributes>>16||33188;return[448,56,7].map(l=>n&l).reduce((l,i)=>l+i,n&61440)}function C(u){if(u instanceof R)return u;let n;return/end of central directory record signature not found/.test(u.message)&&(n="CorruptZip"),new R(n,u)}function y(u,n,l,i,s,r){const o=w.dirname(n),c=w.join(i,o);if(!c.startsWith(i))return Promise.reject(new Error(E.localize(0,null,n)));const g=w.join(i,n);let I;return r.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((_,z)=>{if(!r.isCancellationRequested)try{I=(0,k.createWriteStream)(g,{mode:l}),I.once("close",()=>_()),I.once("error",z),u.once("error",z),u.pipe(I)}catch(W){z(W)}}))}function d(u,n,l,i){let s=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{s.cancel(),u.close()}),new Promise((o,c)=>{const g=new t.Sequencer,I=_=>{_.isCancellationRequested||(r++,u.readEntry())};u.once("error",c),u.once("close",()=>s.then(()=>{i.isCancellationRequested||u.entryCount===r?o():c(new R("Incomplete",new Error(E.localize(1,null,r,u.entryCount))))},c)),u.readEntry(),u.on("entry",_=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(_.fileName)){I(i);return}const z=_.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(z)){const D=w.join(n,z);s=(0,t.createCancelablePromise)(H=>T.Promises.mkdir(D,{recursive:!0}).then(()=>I(H)).then(void 0,c));return}const W=f(u,_),ee=A(_);s=(0,t.createCancelablePromise)(D=>g.queue(()=>W.then(H=>y(H,z,ee,n,l,D).then(()=>I(D)))).then(null,c))})})}function b(u,n=!1){return new Promise((l,i)=>{(0,v.open)(u,n?{lazyEntries:!0}:void 0,(s,r)=>{s?i(C(s)):l((0,S.assertIsDefined)(r))})})}function f(u,n){return new Promise((l,i)=>{u.openReadStream(n,(s,r)=>{s?i(C(s)):l((0,S.assertIsDefined)(r))})})}function m(u,n){return new Promise((l,i)=>{const s=new P.ZipFile;n.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const r=(0,k.createWriteStream)(u);s.outputStream.pipe(r),s.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>l(u))})}e.zip=m;function p(u,n,l={},i){const s=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let r=b(u,!0);return l.overwrite&&(r=r.then(o=>T.Promises.rm(n).then(()=>o))),r.then(o=>d(o,n,{sourcePathRegex:s},i))}e.extract=p;function h(u,n){return b(u).then(l=>new Promise((i,s)=>{l.on("entry",r=>{r.fileName===n&&f(l,r).then(o=>i(o),o=>s(o))}),l.once("close",()=>s(new Error(E.localize(2,null,n))))}))}function a(u,n){return h(u,n).then(l=>new Promise((i,s)=>{const r=[];l.once("error",s),l.on("data",o=>r.push(o)),l.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=a}),define(we[250],ye([0,1,121,161]),function(te,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function w(S){return(0,k.buffer)(S,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=w}),define(we[122],ye([0,1,14,36,9,2,8,5,3,19,55,12,4,26,20,121,160,68,23,216,31,35,49,206,198,250,207,229,66,17,6,13,24,32,51]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c,g,I,_,z,W,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let D=class extends h.AbstractExtensionManagementService{constructor(O,B,V,J,se,me,he,U,N){super(O,B,V,U);this.environmentService=J,this.downloadService=se,this.fileService=he;const q=this._register(me.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(me.createInstance(H,ie=>q.postUninstall(ie))),this.manifestCache=this._register(new r.ExtensionsManifestCache(J,this)),this.extensionsDownloader=this._register(me.createInstance(l.ExtensionsDownloader));const Y=this._register(new o.ExtensionsWatcher(this,he,J,V,N));this._register(Y.onDidChangeExtensionsByAnotherSource(({added:ie,removed:de})=>{ie.length&&this._onDidInstallExtensions.fire(ie.map(le=>({identifier:le.identifier,operation:1,local:le}))),de.forEach(le=>this._onDidUninstallExtension.fire({identifier:le}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const B=await this.collectFiles(O),V=await(0,b.zip)((0,P.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,B);return C.URI.file(V)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const B=await this.downloadVsix(O),V=E.resolve(B.fsPath);return(0,s.getManifest)(V)}getInstalled(O=null){return this.extensionsScanner.scanExtensions(O)}async install(O,B={}){this.logService.trace("ExtensionManagementService#install",O.toString());const V=await this.downloadVsix(O),J=await(0,s.getManifest)(E.resolve(V.fsPath));if(J.engines&&J.engines.vscode&&!(0,c.isEngineValid)(J.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,u.getGalleryExtensionId)(J.publisher,J.name),this.productService.version));return this.installExtension(J,V,B)}async updateMetadata(O,B){this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const V={...B};return B.isPreReleaseVersion&&(V.preRelease=!0),O=await this.extensionsScanner.updateMetadata(O,V),this.manifestCache.invalidate(),O}async updateExtensionScope(O,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.updateMetadata(O,{isMachineScoped:B}),this.manifestCache.invalidate(),O}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(O){if(O.scheme===T.Schemas.file)return O;const B=(0,P.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(O,B),B}createInstallExtensionTask(O,B,V){return C.URI.isUri(B)?new oe(O,B,V,this.galleryService,this.extensionsScanner,this.logService):new $(B,V,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(O,B){return new K(O,B,this.extensionsScanner)}async collectFiles(O){const B=async J=>{let se=await d.Promises.readdir(J);se=se.map(U=>E.join(J,U));const me=await Promise.all(se.map(U=>d.Promises.stat(U)));let he=Promise.resolve([]);return me.forEach((U,N)=>{const q=se[N];U.isFile()&&(he=he.then(Y=>[...Y,q])),U.isDirectory()&&(he=he.then(Y=>B(q).then(ie=>[...Y,...ie])))}),he};return(await B(O.location.fsPath)).map(J=>({path:`extension/${E.relative(O.location.fsPath,J)}`,localPath:J}))}};D=Re([Oe(0,a.IExtensionGalleryService),Oe(1,W.ITelemetryService),Oe(2,_.ILogService),Oe(3,p.INativeEnvironmentService),Oe(4,m.IDownloadService),Oe(5,I.IInstantiationService),Oe(6,g.IFileService),Oe(7,z.IProductService),Oe(8,ee.IUriIdentityService)],D),e.ExtensionManagementService=D;let H=class extends S.Disposable{constructor(O,B,V,J){super();this.beforeRemovingExtension=O,this.fileService=B,this.extensionsScannerService=V,this.logService=J,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(O){const B={includeInvalid:!0};let V=[];return O===null||O===0?V.push(...await this.extensionsScannerService.scanAllExtensions(B)):O===1&&V.push(...await this.extensionsScannerService.scanUserExtensions(B)),V=O!==null?V.filter(J=>J.type===O):V,Promise.all(V.map(J=>this.toLocalExtension(J)))}async scanUserExtensions(O){const B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(B.map(V=>this.toLocalExtension(V)))}async extractUserExtension(O,B,V,J){const se=O.toString(),me=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),he=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,se);try{await d.Promises.rm(he)}catch{throw new a.ExtensionManagementError(f.localize(1,null,he,O.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(O,B,me,J),await this.extensionsScannerService.updateMetadata(C.URI.file(me),{...V,installedTimestamp:Date.now()});try{await this.rename(O,me,he,Date.now()+2*60*1e3),this.logService.info("Renamed to",he)}catch(U){try{await d.Promises.rm(me)}catch{}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(U)}. Deleted from extracted location`,me),U}return this.scanLocalExtension(C.URI.file(he),1)}async updateMetadata(O,B){return await this.extensionsScannerService.updateMetadata(O.location,B),this.scanLocalExtension(O.location,O.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...O){const B=O.map(V=>u.ExtensionKey.create(V));await this.withUninstalledExtensions(V=>{B.forEach(J=>V[J.toString()]=!0)})}async setInstalled(O){await this.withUninstalledExtensions(J=>delete J[O.toString()]);const V=(await this.scanUserExtensions(!0)).find(J=>u.ExtensionKey.create(J).equals(O))||null;return V?this.updateMetadata(V,{installedTimestamp:Date.now()}):null}async removeExtension(O,B){this.logService.trace(`Deleting ${B} extension from disk`,O.identifier.id,O.location.fsPath),await d.Promises.rm(O.location.fsPath),this.logService.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.withUninstalledExtensions(B=>delete B[u.ExtensionKey.create(O).toString()])}async withUninstalledExtensions(O){return this.uninstalledFileLimiter.queue(async()=>{let B;try{B=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let V={};if(B)try{V=JSON.parse(B)}catch{}return O&&(O(V),Object.keys(V).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await d.Promises.rm(this.uninstalledPath)),V})}async extractAtLocation(O,B,V,J){this.logService.trace(`Started extracting the extension from ${B} to ${V}`);try{await d.Promises.rm(V)}catch(se){throw new a.ExtensionManagementError(this.joinErrors(se).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,b.extract)(B,V,{sourcePath:"extension",overwrite:!0},J),this.logService.info(`Extracted extension to ${V}:`,O.id)}catch(se){try{await d.Promises.rm(V)}catch{}let me=a.ExtensionManagementErrorCode.Extract;throw se instanceof b.ExtractError&&(se.type==="CorruptZip"?me=a.ExtensionManagementErrorCode.CorruptZip:se.type==="Incomplete"&&(me=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(se.message,me)}}async rename(O,B,V,J){try{await d.Promises.rename(B,V)}catch(se){if(v.isWindows&&se&&se.code==="EPERM"&&Date.now()<J)return this.logService.info(`Failed renaming ${B} to ${V} with 'EPERM' error. Trying again...`,O.id),this.rename(O,B,V,J);throw new a.ExtensionManagementError(se.message||f.localize(2,null,B,V),se.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(O,B){const V=await this.extensionsScannerService.scanExistingExtension(O,B,{includeInvalid:!0});if(V)return this.toLocalExtension(V);throw new Error(f.localize(3,null,O.path))}async toLocalExtension(O){const B=await this.fileService.resolve(O.location);let V,J;return B.children&&(V=B.children.find(({name:se})=>/^readme(\.txt|\.md|)$/i.test(se))?.resource,J=B.children.find(({name:se})=>/^changelog(\.txt|\.md|)$/i.test(se))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:V,changelogUrl:J,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async removeUninstalledExtensions(){const O=await this.getUninstalledExtensions(),B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),V=new Set;for(const me of B)O[u.ExtensionKey.create(me).toString()]||V.add(me.identifier.id.toLowerCase());const J=(0,u.groupByExtension)(B,me=>me.identifier);await k.Promises.settled(J.map(async me=>{const he=me.sort((U,N)=>R.rcompare(U.manifest.version,N.manifest.version))[0];V.has(he.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(he))}));const se=B.filter(me=>O[u.ExtensionKey.create(me).toString()]);await k.Promises.settled(se.map(me=>this.removeUninstalledExtension(me)))}async removeOutdatedExtensions(){const O=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=[],V=await this.extensionsScannerService.getTargetPlatform(),J=(0,u.groupByExtension)(O,se=>se.identifier);B.push(...J.map(se=>se.sort((me,he)=>{const U=R.rcompare(me.manifest.version,he.manifest.version);return U!==0?U:me.targetPlatform===V?-1:1}).slice(1)).flat()),await k.Promises.settled(B.map(se=>this.removeExtension(se,"outdated")))}joinErrors(O){const B=Array.isArray(O)?O:[O];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((V,J)=>new Error(`${V.message}${V.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};H=Re([Oe(1,g.IFileService),Oe(2,n.IExtensionsScannerService),Oe(3,_.ILogService)],H);class F extends h.AbstractExtensionTask{constructor(O,B,V,J,se){super();this.identifier=O,this.source=B,this.options=V,this.extensionsScanner=J,this.logService=se,this._operation=2}get operation(){return(0,A.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(O,B){try{const V=await this.unsetUninstalledAndGetLocal(O.key);if(V)return O.metadata?this.extensionsScanner.updateMetadata(V,O.metadata):V}catch{throw v.isMacintosh?new a.ExtensionManagementError(f.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(f.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(O,B)}async unsetUninstalledAndGetLocal(O){if(!await this.isUninstalled(O))return null;this.logService.trace("Removing the extension from uninstalled list:",O.id);const V=await this.extensionsScanner.setInstalled(O);return this.logService.info("Removed the extension from uninstalled list:",O.id),V}async isUninstalled(O){return!!(await this.extensionsScanner.getUninstalledExtensions())[O.toString()]}async extract({zipPath:O,key:B,metadata:V},J){let se=await this.extensionsScanner.extractUserExtension(B,O,V,J);return this.logService.info("Extracting completed.",B.id),se}}class $ extends F{constructor(O,B,V,J,se){super(O.identifier,O,B,J,se);this.gallery=O,this.extensionsDownloader=V}async doRun(O){const V=(await this.extensionsScanner.scanExtensions(null)).find(se=>(0,u.areSameExtensions)(se.identifier,this.gallery.identifier));V&&(this._operation=3);const J=await this.downloadInstallableExtension(this.gallery,this._operation);J.metadata.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,J.metadata.isBuiltin=this.options.isBuiltin||V?.isBuiltin,J.metadata.isSystem=V?.type===0?!0:void 0,J.metadata.updated=!!V,J.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,J.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,A.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:V?.preRelease);try{const se=await this.installExtension(J,O);return V&&(V.targetPlatform!==se.targetPlatform||R.neq(V.manifest.version,se.manifest.version))&&await this.extensionsScanner.setUninstalled(V),se}catch(se){throw await this.deleteDownloadedVSIX(J.zipPath),se}}async deleteDownloadedVSIX(O){try{await this.extensionsDownloader.delete(C.URI.file(O))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",O.toString(),(0,w.getErrorMessage)(B))}}async downloadInstallableExtension(O,B){const V={id:O.identifier.uuid,publisherId:O.publisherId,publisherDisplayName:O.publisherDisplayName,targetPlatform:O.properties.targetPlatform};let J;try{this.logService.trace("Started downloading extension:",O.identifier.id),J=(await this.extensionsDownloader.downloadExtension(O,B)).fsPath,this.logService.info("Downloaded extension:",O.identifier.id,J)}catch(se){throw new a.ExtensionManagementError((0,h.joinErrors)(se).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(J),{zipPath:J,key:u.ExtensionKey.create(O),metadata:V}}catch(se){throw await this.deleteDownloadedVSIX(J),new a.ExtensionManagementError((0,h.joinErrors)(se).message,a.ExtensionManagementErrorCode.Invalid)}}}class oe extends F{constructor(O,B,V,J,se,me){super({id:(0,u.getGalleryExtensionId)(O.publisher,O.name)},B,V,se,me);this.manifest=O,this.location=B,this.galleryService=J}async doRun(O){const B=new u.ExtensionKey(this.identifier,this.manifest.version),J=(await this.extensionsScanner.scanExtensions(1)).find(me=>(0,u.areSameExtensions)(this.identifier,me.identifier)),se=await this.getMetadata(this.identifier.id,this.manifest.version,O);if(se.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,se.isBuiltin=this.options.isBuiltin||J?.isBuiltin,J)if(this._operation=3,B.equals(new u.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(f.localize(6,null,this.manifest.displayName||this.manifest.name))}else R.gt(J.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(J);else{const me=await this.unsetUninstalledAndGetLocal(B);if(me)try{await this.extensionsScanner.removeExtension(me,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:E.resolve(this.location.fsPath),key:B,metadata:se},O)}async getMetadata(O,B,V){try{let[J]=await this.galleryService.getExtensions([{id:O,version:B}],V);if(J||([J]=await this.galleryService.getExtensions([{id:O}],V)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class K extends h.AbstractExtensionTask{constructor(O,B,V){super();this.extension=O,this.options=B,this.extensionsScanner=V}async doRun(O){const B=[],V=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const J=u.ExtensionKey.create(this.extension);B.push(...V.filter(se=>J.equals(u.ExtensionKey.create(se))))}else B.push(...V.filter(J=>(0,u.areSameExtensions)(J.identifier,this.extension.identifier)));if(!B.length)throw new Error(f.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const J of B)try{O.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(J)}catch(se){throw new Error(f.localize(9,null,(0,t.toErrorMessage)(se)))}}}}),define(we[60],ye([0,1,71,85,27,16,9,7,2,5,3,26,39,88,251]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{constructor(_,z=""){this.debugLabel=z,this.socket=_,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=W=>{if(this.traceSocketEvent("error",{code:W?.code,message:W?.message}),W){if(W.code==="EPIPE")return;(0,T.onUnexpectedError)(W)}},this.socket.on("error",this._errorListener)}traceSocketEvent(_,z){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,_,z)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(_){const z=W=>{this.traceSocketEvent("read",W),_(S.VSBuffer.wrap(W))};return this.socket.on("data",z),{dispose:()=>this.socket.off("data",z)}}onClose(_){const z=W=>{this.traceSocketEvent("close",{hadError:W}),_({type:0,hadError:W,error:void 0})};return this.socket.on("close",z),{dispose:()=>this.socket.off("close",z)}}onEnd(_){const z=()=>{this.traceSocketEvent("nodeEndReceived"),_()};return this.socket.on("end",z),{dispose:()=>this.socket.off("end",z)}}write(_){if(!this.socket.destroyed)try{this.traceSocketEvent("write",_),this.socket.write(_.buffer,z=>{if(z){if(z.code==="EPIPE")return;(0,T.onUnexpectedError)(z)}})}catch(z){if(z.code==="EPIPE")return;(0,T.onUnexpectedError)(z)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((_,z)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),_();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent("nodeDrainEnd"),_()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.NodeSocket=b;var f;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var m;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(m||(m={}));class p extends v.Disposable{constructor(_,z,W,ee){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=_,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:z,inflateBytesLength:W?.byteLength||0,recordInflateBytes:ee}),this._flowManager=this._register(new h(this,z,W,ee,this._onData,(D,H)=>this._write(D,H))),this._register(this._flowManager.onError(D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(_,z){this.socket.traceSocketEvent(_,z)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(_){return this._onData.event(_)}onClose(_){return this._onClose.event(_)}onEnd(_){return this.socket.onEnd(_)}write(_){this._flowManager.writeMessage(_)}_write(_,z){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",_);let W=2;_.byteLength<126?W+=0:_.byteLength<2**16?W+=2:W+=8;const ee=S.VSBuffer.alloc(W);if(z?ee.writeUInt8(194,0):ee.writeUInt8(130,0),_.byteLength<126)ee.writeUInt8(_.byteLength,1);else if(_.byteLength<2**16){ee.writeUInt8(126,1);let D=1;ee.writeUInt8(_.byteLength>>>8&255,++D),ee.writeUInt8(_.byteLength>>>0&255,++D)}else{ee.writeUInt8(127,1);let D=1;ee.writeUInt8(0,++D),ee.writeUInt8(0,++D),ee.writeUInt8(0,++D),ee.writeUInt8(0,++D),ee.writeUInt8(_.byteLength>>>24&255,++D),ee.writeUInt8(_.byteLength>>>16&255,++D),ee.writeUInt8(_.byteLength>>>8&255,++D),ee.writeUInt8(_.byteLength>>>0&255,++D)}this.socket.write(S.VSBuffer.concat([ee,_]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(_){if(_.byteLength!==0){for(this._incomingData.acceptChunk(_);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const z=this._incomingData.peek(this._state.readLen),W=z.readUInt8(0),ee=(W&128)>>>7,D=(W&64)>>>6,H=z.readUInt8(1),F=(H&128)>>>7,$=H&127;this._state.state=2,this._state.readLen=2+(F?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=ee,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(ee),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const z=this._incomingData.read(this._state.readLen),W=z.readUInt8(1),ee=(W&128)>>>7;let D=W&127,H=1;D===126?D=z.readUInt8(++H)*2**8+z.readUInt8(++H):D===127&&(D=z.readUInt8(++H)*0+z.readUInt8(++H)*0+z.readUInt8(++H)*0+z.readUInt8(++H)*0+z.readUInt8(++H)*2**24+z.readUInt8(++H)*2**16+z.readUInt8(++H)*2**8+z.readUInt8(++H));let F=0;ee&&(F=z.readUInt8(++H)*2**24+z.readUInt8(++H)*2**16+z.readUInt8(++H)*2**8+z.readUInt8(++H)),this._state.state=3,this._state.readLen=D,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const z=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",z),n(z,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",z),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(z,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends v.Disposable{constructor(_,z,W,ee,D,H){super();this._tracer=_,this._onData=D,this._writeFn=H,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,z?(this._zlibInflateStream=this._register(new a(this._tracer,ee,W,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}writeMessage(_){this._writeQueue.push(_),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const _=this._writeQueue.shift();if(this._zlibDeflateStream){const z=await this._deflateMessage(this._zlibDeflateStream,_);this._writeFn(z,!0)}else this._writeFn(_,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(_,z){return new Promise((W,ee)=>{_.write(z),_.flush(D=>W(D))})}acceptFrame(_,z,W){this._readQueue.push({data:_,isCompressed:z,isLastFrameOfMessage:W}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const _=this._readQueue.shift();if(this._zlibInflateStream&&_.isCompressed){const z=await this._inflateFrame(this._zlibInflateStream,_.data,_.isLastFrameOfMessage);this._onData.fire(z)}else this._onData.fire(_.data)}this._isProcessingReadQueue=!1}}_inflateFrame(_,z,W){return new Promise((ee,D)=>{_.write(z),W&&_.write(S.VSBuffer.fromByteArray([0,0,255,255])),_.flush(H=>ee(H))})}}class a extends v.Disposable{constructor(_,z,W,ee){super();this._tracer=_,this._recordInflateBytes=z,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(ee),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(S.VSBuffer.wrap(D))}),W&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",W.buffer),this._zlibInflate.write(W.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}write(_){this._recordInflateBytes&&this._recordedInflateBytes.push(_.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",_),this._zlibInflate.write(_.buffer)}flush(_){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const z=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,_(z)})}}class u extends v.Disposable{constructor(_,z){super();this._tracer=_,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibDeflate.on("data",W=>{this._tracer.traceSocketEvent("zlibDeflateData",W),this._pendingDeflateData.push(S.VSBuffer.wrap(W))})}write(_){this._tracer.traceSocketEvent("zlibDeflateWrite",_.buffer),this._zlibDeflate.write(_.buffer)}flush(_){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let z=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,z=z.slice(0,z.byteLength-4),_(z)})}}function n(I,_){if(_===0)return;let z=I.byteLength>>>2;for(let $=0;$<z;$++){const oe=I.readUInt32BE($*4);I.writeUInt32BE(oe^_,$*4)}let W=z*4,ee=I.byteLength-W;const D=_>>>24&255,H=_>>>16&255,F=_>>>8&255;ee>=1&&I.writeUInt8(I.readUInt8(W)^D,W),ee>=2&&I.writeUInt8(I.readUInt8(W+1)^H,W+1),ee>=3&&I.writeUInt8(I.readUInt8(W+2)^F,W+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const I=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;let _;return e.XDG_RUNTIME_DIR?_=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${I}.sock`):_=(0,P.join)((0,w.tmpdir)(),`vscode-ipc-${I}.sock`),r(_),_}e.createRandomIPCHandle=i;function s(I,_,z){const W=(0,k.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${z}-${_}-sock`;let ee;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ee=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${W.substr(0,8)}-${z}-${_}.sock`):ee=(0,P.join)(I,`${z}-${_}.sock`),r(ee),ee}e.createStaticIPCHandle=s;function r(I){const _=l[R.platform];typeof _=="number"&&I.length>=_&&console.warn(`WARNING: IPC handle "${I}" is longer than ${_} chars, try a shorter --user-data-dir`)}class o extends C.IPCServer{constructor(_){super(o.toClientConnectionEvent(_));this.server=_}static toClientConnectionEvent(_){const z=E.Event.fromNodeEventEmitter(_,"connection");return E.Event.map(z,W=>({protocol:new y.Protocol(new b(W,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(W,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(I){return new Promise((_,z)=>{const W=(0,t.createServer)();W.on("error",z),W.listen(I,()=>{W.removeListener("error",z),_(new o(W))})})}e.serve=c;function g(I,_){return new Promise((z,W)=>{const ee=(0,t.createConnection)(I,()=>{ee.removeListener("error",W),z(y.Client.fromSocket(new b(ee,`ipc-client${_}`),_))});ee.once("error",W)})}e.connect=g}),define(we[123],ye([0,1,72,14,16,9,2,12,28,23,73,13,210,251]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends T.Disposable{constructor(f,m,p){super();this.environmentService=m,this.logService=p,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,m){this.logService.trace("RequestService#request (node) - begin",f.url);const{proxyUrl:p,strictSSL:h}=this;let a;try{a=await(0,R.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",l))}const u={...process.env,...a},n=f.agent?f.agent:await(0,C.getProxyAgent)(f.url||"",u,{proxyUrl:p,strictSSL:h});f.agent=n,f.strictSSL=h,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization});try{const l=await this._request(f,m);return this.logService.trace("RequestService#request (node) - success",f.url),l}catch(l){throw this.logService.trace("RequestService#request (node) - error",f.url,l),l}}async getNodeRequest(f){return((0,k.parse)(f.url).protocol==="https:"?await new Promise((h,a)=>{te(["https"],h,a)}):await new Promise((h,a)=>{te(["http"],h,a)})).request}_request(f,m){return t.Promises.withAsyncBody(async(p,h)=>{let a;const u=(0,k.parse)(f.url),n=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,E.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(l.auth=f.user+":"+f.password),a=n(l,i=>{const s=(0,E.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:s-1},m).then(p,h);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,y.createGunzip)())),p({res:i,stream:(0,w.streamToBufferReadableStream)(r)})}}),a.on("error",h),f.timeout&&a.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&a.write(f.data),a.end(),m.onCancellationRequested(()=>{a.abort(),h((0,S.canceled)())})})}async resolveProxy(f){}};d=Re([Oe(0,v.IConfigurationService),Oe(1,P.INativeEnvironmentService),Oe(2,A.ILogService)],d),e.RequestService=d}),define(we[124],ye([0,1,38,109,8,5,16,7,60,73,13,42,3,248,53,108]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(n={},l,i,s,r,o){const c=await(0,t.getNLSConfiguration)(i,r.userDataPath);let g={};if(l)try{g=await(0,P.getResolvedShellEnv)(o,r.args,process.env)}catch(D){o.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",D)}const _={...process.env,...g,VSCODE_LOG_NATIVE:String(s),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(c,void 0,0),...n},z=r.isBuilt?(0,S.join)(r.appRoot,"bin"):(0,S.join)(r.appRoot,"resources","server","bin-dev"),W=(0,S.join)(z,"remote-cli");let ee=h(_,"PATH");return ee?ee=W+S.delimiter+ee:ee=W,a(_,"PATH",ee),r.args["without-browser-env-var"]||(_.BROWSER=(0,S.join)(z,"helpers",C.isWindows?"browser.cmd":"browser.sh")),u(_),_}e.buildUserEnvironment=f;class m{constructor(l,i,s,r,o,c){this.socket=l,this.socketDrain=i,this.initialDataChunk=s,this.skipWebSocketFrames=r,this.permessageDeflate=o,this.inflateBytes=c}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}let p=class dn{constructor(l,i,s,r,o,c,g){this._reconnectionToken=l,this._environmentService=o,this._logService=c,this._extensionHostStatusService=g,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=i,this._extensionHostProcess=null,this._connectionData=dn._toConnectionData(s,r),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(l){this._logService.info(`${this._logPrefix}${l}`)}_logError(l){this._logService.error(`${this._logPrefix}${l}`)}static _toConnectionData(l,i){return l instanceof v.NodeSocket?new m(l.socket,l.drain(),i,!0,!1,T.VSBuffer.alloc(0)):new m(l.socket.socket,l.drain(),i,!1,l.permessageDeflate,l.recordedInflateBytes)}async _sendSocketToExtensionHost(l,i){await i.socketDrain;const s=i.toIExtHostSocketMessage();l.send(s,i.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const l={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(l)}acceptReconnection(l,i,s){this._remoteAddress=l,this._log("The client has reconnected.");const r=dn._toConnectionData(i,s);if(!this._extensionHostProcess){this._connectionData=r;return}this._sendSocketToExtensionHost(this._extensionHostProcess,r)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(l){try{let i=[];l.port&&!process.pkg&&(i=[`--inspect${l.break?"-brk":""}=${l.port}`]);const s=await f(l.env,!0,l.language,!!l.debugId,this._environmentService,this._logService);(0,d.removeDangerousEnvVariables)(s);const r={env:s,execArgv:i,silent:!0},o=["--type=extensionHost","--transformURIs"],c=this._environmentService.args["use-host-proxy"];o.push(`--useHostProxy=${c?"true":"false"}`),this._extensionHostProcess=k.fork(w.FileAccess.asFileUri("bootstrap-fork",te).fsPath,o,r);const g=this._extensionHostProcess.pid;this._log(`<${g}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const I=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),_=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");I(W=>this._log(`<${g}> ${W}`)),_(W=>this._log(`<${g}><stderr> ${W}`)),this._extensionHostProcess.on("message",W=>{W&&W.type==="__$console"&&(0,y.logRemoteEntry)(this._logService,W,`${this._logPrefix}<${g}>`)}),this._extensionHostProcess.on("error",W=>{this._logError(`<${g}> Extension Host Process had an error`),this._logService.error(W),this._cleanResources()}),this._extensionHostProcess.on("exit",(W,ee)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:W,signal:ee}),this._log(`<${g}> Extension Host Process exited with code: ${W}, signal: ${ee}.`),this._cleanResources()});const z=W=>{W.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",z),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",z)}catch(i){console.error("ExtensionHostConnection errored"),i&&console.error(i)}}};p=Re([Oe(4,A.IServerEnvironmentService),Oe(5,R.ILogService),Oe(6,b.IExtensionHostStatusService)],p),e.ExtensionHostConnection=p;function h(n,l){const i=Object.keys(n).filter(r=>r.toLowerCase()===l.toLowerCase()),s=i.length>0?i[0]:l;return n[s]}function a(n,l,i){const s=Object.keys(n).filter(o=>o.toLowerCase()===l.toLowerCase()),r=s.length>0?s[0]:l;n[r]=i}function u(n){for(let l of Object.keys(n))n[l]===null&&delete n[l]}}),define(we[252],ye([0,1,69,13,56,99,28,50,123,41,32,31,103,122,95,47,2,96,58,8,17,24,98,120,42,101,70,102,9,4,5,25,208,68,51,106,54,3,49,110]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c,g,I,_,z,W,ee,D,H,F,$,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class K extends f.Disposable{constructor(V,J){super();this.args=V,this.remoteDataFolder=J,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async J=>{const se=J.get(t.ILogService),me=J.get(A.IExtensionManagementCLIService);try{await this.doRun(me)}catch(he){throw se.error(he),console.error((0,c.getErrorMessage)(he)),he}})}async initServices(){const V=new k.ServiceCollection,J={_serviceBrand:void 0,...b.default};V.set(u.IProductService,J);const se=new i.ServerEnvironmentService(this.args,J);V.set(i.IServerEnvironmentService,se);const me=new t.LogService(new n.SpdLogLogger(l.RemoteExtensionLogFileName,(0,I.join)(se.logsPath,`${l.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(se)));V.set(t.ILogService,me),me.trace(`Remote configuration data at ${this.remoteDataFolder}`),me.trace("process arguments:",this.args);const he=this._register(new m.FileService(me));V.set(a.IFileService,he),he.registerProvider(h.Schemas.file,this._register(new p.DiskFileSystemProvider(me)));const U=this._register(new S.ConfigurationService(se.settingsResource,he));return await U.initialize(),V.set(T.IConfigurationService,U),V.set(ee.IUriIdentityService,new D.UriIdentityService(he)),V.set(E.IRequestService,new w.SyncDescriptor(v.RequestService)),V.set(W.IDownloadService,new w.SyncDescriptor(z.DownloadService)),V.set(R.ITelemetryService,P.NullTelemetryService),V.set(A.IExtensionGalleryService,new w.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService)),V.set($.IExtensionsScannerService,new w.SyncDescriptor(oe.ExtensionsScannerService)),V.set(A.IExtensionManagementService,new w.SyncDescriptor(y.ExtensionManagementService)),V.set(A.IExtensionManagementCLIService,new w.SyncDescriptor(s.ExtensionManagementCLIService)),V.set(r.ILocalizationsService,new w.SyncDescriptor(o.LocalizationsService)),new d.InstantiationService(V)}async doRun(V){if(this.args["list-extensions"])return V.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const J={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return V.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],J,!!this.args.force)}else{if(this.args["uninstall-extension"])return V.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return V.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(V){return V.map(J=>/\.vsix$/i.test(J)?g.URI.file((0,I.isAbsolute)(J)?J:(0,I.join)((0,_.cwd)(),J)):J)}}function j(B){setTimeout(()=>process.exit(B),0)}async function O(B,V,J){if(B.help){const me=b.default.serverApplicationName+(F.isWindows?".cmd":"");console.log((0,H.buildHelpMessage)(b.default.nameLong,me,b.default.version,J,{noInputFiles:!0,noPipe:!0}));return}if(B.version){console.log((0,H.buildVersionMessage)(b.default.version,b.default.commit));return}const se=new K(B,V);try{await se.run(),j(0)}catch{j(1)}finally{se.dispose()}}e.run=O}),define(we[253],ye([0,1,60,264,30,247,4,13,107]),function(te,e,k,t,w,S,T,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(C,y,d){this._commands=C,this.logService=y,this._ipcHandlePath=d,this._server=t.createServer((b,f)=>this.onRequest(b,f)),this.setup().catch(b=>(y.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",C=>this.logService.error(C))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(C,y){const d=(f,m)=>{y.writeHead(f,{"content-type":"application/json"}),y.end(JSON.stringify(m||null),p=>p&&this.logService.error(p))},b=[];C.setEncoding("utf8"),C.on("data",f=>b.push(f)),C.on("end",async()=>{try{const f=JSON.parse(b.join(""));let m;switch(f.type){case"open":m=await this.open(f);break;case"openExternal":m=await this.openExternal(f);break;case"status":m=await this.getStatus(f);break;case"extensionManagement":m=await this.manageExtensions(f);break;default:d(404,`Unknown message type: ${f.type}`);break}d(200,m)}catch(f){const m=f instanceof Error?f.message:JSON.stringify(f);d(500,m),this.logService.error("Error while processing pipe request",f)}})}async open(C){const{fileURIs:y,folderURIs:d,forceNewWindow:b,diffMode:f,addMode:m,forceReuseWindow:p,gotoLineMode:h,waitMarkerFilePath:a,remoteAuthority:u}=C,n=[];if(Array.isArray(d))for(const r of d)try{n.push({folderUri:T.URI.parse(r)})}catch{}if(Array.isArray(y))for(const r of y)try{(0,v.hasWorkspaceFileExtension)(r)?n.push({workspaceUri:T.URI.parse(r)}):n.push({fileUri:T.URI.parse(r)})}catch{}const l=a?T.URI.file(a):void 0,s={forceNewWindow:b,diffMode:f,addMode:m,gotoLineMode:h,forceReuseWindow:p,preferNewWindow:!p&&!l&&!m,waitMarkerFileURI:l,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",n,s),""}async openExternal(C){for(const y of C.uris){const d=T.URI.parse(y),b=d.scheme==="file"?d:y;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(C){const y=b=>b?.map(f=>/\.vsix$/i.test(f)?T.URI.parse(f):f),d={list:C.list,install:y(C.install),uninstall:y(C.uninstall),force:C.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",d)}async getStatus(C){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&w.existsSync(this._ipcHandlePath)&&w.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let R=class extends P{constructor(C,y){super(C,y,(0,k.createRandomIPCHandle)())}};R=Re([Oe(0,S.IExtHostCommands),Oe(1,E.ILogService)],R),e.CLIServer=R}),define(we[254],ye([0,1,27,7,22,2,5,3,4,60,59,253,238,114,239,242,124]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class m extends b.AbstractVariableResolverService{constructor(a,u,n,l,i){super({getFolderUri:s=>{const r=u.filter(o=>o.name===s);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(s,r)=>l[`config:${r}`],getExecPath:()=>a.VSCODE_EXEC_PATH,getAppRoot:()=>a.VSCODE_CWD,getFilePath:()=>{if(n)return T.normalize(n.fsPath)},getSelectedText:()=>l.selectedText,getLineNumber:()=>l.lineNumber,getExtension:async s=>{const o=(await i.getInstalled()).find(c=>c.identifier.id===s);return o&&{extensionLocation:o.location}}},void 0,Promise.resolve(k.homedir()),Promise.resolve(a))}}class p extends S.Disposable{constructor(a,u,n,l,i){super();this._environmentService=a,this._logService=u,this._ptyService=n,this._productService=l,this._extensionManagementService=i,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(a,u,n){switch(u){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,n);case"$createProcess":{const l=(0,R.createURITransformer)(a.remoteAuthority);return this._createProcess(l,n)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,n);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,n);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,n);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,n);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,n);case"$start":return this._ptyService.start.apply(this._ptyService,n);case"$input":return this._ptyService.input.apply(this._ptyService,n);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,n);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,n);case"$resize":return this._ptyService.resize.apply(this._ptyService,n);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,n);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,n);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,n);case"$sendCommandResult":return this._sendCommandResult(n[0],n[1],n[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,n);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,n);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,n);case"$getProfiles":return this._getProfiles.apply(this,n);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(n[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,n);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,n);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,n);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,n);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,n);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,n);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,n);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(n[0],n[1])}throw new Error(`IPC Command ${u} not found`)}listen(a,u,n){switch(u){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(a,u){const n={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd=="undefined"?u.shellLaunchConfig.cwd:v.URI.revive(a.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment},l=await(0,f.buildUserEnvironment)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,E.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",l);const i=$=>({uri:v.URI.revive(a.transformIncoming($.uri)),name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),s=u.workspaceFolders.map(i),r=u.activeWorkspaceFolder?i(u.activeWorkspaceFolder):void 0,o=u.activeFileResource?v.URI.revive(a.transformIncoming(u.activeFileResource)):void 0,c=new m(l,s,o,u.resolvedVariables,this._extensionManagementService),g=d.createVariableResolver(r,process.env,c),I=await d.getCwd(n,k.homedir(),g,r?.uri,u.configuration["terminal.integrated.cwd"],this._logService);n.cwd=I;const _=E.isWindows?"terminal.integrated.env.windows":E.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",z=u.configuration[_],W=await d.createTerminalEnvironment(n,z,g,this._productService.version,u.configuration["terminal.integrated.detectLocale"],l);if(!n.strictEnv){const $=[];for(const[j,O]of u.envVariableCollections)$.push([j,{map:(0,y.deserializeEnvironmentVariableCollection)(O)}]);const oe=new Map($);await new C.MergedEnvironmentVariableCollection(oe).applyToProcessEnvironment(W,g)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:I,cols:u.cols,rows:u.rows,env:W});const ee=(0,P.createRandomIPCHandle)();W.VSCODE_IPC_HOOK_CLI=ee;const D={executeCommand:($,...oe)=>this._executeCommand($,oe,a)},H=new A.CLIServerBase(D,this._logService,ee),F=await this._ptyService.createProcess(n,I,u.cols,u.rows,u.unicodeVersion,W,l,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName);return this._ptyService.onProcessExit($=>$.id===F&&H.dispose()),{persistentTerminalId:F,resolvedShellLaunchConfig:n}}_executeCommand(a,u,n){let l,i;const s=new Promise((c,g)=>{l=c,i=g}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:l,reject:i,uriTransformer:n});const o=(0,w.cloneAndChange)(u,c=>{if(c&&c.$mid===1)return n.transformOutgoing(c);if(c&&c instanceof v.URI)return n.transformOutgoingURI(c)});return this._onExecuteCommand.fire({reqId:r,commandId:a,commandArgs:o}),s}_sendCommandResult(a,u,n){const l=this._pendingCommands.get(a);if(!l)return;this._pendingCommands.delete(a);const i=(0,w.cloneAndChange)(n,s=>{if(s&&s.$mid===1)return l.uriTransformer.transformIncoming(s)});u?l.reject(i):l.resolve(i)}_getDefaultSystemShell(a){return this._ptyService.getDefaultSystemShell(a)}async _getProfiles(a,u,n,l){return this._ptyService.getProfiles?.(a,u,n,l)||[]}_getEnvironment(){return{...process.env}}_getWslPath(a){return this._ptyService.getWslPath(a)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=p}),define(we[255],ye([0,1,27,7,2,8,5,84,20,39,28,99,67,202,178,68,179,189,181,23,103,31,101,190,122,17,96,58,56,95,69,70,102,13,97,98,47,24,50,209,123,212,32,41,220,221,104,228,51,106,235,236,214,219,254,59,42,245,120,249,108,49,110]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c,g,I,_,z,W,ee,D,H,F,$,oe,K,j,O,B,V,J,se,me,he,U,N,q,Y,ie,de,le,ue,pe,X,Z,G,Q,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const ve="monacoworkbench";async function ke(_e,qe,Be,Ge){const je=new I.ServiceCollection,Ke=new Ue,re={_serviceBrand:void 0,...H.default};je.set(F.IProductService,re);const be=new ue.ServerEnvironmentService(qe,re);je.set(h.IEnvironmentService,be),je.set(h.INativeEnvironmentService,be);const Pe=new W.LogService(new D.SpdLogLogger(X.RemoteExtensionLogFileName,T.join(be.logsPath,`${X.RemoteExtensionLogFileName}.log`),!0,!1,(0,W.getLogLevel)(be))),Le=new W.MultiplexLogService([new fe((0,W.getLogLevel)(be)),Pe]);je.set(W.ILogService,Le),setTimeout(()=>Fe(be.logsPath).then(null,at=>Le.error(at)),1e4),Le.trace(`Remote configuration data at ${Be}`),Le.trace("process arguments:",be.args),Array.isArray(re.serverGreeting)&&Pe.info(`

${re.serverGreeting.join(`
`)}

`),Ke.registerChannel(d.ExtensionHostDebugBroadcastChannel.ChannelName,new d.ExtensionHostDebugBroadcastChannel);const ze=new P.StaticRouter(at=>at.clientId==="renderer");Ke.registerChannel("logger",new ee.LogLevelChannel(Le));const Me=Ge.add(new r.FileService(Le));je.set(s.IFileService,Me),Me.registerProvider(S.Schemas.file,Ge.add(new o.DiskFileSystemProvider(Le)));const He=new A.ConfigurationService(be.machineSettingsResource,Me);je.set(R.IConfigurationService,He);const Ye=new G.ExtensionHostStatusService;je.set(G.IExtensionHostStatusService,Ye),je.set(he.IUriIdentityService,new U.UriIdentityService(Me)),je.set($.IRequestService,new c.SyncDescriptor(K.RequestService));let Qe=B.NullAppender;const xe=await(0,E.getMachineId)();if((0,B.supportsTelemetry)(re,be)){re.aiConfig&&re.aiConfig.asimovKey&&(Qe=new V.AppInsightsAppender(ve,null,re.aiConfig.asimovKey),Ge.add((0,w.toDisposable)(()=>Qe.flush())));const at={appenders:[Qe],commonProperties:(0,j.resolveCommonProperties)(Me,(0,k.release)(),(0,k.hostname)(),process.arch,re.commit,re.version+"-remote",xe,re.msftInternalDomains,be.installSourcePath,"remoteAgent"),piiPaths:(0,B.getPiiPathsFromEnvironment)(be)},ut=be.args["telemetry-level"];let ct=3;ut==="all"?ct=3:ut==="error"?ct=2:ut==="crash"?ct=1:ut!==void 0&&(ct=0),je.set(ie.IServerTelemetryService,new c.SyncDescriptor(ie.ServerTelemetryService,[at,ct]))}else je.set(ie.IServerTelemetryService,ie.ServerNullTelemetryService);je.set(u.IExtensionGalleryService,new c.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService));const nt=Ke.getChannel("download",ze);je.set(b.IDownloadService,new f.DownloadServiceChannelClient(nt,()=>Ne("renderer"))),je.set(Q.IExtensionsScannerService,new c.SyncDescriptor(ae.ExtensionsScannerService)),je.set(u.IExtensionManagementService,new c.SyncDescriptor(i.ExtensionManagementService));const tt=new g.InstantiationService(je);je.set(_.ILocalizationsService,tt.createInstance(z.LocalizationsService));const ot=tt.createInstance(n.ExtensionManagementCLIService);je.set(u.IExtensionManagementCLIService,ot);const pt=tt.createInstance(me.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100});return je.set(se.IPtyService,pt),je.set(m.IEncryptionMainService,new c.SyncDescriptor(p.EncryptionMainService,[xe])),je.set(C.ICredentialsMainService,new c.SyncDescriptor(y.CredentialsWebMainService)),tt.invokeFunction(at=>{const ut=at.get(u.IExtensionManagementService),ct=at.get(Q.IExtensionsScannerService),vt=new N.RemoteAgentEnvironmentChannel(_e,be,ot,Le,Ye,ct);Ke.registerChannel("remoteextensionsenvironment",vt);const bt=new Y.ServerTelemetryChannel(at.get(ie.IServerTelemetryService),Qe);Ke.registerChannel("telemetry",bt),Ke.registerChannel(pe.REMOTE_TERMINAL_CHANNEL_NAME,new de.RemoteTerminalChannel(be,Le,pt,re,ut));const kt=new q.RemoteAgentFileSystemProviderChannel(Le,be);Ke.registerChannel(Z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,kt),Ke.registerChannel("request",new oe.RequestChannel(at.get($.IRequestService)));const Tt=new l.ExtensionManagementChannel(ut,_t=>Ne(_t.remoteAuthority));Ke.registerChannel("extensions",Tt);const Rt=P.ProxyChannel.fromService(at.get(m.IEncryptionMainService));Ke.registerChannel("encryption",Rt);const At=P.ProxyChannel.fromService(at.get(C.ICredentialsMainService));return Ke.registerChannel("credentials",At),ut.removeDeprecatedExtensions(),Ge.add(new J.default(at.get(O.ITelemetryService))),{telemetryService:at.get(O.ITelemetryService)}}),{socketServer:Ke,instantiationService:tt}}e.setupServerServices=ke;const Te=Object.create(null);function Ne(_e){return Te[_e]||(Te[_e]=(0,le.createURITransformer)(_e)),Te[_e]}class Ue extends P.IPCServer{constructor(){const qe=new t.Emitter;super(qe.event);this._onDidConnectEmitter=qe}acceptConnection(qe,Be){this._onDidConnectEmitter.fire({protocol:qe,onDidClientDisconnect:Be})}}e.SocketServer=Ue;class fe extends W.AbstractLogger{constructor(qe=W.DEFAULT_LOG_LEVEL){super();this.setLevel(qe),this.useColors=Boolean(process.stdout.isTTY)}trace(qe,...Be){this.getLevel()<=W.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ee()}][0m`,qe,...Be):console.log(`[${Ee()}]`,qe,...Be))}debug(qe,...Be){this.getLevel()<=W.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ee()}][0m`,qe,...Be):console.log(`[${Ee()}]`,qe,...Be))}info(qe,...Be){this.getLevel()<=W.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ee()}][0m`,qe,...Be):console.log(`[${Ee()}]`,qe,...Be))}warn(qe,...Be){this.getLevel()<=W.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ee()}][0m`,qe,...Be):console.warn(`[${Ee()}]`,qe,...Be))}error(qe,...Be){this.getLevel()<=W.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ee()}][0m`,qe,...Be):console.error(`[${Ee()}]`,qe,...Be))}critical(qe,...Be){this.getLevel()<=W.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ee()}][0m`,qe,...Be):console.error(`[${Ee()}]`,qe,...Be))}dispose(){}flush(){}}function Ee(){const _e=new Date;return`${ge(_e.getHours())}:${ge(_e.getMinutes())}:${ge(_e.getSeconds())}`}function ge(_e){return _e<10?`0${_e}`:String(_e)}async function Fe(_e){const qe=T.basename(_e),Be=T.dirname(_e),Ke=(await v.Promises.readdir(Be)).filter(be=>/^\d{8}T\d{6}$/.test(be)).sort().filter(be=>be!==qe),re=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(re.map(be=>v.Promises.rm(T.join(Be,be))))}}),define(we[256],ye([0,1,71,30,85,257,72,125,16,9,33,2,8,5,45,3,15,4,26,141,88,60,6,13,24,32,124,230,231,42,255,233]),function(te,e,k,t,w,S,T,E,v,P,R,A,C,y,d,b,f,m,p,h,a,u,n,l,i,s,r,o,c,g,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const z=5*60*1e3;let W=class extends A.Disposable{constructor(F,$,oe,K,j,O,B,V){super();this._socketServer=F,this._connectionToken=$,this._vsdaMod=oe,this._environmentService=j,this._productService=O,this._logService=B,this._instantiationService=V,this._webEndpointOriginChecker=D.create(this._productService),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=K?this._instantiationService.createInstance(_.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(F,$){if(F.method!=="GET")return(0,_.serveError)(F,$,405,`Unsupported method ${F.method}`);if(!F.url)return(0,_.serveError)(F,$,400,"Bad request.");const oe=T.parse(F.url,!0),K=oe.pathname;if(!K)return(0,_.serveError)(F,$,400,"Bad request.");if(K==="/version")return $.writeHead(200,{"Content-Type":"text/plain"}),$.end(this._productService.commit||"");if(K==="/delay-shutdown")return this._delayShutdown(),$.writeHead(200),$.end("OK");if(!(0,c.requestHasValidConnectionToken)(this._connectionToken,F,oe))return(0,_.serveError)(F,$,403,"Forbidden.");if(K==="/vscode-remote-resource"){const j=oe.query.path;if(typeof j!="string")return(0,_.serveError)(F,$,400,"Bad request.");let O;try{O=m.URI.from({scheme:C.Schemas.file,path:j}).fsPath}catch{return(0,_.serveError)(F,$,400,"Bad request.")}const B=Object.create(null);this._environmentService.isBuilt&&((0,R.isEqualOrParent)(O,this._environmentService.builtinExtensionsPath,!b.isLinux)||(0,R.isEqualOrParent)(O,this._environmentService.extensionsPath,!b.isLinux))&&(B["Cache-Control"]="public, max-age=31536000"),B.Vary="Origin";const V=F.headers.origin;return V&&this._webEndpointOriginChecker.matches(V)&&(B["Access-Control-Allow-Origin"]=V),(0,_.serveFile)(this._logService,F,$,O,B)}if(this._webClientServer){this._webClientServer.handle(F,$,oe);return}return $.writeHead(404,{"Content-Type":"text/plain"}),$.end("Not found")}handleUpgrade(F,$){let oe=(0,p.generateUuid)(),K=!1,j=!1;if(F.url){const me=T.parse(F.url,!0).query;typeof me.reconnectionToken=="string"&&(oe=me.reconnectionToken),me.reconnection==="true"&&(K=!0),me.skipWebSocketFrames==="true"&&(j=!0)}if(F.headers.upgrade!=="websocket"){$.end("HTTP/1.1 400 Bad Request");return}const O=F.headers["sec-websocket-key"],B=k.createHash("sha1");B.update(O+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const V=B.digest("base64"),J=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${V}`];let se=!1;if(!j&&!this._environmentService.args["disable-websocket-compression"]&&F.headers["sec-websocket-extensions"]){const me=Array.isArray(F.headers["sec-websocket-extensions"])?F.headers["sec-websocket-extensions"]:[F.headers["sec-websocket-extensions"]];for(const he of me)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(he)){if(/\b(permessage-deflate)\b/.test(he)){se=!0,J.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(he)){se=!0,J.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}$.write(J.join(`\r
`)+`\r
\r
`),$.setTimeout(0),$.setNoDelay(!0),j?this._handleWebSocketConnection(new u.NodeSocket($,`server-connection-${oe}`),K,oe):this._handleWebSocketConnection(new u.WebSocketNodeSocket(new u.NodeSocket($,`server-connection-${oe}`),se,null,!0),K,oe)}handleServerError(F){this._logService.error("Error occurred in server"),this._logService.error(F)}_getRemoteAddress(F){let $;return F instanceof u.NodeSocket?$=F.socket:$=F.socket.socket,$.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(F,$,oe){const K=$.getSocket();this._logService.error(`${F} ${oe}.`);const j={type:"error",reason:oe};$.sendControl(v.VSBuffer.fromString(JSON.stringify(j))),$.dispose(),await K.drain(),K.dispose()}_handleWebSocketConnection(F,$,oe){const K=this._getRemoteAddress(F),j=`[${K}][${oe.substr(0,8)}]`,O=new a.PersistentProtocol(F),B=this._vsdaMod?new this._vsdaMod.validator:null,V=this._vsdaMod?new this._vsdaMod.signer:null;let J;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(J||(J={}));let se=0;const me=U=>{se=3,he.dispose(),this._rejectWebSocketConnection(j,O,U)},he=O.onControlMessage(U=>{if(se===0){let N;try{N=JSON.parse(U.toString())}catch{return me("Malformed first message")}if(N.type!=="auth")return me("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(N.auth))return me("Unauthorized client refused: auth mismatch");let q=(0,p.generateUuid)();if(V)try{q=V.sign(N.data)}catch{}let Y=(0,p.generateUuid)();if(B)try{Y=B.createNewMessage(Y)}catch{}const ie={type:"sign",data:Y,signedData:q};O.sendControl(v.VSBuffer.fromString(JSON.stringify(ie))),se=1}else if(se===1){let N;try{N=JSON.parse(U.toString())}catch{return me("Malformed second message")}if(N.type!=="connectionType")return me("Invalid second message");if(typeof N.signedData!="string")return me("Invalid second message field type");const q=N.commit,Y=this._productService.commit;if(q&&Y&&q!==Y)return me("Client refused: version mismatch");let ie=!1;if(!B)ie=!0;else if(this._connectionToken.validate(N.signedData))ie=!0;else try{ie=B.validate(N.signedData)==="ok"}catch{}if(!ie){if(this._environmentService.isBuilt)return me("Unauthorized client refused");this._logService.error(`${j} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let de in this._managementConnections)this._managementConnections[de].shortenReconnectionGraceTimeIfNecessary();for(let de in this._extHostConnections)this._extHostConnections[de].shortenReconnectionGraceTimeIfNecessary();se=2,he.dispose(),this._handleConnectionType(K,j,O,F,$,oe,N)}})}async _handleConnectionType(F,$,oe,K,j,O,B){const V=B.desiredConnectionType===1?`${$}[ManagementConnection]`:B.desiredConnectionType===2?`${$}[ExtensionHostConnection]`:$;if(B.desiredConnectionType===1)if(j){if(!this._managementConnections[O])return this._allReconnectionTokens.has(O)?this._rejectWebSocketConnection(V,oe,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(V,oe,"Unknown reconnection token (never seen)");oe.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=oe.readEntireBuffer();oe.dispose(),this._managementConnections[O].acceptReconnection(F,K,J)}else{if(this._managementConnections[O])return this._rejectWebSocketConnection(V,oe,"Duplicate reconnection token");oe.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=new o.ManagementConnection(this._logService,O,F,oe);this._socketServer.acceptConnection(J.protocol,J.onClose),this._managementConnections[O]=J,this._allReconnectionTokens.add(O),J.onClose(()=>{delete this._managementConnections[O]})}else if(B.desiredConnectionType===2){const J=B.args||{language:"en"},se=await this._updateWithFreeDebugPort(J);if(se.port&&this._logService.trace(`${V} - startParams debug port ${se.port}`),this._logService.trace(`${V} - startParams language: ${se.language}`),this._logService.trace(`${V} - startParams env: ${JSON.stringify(se.env)}`),j){if(!this._extHostConnections[O])return this._allReconnectionTokens.has(O)?this._rejectWebSocketConnection(V,oe,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(V,oe,"Unknown reconnection token (never seen)");oe.sendPause(),oe.sendControl(v.VSBuffer.fromString(JSON.stringify(se.port?{debugPort:se.port}:{})));const me=oe.readEntireBuffer();oe.dispose(),this._extHostConnections[O].acceptReconnection(F,K,me)}else{if(this._extHostConnections[O])return this._rejectWebSocketConnection(V,oe,"Duplicate reconnection token");oe.sendPause(),oe.sendControl(v.VSBuffer.fromString(JSON.stringify(se.port?{debugPort:se.port}:{})));const me=oe.readEntireBuffer();oe.dispose();const he=this._instantiationService.createInstance(r.ExtensionHostConnection,O,F,K,me);this._extHostConnections[O]=he,this._allReconnectionTokens.add(O),he.onClose(()=>{delete this._extHostConnections[O],this._onDidCloseExtHostConnection()}),he.start(se)}}else if(B.desiredConnectionType===3){const J=B.args;this._createTunnel(oe,J)}else return this._rejectWebSocketConnection(V,oe,"Unknown initial data received")}async _createTunnel(F,$){const oe=F.getSocket().socket,K=F.readEntireBuffer();F.dispose(),oe.pause();const j=await this._connectTunnelSocket($.host,$.port);K.byteLength>0&&j.write(K.buffer),j.on("end",()=>oe.end()),j.on("close",()=>oe.end()),j.on("error",()=>oe.destroy()),oe.on("end",()=>j.end()),oe.on("close",()=>j.end()),oe.on("error",()=>j.destroy()),j.pipe(oe),oe.pipe(j)}_connectTunnelSocket(F,$){return new Promise((oe,K)=>{const j=w.createConnection({host:F,port:$},()=>{j.removeListener("error",K),j.pause(),oe(j)});j.once("error",K)})}_updateWithFreeDebugPort(F){return typeof F.port=="number"?(0,h.findFreePort)(F.port,10,5e3).then($=>(F.port=$,F)):(F.debugId=void 0,F.port=void 0,F.break=void 0,Promise.resolve(F))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},z))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};W=Re([Oe(4,g.IServerEnvironmentService),Oe(5,i.IProductService),Oe(6,l.ILogService),Oe(7,n.IInstantiationService)],W),e.RemoteExtensionHostAgentServer=W;async function ee(H,F,$){const oe=await(0,c.determineServerConnectionToken)(F);oe instanceof c.ServerConnectionTokenParseError&&(console.warn(oe.message),process.exit(1));const K=new A.DisposableStore,{socketServer:j,instantiationService:O}=await(0,I.setupServerServices)(oe,F,$,K);O.invokeFunction(N=>{const q=N.get(l.ILogService);(0,P.setUnexpectedErrorHandler)(Y=>{Y&&Y.code==="EPIPE"&&Y.syscall==="write"&&Y.stack&&/unexpectedErrorHandler/.test(Y.stack)||q.error(Y)}),process.on("SIGPIPE",()=>{(0,P.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),O.invokeFunction(N=>{const q=N.get(l.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Y=(0,y.join)(process.env.HOMEDRIVE,"node_modules"),ie=(0,y.dirname)((0,y.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),de=(0,y.join)(ie,"node_modules");if(t.existsSync(Y)||t.existsSync(de)){const le=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Y}
* ${de}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;q.warn(le),console.warn(le),process.exit(0)}}});const B=O.invokeFunction(N=>{const q=N.get(l.ILogService);if(t.existsSync((0,y.join)(C.FileAccess.asFileUri("",te).fsPath,"../node_modules/vsda")))try{return te.__$__nodeRequire("vsda")}catch(ie){q.error(ie)}return null}),V=t.existsSync(C.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",te).fsPath);if(V&&H&&typeof H!="string"){const N=oe.type!==0?`?${C.connectionTokenQueryName}=${oe.value}`:"";console.log(`Web UI available at http://localhost${H.port===80?"":`:${H.port}`}/${N}`)}const J=O.createInstance(W,j,oe,B,V);d.mark("code/server/ready");const se=S.performance.now(),me=global.vscodeServerStartTime,he=global.vscodeServerListenTime,U=global.vscodeServerCodeLoadedTime;if(O.invokeFunction(N=>{N.get(s.ITelemetryService).publicLog2("serverStart",{startTime:me,startedTime:he,codeLoadedTime:U,readyTime:se})}),F["print-startup-performance"]){const N=E.LoaderStats.get();let q="";q+=`

### Load AMD-module
`,q+=E.LoaderStats.toMarkdownTable(["Module","Duration"],N.amdLoad),q+=`

### Load commonjs-module
`,q+=E.LoaderStats.toMarkdownTable(["Module","Duration"],N.nodeRequire),q+=`

### Invoke AMD-module factory
`,q+=E.LoaderStats.toMarkdownTable(["Module","Duration"],N.amdInvoke),q+=`

### Invoke commonjs-module
`,q+=E.LoaderStats.toMarkdownTable(["Module","Duration"],N.nodeEval),q+=`Start-up time: ${he-me}
`,q+=`Code loading time: ${U-me}
`,q+=`Initialized time: ${se-me}
`,q+=`
`,console.log(q)}return J}e.createServer=ee;class D{constructor(F){this._originRegExp=F}static create(F){const $=F.webEndpointUrlTemplate,oe=F.commit,K=F.quality;if(!$||!oe||!K)return new D(null);const j=(0,p.generateUuid)(),B=new URL($.replace("{{uuid}}",j).replace("{{commit}}",oe).replace("{{quality}}",K)).origin,V=(0,f.escapeRegExpCharacters)(B).replace(j,"[a-zA-Z0-9\\-]+");try{const J=(0,f.createRegExp)(`^${V}$`,!0,{matchCase:!1});return new D(J)}catch{return new D(null)}}matches(F){return this._originRegExp?this._originRegExp.test(F):!1}}}),define(we[265],ye([0,1,27,30,8,252,256,54,5,257,42,47,45]),function(te,e,k,t,w,S,T,E,v,P,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,C.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=P.performance.now();const y={onMultipleValues:(s,r)=>{console.error(`Option ${s} can only be defined once. Using value ${r}.`)},onUnknownOption:s=>{console.error(`Ignoring option ${s}: not supported for server.`)},onDeprecatedOption:(s,r)=>{console.warn(`Option '${s}' is deprecated: ${r}`)}},d=(0,E.parseArgs)(process.argv.slice(2),R.serverOptions,y),b=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(k.homedir(),A.default.serverDataFolderName||".vscode-remote"),f=(0,v.join)(b,"data"),m=(0,v.join)(f,"User"),p=(0,v.join)(m,"globalStorage"),h=(0,v.join)(m,"History"),a=(0,v.join)(f,"Machine");d["user-data-dir"]=f;const u=(0,v.dirname)(w.FileAccess.asFileUri("",te).fsPath),n=(0,v.join)(u,"extensions");d["builtin-extensions-dir"]=n,d["extensions-dir"]=d["extensions-dir"]||(0,v.join)(b,"extensions"),[b,d["extensions-dir"],f,m,a,p,h].forEach(s=>{try{t.existsSync(s)||t.mkdirSync(s,{mode:448})}catch(r){console.error(r)}});function l(){(0,S.run)(d,b,R.serverOptions)}e.spawnCli=l;function i(s){return(0,T.createServer)(s,d,b)}e.createServer=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/57fd6d0195bb9b9d1b49f6da5db789060795de47/core/vs/server/node/server.main.js.map
